﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Dim ABMComp As ABMCustomComponent
	Dim ABM As ABMaterial
	Private HTML As String
	Private iID As String
	Private intPage As ABMPage
	Private Pills As List
	Type ThemeEnum0(primary As String, info As String, success As String, warning As String, danger As String)
	Public EnumTheme As ThemeEnum0
	Public Theme As String
	EnumTheme.Initialize
	EnumTheme.danger = "nav-pills-danger"
	EnumTheme.info = "nav-pills-info"
	EnumTheme.primary = "nav-pills-primary"
	EnumTheme.success = "nav-pills-success"
	EnumTheme.warning = "nav-pills-warning"
	Private bStacked As Boolean
	Private bHasIcons As Boolean
	Private sBorderColor As String
	Private sBorderWidth As String
	Private sBorderStyle As String 
	Private sBorderRadius As String
	Private pgName As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, Stacked As Boolean)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	iID = ID
	intPage = InternalPage
	HTML = ""
	pgName = InternalPage.name
	Pills.Initialize
	bStacked = Stacked
	bHasIcons = False
	sBorderColor = ""
	sBorderStyle=""
	sBorderRadius="0"
	sBorderWidth="0"
End Sub



Sub SetBorder(BorderColor As String, BorderWidth As String, BorderRadius As String, BorderStyle As String)
	sBorderColor = BorderColor
	sBorderWidth = BorderWidth
	sBorderRadius = BorderRadius
	sBorderStyle = BorderStyle
End Sub

Public Sub SetTheme(sTheme As String)
	Theme = sTheme
End Sub

Sub AddPill(pillID As String, pillActive As Boolean, pillIcon As String, pillText As String)
	'define the pill
	Dim li As HTMLElement
	li.Initialize(pillID, "li")
	If pillActive = True Then li.AddClass("active")
	li.AddAttribute("onclick",$"navclick('${pgName.tolowercase}','${pillID}','${pillID}')"$,True)	
	
	If pillIcon.Length > 0 Then	
		'define the icon
		Dim i As HTMLElement
		i.Initialize(pillID & "icon","i")
		i.materialBuildIcon(pillIcon,"")
		bHasIcons = True
	End If
	
	'define the anchor
	Dim a As HTMLElement
	a.Initialize(pillID & "anchor","a")
	a.AddAttribute("role","tab",True)
	a.AddAttribute("data-toggle","tab",True)
	'a.AddAttribute("href", pillNavigateTo,True)
	If pillIcon.Length > 0 Then a.AddContent(i.HTML)
	a.AddContent(pillText)
	a.AddStyleAttribute("border", sBorderColor)
	a.AddStyleAttribute("border-width", sBorderWidth & "px")
	a.AddStyleAttribute("border-style", sBorderStyle)
	a.AddStyleAttribute("border-radius", sBorderRadius)	
	'add to the pill
	li.AddContent(a.HTML)
	Pills.Add(li.HTML)
End Sub

' runs when an object is created for the first time. Expects a valid html string
' will get surrounded by a div automatically
' in the html file:
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	iID = internalID
	Return $"<div id="${internalID}";"></div>"$
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	intPage = InternalPage
	'build the chart here and initialize it
	HTML = Build(internalID)
	ABM.ReplaceMyHTML(InternalPage,internalID,HTML)
	' flush not needed, it's done in the refresh method in the lib
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	intPage = InternalPage
	' use these methods to adjust the object
	' ABM.HasClass
	' ABM.AddClass
	' ABM.RemoveClass
	' ABM.AddHTML
	' ABM.InsertHTMLAfter
	' ABM.RemoveHTML
	' ABM.GetProperty
	' ABM.SetProperty
	' ABM.RemoveProperty
	' ABM.GetStyleProperty
	' ABM.SetStyleProperty
	'set chart properties
	' do some script stuff like you do in RunJavaScript
	'InternalPage.ws.Eval(HTML, Null)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

'build the html of the kanban board for rendering
private Sub Build(xid As String) As String
	Dim ePills As HTMLElement
	ePills.Initialize(xid,"ul")
	ePills.AddClass("nav")
	ePills.AddClass("nav-pills")
	ePills.AddClass(Theme)
	If bStacked = True Then ePills.AddClass("nav-stacked")
	If bHasIcons = True Then ePills.AddClass("nav-pills-icons")
	ePills.AddAttribute("role","tablist",True)

	For Each strPill As String In Pills
		ePills.AddContent(strPill)
	Next
	'return the pills
	Return ePills.HTML
End Sub

private Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim xPos As Int: xPos = sValue.IndexOf(Delimiter)
	If xPos = -1 Then Return sValue
	Dim mValues() As String
	Dim tValues As Int
	If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
	mValues = Regex.split(Delimiter, sValue)
	tValues = mValues.Length -1
	Select Case iPosition
	Case -1
		Return mValues(tValues)
	Case -2
		Return mValues(tValues - 1)
	Case Else
		iPosition = iPosition - 1
		If iPosition <= -1 Then Return mValues(tValues)
		If iPosition > tValues Then Return ""
		Return mValues(iPosition)
	End Select
End Sub