﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Public ID As String
	Public ElementType As String
	Private properties As Map
	Private Contents As List
	Public Styles As List
	Private cssFiles As List
	Private classes As Map
	Private jsCode As List
	Private style As Map
	Private SingleQuote As List
	Private MetaContent As List
	Private LooseAttributes As List
	Public Required As Boolean
	Public Enabled As Boolean
	Public ReadOnly As Boolean
	Public NoValidate As Boolean
	Public Inline As Boolean
	Private Prefix As String
	Public DoAProperClose As Boolean
	Private metas As List
	Private jsfiles As List
	Public ForeColor As String
	Public ForeColorIntensity As String
	Public BackColor As String
	Public BackColorIntensity As String
	Private divider As String
	Private DontBreak As List
	Private OnClickCode As List
	Private OnDoubleClickCode As List
	Private sbMaster As StringBuilder
	Public Parent As HTMLElement
	Private PropName As String
	Type BorderStyleType(bDefault As String, bDashed As String, bDotted As String, bDouble As String, bGroove As String, bHidden As String, bInset As String, bNone As String, bOutset As String, bRidge As String, bSolid As String)
	Public EnumBorderStyle As BorderStyleType
	Private ExternalStyle As Map
	Private sParentID As String
End Sub

Sub GetCssStyle(sClassName As String) As String
	Return ExternalStyle.Get(sClassName)
End Sub

Sub MaterialGetTheme(sTheme As String) As String
	Dim sHBackColor As String = ""
	Dim sHForeColor As String = ""
	sHBackColor = MashPlugIns.GetBackColorFromTheme(sTheme)
	sHForeColor = MashPlugIns.GetForeColorFromTheme(sTheme)
	Return $" ${sHBackColor} ${sHForeColor} "$
End Sub

Sub AddCSSClassProperties(sProperties As String) As HTMLElement
	AddExternalStyle(ID,sProperties)
	Return Me
End Sub

Sub AddCSSClass(sClass As String, sProperties As String) As HTMLElement
	AddExternalStyle(sClass,sProperties)
	Return Me
End Sub

'add a style to be used across the project
Sub AddExternalStyle(styleName As String, content As String) As HTMLElement
	styleName = styleName.trim
	Dim scontent As String
	If ExternalStyle.ContainsKey(styleName) Then
		scontent = ExternalStyle.Get(styleName)
		scontent = scontent & ";" & content
		ExternalStyle.Put(styleName,scontent)
	Else
		ExternalStyle.Put(styleName,content)
	End If
	Return Me
End Sub

Sub RemoveExternalStyle(styleName As String, styleProp As String)
	styleName = styleName.trim
	Dim scontent As String
	If ExternalStyle.ContainsKey(styleName) Then
		scontent = ExternalStyle.Get(styleName)
		Dim spProps() As String = StrParse(";",scontent)
		Dim nList As List
		nList.initialize
		For Each strPropValue As String In spProps
			strPropValue = strPropValue.Trim
			Dim strProp As String = MvField(strPropValue,1,":")
			Dim strValue As String = MvField(strPropValue,2,":")
			strProp = strProp.Trim
			strValue = strValue.trim
			If styleProp.EqualsIgnoreCase(strProp) = False Then
				Dim nLine As String = $"${strProp}:${strValue}"$
				nList.Add(nLine)
			End If
		Next
		scontent = MvFromList(nList,";")
		ExternalStyle.Put(styleName,scontent)
	End If
End Sub

Sub RightAlign() As HTMLElement
	AddClass("right")
	Return Me
End Sub

Sub CenterAlign() As HTMLElement
	AddClass("center")
	Return Me
End Sub

'set this element to a column and set the sizes for all devices
Sub MaterialSetSizes(Small As Int, Medium As Int, Large As Int) As HTMLElement
	AddClass("col").addClass("s" & Small).addclass("m" & Medium).addclass("l" & Large)
	Return Me
End Sub

'set this element to a column and set the offsets for all devices
Sub MaterialSetOffsets(Small As Int, Medium As Int, Large As Int) As HTMLElement
	AddClass("col").AddClassOnValue(Small,"offset-s" & Small).AddClassOnValue(Medium,"offset-m" & Medium).AddClassOnValue(Large,"offset-l" & Large)
	Return Me
End Sub

Sub SetMargins(etop As String, ebottom As String, eleft As String, eright As String) As HTMLElement
	SetMARGINTOP(etop).SetMARGINBOTTOM(ebottom).SetMARGINLEFT(eleft).SetMARGINRIGHT(eright)
	Return Me
End Sub

Sub SetBorderRadiuses(etopleft As String, ebottomleft As String, etopright As String, ebottomright As String) As HTMLElement
	SetBorderTopLeftRadius(etopleft)
	SetBorderTopRightRadius(etopright)
	SetBorderBottomLeftRadius(ebottomleft)
	SetBorderBottomRightRadius(ebottomright)
	Return Me
End Sub

Sub SetPaddings(etop As String, ebottom As String, eleft As String, eright As String) As HTMLElement
	SetPADDINGLEFT(eleft).SetPADDINGRIGHT(eright).SetPADDINGTOP(etop).SetPADDINGBOTTOM(eright)
	Return Me
End Sub

'use the theme based on a condition
Sub MaterialUseThemeOnCondition(bStatus As Boolean, themeName As String) As HTMLElement
	MashPlugIns.MaterialUseThemeOnCondition(bStatus,themeName,Me)
	Return Me
End Sub

Sub MaterialUseReversedTheme(sTheme As String) As HTMLElement
	MashPlugIns.MaterialUseReversedTheme(sTheme,Me)
	Return Me
End Sub

Sub MaterialUseTheme(sTheme As String) As HTMLElement
	MashPlugIns.MaterialUseTheme(sTheme,Me)
	Return Me
End Sub

Sub MaterialAddBadge(page As ABMPage, sText As String, bNew As Boolean, sVisibility As String, bCircle As Boolean, sTheme As String, bAddClass1 As Boolean,sStyle As String,bSecondary As Boolean) As HTMLElement
	Dim badge As MashBadge
	badge.Initialize(page,ID & "badge",sTheme)
	badge.Circle = bCircle
	badge.Text = sText
	badge.IsNew = bNew
	badge.Visibility = sVisibility
	badge.Theme = sTheme
	badge.Element.applystyle(sStyle)
	badge.element.MaterialSecondaryContent(bSecondary)
	If bAddClass1 = True Then
		badge.Element.AddClass("badge1")
		badge.Element.RemoveClass("badge")
	End If
	AddContent(badge.html)
	Return Me
End Sub


Sub SetID(sID As String) As HTMLElement
	ID = sID
	Return Me
End Sub

Sub StylesFromMap(mp As Map) As HTMLElement
	For Each strKey As String In mp.Keys
		Dim strValue As String = mp.Get(strKey)
		AddStyleAttribute(strKey,strValue)
	Next
	Return Me
End Sub

Sub PropertiesFromMap(mp As Map) As HTMLElement
	For Each strKey As String In mp.Keys
		Dim strValue As String = mp.Get(strKey)
		AddProperty(strKey,strValue)
	Next
	Return Me
End Sub

Sub AddChildElement(ofType As String) As HTMLElement
	Dim el As HTMLElement
	el = el.Initialize("",ofType)
	el.Parent = Me
	Return el 
End Sub

Sub Pop() As HTMLElement
	Parent.AddElement(Me)
	Return Parent
End Sub

Sub MaterialCreateColumn() As HTMLElement
	Dim row As HTMLElement
	row = row.CreateDIV("").AddClass("col")
	row.Parent = Me
	Return row
End Sub

Sub MaterialCreateRow() As HTMLElement
	Dim row As HTMLElement
	row = row.CreateDIV("").AddClass("row")
	row.Parent = Me
	Return row
End Sub

Sub MaterialAddSimpleDivider() As HTMLElement
	Dim dividerx As HTMLElement
	dividerx = dividerx.creatediv("").addclass("divider")
	AddContent(dividerx.html)
	Return Me
End Sub

Sub JQueryAnimate(animationType As String, bInfinity As Boolean, bAfter As String) As String
	Dim inf As String = ""
	If bInfinity = True Then inf = "infinite"
	Dim script As String = $"$('#${ID}').addClass('animated ${inf} ${animationType}').one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend',
	function() { $(this).removeClass('animated ${inf} ${animationType}');
	${bAfter}
	});"$
	Return script
End Sub

Sub JQueryHideSlow() As String
	Return $"$('#${ID}').hide("slow");"$
End Sub

Sub JQueryHide() As String
	Return $"$('#${ID}').hide();"$
End Sub

Sub JQueryFadeOutSlow() As String
	Return $"$('#${ID}').fadeOut('slow');"$
End Sub

public Sub MaterialAddImage(imgURL As String, imgAlt As String, imgHeight As String, imgWidth As String, imgCircle As Boolean, imgResponsive As Boolean, topMargin As String, bMaterialBoxed As Boolean, bStatic As Boolean,imgStyle As String) As HTMLElement
	If imgURL.Length > 0 Then
		Dim img As HTMLElement
		img.Initialize(ID & "img","img")
		img.MaterialCircle(imgCircle)
		img.SetAlt(imgAlt)
		img.SetSrc(imgURL,bStatic)
		img.MaterialResponsive(imgResponsive)
		img.MaterialBoxed(bMaterialBoxed)
		img.MaterialWavesEffect(True)
		img.setheight(imgHeight)
		img.setwidth(imgWidth)
		img.SetMarginTop(topMargin)
		img.ApplyStyle(imgStyle)
		AddContent(img.HTML.Replace(CRLF,""))
	End If
	Return Me
End Sub


Sub FixDelimiter(sValue As String) As String
	If sValue = "|" Then sValue = "\|"
	If sValue = "." Then sValue = "\."
	If sValue = "\" Then sValue = "\\"
	If sValue = "^" Then sValue = "\^"
	If sValue = "$" Then sValue = "\$"
	If sValue = "?" Then sValue = "\?"
	If sValue = "*" Then sValue = "\*"
	If sValue = "+" Then sValue = "\+"
	If sValue = "(" Then sValue = "\("
	If sValue = ")" Then sValue = "\)"
	If sValue = "[" Then sValue = "\["
	If sValue = "{" Then sValue = "\{"
	If sValue = ";" Then sValue = "\;"
	Return sValue
End Sub

Sub StrParse(Delimiter As String, MV As String) As String()
	Delimiter = FixDelimiter(Delimiter)
	Return Regex.Split(Delimiter, MV)
End Sub

Sub ApplyStyle(sStyle As String) As HTMLElement
	'we expect a delimited string with ;
	sStyle = sStyle.trim
	sStyle = RemDelim(sStyle,";")
	Dim pieces() As String = StrParse(";",sStyle)
	For Each strPiece As String In pieces
		Dim attr As String = MvField(strPiece,1,":")
		Dim val As String = MvField(strPiece,2,":")
		attr = attr.trim
		val = val.trim
		If attr <> "" Then AddStyleAttribute(attr,val)
	Next
	Return Me
End Sub

Sub AddSpace() As HTMLElement
	AddContent("{NBSP}")
	Return Me
End Sub

'add a click event to any element on the page
Sub AddClickEvent(compID As String,compText As String) As String
	Return AddClickEventCode(compID,compText,"")
End Sub

'add a click event to any element on the page
Sub AddClickEventCode(compID As String,compText As String,sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"$(function() {"$)
	sb.Append($"$('#${compID}').click(function(){"$)
	sb.append(sCode)
	sb.Append($"b4j_raiseEvent('${compID}_click', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub


'Sub AddChildClickEvent(parentID As String, compID As String,compText As String) As String
'	Return AddChildClickEventCode(parentID,compID,compText,"")
'End Sub

Sub AddChildClickEventCode(ParentID As String, compID As String,compText As String,sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"$(function() {"$)
	sb.Append($"$('#${compID}').click(function(){"$)
	sb.Append(sCode)
	sb.Append($"b4j_raiseEvent('${ParentID}_click', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub


Sub AddChangeEvent(ParentID As String, compID As String,compText As String) As String
	Return AddChangeEventCode(ParentID,compID,compText,"")
End Sub

Sub AddChangeEventCode(ParentID As String, compID As String,compText As String, sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"$(function() {"$)
	sb.Append($"$('#${compID}').change(function(){"$)
	sb.Append($"var thisCheck = $(this);"$)
	sb.Append($"var bchecked = thisCheck.is(':checked');"$)
	sb.Append(sCode)
	sb.Append($"b4j_raiseEvent('${ParentID}_change', {'value':'${compText}.' + bchecked});"$)
	sb.Append("});").Append(CRLF)
	sb.Append("});")
	Return sb.ToString
End Sub

Sub MoveUp(sTop As String) As HTMLElement
	SetMARGINTOP(sTop)
	AddStyleAttribute("z-index","9999")
	Return Me
End Sub

Sub MaterialWavesLight(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"waves-light")
	Return Me
End Sub

Sub MaterialTextTheme(sColor As String, sIntensity As String) As HTMLElement
	MaterialTextColor(sColor)
	MaterialTextIntensity(sIntensity)
	Return Me
End Sub

Sub MaterialTextIntensity(sIntensity As String) As HTMLElement
	sIntensity = sIntensity.trim
	If sIntensity = "" Then Return Me
	If sIntensity.startswith("text-") = False Then sIntensity = "text-" & sIntensity
	AddClass(sIntensity)
	Return Me
End Sub

Sub MaterialTextColor(sColor As String) As HTMLElement
	sColor = sColor.trim
	If sColor = "" Then Return Me
	If sColor.EndsWith("-text") = False Then sColor = sColor & "-text"
	AddClass(sColor)
	Return Me
End Sub


Sub MaterialCardImage(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"card-image")
	Return Me
End Sub

Sub MaterialCard(bStatus As Boolean) As HTMLElement 
	AddClassOnCondition(bStatus,"card")
	Return Me
End Sub

Sub MaterialCardContent(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"card-content")
	Return Me
End Sub

Sub MaterialCardReveal(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"card-reveal")
	Return Me
End Sub

Sub AddOnDoubleClickEvent(sCode As String) As HTMLElement
	OnDoubleClickCode.Add(sCode)
	Return Me
End Sub


Sub InQuoteHash(sValue As String) As String
	Return InQuotes(InHash(sValue))
End Sub

Sub InHash(sValue As String) As String
	Return "#" & sValue & "#"
End Sub

Sub InSingleQuotes(sValue As String) As String
	Return "'" & sValue & "'"
End Sub

Sub AddOnClickEvent(sCode As String) As HTMLElement
	OnClickCode.Add(sCode)
	Return Me
End Sub

Sub CreateLINK(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"link")
	el.Parent = Me
	Return el
End Sub

Sub SetONSUBMIT(sOnSubmit As String) As HTMLElement
	AddAttribute("onsubmit",sOnSubmit,True)
	Return Me
End Sub

Sub SetMETHOD(sMethod As String) As HTMLElement
	AddAttribute("method",sMethod,True)
	Return Me
End Sub


Sub SetDISABLED() As HTMLElement
	AddAttribute("disabled","disabled",True)
	Return Me
End Sub

Sub SetCHECKED() As HTMLElement
	AddAttribute("checked","checked",True)	
	Return Me
End Sub

Sub SetFOR(sFor As String) As HTMLElement
	AddAttribute("for",sFor,True)
	Return Me
End Sub

Sub CreateBUTTON( sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"button")
	el.AddProperty("type","button")
	el.AddClass("btn")
	el.Parent = Me
	Return el
End Sub


Sub CreateOPTION(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"option")
	el.Parent = Me
	Return el
End Sub


Sub CreateSELECT(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"select")
	el.Parent = Me
	Return el
End Sub

Sub CreateLABEL( sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"label")
	el.parent = Me
	Return el
End Sub

Sub CreateTEXTAREA( sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"textarea")
	el.Parent = Me
	Return el
End Sub

Sub CreateINPUT(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"input")
	el.Parent = Me
	Return el
End Sub

Sub CreateQ(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"q")
	el.Parent = Me
	Return el
End Sub

Sub CreateH1(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"h1")
	el.Parent = Me
	Return el
End Sub

Sub CreateBLOCKQUOTE( sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"blockquote")
	el.Parent = Me
	Return el
End Sub

Sub CreateSTRONG( sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"strong")
	el.Parent = Me
	Return el
End Sub

Sub CreateADDRESS(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"address")
	el.Parent = Me
	Return el
End Sub

Sub CreateSMALL(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"small")
	el.Parent = Me
	Return el
End Sub

Sub CreateNAV(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"nav")
	el.Parent = Me
	Return el
End Sub


Sub CreateBDO(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"bdo")
	el.Parent = Me
	Return el
End Sub

Sub CreateSUP(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"sup")
	el.Parent = Me
	Return el
End Sub

Sub CreateSUB(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"sub")
	el.Parent = Me
	Return el
End Sub

Sub AddSup(sContent As String) As HTMLElement
	Dim sup As HTMLElement
	sup = sup.CreateSUP("").AddContent(sContent)
	sup.Parent = Me
	AddElement(sup)
	Return Me
End Sub

Sub AddSub(sContent As String) As HTMLElement
	Dim subx As HTMLElement
	subx = subx.CreateSUB("").AddContent(sContent)
	subx.Parent = Me
	AddElement(subx)
	Return Me
End Sub

Sub CreateABBR(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"abbr")
	el.Parent = Me
	Return el
End Sub


Sub CreateCAPTION(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"caption")
	el.Parent = Me
	Return el
End Sub

Sub CreateSECTION(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"section")
	el.Parent = Me
	Return el
End Sub


Sub CreateCODE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"code")
	el.Parent = Me
	Return el
End Sub

Sub CreateSAMP(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"samp")
	el.Parent = Me
	Return el
End Sub

Sub CreateKBD(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"kbd")
	el.Parent = Me
	Return el
End Sub


Sub CreateARTICLE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"article")
	el.Parent = Me
	Return el
End Sub

Sub CreateFOOTER(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"footer")
	el.Parent = Me
	Return el
End Sub

Sub CreateASIDE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"aside")
	el.Parent = Me
	Return el
End Sub

Sub CreateBODY(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"body")
	el.Parent = Me
	Return el
End Sub

Sub CreateTITLE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"title")
	el.Parent = Me
	Return el
End Sub


Sub CreateTABLE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"table")
	el.Parent = Me
	Return el
End Sub

Sub CreateTR(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"tr")
	el.Parent = Me
	Return el
End Sub


Sub CreateTD(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"td")
	el.Parent = Me
	Return el
End Sub

Sub CreateTH(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"th")
	el.Parent = Me
	Return el
End Sub

Sub CreateDL(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"dl")
	el.parent = Me
	Return el
End Sub



Sub CreateIFRAME(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"iframe")
	el.Parent = Me
	Return el
End Sub

Sub CreateSPAN(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"span")
	el.Parent = Me
	Return el
End Sub

Sub CreateFORM(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"form")
	el.Parent = Me
	Return el
End Sub

Sub CreateDT(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"dt")
	el.Parent = Me
	Return el
End Sub


Sub CreateDD(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"dd")
	el.Parent = Me
	Return el
End Sub

Sub CreateH2(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"h2")
	el.Parent = Me
	Return el
End Sub


Sub CreateH3(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"h3")
	el.Parent = Me
	Return el
End Sub

Sub CreateH4(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"h4")
	el.Parent = Me
	Return el
End Sub


Sub CreateH5(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"h5")
	el.Parent = Me
	Return el
End Sub


Sub CreatePRE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"pre")
	el.Parent = Me
	Return el
End Sub

Sub CreateH6(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"h6")
	el.Parent = Me
	Return el
End Sub

Sub AddLineBreak As HTMLElement
	AddContent("<br/>")
	Return Me
End Sub


Sub AddHorizontalRule As HTMLElement
	AddContent("<hr/>")
	Return Me
End Sub

Sub CreateHEAD(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"head")
	el.Parent = Me
	Return el
End Sub


Sub CreateSCRIPT( sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"script")
	el.Parent = Me
	Return el
End Sub

Sub CreateCSSClass(sClassID As String) As HTMLElement
	Return CreateSTYLE(sClassID)
End Sub

Sub CreateSTYLE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"style")
	el.Parent = Me
	Return el
End Sub

Sub CreateBASE(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"base")
	el.Parent = Me
	Return el
End Sub


Sub CreateHTML(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"html")
	el.Parent = Me
	Return el
End Sub

Sub CreateIMG(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"img")
	el.Parent = Me
	Return el
End Sub


Sub CreateMETA(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"meta")
	el.Parent = Me
	Return el
End Sub

Sub CreateP(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID, "p")
	el.Parent = Me
	Return el
End Sub

Sub CreateDIV(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"div")
	el.Parent = Me
	Return el
End Sub

Sub CreateA(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"a")
	el.Parent = Me
	Return el
End Sub


Sub CreateI(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"i")
	el.Parent = Me
	Return el
End Sub

Sub CreateLI(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"li")
	el.Parent = Me
	Return el
End Sub


Sub CreateOL( sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"ol")
	el.Parent = Me
	Return el
End Sub

Sub CreateUL(sID As String) As HTMLElement
	Dim el As HTMLElement
	el.Initialize(sID,"ul")
	el.Parent = Me
	Return el
End Sub

Sub AddParagraph(sContent As String) As HTMLElement
	Dim p As HTMLElement
	p.Initialize("","p")
	p.AddContent(sContent)
	AddContent(p.HTML)
	Return Me
End Sub


Sub AddQuote(sContent As String) As HTMLElement
	Dim title As HTMLElement
	title.Initialize("","q")
	title.AddContent(sContent)
	title.Parent = Me
	Return Me
End Sub


Sub AddTitle(sContent As String) As HTMLElement
	Dim title As HTMLElement
	title.Initialize("","title")
	title.AddContent(sContent)
	title.Parent = Me
	Return Me
End Sub


Sub AddAnchor(href As String, sContent As String) As HTMLElement
	Dim hdr As HTMLElement
	hdr.Initialize("","a").SetHREF(href).AddContent(sContent)
	AddContent(hdr.HTML)
	Return Me
End Sub

Sub AddHeading(sSize As Int, sContent As String) As HTMLElement
	Dim hdr As HTMLElement
	Dim hKey As String = "h" & sSize
	hdr.Initialize("",hKey)
	hdr.AddContent(sContent)
	AddContent(hdr.HTML)
	Return Me
End Sub

Sub SetTITLE(sValue As String) As HTMLElement
	AddAttribute("title", sValue,True)
	Return Me
End Sub

Sub SetLANG(sValue As String) As HTMLElement
	AddAttribute("lang", sValue,True)
	Return Me
End Sub


Sub SetMargin(sMargin As String) As HTMLElement
	AddStyleAttribute("margin",MakePx(sMargin))
	Return Me
End Sub

Sub SetHEIGHT(sHeight As String) As HTMLElement
	AddAttribute("height",MakePx(sHeight),True)
	Return Me
End Sub

Sub SetTEXTALIGN(sAlign As String) As HTMLElement
	AddAttribute("text-align", sAlign,True)
	Return Me
End Sub

Sub SetWIDTH(sWidth As String) As HTMLElement
	AddAttribute("width",MakePx(sWidth),True)
	Return Me
End Sub

Sub SetCITE(sWidth As String) As HTMLElement
	AddAttribute("cite",sWidth,True)
	Return Me
End Sub

Sub SetStyleHEIGHT(sHeight As String) As HTMLElement
	AddStyleAttribute("height",MakePx(sHeight))
	Return Me
End Sub

Sub SetStyleWIDTH(sWidth As String) As HTMLElement
	AddStyleAttribute("width",MakePx(sWidth))
	Return Me
End Sub

private Sub MakePx(sValue As String) As String
	sValue = sValue.Trim
	If sValue.EndsWith("px") Then sValue.Replace("px","")
	sValue = $"${sValue}px"$
	If sValue = "px" Then sValue = ""
	Return sValue
End Sub


Sub MaterialClose(bStatus As String) As HTMLElement
	AddClassOnCondition(bStatus,"close")
	Return Me
End Sub

Sub MaterialBoxed(bStatus As String) As HTMLElement
	AddClassOnCondition(bStatus,"materialboxed")
	Return Me
End Sub

Sub MaterialIconSize(sSize As String) As HTMLElement
	RemoveClass("large").RemoveClass("tiny").RemoveClass("small").RemoveClass("medium")
	AddClass(sSize)	
	Return Me
End Sub

Sub MaterialAddIconSimple(iconName As String,sTheme As String) As HTMLElement
	MaterialAddIcon(iconName,"",sTheme,False,False,False,False,False,"")
	Return Me
End Sub

Sub MaterialGetIcon(IconName As String, iconPos As String, IconTheme As String, IconCircle As Boolean, bWave As Boolean, bCursor As Boolean, bPrefix As Boolean, bClose As Boolean, iconStyle As String) As String
	'check if floating buttons and make icon a circle
	If ClassExists("fixed-action-btn") = True Then
		IconCircle = True
	else if ClassExists("halfway-fab") = True Then
		IconCircle = True
	else if ClassExists("btn-floating") = True Then
		IconCircle = True
	End If
	If IconName.Length > 0 Then
		Dim icn As HTMLElement
		icn.Initialize(ID & "icon","i")
		icn.MaterialUseTheme(IconTheme)
		icn.MaterialBuildIcon(IconName, iconPos)
		icn.MaterialCircle(IconCircle)
		'leave this true for proper alignment
		icn.MaterialWavesEffect(True)
		icn.AddClassOnCondition(bPrefix,"prefix")
		icn.MaterialWavesType("")
		icn.MaterialWavesCircle(False)
		icn.MaterialWavesEffect(bWave)
		icn.MaterialIconSize("")
		icn.MaterialClose(bClose)
		icn.ApplyStyle(iconStyle)
		If bCursor = True Then icn.addcursor
		Return icn.html.Replace(CRLF,"")
	End If
	Return ""
End Sub


Sub MaterialAddIcon(IconName As String, iconPos As String, IconTheme As String, IconCircle As Boolean, bWave As Boolean, bCursor As Boolean, bPrefix As Boolean, bClose As Boolean, iconStyle As String) As HTMLElement
	'check if floating buttons and make icon a circle
	Dim icn As String = MaterialGetIcon(IconName,iconPos,IconTheme,IconCircle,bWave,bCursor,bPrefix,bClose,iconStyle)
	AddContent(icn)
	Return Me
End Sub

Sub MaterialAddDivider(sVisibility As String, themeName As String) As HTMLElement
	Dim li As HTMLElement
	li.Initialize("","li").AddClass("divider")
	li.MaterialVisibility(sVisibility)
	divider = li.html
	Return Me
End Sub

Sub MaterialGetDivider(sVisibility As String) As String
	Dim li As HTMLElement
	li.Initialize("","li").AddClass("divider")
	li.MaterialVisibility(sVisibility)
	Return li.html
End Sub

Sub SetHREF(href As String) As HTMLElement
	AddAttribute("href",href,False)
	Return Me
End Sub

Sub MaterialWavesType(sType As String) As HTMLElement
	RemoveClass("waves-green").RemoveClass("waves-light").RemoveClass("waves-orange")
	RemoveClass("waves-purple").RemoveClass("waves-red").RemoveClass("waves-teal").RemoveClass("waves-yellow")
	AddClass(sType)
	Return Me
End Sub

Sub MaterialWavesCircle(bStatus As Boolean) As HTMLElement
	RemoveClass("waves-circle").RemoveClass("waves-block")
	If bStatus = True Then
		AddClass("waves-circle")
	End If
	Return Me
End Sub

Sub MaterialWavesBlock(bStatus As Boolean) As HTMLElement
	RemoveClass("waves-circle").RemoveClass("waves-block")
	If bStatus = True Then
		AddClass("waves-block")
	End If
	Return Me
End Sub

Sub MaterialAddDividerOnCondition(bStatus As Boolean, sVisibility As String, themeName As String) As HTMLElement
	If bStatus = True Then 
		MaterialAddDivider(sVisibility,themeName)
	End If
	Return Me
End Sub

Sub MaterialSetToolTip(position As String, delay As String, tooltip As String) As HTMLElement
	If tooltip.Length > 0 Then
		AddClass("tooltipped").AddAttribute("data-position",position,True)
		AddAttribute("data-delay",delay,True).AddAttribute("data-tooltip",tooltip,True)
	Else
		RemoveClass("tooltipped").RemoveClass("data-position").RemoveClass("data-delay").RemoveClass("data-tooltip")
	End If
	Return Me
End Sub

Sub AddCursor As HTMLElement
	AddStyleAttribute("cursor", "pointer")
	Return Me
End Sub

Sub AddContentMap(m As Map) As HTMLElement
	For Each strKey As String In m.keys
		Dim strValue As String = m.Get(strKey)
		AddContent(strValue)
	Next
	Return Me
End Sub

Sub AddContentList(lst As List) As HTMLElement
	For Each strContent As String In lst
		AddContent(strContent)
	Next
	Return Me
End Sub

Sub SetTYPE(sValue As String) As HTMLElement
	AddAttribute("type",sValue,True)
	Return Me
End Sub


Sub SetMAX(sValue As String) As HTMLElement
	AddAttribute("max",sValue,True)
	Return Me
End Sub


Sub SetMIN(sValue As String) As HTMLElement
	AddAttribute("min",sValue,True)
	Return Me
End Sub

Sub SetSTEP(sValue As String) As HTMLElement
	AddAttribute("step",sValue,True)
	Return Me
End Sub


Sub SetCOLSPAN(sValue As String) As HTMLElement
	AddAttribute("colspan",sValue,True)
	Return Me
End Sub

Sub SetROWSPAN(sValue As String) As HTMLElement
	AddAttribute("rowspan",sValue,True)
	Return Me
End Sub

Sub SetFontSize(fSize As Int) As HTMLElement
	Dim sSize As String = fSize & "pt"
	Return AddStyleAttribute("font-size", sSize)
End Sub

Sub SetFontName(fName As String) As HTMLElement
	Return AddStyleAttribute("font-family", fName)
End Sub

Sub SetMailTo(sEmail As String) As HTMLElement
	sEmail = $"mailto:${sEmail}"$
	SetHREF(sEmail)
	Return Me
End Sub

Sub SetONCLICK(sValue As String) As HTMLElement
	AddAttribute("onclick",sValue,True)
	Return Me
End Sub

Sub SetZIndex(zindex As String) As HTMLElement
	AddStyleAttribute("z-index",zindex)
	Return Me
End Sub


Sub SetACTION(sValue As String) As HTMLElement
	AddAttribute("action",sValue,True)
	Return Me
End Sub

Sub SetBORDER(sValue As String) As HTMLElement
	AddStyleAttributeBorder(sValue)
	Return Me
End Sub

Sub SetBorderRadius(sRadius As String) As HTMLElement
	AddStyleAttribute("border-radius",MakePx(sRadius))
	Return Me
End Sub

Sub SetROLE(sValue As String) As HTMLElement
	AddAttribute("role",sValue,True)
	Return Me
End Sub

Sub SetAUTOCOMPLETE(sValue As String) As HTMLElement
	AddAttribute("autocomplete",sValue,True)
	Return Me
End Sub


Sub SetMAXLENGTH(sValue As String) As HTMLElement
	AddAttribute("maxlength",sValue,True)
	Return Me
End Sub

Sub SetSIZE(sValue As String) As HTMLElement
	AddAttribute("size",sValue,True)
	Return Me
End Sub

Sub SetVALUE(sValue As String) As HTMLElement
	AddAttribute("value",sValue,True)
	Return Me
End Sub

Sub SetALT(sValue As String) As HTMLElement
	AddAttribute("alt",sValue,True)
	Return Me
End Sub

Sub SetSTYLE(sValue As String) As HTMLElement
	AddAttribute("style",sValue,True)
	Return Me
End Sub

Sub SetTARGET(sValue As String) As HTMLElement
	AddAttribute("target",sValue,True)
	Return Me
End Sub

Sub SetTARGET_BLANK() As HTMLElement
	AddAttribute("target","_blank",True)
	Return Me
End Sub


Sub SetTARGET_SELF() As HTMLElement
	AddAttribute("target","_self",True)
	Return Me
End Sub


Sub SetTARGET_PARENT() As HTMLElement
	AddAttribute("target","_parent",True)
	Return Me
End Sub

Sub SetTARGET_TOP() As HTMLElement
	AddAttribute("target","_top",True)
	Return Me
End Sub

Sub SetREL(sValue As String) As HTMLElement
	AddAttribute("rel",sValue,True)
	Return Me
End Sub

Sub SetSRC(sValue As String, Static As Boolean) As HTMLElement
	Dim tmpFile As String = MashPlugIns.MvField(sValue,1,"?")
	If Static = True Then
		sValue = tmpFile
	Else
		sValue = tmpFile & "?" & DateTime.now
	End If
	AddAttribute("src",sValue,True)
	Return Me
End Sub

Sub Enclose(OfType As String) As String
	Return $"<${OfType}>${HTML}</${OfType}>"$
End Sub

Sub AddClassOnValue(iValue As Int, sClass As String) As HTMLElement
	If iValue > 0 Then
		AddClass(sClass)
	End If
End Sub

Sub AddClassOnCondition(bCondition As Boolean, sClass As String) As HTMLElement
	RemoveClass(sClass)
	If bCondition = True Then AddClass(sClass)
	Return Me
End Sub

Sub RemoveClassOnCondition(bCondition As Boolean, sClass As String) As HTMLElement
	If bCondition = True Then RemoveClass(sClass)
	Return Me	
End Sub


Sub RemoveClassOnFalseCondition(bCondition As Boolean, sClass As String) As HTMLElement
	If bCondition = False Then RemoveClass(sClass)
	Return Me	
End Sub

Sub SetNAME(sName As String) As HTMLElement
	AddAttribute("name",sName,True)
	Return Me
End Sub

Sub MaterialWavesEffect(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"waves-effect")
	Return Me
End Sub

Sub MaterialHorizontal(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"horizontal")
	Return Me
End Sub

Sub MaterialToolBar(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"toolbar")
	Return Me
End Sub

Sub MaterialClick2Toggle(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"click-to-toggle")
	Return Me
End Sub


Sub MaterialButtonFloating(bStatus As Boolean) As HTMLElement
	RemoveClass("fixed-action-btn")
	RemoveClass("btn-flat")
	RemoveClass("btn-raised")
	RemoveClass("halfway-fab")
	AddClassOnCondition(bStatus,"btn-floating")
	Return Me
End Sub

Sub MaterialButton(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"btn")
	Return Me
End Sub

Sub MaterialPulse(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"pulse")
	Return Me
End Sub

Sub MaterialCircle(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"circle")
	Return Me
End Sub


Sub MaterialCardSize(sSize As String) As HTMLElement
	RemoveClass("small").RemoveClass("medium").RemoveClass("large").AddClass(sSize)
	Return Me
End Sub

Sub MaterialButtonSize(sSize As String) As HTMLElement
	RemoveClass("btn-small").RemoveClass("btn-large").RemoveClass("btn-medium").AddClass(sSize)
	AddClass("btn")
	Return Me
End Sub

Sub MaterialHalfFAB(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"halfway-fab")
	AddClassOnCondition(bStatus,"btn-floating")
	Return Me
End Sub

Sub MaterialDismissable(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"dismissable")
	Return Me
End Sub

Sub MaterialButtonType(btnType As String) As HTMLElement
	RemoveClass("fixed-action-btn")
	RemoveClass("btn-flat")
	RemoveClass("btn-raised")
	RemoveClass("halfway-fab")
	RemoveClass("btn-floating")
	AddClass(btnType)
	Return Me
End Sub

Sub MaterialScaleIn(bStatus As Boolean) As HTMLElement
	RemoveClass("scale-transition").RemoveClass("scale-in").RemoveClass("scale-out")
	If bStatus = True Then
		AddClass("scale-transition").AddClass("scale-in")
	End If
	Return Me
End Sub

Sub MaterialScaleOut(bStatus As Boolean) As HTMLElement
	RemoveClass("scale-transition").RemoveClass("scale-in").RemoveClass("scale-out")
	If bStatus = True Then
		AddClass("scale-transition").AddClass("scale-out")
	End If
	Return Me
End Sub

Sub MaterialZDepth(szdepth As String) As HTMLElement
	'remove existing classes
	RemoveClass("z-depth-1").RemoveClass("z-depth-2").RemoveClass("z-depth-3").RemoveClass("z-depth-4").RemoveClass("z-depth-5").AddClass(szdepth)
	Return Me
End Sub

'get the color for this item
Sub MaterialGetColor(sColor As String, sIntensity As String) As String
	Dim sTheme As String
	sTheme = sColor & " " & sIntensity
	sTheme = sTheme.Trim
	Return sTheme
End Sub

Sub MaterialSetForeColor(sForeColor As String, sForeColorIntensity As String) As HTMLElement
	MaterialTextColor(sForeColor)
	MaterialTextIntensity(sForeColorIntensity)
	Return Me
End Sub

Sub MaterialSetBackgroundColor(BackgroundColor As String, BackgroundColorIntensity As String) As HTMLElement
	AddClass(BackgroundColor).AddClass(BackgroundColorIntensity)
	Return Me
End Sub

Sub MaterialActivator(bStatus As String) As HTMLElement
	AddClassOnCondition(bStatus,"activator")
	Return Me
End Sub

Sub MaterialCardTitle(bStatus As String) As HTMLElement
	AddClassOnCondition(bStatus,"card-title")
	Return Me
End Sub


Sub MaterialVerticalAlign(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"valign-wrapper")
	Return Me
End Sub

Sub MaterialVisibility(sVisibility As String) As HTMLElement
	RemoveClass("hide-on-small-only")
	RemoveClass("hide-on-med-only")
	RemoveClass("hide-on-med-and-down")
	RemoveClass("hide-on-med-and-up")
	RemoveClass("hide-on-large-only")
	RemoveClass("show-on-large")
	RemoveClass("show-on-small")
	RemoveClass("show-on-medium")
	RemoveClass("show-on-medium-and-up")
	RemoveClass("show-on-medium-and-down")
	RemoveClass("hide")
	AddClass(sVisibility)
	Return Me
End Sub	

Sub MaterialCollectionItem(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"collection-item")
	Return Me
End Sub

Sub MaterialModalClose() As HTMLElement
	AddClass("modal-action")
	AddClass("modal-close")
	Return Me
End Sub

Sub MaterialAvatar(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"avatar")
	Return Me
End Sub

Sub MaterialSecondaryContent(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"secondary-content")
	Return Me
End Sub

Sub MaterialCollectionHeader(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"collection-header")
	Return Me
End Sub


Sub MaterialCollapsibleHeader(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"collapsible-header")
	Return Me
End Sub

Sub MaterialHoverable(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"hoverable")
	Return Me
End Sub

Sub MaterialTruncate(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"truncate")
	Return Me
End Sub

Sub MaterialFloatLeft(bStatus As Boolean) As HTMLElement
	RemoveClass("right").RemoveClass("left")
	If bStatus = True Then
		AddClass("left")
	End If
	Return Me
End Sub

Sub MaterialFlowText(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"flow-text")
	Return Me
End Sub


Sub MaterialFloatRight(bStatus As Boolean) As HTMLElement
	RemoveClass("left").RemoveClass("right")
	If bStatus = True Then
		AddClass("right")
	End If
	Return Me
End Sub

Sub MaterialLeftAlignText(bStatus As Boolean) As HTMLElement
	RemoveClass("center-align").RemoveClass("right-align").RemoveClass("left-align")
	If bStatus = True Then
		AddClass("left-align")
	End If
	Return Me
End Sub

Sub MaterialCenterAlignText(bStatus As Boolean) As HTMLElement
	RemoveClass("center-align").RemoveClass("right-align").RemoveClass("left-align")
	If bStatus = True Then
		AddClass("center-align")
	End If
	Return Me
End Sub

Sub MaterialRightAlignText(bStatus As Boolean) As HTMLElement
	RemoveClass("center-align").RemoveClass("right-align").RemoveClass("left-align")
	If bStatus = True Then
		AddClass("right-align")
	End If
	Return Me
End Sub

Sub MaterialAlignText(sAlignment As String) As HTMLElement
	RemoveClass("center-align").RemoveClass("right-align").RemoveClass("left-align")
	AddClass(sAlignment)
	Return Me
End Sub

Sub AddComment(sComment As String) As HTMLElement
	Dim s As String = $"<!-- ${sComment} -->"$
	AddContent(s)
	AddContent(CRLF)
	Return Me
End Sub

Sub AddJSFile(src As String, bDefer As Boolean, basync As Boolean, bIE As Boolean) As HTMLElement
	Dim js As HTMLElement
	js.Initialize("","script")
	'js.AddAttribute("language","javascript")
	If basync = True Then js.AddLooseAttribute("async")
	If bDefer = True Then js.AddLooseAttribute("defer")
	'js.AddAttribute("type","text/js")
	js.AddAttribute("src", src,True)
	If bIE = True Then
		Dim sout As StringBuilder
		sout.Initialize
		sout.Append("<!--[if IE]>").Append(CRLF)
		sout.Append(js.HTML).Append(CRLF)
		sout.Append("<![endif]-->").Append(CRLF)
	End If
	jsfiles.Add(js.HTML)
	Return Me	
End Sub

Sub AddCSSFile(href As String) As HTMLElement
	Dim css As HTMLElement
	css.Initialize("","link")
	css.AddAttribute("href",href,True).AddAttribute("type","text/css",True).AddAttribute("rel","stylesheet",True)
	css.AddAttribute("media","screen",True)
	cssFiles.Add(css.HTML)
	Return Me
End Sub

Sub AddCSSLink(href As String) As HTMLElement
	Dim css As HTMLElement
	css.Initialize("","link")
	css.AddAttribute("href",href,True).AddAttribute("rel","stylesheet",True).AddAttribute("type","text/css",True)
	cssFiles.Add(css.HTML)
	Return Me
End Sub

Sub AddMetaData(sname As String, scontent As String, shttpequiv As String) As HTMLElement
	Dim meta As HTMLElement
	meta.Initialize("","meta")
	meta.AddAttribute("name", sname,False)
	meta.AddAttribute("content", scontent,False)
	meta.AddAttribute("http-equiv", shttpequiv,False)
	metas.Add(meta.HTML)
	Return Me
End Sub

Sub AddMetaExpiry(expiryDate As String) As HTMLElement
	Dim meta As HTMLElement
	meta.Initialize("","meta")
	meta.AddAttribute("http-equiv","expires",False)
	meta.AddAttribute("content", expiryDate,False)
	metas.Add(meta.HTML)
	Return Me
End Sub

Sub AddMetaDataProperty(sAttribute As String, sValue As String) As HTMLElement
	Dim meta As HTMLElement
	meta.Initialize("","meta")
	meta.AddAttribute(sAttribute,sValue,False)
	metas.Add(meta.HTML)
	Return Me
End Sub

Sub SetPrefix(sPrefix As String)  As HTMLElement
	Prefix = sPrefix
	Return Me
End Sub

'change the element type
Sub SetElementType(sElementType As String) As HTMLElement
	ElementType = sElementType
	Return Me
End Sub



'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(sid As String, sElementType As String) As HTMLElement
	ExternalStyle.initialize
	sbMaster.initialize
	sid = sid.tolowercase
	sParentID = ""
	DontBreak.Initialize
	OnClickCode.Initialize 
	OnDoubleClickCode.Initialize 
	DontBreak.Add("li")
	DontBreak.Add("a")
	DontBreak.Add("i")
	DontBreak.Add("span")
	DontBreak.Add("img")
	divider=""
	metas.Initialize 
	cssFiles.Initialize 
	jsfiles.Initialize 
	ElementType = sElementType
	style.Initialize
	ID = sid
	classes.Initialize 
	properties.Initialize
	Contents.Initialize 
	Styles.Initialize 
	jsCode.Initialize 
	SingleQuote.Initialize 
	MetaContent.Initialize 
	LooseAttributes.Initialize 
	Required = False
	Prefix = ""
	DoAProperClose = True
	Enabled = True
	ForeColor = ""
	ForeColorIntensity = ""
	BackColor = ""
	BackColorIntensity = ""
	PropName = sid
	EnumBorderStyle.Initialize
	EnumBorderStyle.bDashed= "dashed"
	EnumBorderStyle.bDefault= ""
	EnumBorderStyle.bDotted= "dotted"
	EnumBorderStyle.bDouble= "double"
	EnumBorderStyle.bGroove= "groove"
	EnumBorderStyle.bHidden= "hidden"
	EnumBorderStyle.bInset = "inset"
	EnumBorderStyle.bNone= "none"
	EnumBorderStyle.bOutset= "outset"
	EnumBorderStyle.bRidge= "ridge"
	EnumBorderStyle.bSolid= "solid"
	Return Me
End Sub

Sub GetComponentBuilder() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("<")
	If Prefix.Length > 0 Then
		sb.Append(Prefix).Append(" ")
	End If
	sb.Append(ElementType).Append(" ")
	If ID.Length > 0 Then
		sb.Append(ToProperty("id",ID))
	End If
	sb.Append(">")
	Select Case ElementType.ToLowerCase
		Case "img","link","meta","input","source"
			DoAProperClose = False
	End Select
	If DoAProperClose = True Then
		sb.Append("</").Append(ElementType).Append(">")
	End If
	Return sb.ToString.trim
End Sub

'render a string in quotes
Sub InQuotes(value As String) As String
	Return QUOTE & value & QUOTE
End Sub

' what is the lengths of the contents list of this element
Sub Size() As Int
	Return Contents.Size
End Sub

'clear the contents of this element
Sub ClearContent As HTMLElement
	Contents.clear
	Return Me
End Sub

'clear the styles of this element
Sub ClearStyles As HTMLElement
	Styles.Initialize 
	Return Me
End Sub

'clear the classes of this element
Sub ClearClasses As HTMLElement
	classes.Initialize 
	Return Me
End Sub

Sub SetFontFamily(sFontName As String) As HTMLElement
	AddStyleAttribute("font-family", sFontName)
	Return Me
End Sub

Sub SetPlaceholder(sPlaceholder As String) As HTMLElement
	AddStyleAttribute("placeholder", sPlaceholder)
	Return Me
End Sub


Sub SetFloat(sAlignment As String) As HTMLElement
	AddStyleAttribute("float", sAlignment)
	Return Me
End Sub

Sub AddStyleAttributeTextAlign(sAlignment As String) As HTMLElement
	AddStyleAttribute("text-align", sAlignment)
	Return Me
End Sub

Sub AddStyleAttributeBorder(sBorder As String) As HTMLElement
	AddStyleAttribute("border", sBorder)
	Return Me
End Sub

Sub AddStyleAttributeBorderRadius(sRadius As String) As HTMLElement
	AddStyleAttribute("border-radius", MakePx(sRadius))
	Return Me
End Sub

Sub SetBorderBottomRightRadius(sRadius As String) As HTMLElement
	AddStyleAttribute("border-bottom-right-radius", MakePx(sRadius))
	Return Me
End Sub

Sub SetBorderTopLeftRadius(sRadius As String) As HTMLElement
	AddStyleAttribute("border-top-left-radius", MakePx(sRadius))
	Return Me
End Sub

Sub SetBorderTopRightRadius(sRadius As String) As HTMLElement
	AddStyleAttribute("border-top-right-radius", MakePx(sRadius))
	Return Me
End Sub

Sub SetBorderStyle(sStyle As String) As HTMLElement
	If sStyle = "" Then Return Me
	AddStyleAttribute("border-style", sStyle)
	Return Me
End Sub


Sub SetBorderBottomLeftRadius(sRadius As String) As HTMLElement
	AddStyleAttribute("border-bottom-left-radius", MakePx(sRadius))
	Return Me
End Sub

Sub SetPadding(sPadding As String) As HTMLElement
	AddStyleAttribute("padding", MakePx(sPadding))
	Return Me
End Sub

Sub AddStyleAttributeBorderCollapse(sColorName As String) As HTMLElement
	AddStyleAttribute("border-collapse", sColorName)
	Return Me
End Sub

Sub AddStyleAttributeColor(sColorName As String) As HTMLElement
	AddStyleAttribute("color", sColorName)
	Return Me
End Sub

Sub AddStyleAttributeBackgroundColor(sColorName As String) As HTMLElement
	AddStyleAttribute("background-color", sColorName)
	Return Me
End Sub

Sub AddStyleAttributeFontSize(sFontSizePercentage As String) As HTMLElement
	AddStyleAttribute("font-size", sFontSizePercentage)
	Return Me
End Sub


Sub AddStyleAttribute(attribute As String, value As String) As HTMLElement
	attribute = attribute.Trim
	value = value.trim
	attribute = attribute.tolowercase
	attribute = RemDelim(attribute,":")
	value = RemDelim(value,";")
	If value.Length > 0 And attribute.Length > 0 Then style.Put(attribute, value & " !important")
	Return Me	
End Sub

'add single quote
Sub AddSingleQuote(value As String)
	If value.Length > 0 Then
		If SingleQuote.IndexOf(value) = -1 Then SingleQuote.Add(value)
	End If
End Sub

'add a class to the element
Sub AddClass(value As String) As HTMLElement
	'add classes delimited by space
	value = value.Replace(" ",";")
	Dim spClasses() As String = StrParse(";",value)
	For Each strClass As String In spClasses
		strClass = strClass.trim
		If strClass <> "" Then classes.Put(strClass,strClass)
	Next
	Return Me
End Sub

Sub ProperCase(myStr As String) As String
	Try
		If myStr.trim.length = 0 Then Return ""
		Dim x As String
		Dim j, k As Int
		myStr = myStr.tolowercase
		x = myStr.ToUpperCase.CharAt(0)
		myStr = x & myStr.SubString2(1, myStr.Length)
		For j = 1 To myStr.Length
			k = myStr.IndexOf2(" ", j + 1)
			If k = -1 Then Exit
			x = myStr.ToUpperCase.CharAt(k + 1)
			myStr = myStr.SubString2(0, k + 1) & x & myStr.SubString2(k + 2, myStr.Length)
		Next
		Return myStr
	Catch
		Return myStr
	End Try
End Sub

Sub ClassExists(value As String) As Boolean
	value = value.trim
	If value.Length > 0 Then
		Return classes.ContainsKey(value)
	End If
	Return False
End Sub

'add a class to the element
Sub AddLooseAttributeOnCondition(bStatus As Boolean, value As String) As HTMLElement
	If bStatus = True Then
		AddLooseAttribute(value) 
	End If
	Return Me
End Sub

'add a class to the element
Sub AddLooseAttributeOnFalseCondition(bStatus As Boolean, value As String) As HTMLElement
	If bStatus = False Then
		AddLooseAttribute(value) 
	End If
	Return Me
End Sub

'add a class to the element
Sub AddLooseAttribute(value As String) As HTMLElement
	If LooseAttributes.IndexOf(value) = -1 Then LooseAttributes.Add(value)
	Return Me
End Sub

'add meta content
Sub AddMetaContent(value As String) As HTMLElement
	If value.Length > 0 Then
		If MetaContent.IndexOf(value) = -1 Then MetaContent.Add(value)
	End If
	Return Me
End Sub

'add a style to the element
private Sub AddStyleClass(value As String) As HTMLElement
	If value.Length > 0 Then
		If Styles.IndexOf(value) = -1 Then Styles.Add(value)
	End If
	Return Me
End Sub

'add css to the page
Sub InjectCSS(css As String) As HTMLElement
	AddStyleClass(css)
	Return Me
End Sub

Sub AddDataAttribute(attribute As String, value As String) As HTMLElement
	If attribute.StartsWith("data-") Then
		AddAttribute(attribute,value,True)
	Else
		AddAttribute("data-" & attribute,value,True)
	End If
	Return Me
End Sub

Sub AddDataAttributeOnCondition(bCondition As Boolean,attribute As String, value As String) As HTMLElement
	If bCondition = False Then Return Me
	AddDataAttribute(attribute,value)
	Return Me
End Sub

public Sub AddElement(el As HTMLElement) As HTMLElement
	AddContent(el.HTML)
	Return Me
End Sub

public Sub AddElementOnCondition(bCondition As Boolean, el As HTMLElement) As HTMLElement
	If bCondition = False Then Return Me
	AddElement(el)
	Return Me
End Sub


Sub MaterialResponsive(bStatus As Boolean) As HTMLElement
	AddClassOnCondition(bStatus,"responsive-img")
	If bStatus = True Then AddCursor
	Return Me
End Sub


Sub SetLineHeight(lineH As String) As HTMLElement
	AddStyleAttribute("line-height",lineH)
	AddStyleAttribute("height",lineH)
	Return Me
End Sub


'add content to the element
public Sub AddContent(value As String) As HTMLElement
	If value.Length > 0 Then
		value = FormatText(value)
		Contents.Add(value)
	End If
	Return Me
End Sub

public Sub AddContentOnCondition(bCondition As Boolean, value As String) As HTMLElement
	If bCondition = False Then Return Me
	AddContent(value)
	Return Me
End Sub


Sub FormatText(sText As String) As String
	Dim RM As Map
	RM.Initialize
	'RM.Put("<","&lt;")
	'RM.Put(">","&gt;")
	'RM.Put("&","&amp;")
	'RM.Put(QUOTE,"&quot;")
	'RM.Put("'","&apos;")
	RM.Put("¢","&cent;")
	RM.put("£","&pound;")
	RM.Put("¥","&yen;")
	RM.Put("€","&euro;")
	RM.put("©","&copy;")
	RM.Put("®","&reg;")
	RM.Put("{POUND}","&pound;")
	RM.Put("{YEN}","&yen;")
	RM.Put("{EURO}","&euro;")
	RM.put("{COPYRIGHT}","&copy;")
	RM.Put("{REGISTERED}","&reg;")
	RM.Put("®", "&reg;")
	
	sText = sText.Replace("{B}", "<b>")
	sText = sText.Replace("{/B}", "</b>")
	sText = sText.Replace("{I}", "<i>")
	sText = sText.Replace("{SMALL}", "<small>")
	sText = sText.Replace("{/SMALL}", "</small>")
	sText = sText.Replace("{EM}", "<em>")
	sText = sText.Replace("{/EM}", "</em>")
	sText = sText.Replace("{MARK}", "<mark>")
	sText = sText.Replace("{/MARK}", "</mark>")
	sText = sText.Replace("{/I}", "</i>")
	sText = sText.Replace("{U}", "<ins>")
	sText = sText.replace("{/U}", "</ins>")
	sText = sText.replace("{SUB}", "<sub>")
	sText = sText.Replace("{CODE}","<code>")
	sText = sText.Replace("{/CODE}","</code>")
	sText = sText.replace("{/SUB}", "</sub>")
	sText = sText.replace("{SUP}", "<sup>")
	sText = sText.replace("{/SUP}", "</sup>")
	sText = sText.replace("{BR}", "<br/>")
	sText = sText.Replace("{WBR}","<wbr>")
	sText = sText.replace("{STRONG}", "<strong>")
	sText = sText.replace("{/STRONG}", "</strong>")
	sText = sText.replace("{NBSP}", "&nbsp;")
	sText = sText.replace("{AL}", $"<a rel=""nofollow"" target=""_blank"" href="""$)
	sText = sText.replace("{AT}", $""">"$)
	sText = sText.replace("{/AL}", "</a>")
	For Each strValue As String In RM.Keys
		Dim strRep As String = RM.Get(strValue)
		sText = sText.Replace(strValue, strRep)
	Next
	Return sText
End Sub

'add content to the element
private Sub AddJSCode(value As String) As HTMLElement
	If value.Length > 0 Then jsCode.Add(value)
	Return Me
End Sub


Sub JQueryOnClickEvent(sid As String, sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$('#${sid}').click(function(){"$)
	'sb.Append("event.stopPropagation();")
	sb.Append(sCode)
	sb.Append("});")
	sb.Append("});")
	Return sb.tostring
End Sub

'the element to click is inside another element i.e. group clickick
Sub AddChildDocumentMouseOverEvent(parentID As String, compID As String,compText As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('mouseover', '#${compID}', function(){"$)
	'sb.Append("event.stopPropagation();")
	sb.Append($"b4j_raiseEvent('${parentID}_mouseover', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub

Sub AddChildDocumentMouseOutEvent(parentID As String, compID As String,compText As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('mouseout', '#${compID}', function(){"$)
	'sb.Append("event.stopPropagation();")
	sb.Append($"b4j_raiseEvent('${parentID}_mouseout', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub


'the element to click is inside another element i.e. group clickick
'Sub AddChildDocumentClickEvent(parentID As String, compID As String,compText As String) As String
'	Return AddChildDocumentClickEventCode(parentID,compID,compText,"")
'End Sub

'the element to click is inside another element i.e. group clickick
Sub AddChildDocumentClickEventCode(parentID As String, compID As String,compText As String,sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('click', '#${compID}', function(){"$)
	sb.Append(sCode)
	sb.Append($"b4j_raiseEvent('${parentID}_click', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub

Sub AddOnClickEventProperty(parentID As String,returnText As String) As HTMLElement
	AddProperty("onclick", OnClick(parentID,returnText))
	Return Me
End Sub

Sub AddOnClickEventPropertySelf(parentID As String) As HTMLElement
	AddProperty("onclick", OnClick(parentID,ID))
	Return Me
End Sub

' the element to click is inside another element, i.e. single element click
'Sub AddDocumentClickEvent(compID As String,compText As String) As String
'	Return AddDocumentClickEventCode(compID,compText,"")
'End Sub

' the element to click is inside another element, i.e. single element click
Sub AddDocumentClickEventCode(compID As String,compText As String, sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('click', '#${compID}', function(){"$)
	sb.Append(sCode)
	sb.Append($"b4j_raiseEvent('${compID}_click', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub

private Sub OnClick(parentID As String,returnText As String) As String
	If parentID = "" Then parentID = ID
	Dim sb As String = $"b4j_raiseEvent('${parentID}_click', {'value':'${returnText}'});"$
	Return sb
End Sub

' the element to click is inside another element, i.e. single element click
Sub AddDocumentMouseOverEvent(compID As String,compText As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('mouseover', '#${compID}', function(){"$)
	'sb.Append("event.stopPropagation();")
	sb.Append($"b4j_raiseEvent('${compID}_mouseover', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub

' the element to click is inside another element, i.e. single element click
Sub AddDocumentMouseOutEvent(compID As String,compText As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('mouseout', '#${compID}', function(){"$)
	'sb.Append("event.stopPropagation();")
	sb.Append($"b4j_raiseEvent('${compID}_mouseout', {'value':'${compText}'});"$)
	sb.Append("});")
	sb.Append("});")
	Return sb.ToString
End Sub

Sub VerifyJavaScript(jsList As List)
	Dim sb As StringBuilder
	sb.initialize 
	For Each strLine As String In jsList
		sb.Append(strLine).Append(CRLF)
		Dim openB() As String = StrParse("{",strLine)
		Dim closeB() As String = StrParse("}",strLine)
		Dim openS() As String = StrParse("(",strLine)
		Dim closeS() As String = StrParse(")",strLine)
		sb.Append("*****").Append(CRLF)
		sb.Append("{: " & openB.Length).Append(CRLF)
		sb.Append("}: " & closeB.Length).Append(CRLF)
		sb.Append("(: " & openS.Length).Append(CRLF)
		sb.Append("): " & closeS.Length).Append(CRLF)
		If openB.Length <> closeB.Length Then
			sb.Append("ERROR {").Append(CRLF)
		End If
		If openS.Length <> closeS.Length Then
			sb.Append("ERROR (").Append(CRLF)
		End If
		sb.Append("*****").Append(CRLF)
	Next
	File.WriteString(File.DirApp,ID & ".txt",sb.ToString)
End Sub

Sub VerifyHTML(jsList As String)
	Dim sb As StringBuilder
	sb.initialize 
	Dim openB() As String = StrParse("{",jsList)
	Dim closeB() As String = StrParse("}",jsList)
	Dim openS() As String = StrParse("(",jsList)
	Dim closeS() As String = StrParse(")",jsList)
	sb.Append(jsList).Append(CRLF)
	sb.Append("*****").Append(CRLF)
	sb.Append("{: " & openB.Length).Append(CRLF)
	sb.Append("}: " & closeB.Length).Append(CRLF)
	sb.Append("(: " & openS.Length).Append(CRLF)
	sb.Append("): " & closeS.Length).Append(CRLF)
	If openB.Length <> closeB.Length Then
		sb.Append("ERROR {").Append(CRLF)
	End If
	If openS.Length <> closeS.Length Then
		sb.Append("ERROR (").Append(CRLF)
	End If
	sb.Append("*****").Append(CRLF)
	File.WriteString(File.DirApp,ID & "HTML.txt",sb.ToString)
End Sub

Sub JQueryOnDocumentClickEvent(sid As String, sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('click', '#${sid}', function(){"$)
	'sb.Append("event.stopPropagation();")
	sb.Append(sCode)
	sb.Append("});")
	sb.Append("});")
	Return sb.tostring
End Sub

Sub JQueryOnDocumentChangeEvent(sid As String, sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('change', '${sid}', function(){"$)
	sb.Append(sCode)
	sb.Append("});")
	sb.Append("});")
	Return sb.tostring
End Sub

Sub JQueryOnDocumentFocusEvent(sid As String, sCode As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function() {")
	sb.Append($"$(document).on('focus', '#${sid}', function(){"$)
	sb.Append(sCode)
	sb.Append("});")
	sb.Append("});")
	Return sb.tostring
End Sub


'Sub GetClickEvent(Script As String) As String
'	Dim sb As StringBuilder
'	sb.Initialize
'	sb.Append($"$('#${ID}').click(function(){"$)
'	sb.Append(Script).Append(CRLF)
'	sb.Append("});").Append(CRLF)
'	Return sb.tostring
'End Sub

private Sub BuildOnClickEvent
	If OnClickCode.Size -1 <> -1 Then
		Dim sb As StringBuilder
		sb.Initialize 
		sb.Append("$(function() {")
		sb.Append($"$('#${ID}').click(function(){"$)
		'sb.Append("event.stopPropagation();")
		sb.Append(Join(CRLF,OnClickCode))
		sb.Append("});")
		sb.Append("});")
		InjectJavaScript(sb.ToString)
	End If
End Sub

Sub MvFromList(lst As List, Delim As String) As String
	Dim lTot As Int
	Dim lCnt As Int
	Dim lStr As StringBuilder
	lStr.Initialize
	lTot = lst.Size - 1
	For lCnt = 0 To lTot
		lStr.Append(lst.Get(lCnt))
		If lCnt <> lTot Then lStr.Append(Delim)
	Next
	Return lStr.tostring
End Sub


Sub Join(Delimiter As String, lst As List) As String
	Return MvFromList(lst,Delimiter)
End Sub

private Sub BuildOnDoubleClickEvent
	If OnDoubleClickCode.Size -1 <> -1 Then
		Dim sb As StringBuilder
		sb.Initialize 
		sb.Append("$(function() {")
		sb.Append($"$('#${ID}').dblclick(function(){"$)
		'sb.Append("event.stopPropagation();")
		sb.Append(Join(CRLF,OnDoubleClickCode))
		sb.Append("});")
		sb.Append("});")
		InjectJavaScript(sb.ToString)
	End If
End Sub


'inject javascript code into the page
public Sub InjectJavaScript(js As String) As HTMLElement
	AddJSCode(js)
	AddJSCode(CRLF)
	Return Me
End Sub

Sub GetAttribute(attr As String) As String
	attr = attr.tolowercase
	If properties.ContainsKey(attr) Then
		Return properties.Get(attr)
	Else
		Return ""
	End If
End Sub


public Sub SetMARGINBOTTOM(sTop As String) As HTMLElement
	AddStyleAttribute("margin-bottom",MakePx(sTop))
	Return Me
End Sub

public Sub SetMARGINLEFT(sTop As String) As HTMLElement
	AddStyleAttribute("margin-left",MakePx(sTop))
	Return Me
End Sub

public Sub SetMARGINRIGHT(sTop As String) As HTMLElement
	AddStyleAttribute("margin-right",MakePx(sTop))
	Return Me
End Sub

public Sub SetPADDINGRIGHT(sTop As String) As HTMLElement
	AddStyleAttribute("padding-right",MakePx(sTop))
	Return Me
End Sub


public Sub SetPADDINGTOP(sTop As String) As HTMLElement
	AddStyleAttribute("padding-top",MakePx(sTop))
	Return Me
End Sub

public Sub SetPADDINGBOTTOM(sTop As String) As HTMLElement
	AddStyleAttribute("padding-bottom",MakePx(sTop))
	Return Me
End Sub


public Sub SetPADDINGLEFT(sTop As String) As HTMLElement
	AddStyleAttribute("padding-left",MakePx(sTop))
	Return Me
End Sub

public Sub SetMARGINTOP(sTop As String) As HTMLElement
	AddStyleAttribute("margin-top",MakePx(sTop))
	Return Me
End Sub

'add an attribute to the element, bset if propvalue is specified
public Sub AddAttribute(Name As String, propValue As String, bSetHasValue As Boolean) As HTMLElement
	Name = Name.ToLowerCase
	If bSetHasValue = False Then
		If propValue.Length > 0 Then
			properties.Put(Name, propValue)
		End If
	Else
		properties.Put(Name, propValue)
	End If
	Return Me
End Sub

Sub Reset
	properties.Initialize
	classes.initialize
	style.initialize
End Sub

Public Sub AddProperty(sKey As String, sValue As String) As HTMLElement
	AddAttribute(sKey, sValue,True)
	Return Me
End Sub

Sub AddStyleAttributeOnCondition(bCondition As Boolean, attr As String, value As String) As HTMLElement
	If bCondition = True Then
		AddStyleAttribute(attr,value)
	End If
	Return Me
End Sub

Sub AddAttributeOnCondition(bCondition As Boolean, attr As String, value As String) As HTMLElement
	If bCondition = True Then
		AddAttribute(attr,value,True)
	End If
	Return Me
End Sub


Sub AddStyleAttributeOnFalseCondition(bCondition As Boolean, attr As String, value As String) As HTMLElement
	If bCondition = False Then
		AddStyleAttribute(attr,value)
	End If
	Return Me
End Sub

Sub AddAttributeOnFalseCondition(bCondition As Boolean, attr As String, value As String) As HTMLElement
	If bCondition = False Then
		AddAttribute(attr,value,True)
	End If
	Return Me
End Sub

'remove an attribute from the ones set
public Sub RemoveAttribute(sName As String) As HTMLElement
	sName = sName.ToLowerCase
	sName = sName.Replace(" ",";")
	Dim sItems() As String = StrParse(";",sName)
	For Each strStyle As String In sItems
		strStyle = strStyle.trim
		If properties.ContainsKey(strStyle) Then properties.Remove(strStyle)
	Next
	Return Me
End Sub

'remove an attribute from the ones set 
public Sub RemoveStyle(styleName As String) As HTMLElement
	styleName = styleName.Trim.tolowercase
	styleName = styleName.Replace(" ",";")
	Dim sItems() As String = StrParse(";",styleName)
	For Each strStyle As String In sItems
		strStyle = strStyle.trim
		If style.ContainsKey(strStyle) Then style.Remove(strStyle)
	Next
	Return Me
End Sub

public Sub RemoveClass(className As String) As HTMLElement
	className = className.trim
	className = className.replace(" ",";")
	Dim sItems() As String = StrParse(";",className)
	For Each strStyle As String In sItems
		strStyle = strStyle.trim
		If classes.ContainsKey(strStyle) Then classes.Remove(strStyle)
	Next
	Return Me
End Sub

Sub MaterialEnable(bEnabled As Boolean) As HTMLElement
	Enabled = bEnabled
	Return Me
End Sub

Sub MaterialRequired(bRequired As Boolean) As HTMLElement
	Required = bRequired
	Return Me
End Sub

Sub MaterialInline(bInline As Boolean) As HTMLElement
	Inline = bInline
	Return Me
End Sub


'define the opening of the element
private Sub Open() As String
	If Required = True Then AddLooseAttribute("required")
	If Enabled = False Then AddLooseAttribute("disabled")
	If Inline = True Then AddLooseAttribute("inline")
	If NoValidate = True Then AddLooseAttribute("novalidate")
	If ReadOnly = True Then AddLooseAttribute("readonly")
	
	MaterialSetForeColor(ForeColor,ForeColorIntensity)
	MaterialSetBackgroundColor(BackColor,BackColorIntensity)
	Dim thisLoose As String = BuildLoose
	Dim thisMeta As String = BuildMeta
	If thisMeta.Length > 0 Then AddAttribute("content", thisMeta,False)
	Dim thisClass As String = BuildClass
	If thisClass.Length > 0 Then AddAttribute("class", thisClass,False)
	Dim thisStyle As String = BuildStyle
	If thisStyle.Length > 0 Then AddAttribute("style", thisStyle,False)
	Dim strValue As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("<")
	If Prefix.Length > 0 Then
		sb.Append(Prefix).Append(" ")
	End If
	sb.Append(ElementType).Append(" ")
	If ID.Length > 0 Then 
		sb.Append(ToProperty("id",ID))
		sb.Append(" ")
	End If
	If thisLoose.Length > 0 Then 
		sb.Append(thisLoose)
		sb.Append(" ")
	End If
	For Each strKey As String In properties.Keys
		strValue = properties.Get(strKey)
		If SingleQuote.IndexOf(strKey) = -1 Then 
			sb.Append(ToProperty(strKey,strValue))
		Else
			sb.Append(ToSingleQuoteProperty(strKey,strValue))
		End If
		sb.Append(" ") 
	Next
	sb.Remove(sb.Length-1,sb.Length)
	sb.Append(">")
	sb.Append(CRLF)
	Return sb.tostring
End Sub

Sub SetParentID(pID As String) As HTMLElement
	sParentID = pID
	Return Me
End Sub

'define the closure of the element
private Sub Close() As String
	Dim sb As StringBuilder
	sb.Initialize 
	Select Case ElementType.ToLowerCase
	Case "img","link","meta","input","source"
		DoAProperClose = False
	End Select
	If DoAProperClose = True Then
		sb.Append("</").Append(ElementType).Append(">")
	End If
	sb.Append(CRLF)
	Return sb.tostring
End Sub

'turn the element into html
public Sub HTML As String
	If sParentID <> "" Then 
		ID = sParentID & ID
	End If
	Select Case ElementType
	Case "img","script"
		'to later check for broken links
		Dim imgURL As String = GetAttribute("src")
		If imgURL.Length > 0 Then 
			imgURL = imgURL.tolowercase
			'Page.App.Links.put(imgURL,imgURL)
		End If
	Case "link"
		Dim lnk As String = GetAttribute("href")
		If lnk.Length > 0 Then
			lnk = lnk.tolowercase
			'Page.App.Links.put(lnk,lnk)
		End If
	End Select
	If PropName <> "" Then SetNAME(PropName)
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append(Open)
	For Each strContent As String In Contents
		If strContent.Length > 0 Then 
			sb.Append(strContent)
			sb.Append(CRLF)
		End If
	Next
	sb.Append(Close)
	sb.Append(divider)
	sb.Append(CRLF)
	Dim sout As String = sb.ToString
	'If DontBreak.IndexOf(ElementType) <> -1 Then
	'	sout = sout.Replace(CRLF,"")
	'End If
	'add any code to the page
	sout = sout.Replace(CRLF,"")
	BuildOnClickEvent
	Return sout
End Sub

'renders a simple property map
Public Sub Render() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strprop As String In properties.Keys
		Dim strValue As String = properties.Get(strprop)
		sb.Append($"${strprop}="${strValue}""$).Append(" ")
	Next
	'remove the last space
	If sb.ToString.EndsWith(" ") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append(CRLF)
	Return sb.ToString
End Sub

Public Sub ToJSON() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strprop As String In properties.Keys
		Dim strValue As String = properties.Get(strprop)
		sb.Append($"${strprop}:${strValue}"$).Append(",")
	Next
	'remove the last space
	sb.Remove(sb.Length-1,sb.Length)
	sb.Append(CRLF)
	Return sb.ToString	
End Sub

'render the styles
public Sub GetStyles() As String
	If Styles.Size -1 = -1 Then Return ""
	Dim sb As StringBuilder
	sb.Initialize 
	'add the available styles
	sb.Append("<style ").Append(ToProperty("type","text/css")).Append(">")
	For Each strStyle As String In Styles
		If strStyle.Length > 0 Then sb.Append(strStyle)
	Next
	sb.Append("</style>")
	Return sb.tostring
End Sub

'render the javascript
public Sub OnDocumentReady() As String
	If jsCode.Size -1 = -1 Then Return ""
	Dim js As HTMLElement
	js.Initialize("","script")
	'js.AddAttribute("type", "text/javascript")
	'js.AddAttribute("language", "javascript")
	'js.AddContent($"$(document).ready(function() {"$).AddContent(CRLF)
	js.AddContent($"(function($){"$).AddContent(CRLF)
	js.AddContent($"$(function(){"$).AddContent(CRLF)
	For Each strLine As String In jsCode
		If strLine.Length > 0 Then js.AddContent(strLine)
	Next
	js.AddContent($"});"$).AddContent(CRLF)
	js.AddContent($"})(jQuery);"$).AddContent(CRLF)
	Return js.html
End Sub

'return a key value string for an attribute
public Sub ToProperty(Name As String, value As String) As String
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append(Name).Append("=").Append(QUOTE).Append(value).Append(QUOTE)
	Return sb.tostring
End Sub

'return a key value string for an attribute
public Sub ToSingleQuoteProperty(Name As String, value As String) As String
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append(Name).Append("=").Append("'").Append(value).Append("'")
	Return sb.tostring
End Sub

'convert key value to style
public Sub ToStyle(Name As String, value As String) As String
	If Name.EndsWith(":") Then
		Name = MvField(Name,1,":")
	End If
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(Name).Append(":").Append(value).Append(";")
	Return sb.tostring
End Sub

private Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim xPos As Int: xPos = sValue.IndexOf(Delimiter)
	If xPos = -1 Then Return sValue
	Dim mValues() As String
	Dim tValues As Int
	If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
	mValues = Regex.split(Delimiter, sValue)
	tValues = mValues.Length -1
	Select Case iPosition
	Case -1
		Return mValues(tValues)
	Case -2
		Return mValues(tValues - 1)
	Case -3
		Dim sb As StringBuilder
		sb.Initialize
		Dim startcnt As Int
		For startcnt = 1 To tValues
			sb.Append(mValues(startcnt)).append(Delimiter)	 
		Next
		sb.Remove(sb.Length-Delimiter.Length,sb.Length)
		Return sb.tostring
	Case Else
		iPosition = iPosition - 1
		If iPosition <= -1 Then Return mValues(tValues)
		If iPosition > tValues Then Return ""
			Return mValues(iPosition)
	End Select
End Sub

public Sub MvFieldFrom(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim mValues() As String
	Dim tValues As Int
	If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
	mValues = Regex.split(Delimiter, sValue)
	tValues = mValues.Length -1
	If tValues < iPosition Then
		Return mValues(tValues)
	End If
	Dim sb As StringBuilder
	sb.Initialize
	Dim startcnt As Int
	For startcnt = iPosition To tValues
		sb.Append(mValues(startcnt)).append(Delimiter)	 
	Next
	sb.Remove(sb.Length-Delimiter.Length,sb.Length)
	Return sb.tostring
End Sub

Sub CopyStyles(elFrom As HTMLElement) As HTMLElement
	For Each strStyle As String In elFrom.style.keys
		Dim strS As String = elFrom.style.Get(strStyle)
		AddStyleAttribute(strStyle,strS)
	Next
	Return Me	
End Sub

Sub CopyClasses(elFrom As HTMLElement) As HTMLElement
	For Each strclass As String In elFrom.classes.keys
		AddClass(strclass)
	Next
	Return Me
End Sub

'convert a map to properties
private Sub BuildClass() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strClass As String In classes.Keys
		'if we have it on external styles, remove it and add the style
		If MashPlugIns.ExternalStyle.ContainsKey(strClass.tolowercase) Then
			Dim eStyle As String = MashPlugIns.ExternalStyle.Get(strClass)
			ApplyStyle(eStyle)
			Continue
		End If
		If ExternalStyle.ContainsKey(strClass.tolowercase) Then
			Dim eStyle As String = ExternalStyle.Get(strClass)
			ApplyStyle(eStyle)
			Continue
		End If
		sb.Append(strClass).Append(" ")
	Next
	Return sb.ToString.trim
End Sub

'build meta content
Public Sub BuildMetaData() As String
	Dim sb As StringBuilder
	sb.Initialize 
	For Each strMeta As String In metas
		sb.Append(strMeta)
		sb.Append(CRLF)
	Next
	Return sb.tostring
End Sub

Public Sub BuildCSSFiles() As String
	Dim sb As StringBuilder
	sb.Initialize 
	For Each strcss As String In cssFiles
		sb.Append(strcss)
		sb.Append(CRLF)
	Next
	Return sb.tostring
End Sub


Public Sub BuildJSFiles() As String
	Dim sb As StringBuilder
	sb.Initialize 
	For Each strjs As String In jsfiles
		sb.Append(strjs)
		sb.Append(CRLF)
	Next
	Return sb.tostring
End Sub


private Sub BuildLoose() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strClass As String In LooseAttributes
		sb.Append(strClass).Append(" ")
	Next
	Return RemDelim(sb.ToString," ")
End Sub

'convert a map to properties for meta
private Sub BuildMeta() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strClass As String In MetaContent
		sb.Append(strClass).Append(" ")
	Next
	Return RemDelim(sb.ToString," ")
End Sub

'convert a map to properties
Sub BuildStyle() As String
	Dim sb As StringBuilder
	Dim strValue As String
	sb.Initialize
	For Each strKey As String In style.Keys
		strValue = style.Get(strKey)
		sb.Append(ToStyle(strKey,strValue))
		sb.Append(" ")
	Next
	Return sb.ToString.trim
End Sub

Sub BuildStyleClass() As String
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append(ID).Append(" {").Append(BuildStyle).Append("}")
	Return sb.tostring
End Sub

Sub BuildStyleClasses() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strKey As String In ExternalStyle.Keys
		Dim values As String = ExternalStyle.Get(strKey)
		sb.Append(".").Append(strKey).Append(" {").Append(values).Append("}").Append(CRLF)
	Next
	Return sb.tostring
End Sub


private Sub RemDelim(value As String, delim As String) As String
	If value.endswith(delim) = True Then
		Dim sb As StringBuilder
		Dim dLength As Int = delim.length
		sb.Initialize 
		sb.Append(value)
		sb.Remove(sb.Length-dLength,sb.Length)
		Return sb.tostring
	Else
		Return value
	End If
End Sub

'convert a map to properties
Public Sub Map2Attributes(m As Map, bSingleQuote As Boolean) As String
	Dim xq As String
	If bSingleQuote = True Then
		xq = "'"
	Else
		xq = QUOTE
	End If
	Dim sb As StringBuilder
	Dim i As Int
	sb.Initialize
	For i = 0 To m.Size - 1
		sb.Append(m.GetKeyAt(i)).Append("=").Append(xq).Append(m.GetValueAt(i)).Append(xq)
		If i <> m.Size - 1 Then
			sb.Append(" ")
		End If
	Next
	Return sb.ToString.trim
End Sub

Sub AlignRight() As HTMLElement
	AddProperty("align","right")
	Return Me
End Sub

Sub AlignCenter() As HTMLElement
	AddProperty("align","center")
	Return Me
End Sub

public Sub MaterialBuildIcon(iconName As String, iconPos As String) As HTMLElement
	iconName = iconName.tolowercase
	If iconName.StartsWith("mdi-") Then
		AddClass("material-icons")
		iconName = MvFieldFrom(iconName,2,"-")
		iconName = iconName.Replace("-","_")
		AddContent(iconName)
	else if iconName.startswith("ggle-") Then
		iconName = MvFieldFrom(iconName,2,"-")
		AddContent(iconName)
	else if iconName.StartsWith("fa-") Then
		AddClass("fa " & iconName)
	else if iconName.StartsWith("fa fa-") Then
		AddClass(iconName)
	else if iconName.StartsWith("fa ") Then
		AddClass(iconName)
	Else
		AddClass(iconName)
	End If
	If iconPos.Length > 0 Then AddClass(iconPos)
	Return Me
End Sub

Public Sub AppendLine(sLine As String)
	sbMaster.Append(sLine).Append(CRLF)
End Sub

Public Sub Append(sLine As String)
	sbMaster.Append(sLine)
End Sub

Public Sub ToString() As String
	Return sbMaster.ToString
End Sub

Sub AddRedStar(bRequired As Boolean) As HTMLElement
	If bRequired = True Then
		Dim span As HTMLElement
		span.Initialize("","span").AddContent("*")
		MashPlugIns.MaterialUseTheme("redtransparent",span)
		AddContent(span.HTML)
	End If
	Return Me
End Sub

Sub BorderColorDanger As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("danger")
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub BorderColorSuccess As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("success")
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub BorderColorWarn As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("warn")
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub BorderColorInfo As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("info")
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub BorderColorPrimary As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("primary")
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub BorderColorMuted As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("mouted")
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub SetBorderColor(sColor As String, sIntensity As String) As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetColor(sColor,sIntensity)
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub SetBorderColorFromTheme(sTheme As String) As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor(sTheme)
	AddStyleAttribute("border-color",sColor)
	Return Me
End Sub

Sub SetBorderWidthStyleRadiusColor(bWidth As String, bStyle As String, bRadius As String, bColor As String, bIntensity As String) As HTMLElement
	Dim sColor As String = MashPlugIns.ABMGetColor(bColor,bIntensity)
	bWidth = MakePx(bWidth)
	ApplyStyle($"border-width: ${bWidth}px; border-style: ${bStyle};border-radius: ${bRadius};border-color:${sColor}"$)
	Return Me
End Sub

