﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private Element As HTMLElement
	Public ZDepth As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Private Content As HTMLElement
	Private Paragraph As HTMLElement
	Private BackgroundColor As String
	Private BackgroundColorIntensity As String
	Private ContentColor As String
	Private ContentIntensity As String
	Private Message As String
	Private button As HTMLElement
	Private span As HTMLElement
	Private warnType As String
	Private icon As HTMLElement
	Private img As HTMLElement
	Private title As HTMLElement
	Public UserImage As String
	Public Heading As String
	Public ShowHeading As Boolean
	Public ShowOKCancel As Boolean
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


Sub Normal(Text As String)
	BackgroundColor = ABM.COLOR_LIGHTBLUE
	BackgroundColorIntensity = ABM.INTENSITY_LIGHTEN5
	ContentColor = ABM.COLOR_LIGHTBLUE
	Message = Text
	warnType = "n"
End Sub

Sub NormalDark(Text As String)
	BackgroundColor = ABM.COLOR_LIGHTBLUE
	BackgroundColorIntensity = ""
	ContentColor = ABM.COLOR_WHITE
	Message = Text
	warnType = "n"
End Sub


Sub Success(Text As String)
	BackgroundColor = ABM.COLOR_GREEN
	BackgroundColorIntensity = ABM.INTENSITY_LIGHTEN5
	ContentColor = ABM.COLOR_GREEN
	Message = Text
	warnType = "s"
End Sub

Sub SuccessDark(Text As String)
	BackgroundColor = ABM.COLOR_GREEN
	BackgroundColorIntensity = ""
	ContentColor = ABM.COLOR_WHITE
	Message = Text
	warnType = "s"
End Sub

Sub Info(Text As String)
	BackgroundColor = ABM.COLOR_DEEPPURPLE
	BackgroundColorIntensity = ABM.INTENSITY_LIGHTEN5
	ContentColor = ABM.COLOR_DEEPPURPLE
	Message = Text
	warnType = "i"
End Sub

Sub InfoDark(Text As String)
	BackgroundColor = ABM.COLOR_DEEPPURPLE
	BackgroundColorIntensity = ""
	ContentColor = ABM.COLOR_WHITE
	Message = Text
	warnType = "i"
End Sub

Sub Danger(Text As String)
	BackgroundColor = ABM.COLOR_RED
	BackgroundColorIntensity = ABM.INTENSITY_LIGHTEN5
	ContentColor = ABM.COLOR_WHITE
	Message = Text
	warnType = "d"
End Sub

Sub DangerDark(Text As String)
	BackgroundColor = ABM.COLOR_RED
	BackgroundColorIntensity = ""
	ContentColor = ABM.COLOR_WHITE
	Message = Text
	warnType = "d"
End Sub

Sub Warn(Text As String)
	BackgroundColor = ABM.COLOR_ORANGE
	BackgroundColorIntensity = ABM.INTENSITY_LIGHTEN5
	ContentColor = ABM.COLOR_ORANGE
	Message = Text
	warnType = "w"
End Sub

Sub WarnDark(Text As String)
	BackgroundColor = ABM.COLOR_ORANGE
	BackgroundColorIntensity = ""
	ContentColor = ABM.COLOR_WHITE
	Message = Text
	warnType = "w"
End Sub



Sub HTML As String
	'define the background color
	Element.AddClass(BackgroundColor).AddClass(BackgroundColorIntensity).MaterialHoverable(Hoverable)
	Content = Content.CreateDIV("").AddClass("card-content").AddClass(ContentColor & "-text")
	Content.ApplyStyle("padding:20px 40px 20px 20px")
	button = button.CreateBUTTON($"${compID}close"$).AddProperty("type","button").AddClass("close").AddClass(ContentColor & "-text")
	button.AddProperty("data-dismiss","alert").AddProperty("aria-label","Close")
	'JavaCalls.Add(button.AddChildClickEvent(compID,button.ID,"close"))
	button.AddOnClickEventProperty(compID,"close")
	span = span.CreateSPAN("").AddProperty("aria-hidden","true").AddContent("x")
	button.AddContent(span.HTML.Replace(CRLF,""))
	'button style
	button.AddStyleAttribute("background","none").AddStyleAttribute("border","none").AddStyleAttribute("position","absolute")
	button.AddStyleAttribute("top","15px").AddStyleAttribute("right","10px").AddStyleAttribute("font-size","20px")
	button.AddStyleAttribute("color","#fff")
	'add close event
	JavaCalls.Add($"$("#${compID} .close").click(function() { $(this).closest('#${compID}').fadeOut('slow');});"$)
	
	If UserImage <> "" Then
		img = img.CreateIMG("").SetSRC(UserImage,False).SetALT("avatar").AddClass("alert-circle")
		img.AddClass("responsive-img").AddClass("valign").AddClass("profile-image")
		'alert-circle
		img.AddStyleAttribute("display","inline-block").AddStyleAttribute("width","40px").AddStyleAttribute("white-space","nowrap")
		img.AddStyleAttribute("border-radius","1000px").AddStyleAttribute("vertical-align","bottom").AddStyleAttribute("position","relative")
		img.AddStyleAttribute("top","-5px").AddStyleAttribute("left","-2px")
		img.ApplyStyle("float:left").MaterialZDepth(ABM.ZDEPTH_1)	
	End If
		
	title = title.CreateSPAN("").AddClass("card-title").AddClass(ContentColor & "-text").AddClass("darken-1")
	
	Paragraph = Paragraph.CreateP("")
	icon.Initialize("","i").ApplyStyle("font-size:20px").ApplyStyle("position:relative").ApplyStyle("top:2px")
	
	Select Case warnType
	Case "n"
		icon.materialbuildicon("mdi-social-notifications","")
	Case "s"
		icon.materialbuildicon("mdi-navigation-check","")
	Case "w"
		icon.materialbuildicon("mdi-alert-warning","")
	Case "d"
		icon.materialbuildicon("mdi-alert-error","")
	Case "i"
		icon.materialbuildicon("mdi-action-info-outline","")
	End Select
	If UserImage <> "" Then Content.AddContent(img.HTML)
	If ShowHeading = True Then
		title.AddContent(icon.HTML.Replace(CRLF,"")).AddSpace.AddContent(Heading)
		Paragraph.Addcontent(Message)
		Content.AddContent(title.HTML.Replace(CRLF,""))
	Else
		Paragraph.AddContent(icon.HTML.Replace(CRLF,"")).AddSpace.AddContent(Message)
	End If
	Content.AddContent(Paragraph.HTML.Replace(CRLF,""))
	Element.AddContent(Content.HTML.Replace(CRLF,""))
	'if we have ok cancel showing
	If ShowOKCancel = True Then
		Dim cardaction As HTMLElement
		Dim ok As HTMLElement
		Dim cancel As HTMLElement
		cardaction = cardaction.CreateDIV("").AddClass("card-action").AddClass(BackgroundColor).AddClass("darken-2")
		cardaction.ApplyStyle("padding:10px 14px")
		ok = ok.CreateA($"${compID}ok"$).MaterialWavesEffect(True).MaterialWavesLight(True).addclass("btn").MaterialTextColor(ContentColor).AddContent("Ok")
		ok.AddClass(BackgroundColor).AddClass(BackgroundColorIntensity)
		cancel = cancel.CreateA($"${compID}cancel"$).MaterialWavesEffect(True).MaterialWavesLight(True).addclass("btn").MaterialTextColor(ContentColor).AddContent("Cancel")
		cancel.AddClass(BackgroundColor).AddClass(BackgroundColorIntensity)
		ok.AddOnClickEventProperty(compID,"ok")
		cancel.AddOnClickEventProperty(compID,"cancel")
		cardaction.AddContent(ok.HTML.Replace(CRLF,""))
		cardaction.AddContent(cancel.HTML.Replace(CRLF,""))
		'JavaCalls.Add(ok.AddChildClickEvent(compID,ok.ID,"ok"))
		'JavaCalls.Add(cancel.AddChildClickEvent(compID,cancel.ID,"cancel"))
		Element.AddContent(cardaction.HTML)		
	End If
	
	Element.AddContent(button.HTML.Replace(CRLF,""))
	Element.MaterialZDepth(ZDepth)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Return Element.html
End Sub


Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.initialize
	Page = InternalPage
	compID = ID.tolowercase
	WavesEffect = False
	WavesType = ""
	WavesCircle = False
	Heading = "Alert"
	ShowHeading = False
	ShowOKCancel = False
	Element = Element.CreateDIV(compID).AddClass("card")
End Sub


Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,CRLF)
	Page.ws.Eval(script, Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compID))
End Sub

Sub HideScript() As String
	Return Element.JQueryHide
End Sub

Sub Hide
	JQueryExecute(Element.JQueryHide)
End Sub

Sub HideSlow()
	JQueryExecute(Element.JQueryHideSlow)
End Sub

Sub FadeOutSlow
	JQueryExecute(Element.JQueryFadeOutSlow)
End Sub

Sub Animate(animationType As String, bInfinity As Boolean, bAfter As String)
	JQueryExecute(Element.JQueryAnimate(animationType,bInfinity,bAfter))
End Sub
