﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Element As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private sTheme As String
	Public Hoverable As Boolean
	Private style As HTMLElement
	Public ArrayName As String
	Public MyStore As String
	Type StoreType(apple As String, google As String)
	Public EnumStore As StoreType
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	EnumStore.Initialize
	EnumStore.apple = "apple"
	EnumStore.google = "google"
	'define style classes to load with the component
	style = style.CreateCSSClass("apple")
	style.AddCSSClass("btn1","margin-bottom: .25rem;font-weight: 500;outline: 0;display: inline-block;")
	style.AddCSSClass("btn1", "line-height: 1.25;text-align: center;white-space: nowrap;vertical-align: middle;cursor: pointer;")
	style.AddCSSClass("btn1", "-moz-user-select: none;border: 1px solid transparent;")
	style.AddCSSClass("m-r-xs","margin-right: .25rem;")
	style.AddCSSClass("btn-lg","padding: .75rem 1.5rem;	font-size: 1.25rem;	border-radius: .3rem;font-weight: 500;")
	style.AddCSSClass("black","color: rgba(255,255,255,.87);")
	style.AddCSSClass("m-r-sm","margin-right: .5rem")
	style.AddCSSClass("pull-left","float: left;")
	style.AddCSSClass("l-h-1x","line-height: 1;")
	style.AddCSSClass("clear","display: block;overflow: hidden;")
	style.AddCSSClass("text-left","text-align: left;")
	style.AddCSSClass("text-xs","font-size: .75rem;")
	style.AddCSSClass("text-muted","color: inherit;opacity: .6;")
	style.AddCSSClass("text-md","font-size: 1.125rem;")
	style.AddCSSClass("m-b-xs","margin-bottom: .25rem")
	style.AddCSSClass("block","display: block;font-weight: bolder;")
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,style.BuildStyleClasses)
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize
	Element.Initialize(ID,"a")
	Enabled = True
	Hoverable = True
	Visibility= ""
	ZDepth = ""
	sTheme = ThemeName
	ArrayName = ""
	MyStore = "apple"
End Sub


Sub HTML As String
	Dim fFont As String = "fa fa-apple fa-2x"
	Dim fTitle As String = "Available on the"
	Dim fStore As String = "iStore"
	If MyStore = "google" Then
		fFont  = "fa fa-play fa-2x"
		fTitle  = "Get it on"
		fStore  = "Google Play"
	End If
	Element.AddClass("btn1 btn-lg m-r-xs")
	Dim s As String = $"<span class="pull-left m-r-sm">
                <i class="${fFont}"></i>
              </span>
              <span class="clear text-left l-h-1x">
                <span class="text-muted text-xs">${fTitle}</span>
                <b class="text-md block m-b-xs">${fStore}</b>
              </span>"$
	Element.ID = compid
	Element.MaterialUseTheme(sTheme)
	Element.MaterialVisibility(Visibility).MaterialZDepth(ZDepth).MaterialEnable(Enabled).MaterialHoverable(Hoverable)
	Element.addcontent(s)
	If ArrayName = "" Then ArrayName = compid
	Element.AddOnClickEventProperty(ArrayName,Element.ID).addcursor
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If MashPlugIns.Debug = True Then
		Element.VerifyJavaScript(JavaCalls)
		Element.VerifyHTML(HTML)
		Page.ws.Eval(script, Array As String(compid))
	Else
		Page.ws.Eval(script, Array As String(compid))
	End If
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compid))
End Sub

Sub HideScript() As String
	Return Element.JQueryHide
End Sub

Sub Hide
	JQueryExecute(Element.JQueryHide)
End Sub

Sub HideSlow()
	JQueryExecute(Element.JQueryHideSlow)
End Sub

Sub Animate(animationType As String, bInfinity As Boolean, bAfter As String)
	JQueryExecute(Element.JQueryAnimate(animationType,bInfinity,bAfter))
End Sub

Sub FadeOutSlow
	JQueryExecute(Element.JQueryFadeOutSlow)
End Sub

