﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public ID As String
	Public Theme As String
	Public Text As String
	Public IsNew As Boolean
	Public Visibility As String
	Public ZDepth As String
	Public Circle As Boolean
	Public Element As HTMLElement
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public Enabled As Boolean
	Private JavaCalls As List
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


Public Sub Initialize(InternalPage As ABMPage, sID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	ID = sID.tolowercase
	JavaCalls.initialize
	Text = ""
	IsNew = False
	Circle = False
	Element.Initialize(ID,"span")
	Element.addClass("badge")
	Enabled = True
	Theme = ThemeName
	Visibility= ""
	ZDepth = ""
	WavesType= ""
	WavesEffect = False
	WavesCircle = False
End Sub

Sub HTML As String
	Element.ID = ID
	Element.AddContent(Text).MaterialHoverable(Hoverable)
	Element.AddClassOnCondition(Circle,"circle")
	If Circle = True Then
		Element.ApplyStyle("border-radius:10px;padding:4px 5px")
	End If
	Element.AddClassOnCondition(IsNew,"new")
	MashPlugIns.MaterialUseThemeOnCondition(Not(IsNew),Theme,Element)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialWaveseffect(WavesEffect)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Return Element.HTML
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'we create a div with a video and a canvas and we hide the canvas
	Page = InternalPage
	ID = internalID
	Return Element.GetComponentBuilder
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,ID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	Page.ws.Eval(script, Array As String(ID))
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	ID = internalID
	Page = InternalPage
	Refresh
End Sub

Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

