﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Element As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private theme As String
	Private sValue As String
	Private bAlone As Boolean
	Public Inline As Boolean
	Public UnsetRight As Boolean
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'this is a stand alone component
Public Sub StandAlone(InternalPage As ABMPage, ID As String, Value As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	compid = ID.tolowercase
	Prepare(ID,Value,ThemeName)
	bAlone = True
End Sub


Private Sub  Prepare(ID As String, Value As String, ThemeName As String)
	compid = ID
	JavaCalls.Initialize
	JavaCalls.initialize
	Enabled = True
	Visibility= ""
	ZDepth = ""
	theme = ThemeName
	sValue = Value
	bAlone = False
	Inline = False
	UnsetRight = False
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(ID As String, Value As String, ThemeName As String)
	Element.Initialize(compid,"span")
	Prepare(ID,Value,ThemeName)
End Sub

Sub HTML As String
	Element.MaterialVisibility(Visibility)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Dim sForeColor As String = MashPlugIns.ABMGetForeColor(theme)
	Dim sBackColor As String = MashPlugIns.ABMGetBackGroundColor(theme)
	Element.ApplyStyle("position: absolute; top: -4px; right:-10px; font-size: 11px; font-weight: bold;")
	Element.ApplyStyle("display: inline-block;min-width: 10px;padding: 3px 7px;line-height: 1;text-align: center;white-space: nowrap;vertical-align: middle;border-radius: 10px;")
	Element.AddStyleAttribute("background",sBackColor).applystyle("border: 1px solid " & sBackColor).ApplyStyle("vertical-align: baseline;")
	Element.AddStyleAttribute("color",sForeColor)
	Element.AddContent(sValue)
	Element.MaterialZDepth(ABM.ZDEPTH_1)
	If Inline = True Then Element.RemoveStyle("right;position")
	If UnsetRight = True Then Element.RemoveStyle("right")
	Return Element.html
End Sub

Sub RemoveStyle(sStyle As String)
	Element.RemoveStyle(sStyle)
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'we create a div with a video and a canvas and we hide the canvas
	If bAlone = False Then Return ""
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	Page.ws.Eval(script, Array As String(compid))
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	If bAlone = False Then Return
	compid = internalID
	Page = InternalPage
	Refresh
End Sub

Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

