﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Element As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private buttons As Map
	Public IsVertical As Boolean
	Public ButtonSize As String
	Public IsFloating As Boolean
	Public HalfCircleDown As Boolean
	Public HalfCircleUp As Boolean
	Public HalfCircleLeft As Boolean
	Public HalfCircleRight As Boolean
	Public Margin As String 
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Sub AddButtonCircle(btnID As String,btnIcon As String,btnSize As String, btnTheme As String)
	AddButtonCircleBadge(btnID,btnIcon,btnSize,btnTheme,"","")
End Sub

Sub AddButtonCircleBadge(btnID As String,btnIcon As String,btnSize As String, btnTheme As String, Badge As String, badgeTheme As String)
	Dim btn As HTMLElement
	btn = btn.CreateBUTTON($"${compid}${btnID}"$).MaterialUseTheme(btnTheme).AddClass("btn")
	If Margin <> "" Then 
		Margin = Margin.replace("px","")
		btn.ApplyStyle($"margin: ${Margin}px"$)
	End If
	btn.MaterialWavesEffect(True)
	If IsVertical = True Then
		btn.ApplyStyle("display: block;	float: none; width: 100%; max-width: 100%;position: relative;")
	End If
	If Badge <> "" Then
		Dim b As MashBadgeOn
		b.Initialize($"${btnID}badge"$,Badge,badgeTheme)
		btn.AddContent(b.HTML)
		btn.applystyle("overflow: visible;")
	End If
	If btnIcon <> "" Then
		Dim i As HTMLElement
		i = i.CreateI("").MaterialBuildIcon(btnIcon,"left")
		btn.addcontent(i.html)
	End If
	If IsVertical = False Then btn.RemoveStyle("display float width max-width position")
	btn.AddClass("btn-floating").AddCursor
	btn.AddClass(btnSize)
	'JavaCalls.Add(btn.AddChildDocumentClickEvent(compid,btn.ID,btnID))
	btn.AddOnClickEventProperty(compid,btnID)
	buttons.Put(btnID,btn)
End Sub

Sub AddButton(btnID As String,btnText As String, btnIcon As String, btnIconPos As String,btnTheme As String)
	AddButtonBadge(btnID,btnText,btnIcon,btnIconPos,btnTheme,"","",False)
End Sub

Sub AddButtonBadge(btnID As String,btnText As String, btnIcon As String, btnIconPos As String,btnTheme As String,badge As String, badgeTheme As String, badgeInline As Boolean)
	Dim btn As HTMLElement
	btn = btn.CreateBUTTON($"${compid}${btnID}"$).MaterialUseTheme(btnTheme).AddClass("btn")
	If Margin <> "" Then btn.ApplyStyle($"margin: ${Margin}px"$)
	
	btn.MaterialWavesEffect(True)
	If IsVertical = True Then
		btn.ApplyStyle("display: block;	float: none; width: 100%; max-width: 100%;position: relative;")
	End If
	If badgeInline = False Then
		If badge <> "" Then
			Dim b As MashBadgeOn
			b.Initialize($"${btnID}badge"$,badge,badgeTheme)
			b.Inline = False
			btn.AddContent(b.HTML)
			btn.applystyle("overflow: visible;")
		End If
	End If
	If btnIcon <> "" Then
		Dim i As HTMLElement
		i = i.CreateI("").MaterialBuildIcon(btnIcon,btnIconPos)
		btn.addcontent(i.html)
	End If
	If IsFloating = True Or HalfCircleDown = True Or HalfCircleUp = True Or HalfCircleLeft = True Or HalfCircleRight = True Then
		If IsVertical = False Then btn.RemoveStyle("display float width max-width position")
		btn.AddClass("btn-floating")
		btnText = ""		
	End If
	btn.AddContent(btnText)
	If badgeInline = True Then
		If badge <> "" Then
			Dim b As MashBadgeOn
			b.Initialize($"${btnID}badge"$,badge,badgeTheme)
			b.Inline = True
			btn.AddContent("{NBSP}")
			btn.AddContent(b.HTML)
			
		End If
	End If
	'JavaCalls.Add(btn.AddChildDocumentClickEvent(compid,btn.ID,btnID))
	btn.AddOnClickEventProperty(compid,btnID)
	btn.AddClass(ButtonSize)
	buttons.Put(btnID,btn)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize
	Element.Initialize(ID,"div")
	Enabled = True
	Visibility= ""
	ZDepth = ""
	buttons.Initialize
	IsVertical = False
	ButtonSize = MashPlugIns.EnumButtonSize.medium
	IsFloating = False
	HalfCircleDown = False
	Margin = 5
End Sub

Sub HTML As String
	
	Element.ApplyStyle("position: relative; display: inline-block; vertical-align: middle;box-sizing: border-box;")
	If IsVertical = True Then
		Element.RemoveStyle("position display vertical-align box-sizing")
	End If
	'leave this true for proper alignment
	Element.MaterialVisibility(Visibility)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Dim btnI As Int = 0
	For Each btnE As String In buttons.Keys
		btnI = btnI + 1
		Dim btnX As HTMLElement = buttons.Get(btnE)
		btnX.RemoveStyle("border-bottom-right-radius border-bottom-left-radius")
		btnX.RemoveStyle("border-top-right-radius border-top-left-radius")
		If HalfCircleDown = True Then
			btnX.ApplyStyle("border-bottom-right-radius: 3px;border-bottom-left-radius: 3px;")
		End If
		If HalfCircleUp = True Then
			btnX.ApplyStyle("border-top-right-radius: 3px;border-top-left-radius: 3px;")
		End If
		If HalfCircleLeft = True Then
			btnX.ApplyStyle("border-top-left-radius: 3px;border-bottom-left-radius:3px")
		End If
		If HalfCircleRight = True Then
			btnX.ApplyStyle("border-top-right-radius: 3px;border-bottom-right-radius:3px")
		End If
		If IsVertical = True And IsFloating = True Then
			btnX.ApplyStyle("width: 56px;height: 56px;")
		End If
		Element.AddElement(btnX)
	Next
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If MashPlugIns.Debug = True Then 
		Element.VerifyJavaScript(JavaCalls)
		Element.VerifyHTML(HTML)
		Page.ws.Eval(script, Array As String(compid))
	Else
		Page.ws.Eval(script, Array As String(compid))
	End If
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub


