﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Created by alons on 9/8/2016.
'wrapped by Anele 'Mashy' Mbanga for ABMaterial
'anele@mbangas.com
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private mvarWidth As String
	Private mvarHeight As String
	Private pg As ABMPage
	Private mvarWidthLess As Int
	Private camid As String
	Private su As StringUtils
	Public PaddingLeft As String
	Public PaddingRight As String
	Public PaddingTop As String
	Public PaddingBottom As String
	Public MarginTop As String
	Public MarginBottom As String
	Public MarginLeft As String
	Public MarginRight As String
	Public ZDepth As String
	Public BorderColor As String
	Public BorderIntensity As String
	Public BorderWidth As String
	Public BorderStyle As String
	Public IsHighDefinition As Boolean
	Public FrontCamera As Boolean
	Private Element As HTMLElement
	Public ToolTip As String
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, Width As String, Height As String)
	Element.Initialize("","") 
	mvarWidth = Width
	mvarHeight = Height
	mvarWidthLess = Width - 10
	pg = InternalPage
	PaddingLeft = ""
	PaddingRight = ""
	IsHighDefinition = False
	FrontCamera = False
	PaddingTop = ""
	PaddingBottom = ""
	MarginTop = ""
	MarginBottom = ""
	MarginLeft = ""
	MarginRight = ""
	ZDepth = ""
	BorderColor = ABM.COLOR_LIGHTBLUE
	BorderIntensity = ABM.INTENSITY_NORMAL
	BorderWidth = "2"
	BorderStyle = ABM.BORDER_SOLID
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
End Sub
private Sub BuildClass() As String
	Dim sb As StringBuilder
	sb.Initialize
	If MarginTop <> "" Then sb.append(" margin-top: " & MarginTop & "px;")
	If MarginBottom <> "" Then sb.append(" margin-bottom: " & MarginBottom & "px;")
	If MarginLeft <> "" Then sb.append(" margin-left: " & MarginLeft & "px;")
	If MarginRight <> "" Then sb.append(" margin-right: " & MarginRight & "px;")
	If PaddingTop <> "" Then sb.append(" padding-top: " & PaddingTop & "px;")
	If PaddingBottom <> "" Then sb.append(" padding-bottom: " & PaddingBottom & ";")
	If PaddingLeft <> "" Then sb.append(" padding-left: " & PaddingLeft & "px;")
	If PaddingRight <> "" Then sb.append(" padding-right: " & PaddingRight & "px;")
	If ZDepth <> "" Then sb.Append(" ").Append(ZDepth).Append(";")
	sb.Append($"width:${mvarWidth}px;height:${mvarHeight}px;background:#ffffff;border-radius:5px;"$)
	Return sb.tostring.trim
End Sub
private Sub BuildVideoStyle() As String
	Dim sColor As String = MashPlugIns.ABMGetColor(BorderColor,BorderIntensity)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"border:${BorderStyle} ${sColor};border-width:${BorderWidth}px;border-radius:5px;padding: 5px 5px 5px 5px;"$)
	Return sb.tostring
End Sub
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'we create a div with a video and a canvas and we hide the canvas
	pg = InternalPage
	camid = internalID
	Dim sColor As String = MashPlugIns.ABMGetColor(BorderColor,BorderIntensity)
	Return $"<div id="${internalID}" style="${BuildClass}">
	<video id="${internalID}video" width="${mvarWidthLess}px" height="${mvarHeight}px" autoplay" style="${BuildVideoStyle}"></video>
	<canvas id="${internalID}canvas" width="${mvarWidthLess}px" height="${mvarHeight}px" style="border:${BorderStyle} ${sColor};display:none;"></canvas>
	</div><script>var _${internalID};</script>"$
End Sub
' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	camid = internalID
	pg = InternalPage
	Prepare
	camid = internalID
	pg = InternalPage
	If ZDepth <> "" Then
		ABM.AddClass(InternalPage,internalID,ZDepth)
		ABM.AddClass(InternalPage,internalID & "video",ZDepth)
		ABM.AddClass(InternalPage,internalID & "canvas",ZDepth)
	End If
End Sub
'prepare the areas and preview video
private Sub Prepare
	'//navigator.gettMedia({video:True,audio: False}, function (stream){
	Dim configureSizes As String = ""
	Dim faceMode As String = ""
	If FrontCamera = True Then
		faceMode = $"facingMode:"user""$
	Else
		faceMode = $"facingMode:{exact:"environment"}"$
	End If
	If IsHighDefinition = True Then
		'set to high definition
		configureSizes = $"var hdConstraints = {video:true,audio:false,${faceMode},width:1280,height:720,mandatory:{minwidth:1280,minheight:720}};"$
	Else
		'set to vga / specified sizes
		configureSizes = $"var hdConstraints = {video:true,audio:false,${faceMode},width:${mvarWidth},height:${mvarHeight},mandatory:{maxwidth:${mvarWidth},maxheight:${mvarHeight}}};"$
	End If
	Dim script As String = $"var ${camid}canvas = document.getElementById('${camid}canvas');
	var ${camid}context = ${camid}canvas.getContext('2d');
	var ${camid}video = document.getElementById('${camid}video');
	${configureSizes}
	vendorUrl = window.URL || window.webkitURL;
	navigator.gettMedia = navigator.getUserMedia ||navigator.webkitGetUserMedia ||navigator.mozGetUserMedia || navigator.msGetUserMedia;
	navigator.gettMedia(hdConstraints, function (stream){
	${camid}video.src = vendorUrl.createObjectURL(stream);
	${camid}video.play();
	b4j_raiseEvent('${camid}_ready', {'value':'Supported'});
	},function(error){
	b4j_raiseEvent('${camid}_error', {'value':'Not Supported'});
	});	"$
	pg.ws.Eval(script, Array As Object(camid))
End Sub
'take a picture
Sub TakePicture(img As ABMImage)
	Dim script As String = $"var ${camid}canvas = document.getElementById('${camid}canvas');
	var ${camid}context = ${camid}canvas.getContext('2d');
	var ${camid}video = document.getElementById('${camid}video');
	${camid}context.drawImage(${camid}video, 0, 0, ${mvarWidthLess}, ${mvarHeight});
	var ${camid}dataURL = ${camid}canvas.toDataURL('image/jpeg');
	var image = document.getElementById('${img.id}');
	image.src =  ${camid}dataURL;
	b4j_raiseEvent('${ABMComp.ID}_takepicture', {'value':${camid}dataURL});"$
	pg.ws.Eval(script, Array As Object(camid))
End Sub
'convert the base64 string to an image
private Sub Base64StringToImage(s As String) As Image
	Dim su As StringUtils
	Dim bytes() As Byte = su.DecodeBase64(s)
	Dim inp As InputStream
	inp.InitializeFromBytesArray(bytes, 0, bytes.Length)
	Dim bmp As Image
	bmp.Initialize2(inp)
	inp.Close
	Return bmp
End Sub
'save the image
public Sub Save(dataURL As String,imgDir As String, imgFile As String)
	Try
		'clean up the image first
		dataURL = dataURL.Replace("data:image/jpeg;base64,","")
		Dim img As Image = Base64StringToImage(dataURL)
		Dim outp As OutputStream = File.OpenOutput(imgDir, imgFile,False)
		img.WriteToStream(outp)
		outp.Close
	Catch
	End Try
End Sub
'toggle the camera
Sub ToggleCamera
	If FrontCamera = True Then
		FrontCamera = False
		Prepare
	Else
		FrontCamera = True
		Prepare
	End If
End Sub
' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub
' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
