﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Public Element As HTMLElement
	Public Theme As String
	Public Enabled As Boolean
	Public Visibility As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
	Private Contents As List
	Private revealContent As List
	Private cardContent As HTMLElement
	Private cardReveal As HTMLElement
	Private cardActions As HTMLElement
	Private hasActions As Boolean
	Type CardSizeType(small As String, medium As String, large As String)
	Public EnumCardSize As CardSizeType
	Private cardAction As HTMLElement
	Private hascardaction As Boolean
	Private cardImage As HTMLElement
	Private sLogoURL As String
	Private sLogoLink As String
	Private sLogoAlt As String
	Private sProductName As String
	Private sProductDetails As String
	Private isProduct As Boolean
	Public ToolTip As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Sub AddProductName(pName As String)
	sProductName = pName
	isProduct = True
End Sub

Sub AddProductDetails(pDetails As String)
	sProductDetails = pDetails
	isProduct = True
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String, sHeight As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.Initialize
	Page = InternalPage
	compID = ID.tolowercase
	WavesType = ""
	WavesCircle = False
	WavesEffect = False
	ZDepth = ""
	Contents.initialize
	revealContent.initialize
	Element = Element.CreateDIV(compID)
	Element.AddClass("card").ApplyStyle("overflow:hidden").ApplyStyle("margin:0")
	cardContent = cardContent.CreateDIV("")
	cardContent.AddClass("card-content")
	cardReveal = cardReveal.CreateDIV("").AddClass("card-reveal")
	cardActions = cardActions.CreateUL("").AddClass("card-action-buttons")
	cardActions.ApplyStyle("margin:-26px 10px 0 0").ApplyStyle("text-align:right")
	hasActions = False
	EnumCardSize.Initialize 
	EnumCardSize.large = "large"
	EnumCardSize.medium = "medium"
	EnumCardSize.small = "small"
	cardAction = cardAction.CreateDIV("").AddClass("card-action") 
	hascardaction = False
	cardImage = cardImage.CreateDIV("")
	cardImage.AddClass("card-image").MaterialWavesEffect(True).MaterialWavesBlock(True).MaterialWavesLight(True)
	cardImage.ApplyStyle("position:relative").ApplyStyle("width:100%")
	If sHeight <> "" Then cardImage.ApplyStyle($"height:${sHeight}px"$)
	isProduct = False
End Sub


Sub SetLogo(LogoURL As String, LogoLink As String)
	sLogoURL = LogoURL
	sLogoLink = LogoLink
End Sub

Sub SetCardSize(sSize As String)
	Element.AddClass(sSize)
End Sub

Sub AddParagraph(paragraph As String)
	Dim p As HTMLElement
	p = p.CreateP("").AddContent(paragraph)
	cardContent.AddContent(p.HTML)
End Sub

Sub AddPrice(sPrice As String, sColor As String, sIntensity As String)
	Dim a As HTMLElement
	a = a.CreateA("").AddClass("btn-floating").AddClass("btn-large").AddClass("btn-price")
	a.MaterialWavesEffect(True).MaterialWavesLight(True).AddClass(sColor).AddClass(sIntensity)
	a.AddContent(sPrice)
	a.ApplyStyle("width:65px").ApplyStyle("height:65px").ApplyStyle("font-weight:600")
	a.ApplyStyle("font-size:1.0rem").ApplyStyle("line-height:65px").ApplyStyle("margin:10px")
	a.ApplyStyle("position:absolute").ApplyStyle("top:0").ApplyStyle("letter-spacing:0")
	a.addclass("activator").addcursor
	cardImage.AddContent(a.HTML)
	Element.ApplyStyle("margin:0")
	cardContent.ApplyStyle("padding:5px 10px")
	isProduct = True
End Sub

Sub SetAuthorPlusDate(sAuthor As String, sDate As String)
	Dim p As HTMLElement
	p = p.CreateP("").AddClass("ultra-small").AddContent(sDate)
	p.ApplyStyle("font-size:0.8rem").ApplyStyle("margin:0").ApplyStyle("padding:0")	
	cardContent.AddContent(p.HTML)
	
	cardAction.AddSpace.AddContent("By").AddSpace
	hascardaction = True
	'add author name
	Dim a As HTMLElement
	a = a.createa(compID & "author").AddContent(sAuthor)
	cardAction.AddContent(a.HTML)
	'add read more
	Dim rm As HTMLElement
	rm = rm.createa(compID & "readmore").AddClass("right").AddContent("Read More...").addspace.AddCursor
	'JavaCalls.Add(a.AddChildClickEvent(compID,rm.ID,"readmore"))
	rm.AddOnClickEventProperty(compID,"readmore")
	cardAction.AddContent(rm.HTML)
End Sub

Sub AddShare(btnID As String,btnColor As String)
	AddActionButton(btnID,"mdi-social-share",False,btnColor,ABM.INTENSITY_ACCENT4)
End Sub

Sub AddRepeat(btnID As String,btnColor As String)
	AddActionButton(btnID,"mdi-av-repeat",False,btnColor,ABM.INTENSITY_ACCENT4)
End Sub

Sub AddShoppingCart(btnID As String,btnColor As String)
	AddActionButton(btnID,"mdi-action-shopping-cart",False,btnColor,ABM.INTENSITY_ACCENT4)
End Sub

Sub AddFavourate(btnID As String,btnColor As String)
	AddActionButton(btnID,"mdi-action-favorite",False,btnColor,ABM.INTENSITY_ACCENT4)
End Sub

Sub AddInfo(btnID As String, btnColor As String)
	AddActionButton(btnID,"mdi-action-info",True,btnColor,ABM.INTENSITY_ACCENT4)
End Sub

Sub AddRevealParagraph(paragraph As String)
	Dim p As HTMLElement
	p = p.CreateP("").AddContent(paragraph)
	revealContent.Add(paragraph)
End Sub

Sub AddRole(Role As String, bOnReveal As Boolean)
	AddContent(MashPlugIns.MaterialIcons.mdi_perm_identity,Role,bOnReveal)
End Sub

Sub AddContactNumber(ContactNumber As String, bOnReveal As Boolean)
	AddContent(MashPlugIns.MaterialIcons.mdi_perm_phone_msg,ContactNumber, bOnReveal)
End Sub

Sub AddEmailAddress(EmailAddress As String, bOnReveal As Boolean)
	AddContent(MashPlugIns.MaterialIcons.mdi_email,EmailAddress, bOnReveal)
End Sub

Sub AddBirthDay(BirthDay As String, bOnReveal As Boolean)
	AddContent(MashPlugIns.MaterialIcons.mdi_cake,BirthDay, bOnReveal)
End Sub

private Sub AddContent(sIcon As String, sContent As String, bOnReveal As Boolean)
	Dim tmpPara As HTMLElement
	tmpPara = tmpPara.CreateP("")
	Dim tmpIcon As MashIcon
	tmpIcon.Initialize(Page,"","")
	tmpIcon.IconName = sIcon
	tmpPara.AddContent(tmpIcon.HTML).addspace.AddContent(sContent)
	tmpPara.ApplyStyle("font-size:1.2rem").ApplyStyle("margin:10px 0 12px")
	Dim sout As String = tmpPara.html
	Contents.Add(sout)
	If bOnReveal = True Then
		revealContent.Add(sout)
	End If
End Sub

Sub AddCardImage(imgURL As String, bActivator As Boolean, imgAlt As String)
	'create the background image
	Dim img As HTMLElement
	img = img.CreateIMG("").SetALT(imgAlt)
	img.AddClassoncondition(bActivator,"activator")
	img.SetSRC(imgURL,false)
	cardImage.AddContent(img.HTML.Replace(CRLF,""))
End Sub

Sub AddTitlePlusHashTags(sTitle As String, sColor As String, HashTags As List)
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("card-title").AddContent(sTitle)
	span.ApplyStyle("font-size:1.2rem").ApplyStyle("line-height:1.6rem").ApplyStyle("font-weight:400")
	span.MaterialTextColor(sColor).MaterialTextIntensity(ABM.INTENSITY_DARKEN4)
	cardImage.AddContent(span.HTML)
	
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("card-title").AddClass("blog-post-full-cat").AddClass("right").AddClass(ABM.COLOR_CYAN)
	span.ApplyStyle("padding:5px").ApplyStyle("margin:25px").ApplyStyle("right:0")
	span.ApplyStyle("left:inherit").ApplyStyle("font-size:15px").ApplyStyle("font-weight:500").ApplyStyle("letter-spacing:1px")
	span.ApplyStyle("text-transform:uppercase")
	
	Dim sb As StringBuilder
	sb.Initialize
	For Each hashTag As String In HashTags
		Dim a As HTMLElement
		a = a.CreateA("").AddContent("#").AddContent(hashTag.trim).addcursor
		a.ApplyStyle("color:#fff").ApplyStyle("text-shadow:none")
		span.AddContent(a.HTML.Replace(CRLF,"")).addspace
	Next
	cardImage.AddContent(span.HTML)
End Sub

private Sub AddProductNamePlustDetails()
	Dim row As HTMLElement
	row = row.CreateDIV("").AddClass("row").ApplyStyle("margin-bottom:0")
	
	Dim col As HTMLElement
	col = col.CreateDIV("").AddClass("col").AddClass("s8")
	
	Dim p As HTMLElement
	p = p.CreateP("").AddClass("card-title").MaterialTextColor(ABM.COLOR_GREY).MaterialTextIntensity(ABM.INTENSITY_DARKEN4)
	
	
	Dim a As HTMLElement
	a = a.CreateA("").MaterialTextColor(ABM.COLOR_GREY).MaterialTextIntensity(ABM.INTENSITY_DARKEN4).AddContent(sProductName)
	a.addclass("activator").addcursor
	
	p.AddContent(a.HTML)
	col.AddContent(p.HTML)
	row.AddContent(col.HTML)
	
	'if we have a logo
	If sLogoURL <> "" Then
		Dim col1 As HTMLElement
		col1 = col1.CreateDIV("")
		col1.AddClass("col").AddClass("s4").AddClass("no-padding")
		
		Dim a1 As HTMLElement
		a1 = a1.CreateA("").SetHREF("#")
		
		Dim img1 As HTMLElement
		img1 = img1.CreateIMG("").SetSRC(sLogoURL,False).SetALT(sLogoAlt).MaterialResponsive(True)
		
		col1.AddContent(a1.HTML).AddContent(img1.HTML)
		row.AddContent(col1.HTML)
	End If
	
	cardContent.AddContent(row.HTML)
	AddRevealCardTitle(sProductName,ABM.COLOR_GREY)
	AddRevealParagraph(sProductDetails)
End Sub


Sub AddActionButton(actionID As String, iconName As String, bActivator As Boolean, BackgroundColor As String, BackgroundColorIntensity As String)
	Dim li As HTMLElement
	li = li.CreateLI("")
	li.ApplyStyle("display:inline-block").ApplyStyle("padding-left:5px")
	Dim a As HTMLElement
	a = a.CreateA(compID & actionID).AddClass("btn-floating").MaterialWavesEffect(True).MaterialWavesLight(True)
	a.AddClass(BackgroundColor).AddClass(BackgroundColorIntensity)
	Dim i As HTMLElement
	i = i.CreateI(compID & actionID).MaterialBuildIcon(iconName,"").AddClassOnCondition(bActivator,"activator")
	a.AddContent(i.HTML.Replace(CRLF,""))
	li.AddContent(a.HTML.Replace(CRLF,""))
	cardActions.addcontent(li.HTML)
	hasActions = True
	'lets add a click option for this button
	If bActivator = False Then
		'JavaCalls.Add(a.AddChildClickEvent(compID,a.ID,actionID))
		a.AddOnClickEventProperty(compID,actionID)
	End If
End Sub

Sub AddUserImage(imgURL As String)
	Dim uimg As HTMLElement
	uimg = uimg.CreateIMG("").SetSRC(imgURL,False).SetALT("")
	uimg.AddClass("circle").AddClass("responsive-img").AddClass("activator")
	uimg.AddClass("card-profile-image").MaterialZDepth(ABM.ZDEPTH_1)
	'card-profile-image
	uimg.ApplyStyle("width:70px").ApplyStyle("position:absolute").ApplyStyle("top:110px").ApplyStyle("z-index:1").ApplyStyle("cursor:pointer")
	uimg.ApplyStyle("left:40px").ApplyStyle("margin:0")
	'create the edit button
	cardContent.AddContent(uimg.HTML)	
End Sub

Sub AddFloatingButton(btnID As String, iconName As String,bActivator As Boolean)
	Dim iedit As HTMLElement
	iedit = iedit.createa($"${compID}${btnID}"$).AddClass("btn-floating").AddClassoncondition(bActivator,"activator").AddClass("btn-move-up")
	iedit.MaterialWavesEffect(True).MaterialWavesLight(True).AddClass("darken-2").AddClass("right")
	'btn-move-up
	iedit.ApplyStyle("position:relative").applystyle("top:-40px").ApplyStyle("right:-18px").ApplyStyle("margin-right:10px")
	
	Dim iconedit As HTMLElement
	iconedit = iconedit.createi("").MaterialBuildIcon(iconName,"")
	iedit.AddContent(iconedit.HTML)
	cardContent.AddContent(iedit.HTML)
	If bActivator = False Then
		'JavaCalls.Add(iedit.AddChildClickEvent(compID,iedit.ID,btnID))
		iedit.AddOnClickEventProperty(compID,btnID)
	End If
End Sub

Sub AddCardTitle(sTitle As String, sColor As String, bActivator As Boolean,bOnCardReveal As Boolean)
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("card-title").AddClassoncondition(bActivator,"activator").AddContent(sTitle)
	span.MaterialTextColor(sColor).MaterialTextIntensity(ABM.INTENSITY_DARKEN4)
	cardContent.AddContent(span.HTML)
	If bOnCardReveal = True Then
		AddRevealCardTitle(sTitle,sColor)
	End If
End Sub

Sub AddBlogCategoryPlusTopic(sCategory As String, sDate As String, sTopic As String,sTextColor As String)
	Dim p As HTMLElement
	Dim span1 As HTMLElement
	Dim span2 As HTMLElement
	Dim h4 As HTMLElement
	Dim a As HTMLElement
	Dim a1 As HTMLElement 
	p = p.CreateP("").AddClass("row")
	span1 = span1.CreateSPAN("").AddClass("left")
	a = a.CreateA("").AddProperty("href","#").AddContent(sCategory)
	span1.AddContent(a.HTML)
	
	span2 = span2.CreateSPAN("").AddClass("right").AddContent(sDate)
	p.AddContent(span1.HTML).AddContent(span2.HTML)
	h4 = h4.CreateH4("").AddClass("card-title").MaterialTextColor(sTextColor).MaterialTextIntensity(ABM.INTENSITY_DARKEN4)
	h4.ApplyStyle("font-size:1.2rem").ApplyStyle("line-height:1.6rem").ApplyStyle("font-weight:400")
	a1 = a1.CreateA("").MaterialTextColor(sTextColor).MaterialTextIntensity(ABM.INTENSITY_DARKEN4).AddContent(sTopic)
	h4.AddContent(a1.HTML)
	cardContent.AddContent(p.HTML)
	cardContent.AddContent(h4.HTML)
	'lets fix the blog
	Element.ApplyStyle("margin:0")
	cardContent.ApplyStyle("padding:5px 10px")
End Sub

Sub AddRevealCardTitle(sTitle As String, sColor As String)
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("card-title").AddContent(sTitle)
	span.MaterialTextColor(sColor).MaterialTextIntensity(ABM.INTENSITY_DARKEN4)
	Dim i As HTMLElement
	i = i.CreateI("").MaterialBuildIcon("mdi-navigation-close","right")
	span.AddContent(i.HTML.Replace(CRLF,""))
	revealContent.Add(span.html)
End Sub


Sub AddBlogContent(sContent As String)
	Dim p As HTMLElement
	p = p.CreateP("").AddClass("blog-post-content")
	p.ApplyStyle("padding-bottom:10px").AddContent(sContent)
	cardContent.AddContent(p.HTML)	
End Sub

Sub AddBlogAuthor(sAuthor As String, sImageURL As String)
	Dim row As HTMLElement
	Dim col As HTMLElement
	Dim img As HTMLElement
	Dim a As HTMLElement
	Dim namediv As HTMLElement
	
	row = row.CreateDIV("").AddClass("row").ApplyStyle("margin-bottom:0")
	col = col.CreateDIV("").AddClass("col").AddClass("s2")
	img = img.CreateIMG("").SetSRC(sImageURL,false).SetALT("").MaterialCircle(True).MaterialResponsive(True)
	img.AddClass("valign").AddClass("profile-image")
	img.AddStyleAttribute("width","50px").ApplyStyle("height:50px")
	img.MaterialZDepth(ABM.ZDEPTH_1)
	col.AddContent(img.HTML)
	row.AddContent(col.HTML)
	namediv = namediv.CreateDIV("").AddClass("col").AddClass("s9").AddContent("By").AddSpace
	a = a.CreateA("").SetHREF("#").AddContent(sAuthor)
	namediv.AddContent(a.HTML)
	row.AddContent(namediv.HTML)
	cardContent.AddContent(row.HTML)
End Sub

Sub HTML As String
	'create the card
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle).MaterialHoverable(Hoverable)
	
	If isProduct = True Then AddProductNamePlustDetails
	
	Element.AddContent(cardImage.HTML)
	If hasActions = True Then Element.AddContent(cardActions.HTML.Replace(CRLF,""))
	'add the rest of the contents
	cardContent.AddContentlist(Contents)
	
	Element.AddContent(cardContent.HTML)
	
	cardReveal.AddContentList(revealContent)
	Element.AddContent(cardReveal.HTML)
	If hascardaction = True Then
		Element.AddContent(cardAction.HTML)
	End If
	Return Element.HTML
End Sub


Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	InternalPage.ws.Eval(script, Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub