﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Element As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private sSmall As Int
	Private sMedium As Int
	Private sLarge As Int
	Private sTitle As String
	Private sTheme As String
	Private sSubTitle As String
	Private buttons As List
	Public HeaderTheme As String
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, Title As String, SubTitle As String, Small As Int, Medium As Int, Large As Int, ThemeName As String)
	Dim style As HTMLElement
	'define style classes to load with the component
	style = style.CreateSTYLE("card1")
	style.AddExternalStyle("card1","min-height: 50px; position: relative; margin-bottom: 30px;border-radius: 2px;box-shadow: 0 2px 10px rgba(0, 0, 0, 0.2);")
	style.AddExternalStyle("header","padding: 20px; position: relative; border-bottom: 1px solid rgba(204, 204, 204, 0.35);")
	style.AddExternalStyle("cardh2","margin: 0; font-size: 18px; font-weight: normal;")
	style.AddExternalStyle("cardsmall","display: block; font-size: 12px; margin-top: 5px; line-height: 15px;")
	style.AddExternalStyle("header-dropdown","position: absolute; top: 20px; right: 15px; list-style: none;")
	style.AddExternalStyle("m-r--5","margin-right: -5px;")
	style.AddExternalStyle("m-r-0","margin-right: 0px;")
	style.AddExternalStyle("cardul","margin-top: 0; margin-bottom: 10px;")
	style.AddExternalStyle("cardli","display: inline-block;position: relative;")
	style.AddExternalStyle("carda","cursor: pointer;outline: none;text-decoration: none;background-color: transparent;")
	style.AddExternalStyle("dropdown-menu.pull-right","right: 0; left: auto;")
	style.AddExternalStyle("dropdown-menu", "border-radius: 0; margin-top: -35px; box-shadow: 0 2px 10px rgba(0, 0, 0, 0.2);border: none;")
	style.AddExternalStyle("pull-right","float: right;")
	style.AddExternalStyle("dropdown-menu","position: absolute;top: 100%;z-index: 1000;display: none;min-width: 160px; padding: 5px 0; margin: 2px 0 0;")
	style.AddExternalStyle("dropdown-menu", "font-size: 14px; text-align: left; list-style: none; background-color: #fff;background-clip: padding-box;")
	style.AddExternalStyle("cardli1","display: block !important;")
	style.AddExternalStyle("carda1","padding: 7px 18px;color: #666;transition: all 0.5s;font-size: 14px;line-height: 25px;display: block;clear: both;font-weight: normal;")
	style.AddExternalStyle("carda1","white-space: nowrap;")
	style.AddExternalStyle("cardbody","font-size: 14px; color: #555; padding: 20px;box-sizing: border-box;")
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,style.BuildStyleClasses)
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize
	Element.Initialize(ID,"div").AddClass("col")
	Enabled = True
	Visibility= ""
	ZDepth = ""
	sSmall = Small
	sMedium = Medium
	sLarge = Large
	sTitle = Title
	sTheme = ThemeName
	sSubTitle = SubTitle
	buttons.initialize
	HeaderTheme = ""
End Sub

Sub SetSizes(Small As Int, Medium As Int, Large As Int)
	Element.MaterialSetSizes(Small,Medium,Large)
End Sub

Sub AddMenuButton(menuID As String, menuIcon As String, menuTheme As String)
	'create the list item
	Dim li As HTMLElement
	li = li.CreateLI(menuID).SetParentID(compid).AddClass("cardli")
	'create the anchor
	Dim a As HTMLElement
	a = a.CreateA(menuID & "a").SetParentID(compid).AddClass("carda carda1")
	a.MaterialAddIcon(menuIcon,"",menuTheme,True,False,True,False,False,"")
	li.AddElement(a)
	li.AddOnClickEventProperty(compid,menuID)
	buttons.Add(li.HTML)
End Sub


Sub HTML As String
	Dim sHBackColor As String = ""
	Dim sHForeColor As String = ""
	If HeaderTheme <> "" Then
		sHBackColor = MashPlugIns.GetBackColorFromTheme(HeaderTheme)
		sHForeColor = MashPlugIns.GetForeColorFromTheme(HeaderTheme)
	End If
	Element.ID = compid
	Element.MaterialSetSizes(sSmall,sMedium,sLarge).AddClass("col")
	Dim sButtons As String = MashPlugIns.MvFromList(buttons,CRLF)
	Dim sOutput As String = $"<div class="card card1">
                        <div class="header ${sHBackColor} ${sHForeColor}  ">
                            <h2 class="cardh2">
                                ${sTitle}
                                <small class="cardsmall">${sSubTitle}</small>
                            </h2>
                            <ul class="header-dropdown m-r-0 cardul">
							${sButtons}
                            </ul>
                        </div>
                        <div class="cardbody">
                        </div>
                    </div>"$
	Element.AddContent(sOutput)
	Element.MaterialVisibility(Visibility)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If MashPlugIns.Debug = True Then
		Element.VerifyJavaScript(JavaCalls)
		Element.VerifyHTML(HTML)
		Page.ws.Eval(script, Array As String(compid))
	Else
		Page.ws.Eval(script, Array As String(compid))
	End If
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compid))
End Sub

Sub HideScript() As String
	Return Element.JQueryHide
End Sub

Sub Hide
	JQueryExecute(Element.JQueryHide)
End Sub

Sub HideSlow()
	JQueryExecute(Element.JQueryHideSlow)
End Sub

Sub Animate(animationType As String, bInfinity As Boolean, bAfter As String)
	JQueryExecute(Element.JQueryAnimate(animationType,bInfinity,bAfter))
End Sub

Sub FadeOutSlow
	JQueryExecute(Element.JQueryFadeOutSlow)
End Sub

