﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
'the height of the carousel is 400px
'the width of the image is 100%
'the carousel item width and height is 200px
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Public Visibility As String
	Public WavesType As String
	Public ZDepth As String
	Public Enabled As Boolean
	Public WavesEffect As Boolean
	Public WavesCircle As Boolean
	Public Element As HTMLElement
	Private Items As List
	Public IsSlider As Boolean
	Public Duration As Int
	Public Dist As Int
	Public Shift As Int
	Public Padding As Int
	Public FullWidth As Boolean
	Public Indicators As Boolean
	Public NoWrap As Boolean
	Public Center As Boolean
	Private JavaCalls As List
	Public ToolTip As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
	Public Static As Boolean
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String,bIsSlider As Boolean)
	Prepare(InternalPage,ID)
	IsSlider = bIsSlider
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Private Sub Prepare(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.initialize
	Page = InternalPage
	compID = ID.tolowercase
	Element = Element.Initialize(compID,"div")
	Center = False
	Visibility = ""
	Static = True
	WavesType = ""
	ZDepth = ""
	Enabled = True
	WavesEffect = False
	WavesCircle = False
	Items.Initialize
	IsSlider = False
	Duration = 200
	Dist = -100
	Shift = 0
	Padding = 0
	FullWidth = False
	Indicators = True
	NoWrap = True
	JavaCalls.Add(JavaScript)
End Sub


Sub AddFixedItem(itemID As String, itemHTML As String)
	Dim fi As HTMLElement
	fi.Initialize(itemID,"div").AddClass("carousel-fixed-item").AddClass("center")
	fi.AddContent(itemHTML.Replace(CRLF,""))
	Items.Add(fi.HTML)
End Sub

Sub AddItem(itemid As String, itemHTML As String)
	Dim div As HTMLElement
	div.Initialize(itemid,"div")
	div.AddClass("carousel-item")
	div.AddContent(itemHTML)
	div.AddOnClickEventProperty(compID,div.id)
	Items.Add(div.HTML)
End Sub

Sub AddContainer(itemid As String, href As String, itemtitle As String, itemdescription As String, themeName As String)
	If themeName = "" Then themeName = "whitelightblue"
	Dim div As HTMLElement
	div.Initialize(itemid,"div")
	div.AddClass("carousel-item")
	div.setHREF(href)
	MashPlugIns.MaterialUseTheme(themeName,div)
	
	Dim titlediv As HTMLElement
	titlediv.Initialize("","h2")
	titlediv.AddContent(itemtitle)
	div.AddContent(titlediv.HTML)
	
	Dim descdiv As HTMLElement
	descdiv.Initialize("","p")
	descdiv.AddContent(itemdescription)
	MashPlugIns.MaterialUseTheme(themeName,descdiv)
	div.AddContent(descdiv.HTML)
	div.AddOnClickEventProperty(compID,div.id)
	Items.Add(div.HTML)
End Sub

Sub AddSlide(itemID As String, href As String, imgURL As String)
	Dim slideItem As MashAnchor
	slideItem.Initialize(itemID)
	slideItem.Element.AddClass("carousel-item")
	slideItem.HREF = href
	slideItem.element.MaterialAddImage(imgURL,"","","",False,True,"",False,Static,"")
	slideItem.WavesEffect = False
	slideItem.element.AddOnClickEventProperty(compID,slideItem.id)
	Items.Add(slideItem.HTML)
	'If itemID <> "" Then
	'	JavaCalls.Add(slideItem.Element.AddChildClickEvent(compID,itemID,imgURL))
	'End If
End Sub

Sub HTML As String
	Element.AddClass("carousel")
	Element.AddClassOnCondition(IsSlider,"carousel-slider")
	Element.AddAttributeOnCondition(Indicators,"data-indicators","true")
	Element.AddClassOnCondition(Center,"center")
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility).MaterialHoverable(Hoverable)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.AddContentList(Items)
	Return Element.HTML
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,"")
	Page.ws.Eval(script, Array As String(compID))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JavaScript() As String
	Dim sb As String = $"$('#${compID}').carousel({fullwidth: ${FullWidth},duration:${Duration},dist:${Dist},shift:${Shift},padding:${Padding},indicators:${Indicators},nowrap:${NoWrap}});"$
	Return sb
End Sub
