﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private Element As HTMLElement
	Public Theme As String
	Public Visibility As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
	Public Enabled As Boolean
	Private InitialWith As List
	Private AutoComplete As List
	Public PlaceHolder As String
	Public SecondaryPlaceHolder As String
	Private Theme As String
	Public ToolTip As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

private Sub Prepare
	Element.AddClass("chips-initial").AddClass("chips-placeholder")
	Element.AddClass("chips-autocomplete").AddClass("chips")
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String,ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.initialize
	Page = InternalPage
	compID = ID.tolowercase
	InitialWith.Initialize
	AutoComplete.Initialize
	PlaceHolder=""
	Theme = ThemeName
	SecondaryPlaceHolder=""
	Enabled = True
	Theme = ""
	Element.Initialize(compID,"div")
	WavesType = ""
	WavesCircle = False
	WavesEffect = False
	Prepare
End Sub


Sub AddInitialWith(sValue As String) As MashChips
	If sValue = "" Then Return Me
	If InitialWith.IndexOf(sValue) = -1 Then InitialWith.Add(sValue)
	Return Me
End Sub

Sub AddAutoComplete(sValue As String) As MashChips
	If sValue = "" Then Return Me
	If AutoComplete.IndexOf(sValue) = -1 Then AutoComplete.Add(sValue)
	Return Me
End Sub

private Sub JSExecuteInitialWith As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("data: [")
	For Each strValue As String In InitialWith
		sb.Append("{tag: '").Append(strValue).Append("',},")
	Next
	If sb.ToString.EndsWith(",") Then
		sb.Remove(sb.Length-1,sb.Length)
	End If
	sb.Append("],")
	Dim JS As String = $"$('#${compID}').material_chip({"$
	JS = JS & sb.ToString & "});"
	Return JS
End Sub

private Sub JSExecuteAutoComplete As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("autocompleteOptions: {")
	sb.Append("data: {")
	For Each strValue As String In AutoComplete
		sb.Append($"'${strValue}': null,"$)
	Next
	If sb.ToString.EndsWith(",") Then
		sb.Remove(sb.Length-1,sb.Length)
	End If
	sb.Append("},")
	sb.Append("limit: Infinity,")
	sb.Append("minLength: 1")
	sb.Append("}});")
	Dim JS As String = $"$('#${compID}').material_chip({"$
	JS = JS & sb.ToString
	Return JS
End Sub

private Sub JQExecuteAddPlaceHolder(sPlaceholder As String, sSecondaryPlaceholder As String) As String
	Dim JS As String = $"$('#${compID}').material_chip({placeholder: '${sPlaceholder}', secondaryPlaceholder: '${sSecondaryPlaceholder}',});"$
	Return JS
End Sub

Sub HTML As String
	Prepare
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle).MaterialHoverable(Hoverable)
	Return Element.html
End Sub


Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	'add javascripts
	JavaCalls.Add($"$('#${compID}').material_chip();"$)
	If PlaceHolder <> "" And SecondaryPlaceHolder <> "" Then
		JavaCalls.Add(JQExecuteAddPlaceHolder(PlaceHolder,SecondaryPlaceHolder))
	End If
	If InitialWith.Size - 1 <> -1 Then
		JavaCalls.add(JSExecuteInitialWith)
	End If
	If AutoComplete.Size - 1 <> -1 Then
		JavaCalls.add(JSExecuteAutoComplete)
	End If
	JavaCalls.Add(JSExecuteOnDelete($"b4j_raiseEvent('${compID}_chipdelete', {'value':chip.tag});"$))
	JavaCalls.Add(JSExecuteOnAdd($"b4j_raiseEvent('${compID}_chipadd', {'value':chip.tag});"$))
	JavaCalls.Add(JSExecuteOnSelect($"b4j_raiseEvent('${compID}_chipselect', {'value':chip.tag});"$))
	JavaCalls.Add($"$("#${compID} .close").click(function() { $(this).closest('#${compID}').fadeOut('slow');});"$)
	JavaCalls.Add("Materialize.updateTextFields();")
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,CRLF)
	Page.ws.Eval(script, Array As String(compID))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh	
End Sub

Sub Text() As String
	Dim script As String = $"$('#${compID}').material_chip('data');"$
	Dim f As Future = Page.ws.EvalWithResult(script,Array As String(compID))
	Return f.Value 
End Sub

private Sub JSExecuteOnDelete(sCode As String) As String
	Dim js As String = $"$('#${compID}').on('chip.delete', function(e, chip){${sCode}});"$
	Return js
End Sub

private Sub JSExecuteOnAdd(sCode As String) As String
	Dim js As String = $"$('#${compID}').on('chip.add', function(e, chip){${sCode}});"$
	Return js
End Sub

private Sub JSExecuteOnSelect(sCode As String) As String
	Dim js As String = $"$('#${compID}').on('chip.select', function(e, chip){${sCode}});"$
	Return js
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
