﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private Lines As List
	Private fName As String
	Private indent As Int = 0
	Private linePos As Int
	Private strActual As String
	Private strTemp As String
	Private SelStart As Boolean
	Public SubRoutines As Map
	Private SubStart As Int
	Private SubEnd As Int
	Private SubName As String
	Private SubDeclaration As String
	Private SubCode As String
	Private strCode As String
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(dir As String, fil As String)
	fName = File.Combine(dir,fil)
	strCode = File.ReadString("",fName)
End Sub
private Sub SortMap(m As Map) As Map
	Dim nm As Map
	nm.Initialize
	Dim lst As List
	lst.Initialize
	For Each strkey As String In m.Keys
		lst.Add(strkey)
	Next
	'sort the list keys
	lst.Sort(True)
	For Each strkey As String In lst
		Dim strvalue As Object = m.Get(strkey)
		nm.Put(strkey,strvalue)
	Next
	Return nm
End Sub
private Sub Join(Delimiter As String, lst As List) As String
	Return MashPlugIns.MvFromList(lst,Delimiter)
End Sub
Sub Save
	If Lines.IsInitialized = True Then
		File.WriteList("",fName,Lines)
	Else
		File.WriteString("",fName,strCode)
	End If
End Sub
'return the number of lines of code
private Sub Code_CountLines As Long
	Return Lines.Size - 1
End Sub
private Sub ConfirmCase(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling 'Next' at the end of a conditional operation
	Dim tLen As Int = Len(Tempstring)
	If tLen < 4 Then
		Return False
	Else if tLen = 4 Then
		If Left(Tempstring, 4) = "case" Then Return True
	Else if tLen > 4 Then
		If Left(Tempstring, 5) = "case " Then Return True
	End If
	Return False
End Sub
'return the left part of a string
private Sub Left(Text As String, Length As Long) As String
	If Length>Text.Length Then Length=Text.Length
	Return Text.SubString2(0, Length)
End Sub
' return length of a string
private Sub Len(Text As String) As Long
	Return Text.Length
End Sub
'trim a string
private Sub Trim(strValue As String) As String
	Return strValue.trim
End Sub
'lowercase a string
private Sub LCase(Text As String) As String
	Return Text.ToLowerCase
End Sub
'return the position of a string found in a string
private Sub InStr(Text As String, sFind As String) As Int
	Return Text.tolowercase.IndexOf(sFind.tolowercase) + 1
End Sub
'remove lines containing a string
private Sub Code_RemoveLines(StrSearch As String, ExactMatch As Boolean)
	Dim nLines As List
	nLines.Initialize
	Dim totLines As Long
	Dim cntLines As Long
	Dim curLine As String
	totLines = Lines.size - 1
	For cntLines = 0 To totLines
		curLine = Lines.Get(cntLines)
		If ExactMatch = True Then
			If LCase(StrSearch) = LCase(curLine) Then
			Else
				nLines.Add(curLine)
			End If
		Else
			If InStr(LCase(curLine), LCase(StrSearch)) > 0 Then
			Else
				nLines.Add(curLine)
			End If
		End If
	Next
	Lines = nLines
End Sub
private Sub Code_CountLineContinuation() As Long
	Private totLines As Long
	Private cntLines As Long
	Private curLine As String
	Private LC As Long = 0
	totLines = Lines.Size - 1
	For cntLines = totLines To 0 Step -1
		curLine = Lines.Get(cntLines)
		curLine = curLine.Trim
		If Right(curLine,1) = "_" Then
			LC = LC + 1
		End If
	Next
	Return LC
End Sub
'trim all lines in this file
private Sub Code_TrimLines
	Dim totLines As Long
	Dim cntLines As Long
	Dim curLine As String
	totLines = Lines.Size - 1
	For cntLines = 0 To totLines
		curLine = Lines.get(cntLines)
		curLine = Trim(curLine)
		Lines.Set(cntLines, curLine)
	Next
End Sub
private Sub ConfirmIf(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling the 'If' conditional operator
	If Left(Tempstring,3) = "if " Then
		If Right(Tempstring,4) = "then" Then Return True
	End If
	If Left(Tempstring,4) = "#if " Then
		If Right(Tempstring,7) = "release" Then Return True
		If Right(Tempstring,5) = "debug" Then Return True
	End If
	Return False
End Sub
private Sub ConfirmEnd(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling a routine 'End' operator
	If Left(Tempstring, 7) = "#end if" Then Return True
	If Left(Tempstring, 11) = "#end region" Then Return True
	If Left(Tempstring, 6) = "end if" Then Return True
	If Left(Tempstring, 7) = "end sub" Then Return True
	If Left(Tempstring, 7) = "end try" Then Return True
	If Left(Tempstring, 10) = "end select" Then Return True
	Return False
End Sub
Private Sub ConfirmDo(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling the start of a 'Do' loop operation
	Dim tLen As Int = Len(Tempstring)
	If tLen = 2 Then
		If Tempstring = "do" Then Return True
	else if tLen > 2 Then
		If Left(Tempstring, 3) = "do " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmLoop(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling the end of a do 'Loop' operation
	Dim tLen As Int = Len(Tempstring)
	If tLen < 4 Then
		Return False
	else if tLen = 4 Then
		If Left(Tempstring, 4) = "loop" Then Return True
	else if tLen > 4 Then
		If Left(Tempstring, 5) = "loop " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmCatch(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling a 'Catch' point in a Try / End Try operation
	Dim tLen As Int = Len(Tempstring)
	If tLen = 5 Then
		If Left(Tempstring, 5) = "catch" Then Return True
	else if tLen < 5 Then
		Return False
	else if tLen > 6 Then
		If Left(Tempstring, 6) = "catch " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmNext(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling 'Next' at the end of a conditional operation
	Dim tLen As Int = Len(Tempstring)
	If tLen < 4 Then
		Return False
	else if tLen = 4 Then
		If Left(Tempstring, 4) = "next" Then Return True
	else if tLen > 4 Then
		If Left(Tempstring, 5) = "next " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmElse(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling the 'Else' part of an If End if conditional operation
	Dim tLen As Int = Len(Tempstring)
	If tLen < 4 Then
		Return False
	else if tLen = 4 Then
		If Left(Tempstring, 4) = "else" Then Return True
	else if tLen > 4 Then
		If Left(Tempstring, 5) = "else " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmElse1(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling the 'Else' part of an If End if conditional operation
	Dim tLen As Int = Len(Tempstring)
	If tLen < 5 Then
		Return False
	else if tLen = 5 Then
		If Left(Tempstring, 5) = "#else" Then Return True
	else if tLen > 5 Then
		If Left(Tempstring, 6) = "#else " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmRegion(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling the 'Else' part of an If End if conditional operation
	Dim tLen As Int = Len(Tempstring)
	If tLen < 7 Then
		Return False
	else if tLen = 7 Then
		If Left(Tempstring, 5) = "#region" Then Return True
	else if tLen > 7 Then
		If Left(Tempstring, 8) = "#region " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmEndRegion(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	'Confirm that we are handling the 'Else' part of an If End if conditional operation
	Dim tLen As Int = Len(Tempstring)
	If tLen < 11 Then
		Return False
	else if tLen = 11 Then
		If Left(Tempstring, 11) = "#end region" Then Return True
	else if tLen > 11 Then
		If Left(Tempstring, 11) = "#end region " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmSelect(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 7 Then
		Return False
	else if tLen >= 7 Then
		If Left(Tempstring, 7) = "select " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmTry(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 3 Then
		Return False
	else if tLen = 3 Then
		If Left(Tempstring, 3) = "try" Then Return True
	else if tLen > 3 Then
		If Left(Tempstring, 4) = "try " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmFor(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 3 Then
		Return False
	else if tLen = 3 Then
		If Left(Tempstring, 3) = "for" Then Return True
	else if tLen > 3 Then
		If Left(Tempstring, 4) = "for " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmSub(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 3 Then
		Return False
	else if tLen = 3 Then
		If Left(Tempstring, 3) = "sub" Then Return True
	else if tLen > 3 Then
		If Left(Tempstring, 4) = "sub " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmPrivateSub(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 10 Then
		Return False
	else if tLen = 10 Then
		If Left(Tempstring, 11) = "private sub" Then Return True
	else if tLen > 10 Then
		If Left(Tempstring, 12) = "private sub " Then Return True
	End If
	Return False
End Sub
private Sub ConfirmEndSub(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 7 Then
		Return False
	else if tLen = 7 Then
		If Left(Tempstring, 7) = "end sub" Then Return True
	End If
	Return False
End Sub
private Sub ConfirmEndSelect(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 10 Then
		Return False
	else if tLen = 10 Then
		If Left(Tempstring, 10) = "end select" Then Return True
	End If
	Return False
End Sub
private Sub ConfirmPublicSub(Tempstring As String) As Boolean
	Tempstring = Tempstring.Trim.tolowercase
	Dim tLen As Int = Len(Tempstring)
	If tLen < 10 Then
		Return False
	else if tLen = 10 Then
		If Left(Tempstring, 10) = "public sub" Then Return True
	else if tLen > 10 Then
		If Left(Tempstring, 11) = "public sub " Then Return True
	End If
	Return False
End Sub
private Sub Code_GetBetween(intStart As Int, intEnd As Int) As String
	Dim sb As StringBuilder
	sb.Initialize
	For iStart = intStart To intEnd
		sb.Append(Lines.Get(iStart)).Append(CRLF)
	Next
	Return sb.tostring
End Sub
private Sub Code_GetSubName(strDeclaration As String, bIncludeBrackets As Boolean) As String
	Dim fBracket As Int
	Dim sBracket As Int
	Dim sResult As String
	fBracket = InStr(strDeclaration, "(")
	sBracket = InStrRev(strDeclaration, ")")
	If fBracket > 0 Then
		sResult = Left(strDeclaration, fBracket - 1)
	Else
		sResult = strDeclaration
	End If
	If bIncludeBrackets = True Then
		sResult = sResult & "()"
	End If
	If sBracket > 0 Then
		sResult = sResult & Mid(strDeclaration, sBracket + 1)
	End If
	If sResult.tolowercase.StartsWith("sub ") Then
		sResult = Mid(sResult,5)
		sResult = sResult.trim
	else if sResult.tolowercase.StartsWith("private sub ") Then
		sResult = Mid(sResult,13)
	else if sResult.tolowercase.StartsWith("public sub ") Then
		sResult = Mid(sResult,12)
	End If
	sResult = MvField(sResult,1," ")
	Return sResult
End Sub
private Sub FixDelimiter(sValue As String) As String
	If sValue = "|" Then sValue = "\|"
	If sValue = "." Then sValue = "\."
	If sValue = "\" Then sValue = "\\"
	If sValue = "^" Then sValue = "\^"
	If sValue = "$" Then sValue = "\$"
	If sValue = "?" Then sValue = "\?"
	If sValue = "*" Then sValue = "\*"
	If sValue = "+" Then sValue = "\+"
	If sValue = "(" Then sValue = "\("
	If sValue = ")" Then sValue = "\)"
	If sValue = "[" Then sValue = "\["
	If sValue = "{" Then sValue = "\{"
	If sValue = ";" Then sValue = "\;"
	Return sValue
End Sub
private Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim xPos As Int: xPos = sValue.IndexOf(Delimiter)
	If xPos = -1 Then Return sValue
	Dim mValues() As String
	Dim tValues As Int
	Delimiter = FixDelimiter(Delimiter)
	If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
	mValues = Regex.split(Delimiter, sValue)
	tValues = mValues.Length -1
	Select Case iPosition
		Case -1
			Return mValues(tValues)
		Case -2
			Return mValues(tValues - 1)
		Case Else
			iPosition = iPosition - 1
			If iPosition <= -1 Then Return mValues(tValues)
			If iPosition > tValues Then Return ""
			Return mValues(iPosition)
	End Select
End Sub
private Sub Code_Arguements(strDeclaration As String) As String
	If ConfirmSub(strDeclaration) = True Or ConfirmPublicSub(strDeclaration) = True Or ConfirmPrivateSub(strDeclaration) = True Then
		Dim fBracket As Long
		Dim sBracket As Long
		Dim line As String
		'first first bracket
		fBracket = InStr(strDeclaration, "(")
		'find last bracket
		sBracket = InStrRev(strDeclaration, ")")
		Select Case sBracket
			Case fBracket + 1
				Return ""
			Case Else
				line = Mid2(strDeclaration, fBracket + 1, (sBracket - fBracket - 1))
				Return line
		End Select
	Else
		Return ""
	End If
End Sub
private Sub InStrRev(value As String, search As String) As Long
	Return value.LastIndexOf(search) + 1
End Sub
private Sub SplitWords(s As String) As String()
	Return Regex.Split(s, "\W+")
End Sub
private Sub Code_RemoveLineContinuation()
	Dim tLines As Long
	Dim tCount As Long
	Dim currLine As String
	Dim NextLine As String
	tLines = Lines.Size - 2
	For tCount = 0 To tLines
		currLine = Lines.Get(tCount)
		NextLine = Lines.Get(tCount + 1)
		If Right(currLine, 1) = "_" Then
			If Len(currLine) + Len(NextLine) < 255 Then
				currLine = Left(currLine, Len(currLine-1)) & " " & NextLine
				Lines.Set(tCount,currLine)
				Lines.Set(tCount + 1,"")
			End If
		End If
	Next
End Sub
private Sub Mid2(Text As String, Start As Int, Length As Int) As String
	Return Text.SubString2(Start-1,Start+Length-1)
End Sub
private Sub Mid(Text As String, Start As Int) As String
	Return Text.SubString(Start-1)
End Sub
private Sub Right(Text As String, Length As Long) As String
	If Length>Text.Length Then Length=Text.Length
	Return Text.SubString(Text.Length-Length)
End Sub
'kept for backward compatibility
Sub Code_Format
	Code_Beautify
End Sub
Sub Code_Beautify()
	If strCode.trim.Length = 0 Then Return
	Lines = Regex.Split(CRLF,strCode)
	indent = 0
	linePos = 0
	strActual = ""
	strTemp = ""
	SelStart = False
	SubRoutines.Initialize
	'trim all lines in the code
	Code_TrimLines
	'remove all empty lines
	Code_RemoveLines("",True)
	'remove all line continuations
	Code_RemoveLineContinuation
	'start processing the file
	Dim fileTot As Long = Lines.Size - 1
	For fileCnt = 0 To fileTot
		linePos = fileCnt
		Code_Translate
	Next
	'sort the subroutines
	SubRoutines = SortMap(SubRoutines)
End Sub
private Sub Code_Translate()
	Dim y As Int
	strActual = Lines.Get(linePos)
	strActual = strActual.trim
	For y = 0 To indent - 1
		strActual = TAB & strActual
	Next
	strTemp = strActual.Trim.tolowercase
	'strTemp = Code_CommentStrip(strTemp)
	If Len(strTemp) < 2 Then
		Code_Writer
		Return
	End If
	Select Case Left(strTemp,2)
		Case "#r"
			If ConfirmRegion(strTemp) Then
				Code_AddTab
			Else
				Code_Writer
			End If
		Case "#i"
			If ConfirmIf(strTemp) Then
				Code_AddTab
			Else
				Code_Writer
			End If
		Case "if"
			If ConfirmIf(strTemp) Then
				Code_AddTab
			Else
				Code_Writer
			End If
		Case "en"
			If ConfirmEnd(strTemp) = True Then
				If ConfirmEndSub(strTemp) = True Then
					Code_DelTab
					SubEnd = linePos
					SubCode = Code_GetBetween(SubStart,SubEnd)
					SubRoutines.Put(SubName,SubCode)
					Exit
				End If
				If ConfirmEndSelect(strTemp) Then
					indent = indent - 1
					If strActual.SubString2(0, 1) = TAB Then
						strActual = strActual.Substring2(1, strActual.Length)
					End If
					Code_DelTab
					Exit
				End If
				Code_DelTab
			Else
				Code_Writer
			End If
		Case "su"
			If ConfirmSub(strTemp) = True Then
				indent = 0
				Code_AddTab
				SubStart = linePos
				SubDeclaration = strActual
				SubName = Code_GetSubName(strActual,False)
			Else
				Code_Writer
			End If
		Case "pr"
			If ConfirmPrivateSub(strTemp) = True Then
				indent = 0
				Code_AddTab
				SubStart = linePos
				SubDeclaration = strActual
				SubName = Code_GetSubName(strActual,False)
			Else
				Code_Writer
			End If
		Case "pu"
			If ConfirmPublicSub(strTemp) = True Then
				indent = 0
				Code_AddTab
				SubStart = linePos
				SubDeclaration = strActual
				SubName = Code_GetSubName(strActual,False)
			Else
				Code_Writer
			End If
		Case "fo"
			If ConfirmFor(strTemp) = True Then
				Code_AddTab
			Else
				Code_Writer
			End If
		Case "do"
			If ConfirmDo(strTemp) = True Then
				Code_AddTab
			Else
				Code_Writer
			End If
		Case "lo"
			If ConfirmLoop(strTemp) = True Then
				Code_DelTab
			Else
				Code_Writer
			End If
		Case "ne"
			If ConfirmNext(strTemp) = True Then
				Code_DelTab
			Else
				Code_Writer
			End If
		Case "#e"
			If ConfirmEnd(strTemp) = True Then
				Code_DelTab
				Exit
			End If
			If ConfirmElse1(strTemp) = True Then
				Code_DelTab
				indent = indent + 1
				Exit
			End If
			If ConfirmEndRegion(strTemp) = True Then
				Code_DelTab
				Exit
			End If
			Code_Writer
		Case "el"
			If ConfirmElse(strTemp) = True Then
				Code_DelTab
				indent = indent + 1
			Else
				Code_Writer
			End If
		Case "se"
			If ConfirmSelect(strTemp) = True Then
				SelStart = True
				Code_AddTab
			Else
				Code_Writer
			End If
		Case "ca"
			If ConfirmCase(strTemp) = True Then
				If SelStart Then
					Code_AddTab
					SelStart = False
				Else
					Code_DelTab
					indent = indent + 1
				End If
				Exit
			End If
			If ConfirmCatch(strTemp) = True Then
				Code_DelTab
				indent = indent + 1
				Exit
			End If
			Code_Writer
			Exit
		Case "tr"
			If ConfirmTry(strTemp) = True Then
				Code_AddTab
			Else
				Code_Writer
			End If
		Case Else
			Code_Writer
	End Select
End Sub
private Sub Code_Writer
	Lines.Set(linePos,strActual)
End Sub
private Sub Code_AddTab
	indent = indent + 1
	Code_Writer
End Sub
private Sub Code_DelTab
	indent = indent - 1
	If strActual.SubString2(0, 1) = TAB Then
		strActual = strActual.Substring2(1, strActual.Length)
	End If
	Code_Writer
End Sub
private Sub Code_CommentStrip(Tempstring As String) As String
	Dim iSingQuote As Int
	Dim iQUOTE As Int
	If Tempstring.Contains("'") Then
		iSingQuote = Tempstring.LastIndexOf("'")
		Do While iSingQuote > 0
			iSingQuote = Tempstring.LastIndexOf("'")
			iQUOTE = Tempstring.LastIndexOf(QUOTE)
			If iSingQuote > iQUOTE Then
				Tempstring = Tempstring.SubString2(0, Tempstring.LastIndexOf("'"))
				Tempstring = Tempstring.Trim
			Else
				Exit
			End If
		Loop
		Return Tempstring
	Else
		Return Tempstring
	End If
End Sub
private Sub Space(HM As Int) As String
	Dim RS As String = ""
	Do While Len(RS) < HM
		RS = RS & " "
	Loop
	Return RS
End Sub
