﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private IconName As String
	Private Theme As String
	Private Element As HTMLElement
	Public WavesEffect As Boolean
	Public Visibility As String
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
	Public Enabled As Boolean
	Public IconSize As String
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private Title As String
	Private sBadge As String
	Private sBadgeTheme As String
	Private sBadgeInline As Boolean
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, bIconName As String, bTitle As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize
	IconName = bIconName
	Theme = ThemeName
	Element.Initialize(ID,"a")
	Enabled = True
	Visibility= ""
	ZDepth = ""
	WavesType= ""
	IconSize = ""
	WavesEffect = True
	WavesCircle = False
	Title = bTitle
	sBadge=""
	sBadgeTheme = ""
	sBadgeInline = False
End Sub

Sub SetBadge(badge As String, badgeTheme As String,badgeInline As Boolean)
	sBadge = badge
	sBadgeTheme = badgeTheme
	sBadgeInline = badgeInline
End Sub

Sub HTML As String
	Element.AddClass("btn").AddProperty("title","")
	Element.ApplyStyle("width: 150px; margin: 10px 10px 10px 10px;border-radius: 3px; height: auto; padding: 5px 5px 5px 5px; min-width: 34px;")
	Element.ApplyStyle("font-size: 14px; font-weight: normal; position: relative; display: inline-block; cursor: pointer; -moz-user-select: none; background-image: none;")
	Element.ApplyStyle("border: 10px;").addcursor
	
	Dim span As HTMLElement
	span = span.CreateSPAN("").ApplyStyle("text-align:center; font-size:25px; display: block; margin: 5px auto; box-sizing: border-box;")
	
	Dim icon As HTMLElement
	icon = icon.CreateI("").MaterialBuildIcon(IconName,"center").MaterialIconSize(MashPlugIns.EnumIconSize.Large).ApplyStyle("font-size: 2.5rem;")
	span.AddElement(icon)
	
	If sBadgeInline = False Then
		If sBadge <> "" Then
			Dim b As MashBadgeOn
			b.Initialize($"${compid}badge"$,sBadge,sBadgeTheme)
			b.Inline = False
			Element.applystyle("overflow: visible;")
			Element.AddContent(b.HTML)
		End If
	End If
		
	Dim TitleE As HTMLElement
	TitleE = TitleE.CreateSPAN("").AddContent(Title).ApplyStyle("opacity: .7;box-sizing: border-box;")
	MashPlugIns.MaterialUseTheme(Theme,Element)
	'leave this true for proper alignment
	Element.MaterialWavesEffect(True)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Element.AddElement(span)
	Element.AddElement(TitleE)
	If sBadgeInline = True Then
		If sBadge <> "" Then
			Dim b As MashBadgeOn
			b.Initialize($"${compid}badge"$,sBadge,sBadgeTheme)
			b.Inline = True
			Element.AddContent("{NBSP}")
			Element.AddContent(b.HTML)
		End If
	End If
	Element.AddOnClickEventProperty(compid,Element.id)
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	'JavaCalls.Add(Element.AddClickEvent(compid,compid))
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If script <> "" Then Page.ws.Eval(script, Array As String(compid))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub


