﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.98
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private ABM As ABMaterial
	Private Page As ABMPage
	Public ID As String
	Public Element As HTMLElement
	Public Theme As String
	Public Enabled As Boolean
	Public TextVisible As Boolean
	Public Text As String
	Public HREF As String
	Public Visibility As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
	Private JavaCalls As List
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, sID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, sID,"")
	Page = InternalPage
	ID = sID.tolowercase
	JavaCalls.initialize
	Visibility = ""
	Enabled = True
	Theme = ""
	ZDepth = ""
	WavesType = ""
	WavesCircle = False
	WavesEffect = False
	Element = Element.createinput(ID)
End Sub

Sub HTML As String
	'define the anchor
	Element.SetTYPE("text")
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.addproperty("data-format","Y-m-d")
	Element.AddProperty("data-fx","true")
	Element.AddProperty("data-large-mode","true")
	Element.AddProperty("data-large-default","true")
	JavaCalls.Add($"$('#${ID}').dateDropper();"$)
	Return Element.html
End Sub


Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'we create a div with a video and a canvas and we hide the canvas
	Page = InternalPage
	ID = internalID
	Return Element.GetComponentBuilder
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,ID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	Page.ws.Eval(script, Array As String(ID))
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	ID = internalID
	Page = InternalPage
	Refresh
End Sub

Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
