﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Element As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private sTitle As String
	Private sTheme As String
	Private sWidth As String
	Private sHeight As String
	Public MinValue As String
	Public DisplayPrevious As Boolean
	Private fColor As String
	Private bColor As String
	Private sValue As String
	Public DisplayInput As Boolean
	Public Cursor As Boolean
	Public AngleOffset As String
	Public LineCap As String
	Public MaxValue As String
	Public Stepping As String
	Public ThickNess As String
	Public AngleArc As String
	Type LineCapOf(lcbutt As String, lcround As String)
	Public EnumLineCap As LineCapOf
	Public RedValue As String = 50
	Public AmberValue As String = 70
	Public GreenValue As String = 90
	Public ReadOnly As Boolean
	Private R As String = MashPlugIns.ABMGetColor(ABM.COLOR_RED,"")
	Private A As String = MashPlugIns.ABMGetColor(ABM.COLOR_ORANGE,"")
	Private G As String = MashPlugIns.ABMGetColor(ABM.COLOR_GREEN,"")
	Public DifferentColors As Boolean
	Public Tron As Boolean
	Public ReadOnly As Boolean
	Type AngleArcType(two70 As String, two50 As String,three60 As String)
	Public EnumAngleArc As AngleArcType
	Type AngleOffsetType(minus125 As String, minus305 As String, minus35 As String, one45 As String, minus0 As String, ninety As String, zero As String)
	Public EnumAngleOffset As AngleOffsetType
	Public Suffix As String
	Public Animated As Boolean
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, Title As String, Value As String, WidthPx As String, HeightPx As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	DifferentColors = False
	EnumAngleOffset.Initialize
	EnumAngleOffset.minus0 = "-0"
	EnumAngleOffset.minus125 = "-125"
	EnumAngleOffset.minus305 = "-305"
	EnumAngleOffset.minus35 = "-35"
	EnumAngleOffset.ninety = "90"
	EnumAngleOffset.one45 = "145"
	Animated = False
	EnumAngleOffset.zero = "0"
	EnumLineCap.Initialize 
	EnumAngleArc.Initialize
	EnumAngleArc.two50 = "250"
	EnumAngleArc.two70 = "270"
	EnumAngleArc.three60 = "360"
	EnumLineCap.lcbutt = "butt"
	EnumLineCap.lcround = "round"
	Suffix = ""
	ReadOnly = False
	compid = ID
	JavaCalls.Initialize
	Element.Initialize(ID,"div")
	Enabled = True
	Visibility= ""
	ZDepth = ""
	sTitle = Title
	sTheme = ThemeName
	sWidth = WidthPx.Replace("px","")
	sHeight = HeightPx.Replace("px","")
	MinValue = "0"
	DisplayPrevious = False
	sValue = Value
	DisplayInput = True
	ReadOnly = False
	Cursor = False
	LineCap = ""
	MaxValue = "100"
	Stepping = "1"
	ThickNess = "0.25"
	Tron = False
	Element.Initialize(compid,"div").MaterialSetSizes(3,3,3).CenterAlign
End Sub

'set both the angle arc and offset
Sub SetAngleArcOffset(aArc As String, aOffset As String)
	AngleOffset = aOffset
	AngleArc = aArc
End Sub

Sub HTML As String
	Element.ID = compid
	bColor = MashPlugIns.ABMGetBackGroundColor(sTheme)
	fColor = MashPlugIns.ABMGetForeColor(sTheme)
	Element.CreateH6("").AddContent(sTitle).pop
	Dim dial As HTMLElement
	dial = dial.CreateDIV("").ApplyStyle($"display:inline;width:${sWidth}px;height:${sHeight}px;"$)
	Dim inp As HTMLElement
	inp = inp.CreateINPUT($"${compid}dial"$).AddClass(compid).AddDataAttribute("width",sWidth).AddDataAttribute("height", sHeight)
	inp.AddDataAttribute("min",MinValue).AddDataAttribute("displayprevious",DisplayPrevious)
	If AngleOffset <> "" Then inp.AddDataAttribute("angleoffset",AngleOffset)
	inp.AddDataAttribute("linecap", LineCap).AddDataAttribute("cursor",Cursor).AddDataAttribute("fgcolor",bColor)
	'inp.AddDataAttribute("data-bgColor", fColor)
	If AngleArc <> "" Then inp.AddDataAttribute("anglearc",AngleArc)
	inp.AddDataAttribute("displayinput",DisplayInput).AddAttribute("value",sValue,True)
	inp.AddDataAttribute("max",MaxValue).AddDataAttribute("thickness",ThickNess).AddDataAttribute("step",Stepping)
	inp.AddStyleAttribute("width","54px").AddStyleAttribute("height","33px")
	inp.ApplyStyle("position: absolute; vertical-align: middle; margin-top: 33px; margin-left: -77px; border: 0px none;")
	inp.ApplyStyle("background: rgba(0, 0, 0, 0) none repeat scroll 0% 0%; font: bold 20px Arial; text-align: center;")
	inp.AddStyleAttribute("color",bColor).ApplyStyle("padding: 0px;")
	inp.AddDataAttributeOnCondition(Tron,"skin","tron")
	inp.AddAttributeOnCondition(ReadOnly,"readonly","readonly")
	inp.AddAttributeOnCondition(ReadOnly,"data-readOnly","true")
	inp.AddClassOnCondition(Animated,"animated")
	inp.AddAttributeOnCondition(Animated,"value","0")
	inp.AddAttributeOnCondition(Animated,"rel",sValue)
	dial.AddElement(inp)
	Element.AddElement(dial)
	Element.MaterialVisibility(Visibility)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Return Element.html
End Sub

private Sub ColorCode() As String
	Dim sCodes As String
	sCodes = $"// linear interpolation between two values a and b
      // u controls amount of a/b and is in range [0.0,1.0]
      lerp = function (a, b, u) {
          return (1 - u) * a + u * b;
      };

      fade = function (element, property, start, end, duration, fn) {
          var interval = 20;
          var steps = duration / interval;
          var step_u = 1.0 / steps;
          var u = 0.0;
          var theInterval = setInterval(function () {
              if (u >= 1.0) {
                  clearInterval(theInterval);
              }
              var r = parseInt(lerp(start.r, end.r, u), 10);
              var g = parseInt(lerp(start.g, end.g, u), 10);
              var b = parseInt(lerp(start.b, end.b, u), 10);
              var colorname = 'rgb(' + r + ',' + g + ',' + b + ')';
              fn(property, colorname);
              //el.style.setProperty(property, colorname);
              u += step_u;
          }, interval);
      };

      //var current_color = 0; //0 for base,1 for upper
      var min_std = 25;
      var std_max = 75;
      var effect_duration = 300;
      var color_blue = {
          r: 135,
          g: 206,
          b: 235
      };
      var color_green = {
          r: 0,
          g: 128,
          b: 0
      };
      var color_red = {
          r: 178,
          g: 34,
          b: 34
      };
	  function change_color(v, element) {
          var v1 = v;
          var last_val = $(element).data('last_val');
          var current_color = $(element).data('current_color');
          //console.log('last: ' + last_val + ' v: ' + v1);
          if (last_val != v1) {
              //console.log(v);
              if (v1 > std_max && current_color !== 2) { //go red
                  console.log('calling fade to red');
                  if (current_color === 1) {
                      startColor = color_green;
                  } else {
                      startColor = color_blue;
                  }
                  endColor = color_red;

                  fade(this, 'color', startColor, endColor, effect_duration, function (property, colorname) {
                      //console.log('fade color:'+colorname);
                      $(element).trigger('configure', {
	'fgColor': colorname
                      });
                      $(element).trigger('change');
                      $(element).css("color", colorname);
                  });
                  $(element).data('current_color', 2);
              }
              if (v1 > min_std && v1 <= std_max && current_color !== 1) { //go green
                  //this.o.fgColor='red';
                  console.log('calling fade to green');
                  if (current_color === 0) {
                      startColor = color_blue;
                  } else {
                      startColor = color_red;
                  }
                  endColor = color_green;

                  fade(this, 'color', startColor, endColor, effect_duration, function (property, colorname) {
                      //console.log('fade color:'+colorname);
                      $(element).trigger('configure', {
	'fgColor': colorname
                      });
                      $(element).trigger('change');
                      $(element).css("color", colorname);
                  });
                  $(element).data('current_color', 1);
              }
              if (v1 <= min_std && current_color !== 0) { //go blue
                  console.log('calling fade to blue');
                  if (current_color === 1) {
                      startColor = color_green;
                  } else {
                      startColor = color_red;
                  }
                  endColor = color_blue;

                  fade(this, 'color', startColor, endColor, effect_duration, function (property, colorname) {
                      //console.log('fade color:'+colorname);
                      $(element).trigger('configure', {
	'fgColor': colorname
                      });
                      $(element).trigger('change');
                      $(element).css("color", colorname);
                  });
                  $(element).data('current_color', 0);
              }
              $(element).data('last_val', v1);
          }
      }


      $('#${compid}dial').data('current_color', 0);
      $('#${compid}dial').data('last_val', 0);
      $('#${compid}dial').trigger('configure', {
	'release': function (v) {
              change_color(v, '#${compid}dial');
          },
	'format': function (v) {
              return v + '%';
          }
      });
      $('#${compid}dial').trigger('change');"$
	Return sCodes
End Sub


private Sub AnimateIT As String
	Dim ani As String = $"$('.${compid}').each(function () {
           var $this = $(this);
           var myVal = $this.attr("rel");
           $({
               value: 0
           }).animate({
               value: myVal
           }, {
               duration: 2000,
               easing: 'swing',
               step: function () {
                   $this.val(Math.ceil(this.value)).trigger('change');
               }
           })
       });"$
	   Return ani
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	JavaCalls.Add($"$(".${compid}").knob({
	'change' : function (v) {
	var thisid = this.$.attr('id') + '~';
	b4j_raiseEvent('${compid}_change', {'value': v});
	},
	'release' : function (v) {
	var thisid = this.$.attr('id') + '~';
	b4j_raiseEvent('${compid}_release', {'value': v});
	},
	'format': function (v) {
              return v + '${Suffix}';
    },
	draw: function () {
    	if ("tron" == this.$.data("skin")) {
        	this.cursorExt = .3;
            var b, a = this.arc(this.cv),
            c = 1;
            return this.g.lineWidth = this.lineWidth, this.o.displayPrevious && (b = this.arc(this.v), this.g.beginPath(), this.g.strokeStyle = this.pColor, this.g.arc(this.xy, this.xy, this.radius - this.lineWidth, b.s, b.e, b.d), this.g.stroke()), this.g.beginPath(), this.g.strokeStyle = c ? this.o.fgColor : this.fgColor, this.g.arc(this.xy, this.xy, this.radius - this.lineWidth, a.s, a.e, a.d), this.g.stroke(), this.g.lineWidth = 2, this.g.beginPath(), this.g.strokeStyle = this.o.fgColor, this.g.arc(this.xy, this.xy, this.radius - this.lineWidth + 1 + 2 * this.lineWidth / 3, 0, 2 * Math.PI, !1), this.g.stroke(), !1
            }
    },
	});
	$('#${compid}dial').trigger('change');"$)
	If DifferentColors = True Then JavaCalls.Add(ColorCode)
	If Animated = True Then JavaCalls.Add(AnimateIT)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If MashPlugIns.Debug = True Then
		Element.VerifyJavaScript(JavaCalls)
		Element.VerifyHTML(HTML)
		Page.ws.Eval(script, Array As String(compid))
	Else
		Page.ws.Eval(script, Array As String(compid))
	End If
End Sub

Sub SetValue(Value As String)
	Dim sCode As String = $"$('.${compid}').val(${Value}).trigger('change');"$
	JQueryExecute(sCode)
End Sub

Sub GetValue() As String
	'Dim sCode As String = $"$('.${compid}').val();"$
	'Dim jqe As Future = Page.ws.EvalWithResult(sCode,Null)
	'Return jqe.Value 
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compid))
End Sub

Sub HideScript() As String
	Return Element.JQueryHide
End Sub

Sub Hide
	JQueryExecute(Element.JQueryHide)
End Sub

Sub HideSlow()
	JQueryExecute(Element.JQueryHideSlow)
End Sub

Sub Animate(animationType As String, bInfinity As Boolean, bAfter As String)
	JQueryExecute(Element.JQueryAnimate(animationType,bInfinity,bAfter))
End Sub

Sub FadeOutSlow
	JQueryExecute(Element.JQueryFadeOutSlow)
End Sub

