﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private Element As HTMLElement
	Public ZDepth As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public Visibility As String
	Public Enabled As Boolean
	Private Emails As Map
	Public HeaderTheme As String
	Public ProfileImage As String
	Public SideBarTheme As String
	Private collectionof As HTMLElement
	Private viewer As HTMLElement
	Public LastSelected As String
	Public SelectionTheme As String
	Private LastSideItem As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub



'remove the viewer
private Sub RemoveViewer
	ABM.ReplaceMyHTML(Page,$"${compID}viewer"$,"")
End Sub

'remove the email list
private Sub RemoveEmailList
	ABM.ReplaceMyHTML(Page,$"${compID}emaillist"$,"")
End Sub

'clear the contents of the email app
Sub Clear
	Emails.Initialize
	JavaCalls.Initialize
	collectionof = collectionof.createul("").AddClass("collection").ApplyStyle("margin: 0;").MaterialZDepth(ABM.ZDEPTH_REMOVE)
	'remove the viewer and list of emails
	RemoveViewer
	RemoveEmailList
	LastSelected = ""
	LastSideItem = ""
End Sub

'refresh the contents of the list
Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	JQueryExecute(script)
End Sub

'to change the title of the navigator
private Sub SetTitle(sTitle As String)
	Dim script As String = $"$("#${compID}type").html("<b>${sTitle}</b>");"$
	JQueryExecute(script)
End Sub

'create a list item with some options
Private Sub CreateLi(btnID As String, btnTitle As String, btnIcon As String, btnClass As String, bActive As Boolean, themeName As String) As HTMLElement
	Dim li As HTMLElement
	li = li.CreateLI("")
	Dim a As HTMLElement
	a = a.CreateA($"${compID}${btnID}"$).AddContent(btnTitle).AddClass(btnClass).AddClass("center")
	If btnIcon <> "" Then
		Dim i As HTMLElement
		i = i.CreateI($"${compID}${btnID}icon"$).MaterialBuildIcon(btnIcon,"").AddClassOnCondition(bActive,"active")
		MashPlugIns.MaterialUseTheme(themeName,i)
		
		Select Case btnID
		Case "archives", "socialgroup","mapslocaloffer","alerterror"
			i.applystyle("padding: 12px;").ApplyStyle("-webkit-border-radius: 2px;")
				i.AddClass("valign").ApplyStyle("float: right; margin-right: 25px;")
		End Select
		If bActive = True Then
			'i.ApplyStyle("background: #ddd;")
		End If
		a.AddElement(i)
		a.AddOnClickEventProperty(compID,btnID)
		'JavaCalls.Add(a.AddChildClickEvent(compID,a.ID,btnID))
	End If
	li.AddElement(a).addcursor
	Return li
End Sub

'build the navigator for this app
private Sub BuildTopNavigationBar() As HTMLElement
	'create 12 columns
	Dim c12 As HTMLElement
	c12 = c12.MaterialCreateColumn.AddClass("s12")
	
	'add a nav
	Dim nav As HTMLElement
	nav = nav.CreateNAV("").MaterialZDepth(ABM.ZDEPTH_REMOVE)
	MashPlugIns.MaterialUseTheme(HeaderTheme,nav)
	
	'create a navwrapper
	Dim navw As HTMLElement
	navw = navw.CreateDIV("").AddClass("nav-wrapper")
	
	Dim navd As HTMLElement
	navd = navd.CreateDIV("").AddClass("left col s12 m5 l5")
	
	Dim uld As HTMLElement
	uld = uld.CreateUL("")
	'add each of the buttons
	Dim emailmenu As HTMLElement = CreateLi("menu","","mdi-navigation-menu","email-menu",False,HeaderTheme)
	uld.AddElement(emailmenu)
	Dim emailType As HTMLElement = CreateLi("type","{B}Primary{/B}","","email-type",False,HeaderTheme)
	uld.AddElement(emailType)
	Dim search As HTMLElement = CreateLi("search","","mdi-action-search","",False,HeaderTheme)
	search.AddClass("right")
	uld.AddElement(search)
	
	Dim navr As HTMLElement
	navr = navr.CreateDIV("").AddClass("col s12 m7 l7 hide-on-med-and-down")
	
	Dim ulr As HTMLElement
	ulr = ulr.CreateUL("").AddClass("right")
	
	Dim archive As HTMLElement = CreateLi("archive","","mdi-content-archive","",False,HeaderTheme)
	ulr.AddElement(archive)
	
	Dim deleteit As HTMLElement = CreateLi("delete","","mdi-action-delete","",False,HeaderTheme)
	ulr.AddElement(deleteit)
	
	Dim content As HTMLElement = CreateLi("content","","mdi-content-mail","",False,HeaderTheme)
	ulr.AddElement(content)
	
	Dim navigate As HTMLElement = CreateLi("navigate","","mdi-navigation-more-vert","",False,HeaderTheme)
	ulr.AddElement(navigate)
	
	navr.AddElement(ulr)
	navd.AddElement(uld)
	navw.AddElement(navd)
	navw.AddElement(navr)
	nav.AddElement(navw)
	c12.AddElement(nav)
	Return c12
End Sub

'updates the side bar item active status and also the navigation bar title
Sub SetSideBarItem(sItem As String)
	JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}${LastSideItem}icon"$,"background", ""))
	Page.Msgbox("",sItem,"","OK",False,"","")
	Select Case sItem
		Case "archives"
			SetTitle("Archives")
			'JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}archivesicon"$, "background", "#ddd"))
			LastSideItem = sItem
		Case "socialgroup"
			SetTitle("Social")
			'JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}socialgroupicon"$,"background", "#ddd"))
			LastSideItem = sItem
		Case "mapslocaloffer"
			SetTitle("Promotions")
			'JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}mapslocaloffericon"$,"background", "#ddd"))
			LastSideItem = sItem
		Case "alerterror"
			SetTitle("Updates")
			'JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}alerterroricon"$,"background", "#ddd"))
			LastSideItem = sItem
	End Select
End Sub

'build the left side navbar
private Sub BuildLeftSideBar() As HTMLElement
	Dim emailsidebar As HTMLElement
	emailsidebar = emailsidebar.CreateDIV($"${compID}emailsidebar"$).AddClass("col s2 m1 s1 card-panel")
	emailsidebar.ApplyStyle("margin-top: 0;").ApplyStyle("min-height: 650px;").MaterialZDepth(ABM.ZDEPTH_REMOVE)
	Dim ul As HTMLElement
	ul = ul.CreateUL("")
	'add the profile image
	Dim li As HTMLElement
	li = li.CreateLI("")
	Dim img As HTMLElement
	img = img.CreateIMG("").SetSRC(ProfileImage,False).SetALT("").AddClass("circle").MaterialResponsive(True)
	img.AddClass("valign").AddClass("profile-image").MaterialZDepth(ABM.ZDEPTH_1)
	li.AddElement(img)
	ul.AddElement(li)
	'add each item there
	Dim archive As HTMLElement = CreateLi("archives","","mdi-content-archive","",True,SideBarTheme)
	LastSideItem = "archives"
	ul.AddElement(archive)
	Dim socialgroup As HTMLElement = CreateLi("socialgroup","","mdi-social-group","",False,"bluetransparent")
	ul.AddElement(socialgroup)
	Dim mapslocaloffer As HTMLElement = CreateLi("mapslocaloffer","","mdi-maps-local-offer","",False,"greentransparent")
	ul.AddElement(mapslocaloffer)
	Dim alerterror As HTMLElement = CreateLi("alerterror","","mdi-alert-error","",False,"orangetransparent")
	ul.addelement(alerterror)
	
	emailsidebar.AddElement(ul)
	Return emailsidebar
End Sub

'build the email list container
private Sub BuildEmailList As HTMLElement
	Dim emaillist As HTMLElement
	emaillist = emaillist.Initialize($"${compID}emaillist"$,"div").AddClass("col s10 m4 l4 card-panel z-depth-1")
	emaillist.ApplyStyle("margin-top: 0;").ApplyStyle("padding: 0;").MaterialZDepth(ABM.ZDEPTH_REMOVE)
	emaillist.AddElement(collectionof)
	Return emaillist
End Sub

'add the social email
Sub AddSocial(SentTo As String, Subject As String, Content As String, Badge As String, BadgeNew As Boolean)
	AddEmail("social","Social",SentTo,Subject,Content,"",False,"",False,Badge,BadgeNew,ABM.COLOR_BLUE)
End Sub

'add the promotion email
Sub AddPromotion(SentTo As String, Subject As String, Content As String, Badge As String, BadgeNew As Boolean)
	AddEmail("promotions","Promotions",SentTo,Subject,Content,"",False,"",False,Badge,BadgeNew,ABM.COLOR_GREEN)
End Sub

'add the updates email
Sub AddUpdates(SentTo As String, Subject As String, Content As String, Badge As String, BadgeNew As Boolean)
	AddEmail("updates","Updates",SentTo,Subject,Content,"",False,"",False,Badge,BadgeNew,ABM.COLOR_ORANGE)
End Sub

'remove selection style from an email
private Sub RemoveSelection(emailID As String)
	JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}${emailID}"$,"background", ""))
	JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}${emailID}"$,"border-left", ""))
	'mark as read
End Sub

'mark an email as selected
private Sub MarkAsSelected(emailID As String)
	'get the background color for the theme
	Dim scolor As String = MashPlugIns.GetBackColorFromTheme(SelectionTheme)
	scolor = MashPlugIns.ColorMap.Get(scolor)
	'If scolor = "" Then scolor = "#e1f5fe"
	JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}${emailID}"$,"background", scolor))
	JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}${emailID}"$,"border-left", "4px solid #29b6f6"))
	JQueryExecute(MashPlugIns.JQuerySetCssProperty($"${compID}${emailID}title"$,"font-weight", ""))
End Sub

'add an email to the list of existing emails
Sub AddEmail(emailID As String, SentBy As String, SentTo As String, Subject As String, Content As String, DateTimeSent As String, _
	Unread As Boolean, _
	SenderImage As String, HasAttachment As Boolean, Badge As String, BadgeNew As Boolean, BadgeColor As String)
	Dim Selected As Boolean = False
	Dim emailMap As Map = CreateMap("id":emailID, _
	"sentby":SentBy, _
	"sentto":SentTo, _
	"subject":Subject, _
	"content":Content, _
	"datetimesent":DateTimeSent, _
	"unread":Unread, _
	"selected":Selected, _
	"senderimage":SenderImage, _
	"hasattachment": HasAttachment, _
	"badge":Badge, _
	"badgenew":BadgeNew, _
	"badgecolor":BadgeColor)
	Emails.Put(emailID,emailMap)
		
	Dim li As HTMLElement
	li = li.CreateLI($"${compID}${emailID}"$).AddClass("collection-item avatar")
	li.ApplyStyle("height: auto; padding-left: 72px;position: relative;")
	li.ApplyStyle("min-height: 84px;").RemoveStyle("padding-left").RemoveStyle("position")
	If Selected = True Then
		li.AddClassOnCondition(Selected,"selected")
		li.ApplyStyle("background: #e1f5fe;	border-left: 4px solid #29b6f6;")
		LastSelected = emailID
	End If
	li.AddClassOnCondition(Unread,"email-unread").addcursor
	'JavaCalls.Add(li.AddChildClickEvent(compID,li.ID,emailID))
	li.AddOnClickEventProperty(compID,emailID)
	Select Case SentBy.tolowercase
	Case "social","promotions","updates"
		'create the respective icon
		Dim spui As HTMLElement
		spui = spui.CreateI("").AddClass("icon").ApplyStyle("position: absolute; width: 42px; height: 42px;")
		spui.ApplyStyle("overflow: hidden; left: 15px; display: inline-block; text-align: center; vertical-align: middle; top: 20px;")
		Select Case SentBy.ToLowerCase
		Case "social"
			spui.MaterialBuildIcon("mdi-social-group","").MaterialTextColor(ABM.COLOR_BLUE)
		Case "promotions"
			spui.MaterialBuildIcon("mdi-maps-local-offer","").MaterialTextColor(ABM.COLOR_GREEN)
		Case "updates"
			spui.MaterialBuildIcon("mdi-alert-error","").MaterialTextColor(ABM.COLOR_ORANGE)	
		End Select
		li.AddElement(spui)
	Case Else
		'add sender image
		If SenderImage <> "" Then
			Dim img As HTMLElement
			img = img.createimg("").SetSRC(SenderImage,False).SetALT("").AddClass("circle")
			img.ApplyStyle("padding: 0;")
			img.MaterialZDepth(ABM.ZDEPTH_1)
			li.AddElement(img)
		Else
			Dim prefix As String = MashPlugIns.Left(SentBy,1)
			prefix = prefix.touppercase
			Dim brief As HTMLElement
			brief = brief.CreateSPAN("").AddClass("circle").AddContent(prefix)
			brief.ApplyStyle("position: absolute; width: 42px; height: 42px; overflow: hidden; left: 15px;")
			brief.ApplyStyle("display: inline-block; vertical-align: middle; text-align: center; font-size: 1.5rem;")
				brief.ApplyStyle("font-weight: 300; padding: 10px;").AddClass(MashPlugIns.AlphaColorCode(prefix)).MaterialTextColor(ABM.COLOR_WHITE)
			li.AddElement(brief)		
		End If
	End Select
	
	
	'add sender
	Dim span As HTMLElement
	span = span.CreateSPAN($"${compID}${emailID}title"$).AddClass("email-title").AddContent(SentBy)
	If Unread = True Then span.ApplyStyle("font-weight: 500;")
	li.AddElement(span)
	
	'add subject
	Dim hSubject As HTMLElement
	hSubject = hSubject.CreateP("").AddClass("truncate grey-text ultra-small").AddContent(Subject)
	hSubject.ApplyStyle("font-size: 0.8rem; padding: 0")
	li.addelement(hSubject)
	
	'add time
	Dim a As HTMLElement
	a = a.CreateA("").SetHREF("#!").AddClass("secondary-content")
	a.ApplyStyle("position: absolute; top: 10px;").ApplyStyle("right: -4px;")
	If HasAttachment = True Then
		Dim attach As HTMLElement
		attach = attach.CreateI("").MaterialBuildIcon("mdi-editor-attach-file","").AddClass("attach-file")
		attach.ApplyStyle("transform: rotate(90deg); color: #9e9e9e; font-size: 1.1rem;")
		a.AddElement(attach)
	End If
	If DateTimeSent <> "" Then
		a.AddClass("email-time").ApplyStyle("right: 8px;")
				
		Dim timespan As HTMLElement
		timespan = timespan.CreateSPAN("").AddClass("grey-text ultra-small").AddContent(DateTimeSent)
		timespan.ApplyStyle("font-size: 0.8rem; margin: 0; padding: 0;")
		a.AddElement(timespan)
	End If
	
	'add the badge
	If Badge <> "" Then
		Dim hBadge As HTMLElement
		hBadge = hBadge.CreateSPAN("").AddContent(Badge).AddClassOnCondition(BadgeNew,"new").AddClass("badge").AddClass(BadgeColor)
		hBadge.ApplyStyle("-webkit-border-radius: 2px;").MaterialTextColor(ABM.COLOR_WHITE)
		a.AddElement(hBadge)
	End If
	li.AddElement(a)
	collectionof.AddElement(li)
End Sub

'html to render the component
Sub HTML As String
	'leave this true for proper alignment
	Element.MaterialVisibility(Visibility).MaterialHoverable(Hoverable)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	
	'build the email app
	Dim row As HTMLElement
	row = row.MaterialCreateRow.ApplyStyle("margin-bottom: 0")
	row.AddElement(BuildTopNavigationBar)
	
	Dim c12 As HTMLElement
	c12 = c12.MaterialCreateColumn.AddClass("s12")
	c12.AddElement(BuildLeftSideBar)
	c12.AddElement(BuildEmailList)
	c12.AddElement(BuildEmailViewer)
	
	row.AddElement(c12)
	Element.AddElement(row)
	Return Element.html
End Sub

'get the appropriate action for the events manager
Sub GetEmailAction(sOption As String) As String
	If sOption.EndsWith("forward") Then
		Return "forward"
	else if sOption.EndsWith("replytoall") Then
		Return "replytoall"
	else if sOption.EndsWith("replytoo") Then
		Return "reply"
	else if sOption.EndsWith("emailmenu") Then
		Return "emailmenu"
	else if sOption.EndsWith("reply") Then
		Return "reply"
	else if sOption.EndsWith("replytoo1") Then
		Return "reply"
	else if sOption.EndsWith("replytoall1") Then
		Return "replytoall"
	else If sOption.EndsWith("forward1") Then
			Return "forward"
	else if sOption.EndsWith("attach") Then
		Return "attach"
	Else
		Return sOption
	End If
End Sub

'get the email id exactly
Sub GetEmailID(sOption As String) As String
	sOption = sOption.Replace(compID,"").Replace("forward1","").Replace("replytoall1","").Replace("replytoall","").Replace("replytoo1","")
	sOption = sOption.Replace("emailmenu","").Replace("replytoo","").Replace("forward","").Replace("reply","").Replace("attach","")
	Return sOption
End Sub

'view the selected email
Sub View(emailID As String)
	'remove the selection from anything currently
	If LastSelected <> "" Then RemoveSelection(LastSelected)
	LastSelected = emailID
	'mark this as selected
	MarkAsSelected(emailID)
	
	Select Case emailID
	Case "updates"
			SetTitle("Updates")
	Case "social"
			SetTitle("Social")
	Case "promotions"
			SetTitle("Promotions")
	Case Else
			SetTitle("Primary")
	End Select
	
	Dim EmailAct As List
	EmailAct.initialize
	'read the email from memory'
	Dim SentBy As String
	Dim SentTo As String
	Dim Subject As String
	Dim Content As String
	Dim DateTimeSent As String
	Dim Unread As Boolean
	Dim Selected As Boolean
	Dim SenderImage As String
	Dim HasAttachment As Boolean
	Dim Badge As String
	Dim BadgeNew As Boolean
	Dim BadgeColor As String
	Dim emailMap As Map = Emails.Get(emailID)
	SentBy = emailMap.GetDefault("sentby","")
	SentTo = emailMap.GetDefault("sentto","")
	Subject = emailMap.GetDefault("subject","")
	Content = emailMap.GetDefault("content","")
	DateTimeSent = emailMap.GetDefault("datetimesent","")
	Unread = emailMap.GetDefault("unread",True)
	Selected = emailMap.GetDefault("selected",False)
	SenderImage = emailMap.GetDefault("senderimage","")
	HasAttachment = emailMap.GetDefault("hasattachment",False)
	Badge = emailMap.GetDefault("badge","")
	BadgeNew = emailMap.GetDefault("badgenew",False)
	BadgeColor = emailMap.GetDefault("badgecolor","")
	'update the viewer
	PrepareViewer
	
	Dim p As HTMLElement
	p = p.createp("").AddClass("email-subject truncate").AddContent(Subject).ApplyStyle("font-size: 1.2rem;")
	viewer.AddElement(p).MaterialAddSimpleDivider
	'viewer.AddChildElement("hr").MaterialTextTheme(ABM.COLOR_GREY,ABM.INTENSITY_LIGHTEN2).ApplyStyle("display:block;height:1px;border:0;border-top: 1px solid #e0e0e0;margin: 1em 0;padding: 0;").Pop(p)
		
	Dim emailc As HTMLElement
	emailc = emailc.CreateDIV("").AddClass("email-content-wrap")
	
	Dim crow As HTMLElement
	crow = crow.CreateDIV("").AddClass("row").ApplyStyle("margin-bottom: 0;")
	Dim ccol As HTMLElement
	ccol = ccol.CreateDIV("").AddClass("col s10 m10 l10")
	
	Dim cole As HTMLElement
	cole = cole.CreateUL("").AddClass("collection").ApplyStyle("border: none;")
	
	Dim lie As HTMLElement
	lie = lie.CreateLI("").AddClass("collection-item avatar").ApplyStyle("height: auto;padding-left: 72px;position: relative;")
	'add sender image
	Select Case SentBy.tolowercase
		Case "social","promotions","updates"
			'create the respective icon
			Dim spui As HTMLElement
			spui = spui.CreateI("").AddClass("icon").ApplyStyle("position: absolute; width: 42px; height: 42px;")
			spui.ApplyStyle("overflow: hidden; left: 15px; display: inline-block; text-align: center; vertical-align: middle; top: 20px;")
			Select Case SentBy.ToLowerCase
				Case "social"
					spui.MaterialBuildIcon("mdi-social-group","").MaterialTextColor(ABM.COLOR_BLUE)
				Case "promotions"
					spui.MaterialBuildIcon("mdi-maps-local-offer","").MaterialTextColor(ABM.COLOR_GREEN)
				Case "updates"
					spui.MaterialBuildIcon("mdi-alert-error","").MaterialTextColor(ABM.COLOR_ORANGE)
			End Select
			lie.AddElement(spui)
		Case Else
			'add sender image
			If SenderImage <> "" Then
				Dim img As HTMLElement
				img = img.createimg("").SetSRC(SenderImage,False).SetALT("").AddClass("circle")
				img.ApplyStyle("padding: 0;")
				img.MaterialZDepth(ABM.ZDEPTH_1)
				lie.AddElement(img)
			Else
				'add sender alphabet
				Dim prefix As String = MashPlugIns.Left(SentBy,1)
				prefix = prefix.touppercase
				Dim brief As HTMLElement
				brief = brief.CreateSPAN("").AddClass("circle").AddContent(prefix)
				brief.ApplyStyle("position: absolute; width: 42px; height: 42px; overflow: hidden; left: 15px;")
				brief.ApplyStyle("display: inline-block; vertical-align: middle; text-align: center; font-size: 1.5rem;")
				brief.ApplyStyle("font-weight: 300; padding: 10px;").AddClass(MashPlugIns.AlphaColorCode(prefix)).MaterialTextColor(ABM.COLOR_WHITE)
				lie.AddElement(brief)
			End If
	End Select
	
	'add email title	
	Dim liesender As HTMLElement
	liesender = liesender.CreateSPAN("").AddClass("email-title").AddContent(SentBy)
	lie.AddElement(liesender)
	
	'sent to who
	Dim lieto As HTMLElement
	lieto = lieto.CreateP("").AddClass("truncate grey-text ultra-small").AddContent("To").AddSpace.AddContent(SentTo)
	lieto.ApplyStyle("font-size: 0.8rem;padding: 0;")
	lie.AddElement(lieto)
	
	'datetime sent
	Dim lietime As HTMLElement
	lietime = lietime.createp("").AddClass("grey-text ultra-small").AddContent(DateTimeSent)
	lietime.ApplyStyle("font-size: 0.8rem;padding: 0;")
	lie.AddElement(lietime)
	
	'has attachment
	If HasAttachment = True Then
		Dim a As HTMLElement
		a = a.CreateA("").SetHREF("#!").AddClass("secondary-content")
		a.ApplyStyle("position: absolute; top: 10px;")
		Dim attach As HTMLElement
		attach = attach.CreateI($"${compID}${emailID}attach"$).MaterialBuildIcon("mdi-editor-attach-file","").AddClass("attach-file")
		attach.ApplyStyle("transform: rotate(90deg); color: #9e9e9e; font-size: 1.1rem;")
		a.AddElement(attach).MaterialHoverable(False).AddOnClickEventPropertySelf(compID)
		lie.AddElement(a)
	End If
	
	cole.AddElement(lie)
	ccol.AddElement(cole)
	crow.AddElement(ccol)
	'action buttons on the right
	Dim actions As HTMLElement
	actions = actions.CreateDIV("").AddClass("col s2 m2 l2 email-actions").ApplyStyle("padding-top: 25px;")
	Dim reply As HTMLElement
	reply = reply.CreateI("").MaterialBuildIcon("mdi-content-reply","").MaterialTextColor(ABM.COLOR_GREY)
	Dim replyspan As HTMLElement
	replyspan = replyspan.CreateSPAN("").AddElement(reply)
	Dim replya As HTMLElement
	replya = replya.CreateA($"${compID}${emailID}reply"$).AddElement(replyspan).addcursor
	replya.AddOnClickEventProperty(compID,replya.ID)
	actions.AddElement(replya)
	'***
	Dim reply1 As HTMLElement
	reply1 = reply1.CreateI("").MaterialBuildIcon("mdi-navigation-more-vert","").MaterialTextColor(ABM.COLOR_GREY)
	Dim replyspan1 As HTMLElement
	replyspan1 = replyspan1.CreateSPAN("").AddElement(reply1)
	Dim replya1 As HTMLElement
	replya1 = replya1.CreateA($"${compID}${emailID}emailmenu"$).AddElement(replyspan1).addcursor
	replya1.AddOnClickEventProperty(compID,replya1.ID)
	actions.AddElement(replya1)
		
	crow.AddElement(actions)
	emailc.AddElement(crow)
	'add the content
	Dim emailContents As HTMLElement
	emailContents = emailContents.CreateDIV("").AddClass("email-content")
	Dim pcontents As HTMLElement
	pcontents = pcontents.CreateP("").AddContent(Content)
	emailContents.AddElement(pcontents)
	emailc.AddElement(emailContents)	
	viewer.AddElement(emailc)
	'create the reply section to close this component
	Dim emailreply As HTMLElement
	emailreply = emailreply.CreateDIV("").AddClass("email-reply").ApplyStyle("padding-top: 20px;")
	Dim er_row As HTMLElement
	er_row = er_row.CreateDIV("").AddClass("row")
	'add reply back
	Dim replybtn As HTMLElement
	replybtn = replybtn.CreateDIV("").AddClass("col s4 m4 l4 center-align")
	Dim ra As HTMLElement
	ra = ra.CreateA($"${compID}${emailID}replytoo"$).addcursor
	ra.AddChildElement("i").MaterialBuildIcon("mdi-content-reply","").MaterialTextColor(ABM.COLOR_GREY).MaterialHoverable(False).Pop
	ra.AddOnClickEventProperty(compID,ra.ID)
	replybtn.Addelement(ra)
	replybtn.AddChildElement("p").AddClass("ultra-small").SetID($"${compID}${emailID}replytoo1"$).AddOnClickEventPropertySelf(compID).AddContent("Reply").AddCursor.MaterialHoverable(False).Pop
	er_row.AddElement(replybtn)
	'add reply all
	Dim replybtnall As HTMLElement
	replybtnall = replybtnall.CreateDIV("").AddClass("col s4 m4 l4 center-align")
	Dim raall As HTMLElement
	raall = raall.CreateA($"${compID}${emailID}replytoall"$).addcursor
	raall.AddChildElement("i").MaterialBuildIcon("mdi-content-reply-all","").AddOnClickEventPropertySelf(compID).MaterialTextColor(ABM.COLOR_GREY).MaterialHoverable(False).Pop
	replybtnall.Addelement(raall)
	replybtnall.AddChildElement("p").AddClass("ultra-small").SetID($"${compID}${emailID}replytoall1"$).AddOnClickEventPropertySelf(compID).AddCursor.AddContent("Reply all").MaterialHoverable(False).Pop
	er_row.AddElement(replybtnall)
	'add forward
	Dim forward As HTMLElement
	forward = forward.CreateDIV("").AddClass("col s4 m4 l4 center-align")
	Dim forwarda As HTMLElement
	forwarda = forwarda.CreateA($"${compID}${emailID}forward"$).addcursor
	forwarda.AddChildElement("i").MaterialBuildIcon("mdi-content-forward","").AddOnClickEventPropertySelf(compID).MaterialTextColor(ABM.COLOR_GREY).MaterialHoverable(False).Pop
	forward.Addelement(forwarda)
	forward.AddChildElement("p").AddClass("ultra-small").SetID($"${compID}${emailID}forward1"$).AddOnClickEventPropertySelf(compID).AddCursor.AddContent("Forward").MaterialHoverable(False).Pop
	er_row.AddElement(forward)
	er_row.MaterialAddSimpleDivider
	emailreply.AddElement(er_row)
	viewer.AddElement(emailreply).MaterialAddSimpleDivider
	ABM.ReplaceMyHTML(Page,$"${compID}viewer"$,viewer.HTML)
	'add variable actions for this email
	'EmailAct.Add(reply.AddChildClickEvent(compID,replya.ID,replya.id))
	'EmailAct.Add(reply.AddChildClickEvent(compID,replya1.ID,replya1.id))
	'EmailAct.Add(reply.AddChildClickEvent(compID,ra.ID,ra.id))
	'EmailAct.Add(reply.AddChildClickEvent(compID,$"${compID}${emailID}replytoo1"$,$"${compID}${emailID}replytoo1"$))
	'EmailAct.Add(reply.AddChildClickEvent(compID,$"${compID}${emailID}forward1"$,$"${compID}${emailID}forward1"$))
	'EmailAct.Add(reply.AddChildClickEvent(compID,$"${compID}${emailID}replytoall1"$,$"${compID}${emailID}replytoall1"$))
	'EmailAct.Add(reply.AddChildClickEvent(compID,$"${compID}${emailID}attach"$,$"${compID}${emailID}attach"$))
	'EmailAct.Add(reply.AddChildClickEvent(compID,raall.ID,raall.id))
	'EmailAct.Add(reply.AddChildClickEvent(compID,forwarda.ID,forwarda.id))
	Dim script As String = Element.MvFromList(EmailAct,"")
	JQueryExecute(script)
End Sub

'prepare the viewer to view the selected emails
private Sub PrepareViewer
	viewer = viewer.CreateDIV($"${compID}viewer"$).AddClass("col s12 m7 l7 card-panel")
	viewer.ApplyStyle("margin-top: 0;padding: 15px;").MaterialZDepth(ABM.ZDEPTH_REMOVE)
End Sub

'clear the viewing stage
Sub ClearViewer
	PrepareViewer	
	ABM.ReplaceMyHTML(Page,$"${compID}viewer"$,viewer.html)
End Sub

'build the email viewer
private Sub BuildEmailViewer As HTMLElement
	PrepareViewer
	Return viewer
End Sub

'add a theme to this componet
Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'initialize the component
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.initialize
	Page = InternalPage
	compID = ID.tolowercase
	WavesEffect = False
	WavesType = ""
	WavesCircle = False
	ZDepth = ""
	Enabled = True
	Emails.Initialize
	collectionof = collectionof.createul("").AddClass("collection").ApplyStyle("margin: 0;").MaterialZDepth(ABM.ZDEPTH_REMOVE)
	Element = Element.CreateDIV(compID).AddClass("section")
	SelectionTheme = ""
End Sub

'build the component
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	View(LastSelected)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

'execute a query script for this component
private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compID))
End Sub
	