﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Public Element As HTMLElement
	Public ZDepth As String
	Public Visibility As String
	Public Enabled As Boolean
	Private page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private ABM As ABMaterial
	Public Width As Int
	Public Height As Int
	Private Shapes As Map
	Public connectorLength As String
	Public connectorStrokeWidth As String
	Public arrowColour As String
	Public decisionFill As String
	Public processFill As String
	Public finishFill As String
	Public defaultFontSize As String
	Public interactive As Boolean
	Public showButtons As Boolean
	Public scrollto As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	page = InternalPage
	JavaCalls.Initialize
	compID = ID.tolowercase
	Enabled = True
	ZDepth = ""
	Visibility = ""
	Element.Initialize(compID,"div")
	Shapes.initialize
	Width = 500
	Height = 500
	connectorLength = 60
	connectorStrokeWidth = 3
	arrowColour = "lightgrey"
	decisionFill = "firebrick"
	processFill = "navajowhite"
	finishFill = "seagreen"
	defaultFontSize = "14"
	interactive = False
	showButtons = False
	scrollto = True
End Sub

private Sub BuildShapes() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strKey As String In Shapes.Keys
		Dim strValue As String = Shapes.Get(strKey)
		sb.Append(strValue).Append(",")
	Next
	MashPlugIns.RemDelimsb(",",sb)
	Return sb.tostring
End Sub

Sub AddDecision(Label As String,Text As String,OnYesGoto As String, OnNoGoto As String)
	Dim sShape As String = $"{label: '${Label}', type: 'decision', text: ['${Text}'], yes: '${OnYesGoto}', no: '${OnNoGoto}'}"$
	Shapes.put(Label,sShape)
End Sub


Sub AddProcess(Label As String,Text As String, OnNextGoto As String)
	Dim sShape As String = $"{label: '${Label}', type: 'process', text: ['${Text}'], next: '${OnNextGoto}'}"$
	Shapes.put(Label,sShape)
End Sub

Sub AddFinish(Label As String,Text As String)
	Dim sShape As String = $"{label: '${Label}', type: 'finish', text: ['${Text}']}"$
	Shapes.put(Label,sShape)
End Sub

Sub HTML As String
	
	Element.MaterialVisibility(Visibility).MaterialZdepth(ZDepth).MaterialEnable(Enabled)
	JavaCalls.Add($"flowSVG.draw(SVG('${compID}'));"$)
Dim fcOptions As String = $"flowSVG.config({
w: ${Width},
h: ${Height},
connectorLength: ${connectorLength},
connectorStrokeWidth: ${connectorStrokeWidth},
arrowColour: '${arrowColour}',
decisionFill: '${decisionFill}',
processFill: '${processFill}',
finishFill: '${finishFill}',
interactive: ${interactive},
showButtons: ${showButtons},
scrollto: ${scrollto},
defaultFontSize: '${defaultFontSize}'
});"$
	JavaCalls.Add(fcOptions)
	JavaCalls.Add($"flowSVG.shapes([${BuildShapes}]);"$)
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	page.ws.Eval(script, Array As String(compID))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub