﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Public Visibility As String
	Public WavesType As String
	Public ZDepth As String
	Public Enabled As Boolean
	Public WavesEffect As Boolean
	Public WavesCircle As Boolean
	Private Element As HTMLElement
	Private Items As List
	Private ABM As ABMaterial
	Private JavaCalls As List
	Private Albums As Map
	Private backgroundColor As String
	Private textColor As String
	Type ModeType(fullscreen As String, slider As String,standard As String)
	Public EnumMode As ModeType
	Public TransitionCols As String
	Public TransitionRows As String
	Public ThumbnailsPosition As String
	Private mode As String
	Type thumbnailsPositionType(top As String, right As String, bottom As String, left As String)
	Public EnumthumbnailsPosition As thumbnailsPositionType
	Public ThumbType As String
	Type thumbTypeType(image As String, square As String, number As String)
	Public EnumthumbType As thumbTypeType
	Public Transition As String
	Public AutoStart As Boolean
	Public HeightPx As String
	Public preloadAll As Boolean
	Type IntervalType(threeseconds As String, sixseconds As String, eightseconds As String, tenseconds As String)
	Public Interval As String
	Public EnumInterval As IntervalType
	Public ThumbNails As Boolean
	Public Title As Boolean
	Public TransitionBackward As String
	Private Theme As String
	Public Static As Boolean
	Type TransitionObject(moveToLeft_moveFromRight As String,moveToRight_moveFromLeft As String,moveToTop_moveFromBottom As String,moveToBottom_moveFromTop As String, _
	fade_moveFromRight As String,fade_moveFromLeft As String,fade_moveFromBottom As String,fade_moveFromTop As String,moveToLeftFade_moveFromRightFade As String, _
	moveToRightFade_moveFromLeftFade As String,moveToTopFade_moveFromBottomFade As String,moveToBottomFade_moveFromTopFade As String,moveToLeftEasing_moveFromRight As String, _
	moveToRightEasing_moveFromLeft As String,moveToTopEasing_moveFromBottom As String,moveToBottomEasing_moveFromTop As String,scaleDown_moveFromRight As String, _
	scaleDown_moveFromLeft As String,scaleDown_moveFromBottom As String,scaleDown_moveFromTop As String,scaleDown_scaleUpDown As String,scaleDownUp_scaleUp As String, _
	moveToLeft_scaleUp As String,moveToRight_scaleUp As String,moveToTop_scaleUp As String,moveToBottom_scaleUp As String,scaleDownCenter_scaleUpCenter As String, _
	rotateRightSideFirst_moveFromRight As String,rotateLeftSideFirst_moveFromLeft As String,rotateTopSideFirst_moveFromTop As String,rotateBottomSideFirst_moveFromBottom As String, _
	flipOutRight_flipInLeft As String,flipOutLeft_flipInRight As String,flipOutTop_flipInBottom As String,flipOutBottom_flipInTop As String,rotateFall_scaleUp As String, _
	rotateOutNewspaper_rotateInNewspaper As String,rotatePushLeft_moveFromRight As String,rotatePushRight_moveFromLeft As String,rotatePushTop_moveFromBottom As String, _
	rotatePushBottom_moveFromTop As String,rotatePushLeft_rotatePullRight As String,rotatePushRight_rotatePullLeft As String,rotatePushTop_rotatePullBottom As String, _
	rotatePushBottom_page As String,rotateFoldLeft_moveFromRightFade As String,rotateFoldRight_moveFromLeftFade As String,rotateFoldTop_moveFromBottomFade As String, _
	rotateFoldBottom_moveFromTopFade As String,moveToRightFade_rotateUnfoldLeft As String,moveToLeftFade_rotateUnfoldRight As String,moveToBottomFade_rotateUnfoldTop As String, _
	moveToTopFade_rotateUnfoldBottom As String,rotateRoomLeftOut_rotateRoomLeftIn As String,rotateRoomRightOut_rotateRoomRightIn As String,rotateRoomTopOut_rotateRoomTopIn As String, _
	rotateRoomBottomOut_rotateRoomBottomIn As String,rotateCubeLeftOut_rotateCubeLeftIn As String,rotateCubeRightOut_rotateCubeRightIn As String,rotateCubeTopOut_rotateCubeTopIn As String, _
	rotateCubeBottomOut_rotateCubeBottomIn As String,rotateCarouselLeftOut_rotateCarouselLeftIn As String,rotateCarouselRightOut_rotateCarouselRightIn As String, _
	rotateCarouselTopOut_rotateCarouselTopIn As String,rotateCarouselBottomOut_rotateCarouselBottomIn As String,rotateSidesOut_rotateSidesInDelay As String,rotateSlideOut_rotateSlideIn As String,random As String)
	Public EnumTransition As TransitionObject
End Sub

Sub SetMode(sMode As String)
	mode = sMode
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.initialize
	Page = InternalPage
	compID = ID.tolowercase
	Element = Element.Initialize(compID,"div")
	Visibility = ""
	ThumbNails = True
	WavesType = ""
	Static = True
	ZDepth = ""
	Theme = ThemeName
	Enabled = True
	Title = True
	WavesEffect = False
	WavesCircle = False
	textColor = MashPlugIns.ABMGetForeColor(Theme)
	backgroundColor = MashPlugIns.ABMGetBackGroundColor(Theme)
	'backgroundColor = MashPlugIns.GetBackColorOnlyFromTheme(ThemeName)
	'textColor = MashPlugIns.GetForeColorOnlyFromTheme(ThemeName)
	Items.Initialize
	Albums.initialize
	EnumMode.Initialize
	EnumMode.FullScreen = "full-screen"
	EnumMode.slider = "slider"
	EnumMode.standard = "standard"
	TransitionCols = "6"
	TransitionRows = ""
	ThumbnailsPosition = "right"
	mode = EnumMode.FullScreen
	EnumthumbnailsPosition.Initialize
	EnumthumbnailsPosition.bottom = "bottom"
	EnumthumbnailsPosition.left = "left"
	EnumthumbnailsPosition.right = "right"
	EnumthumbnailsPosition.top = "top"
	EnumthumbType.Initialize
	EnumthumbType.image = "image"
	EnumthumbType.number = "number"
	EnumthumbType.square = "square"
	ThumbType = EnumthumbType.image
	AutoStart = True
	HeightPx = "600px"
	preloadAll = False
	Interval = "3s"
	EnumInterval.Initialize
	EnumInterval.sixseconds = "6s"
	EnumInterval.tenseconds = "10s"
	EnumInterval.threeseconds = "3s"
	EnumInterval.eightseconds = "8s"
	TransitionBackward = "auto"
	Transition = "moveToLeft_moveFromRight"
	EnumTransition.Initialize
	EnumTransition.moveToLeft_moveFromRight = "moveToLeft_moveFromRight"
	EnumTransition.moveToRight_moveFromLeft = "moveToRight_moveFromLeft"
	EnumTransition.moveToTop_moveFromBottom = "moveToTop_moveFromBottom"
	EnumTransition.moveToBottom_moveFromTop = "moveToBottom_moveFromTop"
	EnumTransition.fade_moveFromRight = "fade_moveFromRight"
	EnumTransition.fade_moveFromLeft = "fade_moveFromLeft"
	EnumTransition.fade_moveFromBottom = "fade_moveFromBottom"
	EnumTransition.fade_moveFromTop = "fade_moveFromTop"
	EnumTransition.moveToLeftFade_moveFromRightFade = "moveToLeftFade_moveFromRightFade"
	EnumTransition.moveToRightFade_moveFromLeftFade = "moveToRightFade_moveFromLeftFade"
	EnumTransition.moveToTopFade_moveFromBottomFade = "moveToTopFade_moveFromBottomFade"
	EnumTransition.moveToBottomFade_moveFromTopFade = "moveToBottomFade_moveFromTopFade"
	EnumTransition.moveToLeftEasing_moveFromRight = "moveToLeftEasing_moveFromRight"
	EnumTransition.moveToRightEasing_moveFromLeft = "moveToRightEasing_moveFromLeft"
	EnumTransition.moveToTopEasing_moveFromBottom = "moveToTopEasing_moveFromBottom"
	EnumTransition.moveToBottomEasing_moveFromTop = "moveToBottomEasing_moveFromTop"
	EnumTransition.scaleDown_moveFromRight = "scaleDown_moveFromRight"
	EnumTransition.scaleDown_moveFromLeft = "scaleDown_moveFromLeft"
	EnumTransition.scaleDown_moveFromBottom = "scaleDown_moveFromBottom"
	EnumTransition.scaleDown_moveFromTop = "scaleDown_moveFromTop"
	EnumTransition.scaleDown_scaleUpDown = "scaleDown_scaleUpDown"
	EnumTransition.scaleDownUp_scaleUp = "scaleDownUp_scaleUp"
	EnumTransition.moveToLeft_scaleUp = "moveToLeft_scaleUp"
	EnumTransition.moveToRight_scaleUp = "moveToRight_scaleUp"
	EnumTransition.moveToTop_scaleUp = "moveToTop_scaleUp"
	EnumTransition.moveToBottom_scaleUp = "moveToBottom_scaleUp"
	EnumTransition.scaleDownCenter_scaleUpCenter = "scaleDownCenter_scaleUpCenter"
	EnumTransition.rotateRightSideFirst_moveFromRight = "rotateRightSideFirst_moveFromRight"
	EnumTransition.rotateLeftSideFirst_moveFromLeft = "rotateLeftSideFirst_moveFromLeft"
	EnumTransition.rotateTopSideFirst_moveFromTop = "rotateTopSideFirst_moveFromTop"
	EnumTransition.rotateBottomSideFirst_moveFromBottom = "rotateBottomSideFirst_moveFromBottom"
	EnumTransition.flipOutRight_flipInLeft = "flipOutRight_flipInLeft"
	EnumTransition.flipOutLeft_flipInRight = "flipOutLeft_flipInRight"
	EnumTransition.flipOutTop_flipInBottom = "flipOutTop_flipInBottom"
	EnumTransition.flipOutBottom_flipInTop = "flipOutBottom_flipInTop"
	EnumTransition.rotateFall_scaleUp = "rotateFall_scaleUp"
	EnumTransition.rotateOutNewspaper_rotateInNewspaper = "rotateOutNewspaper_rotateInNewspaper"
	EnumTransition.rotatePushLeft_moveFromRight = "rotatePushLeft_moveFromRight"
	EnumTransition.rotatePushRight_moveFromLeft = "rotatePushRight_moveFromLeft"
	EnumTransition.rotatePushTop_moveFromBottom = "rotatePushTop_moveFromBottom"
	EnumTransition.rotatePushBottom_moveFromTop = "rotatePushBottom_moveFromTop"
	EnumTransition.rotatePushLeft_rotatePullRight = "rotatePushLeft_rotatePullRight"
	EnumTransition.rotatePushRight_rotatePullLeft = "rotatePushRight_rotatePullLeft"
	EnumTransition.rotatePushTop_rotatePullBottom = "rotatePushTop_rotatePullBottom"
	EnumTransition.rotatePushBottom_page = "rotatePushBottom_page"
	EnumTransition.rotateFoldLeft_moveFromRightFade = "rotateFoldLeft_moveFromRightFade"
	EnumTransition.rotateFoldRight_moveFromLeftFade = "rotateFoldRight_moveFromLeftFade"
	EnumTransition.rotateFoldTop_moveFromBottomFade = "rotateFoldTop_moveFromBottomFade"
	EnumTransition.rotateFoldBottom_moveFromTopFade = "rotateFoldBottom_moveFromTopFade"
	EnumTransition.moveToRightFade_rotateUnfoldLeft = "moveToRightFade_rotateUnfoldLeft"
	EnumTransition.moveToLeftFade_rotateUnfoldRight = "moveToLeftFade_rotateUnfoldRight"
	EnumTransition.moveToBottomFade_rotateUnfoldTop = "moveToBottomFade_rotateUnfoldTop"
	EnumTransition.moveToTopFade_rotateUnfoldBottom = "moveToTopFade_rotateUnfoldBottom"
	EnumTransition.rotateRoomLeftOut_rotateRoomLeftIn = "rotateRoomLeftOut_rotateRoomLeftIn"
	EnumTransition.rotateRoomRightOut_rotateRoomRightIn = "rotateRoomRightOut_rotateRoomRightIn"
	EnumTransition.rotateRoomTopOut_rotateRoomTopIn = "rotateRoomTopOut_rotateRoomTopIn"
	EnumTransition.rotateRoomBottomOut_rotateRoomBottomIn = "rotateRoomBottomOut_rotateRoomBottomIn"
	EnumTransition.rotateCubeLeftOut_rotateCubeLeftIn = "rotateCubeLeftOut_rotateCubeLeftIn"
	EnumTransition.rotateCubeRightOut_rotateCubeRightIn = "rotateCubeRightOut_rotateCubeRightIn"
	EnumTransition.rotateCubeTopOut_rotateCubeTopIn = "rotateCubeTopOut_rotateCubeTopIn"
	EnumTransition.rotateCubeBottomOut_rotateCubeBottomIn = "rotateCubeBottomOut_rotateCubeBottomIn"
	EnumTransition.rotateCarouselLeftOut_rotateCarouselLeftIn = "rotateCarouselLeftOut_rotateCarouselLeftIn"
	EnumTransition.rotateCarouselRightOut_rotateCarouselRightIn = "rotateCarouselRightOut_rotateCarouselRightIn"
	EnumTransition.rotateCarouselTopOut_rotateCarouselTopIn = "rotateCarouselTopOut_rotateCarouselTopIn"
	EnumTransition.rotateCarouselBottomOut_rotateCarouselBottomIn = "rotateCarouselBottomOut_rotateCarouselBottomIn"
	EnumTransition.rotateSidesOut_rotateSidesInDelay = "rotateSidesOut_rotateSidesInDelay"
	EnumTransition.rotateSlideOut_rotateSlideIn = "rotateSlideOut_rotateSlideIn"
	EnumTransition.random = "random"
End Sub

Sub AddAlbum(AlbumTitle As String)
	Dim images As List
	images.Initialize
	Albums.Put(AlbumTitle,images)
End Sub

private Sub BuildOptions As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	sb.Append($"mode: '${mode}',"$)
	sb.Append($"autostart: ${AutoStart},"$)
	sb.Append($"browserHistory: true,"$)
	sb.Append($"canClose: false,"$)
	sb.Append($"canMinimalizeThumbnails: true,"$)
	sb.Append($"canZoom: true,"$)
	sb.Append($"height: '${HeightPx}',"$)
	sb.Append($"preloadAll: ${preloadAll},"$)
	sb.Append($"slideshowAutostart: true,"$)
	sb.Append($"slideshowInterval: '${Interval}',"$)
	sb.Append($"swipeEvents: true,"$)
	sb.Append($"thumbnails: ${ThumbNails},"$)
	sb.Append($"thumbnailsFullScreen: true,"$)
	sb.Append($"thumbnailsHideOnMobile: true,"$)
	If ThumbnailsPosition <> "" Then sb.Append($"thumbnailsPosition: '${ThumbnailsPosition}',"$)
	If ThumbType <> "" Then sb.Append($"thumbType:'${ThumbType}',"$)
	sb.Append($"disabledOnIE8AndOlder: true,"$)
	sb.Append($"draggableZoom: true,"$)
	sb.Append($"zoomSize: 'fill',"$)
	sb.Append($"title: ${Title},"$)
	sb.Append($"transitionBackward: '${TransitionBackward}',"$)
	sb.Append($"transition: '${Transition}',"$)
	sb.Append($"titleExpanded: true,"$)
	sb.Append($"width: '100%',"$)
	sb.Append($"hideThumbnailsOnInit: true,"$)
	'sb.Append("height: '100vh', canChangeMode: false,")
	If backgroundColor <> "" Then sb.Append($"backgroundColor: '${backgroundColor}',"$)
	If textColor <> "" Then sb.Append($"textColor: '${textColor}',"$)
	If TransitionCols <> "" Then 
		If TransitionCols > 6 Then TransitionCols = 6
		sb.Append($"transitionCols: '${TransitionCols}',"$)
	End If
	If TransitionRows <> "" Then 
		If TransitionRows > 6 Then TransitionRows = 6
		sb.Append($"transitionRows: '${TransitionRows}',"$)
	End If
	MashPlugIns.RemDelimSB(",",sb)
	sb.Append("}")
	Return sb.tostring
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Sub AddAlbumSlide(Album As String, imgURL As String, imgTitle As String)
	If Albums.ContainsKey(Album) Then
		Dim stextColor As String = MashPlugIns.ABMGetForeColor(Theme)
		Dim sbackcolor As String = MashPlugIns.ABMGetBackGroundColor(Theme)
		Dim images As List = Albums.Get(Album)
		Dim nextItem As Int = images.size
		Dim slideItem As MashAnchor
		slideItem.Initialize($"${compID}${nextItem}"$)
		slideItem.HREF = imgURL
		slideItem.Element.CreateIMG("").SetSRC(imgURL,Static).SetALT(imgTitle).AddProperty("data-jgallery-bg-color",sbackcolor).AddProperty("data-jgallery-text-color",stextColor).Pop
		slideItem.WavesEffect = False
		images.Add(slideItem.HTML)
		Albums.Put(Album,images)
	Else
		Log("Album: " & Album & " does not exist.")
	End If	
End Sub


Sub AddSlide(imgURL As String, imgTitle As String)
	Dim stextColor As String = MashPlugIns.ABMGetForeColor(Theme)
	Dim sbackcolor As String = MashPlugIns.ABMGetBackGroundColor(Theme)
	Dim nextItem As Int = Items.size
	Dim slideItem As MashAnchor
	slideItem.Initialize($"${compID}${nextItem}"$)
	slideItem.HREF = imgURL
	slideItem.Element.CreateIMG("").SetSRC(imgURL,Static).SetALT(imgTitle).AddProperty("data-jgallery-bg-color",sbackcolor).AddProperty("data-jgallery-text-color",stextColor).Pop
	slideItem.WavesEffect = False
	Items.Add(slideItem.HTML)
End Sub

Sub HTML As String
	
	Element.MaterialEnable(Enabled).MaterialZDepth(ZDepth).MaterialVisibility(Visibility).MaterialWavesEffect(WavesEffect).MaterialWavesType(WavesType)
	Element.MaterialZDepth(ZDepth).MaterialWavesCircle(WavesCircle)
	'add albums
	For Each strAlbum As String In Albums.Keys
		Dim albumdiv As HTMLElement
		albumdiv = albumdiv.CreateDIV("").AddClass("album").AddProperty("data-jgallery-album-title",strAlbum)
		Dim images As List = Albums.Get(strAlbum)
		albumdiv.AddContentList(images)
		Element.AddElement(albumdiv)
	Next
	'add stand alone images
	Element.AddContentList(Items)
	Return Element.HTML
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	JavaCalls.Add($"$('#${compID}').jGallery(${BuildOptions});"$)
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,"")
	Page.ws.Eval(script, Array As String(compID))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub