﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Public IconName As String
	Public Theme As String
	Public Element As HTMLElement
	Public Alignment As String
	Public AddCursor As Boolean
	Public Circle As Boolean
	Public WaveEffects As Boolean
	Public Prefix As Boolean
	Public WavesEffect As Boolean
	Public Visibility As String
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
	Public Enabled As Boolean
	Public IconSize As String
	Public Close As Boolean
	Private JavaCalls As List
	Public ToolTip As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize 
	Close = False
	IconName = ""
	Prefix = False
	Circle = False
	AddCursor = False
	Theme = ThemeName
	WaveEffects = True
	Alignment = ""
	Element.Initialize(ID,"i")
	Enabled = True
	Visibility= ""
	ZDepth = ""
	WavesType= ""
	IconSize = ""
	WavesEffect = True
	WavesCircle = False
End Sub

Sub HTML As String
	Element.ID = compid
	MashPlugIns.MaterialUseTheme(Theme,Element).MaterialHoverable(Hoverable)
	Element.MaterialBuildIcon(IconName, Alignment)
	Element.MaterialCircle(Circle)
	'leave this true for proper alignment
	Element.MaterialWavesEffect(True)
	Element.AddClassOnCondition(Prefix,"prefix")
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Element.MaterialIconSize(IconSize)
	Element.MaterialClose(Close)
	If AddCursor = True Then Element.addcursor
	Return Element.html
End Sub


Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	ABM.ReplaceMyHTML(Page,compid,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	InternalPage.ws.Eval(script, Array As String(compid))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub


