﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Public Responsive As Boolean
	Public Circle As Boolean
	Public URL As String
	Public Alt As String
	Public Element As HTMLElement
	Public ZDepth As String
	Public Visibility As String
	Public Hoverable As Boolean
	Public MaterialBoxed As Boolean
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public Enabled As Boolean
	Public Caption As String
	Public Activator As Boolean
	Private page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private bStatic As Boolean
	Private imgBadge As MashBadgeOn
	Public Bordered As Boolean
	Public ArrayName As String
	Public RoundedCorners As Boolean
	Public Width As String
	Public Height As String
	Public OnClick As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, imgURL As String, Static As Boolean)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	page = InternalPage
	JavaCalls.Initialize
	bStatic = Static 
	compID = ID
	Responsive = False
	RoundedCorners = False
	Bordered = False
	ArrayName = ""
	Activator = False
	Circle = False
	URL = imgURL
	Alt = ""
	compID = ID.tolowercase
	Enabled = True
	ZDepth = ""
	Visibility = ""
	Caption = ""
	Hoverable = True
	MaterialBoxed = False
	Element.Initialize(ID,"img")
	WavesEffect = True
	WavesType = ""
	WavesCircle = False
	OnClick = ""
	Width = ""
	Height = ""
	MashPlugIns.AddExternalStyle("img-bordered", "padding: 3px; border-width: 1px; border-style: solid;	background: #fff;")
	MashPlugIns.AddExternalStyle("img-rounded", "border-radius: 6px;")
	MashPlugIns.AddExternalStyle("img-circle","border-radius: 50%;")
End Sub

Sub SetBadge(badge As String, badgeTheme As String)
	Dim b As MashBadgeOn
	b.Initialize($"${compID}badge"$,badge,badgeTheme)
	b.Inline = False
	'remove the right property so that badge is close to the image
	b.Inline = True
	b.UnsetRight = True
	imgBadge = b
End Sub

Sub BorderColorDanger
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("danger")
	Element.AddStyleAttribute("border-color",sColor)
End Sub

Sub BorderColorSuccess
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("success")
	Element.AddStyleAttribute("border-color",sColor)
End Sub

Sub BorderColorWarn
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("warn")
	Element.AddStyleAttribute("border-color",sColor)
End Sub

Sub BorderColorInfo
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("info")
	Element.AddStyleAttribute("border-color",sColor)
End Sub

Sub BorderColorPrimary
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("primary")
	Element.AddStyleAttribute("border-color",sColor)
End Sub

Sub BorderColorMuted
	Dim sColor As String = MashPlugIns.ABMGetBackGroundColor("mouted")
	Element.AddStyleAttribute("border-color",sColor)
End Sub

Sub SetBorderColor(sColor As String, sIntensity As String)
	Dim sColor As String = MashPlugIns.ABMGetColor(sColor,sIntensity)
	Element.AddStyleAttribute("border-color",sColor)
End Sub

Sub SetSize(imgHeight As String, imgWidth As String)
	Element.SetHEIGHT(imgHeight)
	Element.SetWIDTH(imgWidth)
	Height = imgHeight
	Width = imgWidth
End Sub

Sub SetMargins(sMargin As String)
	Element.SetMargins(sMargin,sMargin,sMargin,sMargin)
End Sub

Sub SetWidth(sWidth As String)
	Element.SetWIDTH(sWidth)
	Width = sWidth
End Sub

Sub SetHeigh(sHeight As String)
	Element.SetHEIGHT(sHeight)
	Height = sHeight
End Sub

Sub HTML As String
	Element.ID = compID
	WavesEffect = Responsive
	Element.addclassoncondition(RoundedCorners,"img-rounded")
	Element.AddClassOnCondition(Bordered,"img-bordered")
	Element.AddClassOncondition(Circle,"img-circle")
	Element.MaterialVisibility(Visibility)
	Element.MaterialHoverable(Hoverable)
	Element.MaterialZdepth(ZDepth)
	Element.MaterialCircle(Circle)
	Element.SetAlt(Alt)
	Element.SetSrc(URL,bStatic)
	Element.MaterialHoverable(Hoverable)
	Element.MaterialResponsive(Responsive)
	Element.MaterialBoxed(MaterialBoxed)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialEnable(Enabled)
	Element.AddDataAttribute("caption",Caption)
	Element.AddClassOnCondition(Activator,"activator")
	If Width <> "" Then Element.SetWIDTH(Width)
	If Height <> "" Then Element.SetHEIGHT(Height)
	If imgBadge.IsInitialized Then
		Element.AddContent(imgBadge.HTML)
		Element.applystyle("overflow: visible;")
		Dim wrap As HTMLElement
		wrap = wrap.CreateDIV(compID)
		Element.ID = compID & "img"
		wrap.AddElement(Element)
		wrap.AddOnClickEventProperty(ArrayName,Element.id)
		Return wrap.html
	End If
	Element.AddOnClickEventProperty(ArrayName,Element.id)
	Return Element.html
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,HTML)
	'If ArrayName = "" Then ArrayName = compID
	'JavaCalls.Add(Element.AddChildClickEvent(ArrayName,compID,compID))
	Dim script As String = Element.MvFromList(JavaCalls,"")
	page.ws.Eval(script, Array As String(compID))
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub