﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Public Page As ABMPage
	Public Element As HTMLElement
	Private Items As List
	Public Enabled As Boolean
	Public WavesEffect As Boolean
	Public WavesCircle As Boolean
	Public ID As String
	Public Theme As String
	Public TooltipPosition As String
	Public TooltipDelay As String
	Public ToolTip As String
	Public Visibility As String
	Public WavesType As String
	Public ZDepth As String
	Private Slides As HTMLElement
	Public Indicators As Boolean
	Public Height As String
	Public Transition As String
	Public Interval As String
	Private JavaCalls As List
	Public Hoverable As Boolean
	Private ABM As ABMaterial
	Public Static As Boolean
End Sub

Public Sub Initialize(pg As ABMPage, sID As String)
	ABMComp.Initialize("ABMComp", Me, pg, ID,"")
	Page = pg
	JavaCalls.Initialize 
	Page = pg
	Element = Element.Initialize(ID,"div")
	Items.Initialize
	Enabled = True
	WavesEffect = False
	WavesCircle = False
	Indicators = True
	Static = True
	Transition = "500"
	Height = "400"
	Interval = "6000"
	ID = sID.tolowercase
	Theme = ""
	ToolTip = ""
	Visibility = ""
	WavesType = ""
	ZDepth = ""
	Slides.Initialize(ID & "slides","ul").addclass("slides")
End Sub


Sub AddSlide(slideID As String, imgURL As String, Title As String, Alignment As String, Description As String, titleTheme As String, descriptionTheme As String)
	'create the list item
	Dim li As HTMLElement
	li.Initialize(slideID,"li")
	'create the image
	Dim img As MashImage
	img.Initialize(Page,slideID & "img",imgURL,Static)
	'img.element.SetStyleHEIGHT("100%")
	'img.Element.SetStyleWIDTH("100%")
	img.Element.AddStyleAttribute("object-fit","contain")
	li.AddContent(img.HTML)
	'create the content
	Dim content As HTMLElement
	content.Initialize(slideID & "content","div").addclass("caption")
	content.MaterialAlignText(Alignment)
	
	Dim h3 As HTMLElement
	h3.Initialize("","h3")
	h3.AddContent(Title)
	MashPlugIns.MaterialUseTheme(titleTheme,h3)
	
	Dim h5 As HTMLElement
	h5.Initialize("","h5")
	h5.AddContent(Description)
	MashPlugIns.MaterialUseTheme(descriptionTheme,h5)

	content.AddContent(h3.HTML)
	content.AddContent(h5.HTML)
	
	'add content to the list
	li.AddContent(content.HTML)
	Slides.addcontent(li.HTML)
End Sub

Sub HTML As String
	Element.ID = ID
	Slides.ID = ID & "slides"
	Element.AddClass("slider")
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility)
	Element.MaterialSetToolTip(TooltipPosition,TooltipDelay,ToolTip)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle).MaterialHoverable(Hoverable)
	Element.AddContent(Slides.HTML)
	Return Element.HTML
End Sub

private Sub JQExecuteOptions() As String
	Dim js As String = $"$('#${ID}').slider({indicators:${Indicators},height:${Height},transition:${Transition},interval:${Interval}});"$
	Return js
End Sub


Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'we create a div with a video and a canvas and we hide the canvas
	Page = InternalPage
	ID = internalID
	Return Element.GetComponentBuilder
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,ID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	Page.ws.Eval(script, Array As String(ID))
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	ID = internalID
	Page = InternalPage
	Refresh
End Sub

Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub


Sub SetToolTip(stooltip As String)
	Element.MaterialSetToolTip(MashPlugIns.TooltipPosition,MashPlugIns.TooltipDelay,stooltip)
End Sub
