﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Element As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private sSmall As Int
	Private sMedium As Int
	Private sLarge As Int
	Private sTitle As String
	Private sTheme As String
	Public Hoverable As Boolean
	Private sValue As String
	Private sIconName As String
	Private style As HTMLElement
	Public Animated As Boolean
	Public HoverZoom As Boolean
	Public HoverExpand As Boolean
	Public ThemeContent As Boolean
	Public IconTheme As String
	Public ArrayName As String
	Public Prefix As String
	Public Suffix As String
	Public Speed As String
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, IconName As String, Title As String, Value As String, Small As Int, Medium As Int, Large As Int, ThemeName As String)
	'define style classes to load with the component
	style = style.CreateCSSClass("info-box")
	style.AddCSSClassProperties("box-shadow: 0 2px 10px rgba(0, 0, 0, 0.2);height: 80px;display: flex;background-color: #fff;")
	style.AddCSSClassProperties("position: relative;overflow: hidden;margin-bottom: 30px;box-sizing: border-box;")
	style.AddCSSClass("icon","display: inline-block; text-align: center;width: 80px;")
	style.AddCSSClass("ibi","font-size: 50px;line-height: 80px;")
	style.AddCSSClass("content", "display: inline-block; padding: 7px 10px;")
	style.AddCSSClass("itext","font-size: 13px; margin-top: 11px; color: #555;")
	style.AddCSSClass("inumber","font-weight: normal;font-size: 26px; margin-top: -4px; color: #555;")
	style.AddCSSClass("info-box.hover-zoom-effect .icon", "overflow: hidden;")
	style.AddCSSClass("info-box.hover-zoom-effect .icon i","-moz-transition: all 0.3s ease;-o-transition: all 0.3s ease;-webkit-transition: all 0.3s ease;transition: all 0.3s ease;")
	style.AddCSSClass("info-box.hover-zoom-effect:hover .icon i","opacity: 0.4;-moz-transform: rotate(-32deg) scale(1.4);-ms-transform: rotate(-32deg) scale(1.4);-o-transform: rotate(-32deg) scale(1.4);")
	style.AddCSSClass("info-box.hover-zoom-effect:hover .icon i","-webkit-transform: rotate(-32deg) scale(1.4); transform: rotate(-32deg) scale(1.4);")
	
	style.AddCSSClass("info-box.hover-expand-effect:after", $"background-color: rgba(0, 0, 0, 0.05); content: "."; position: absolute; left: 80px;top: 0;"$)
	style.AddCSSClass("info-box.hover-expand-effect:after","width: 0;height: 100%;color: transparent;-moz-transition: all 0.95s;-o-transition: all 0.95s;-webkit-transition: all 0.95s;transition: all 0.95s;")
	style.AddCSSClass("info-box.hover-expand-effect:hover:after","width: 100%;")
	

	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,style.BuildStyleClasses)
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize
	Element.Initialize(ID,"div").AddClass("col")
	Enabled = True
	Hoverable = False
	ThemeContent = False
	Visibility= ""
	ZDepth = ""
	sSmall = Small
	sMedium = Medium
	sLarge = Large
	sTitle = Title
	sTheme = ThemeName
	sIconName = IconName
	Animated = False
	sValue = Value
	HoverZoom = False
	HoverExpand = False
	IconTheme = ThemeName
	ArrayName = ""
	Prefix = ""
	Suffix = ""
	Speed = "1000"
End Sub

Sub SetSizes(Small As Int, Medium As Int, Large As Int)
	Element.MaterialSetSizes(Small,Medium,Large)
End Sub

Sub SetTitle(Title As String)
	sTitle = Title
	Element.ClearContent
End Sub

'update the value the 
Sub SetValue(Value As String)
	sValue = Value
	Element.clearcontent
End Sub

Sub HTML As String
	If IconTheme <> "" Then sTheme = IconTheme
	If IconTheme = "" Then IconTheme = sTheme
	Element.ID = compid
	Element.MaterialSetSizes(sSmall,sMedium,sLarge).AddClass("col").MaterialVisibility(Visibility).MaterialZDepth(ZDepth).MaterialEnable(Enabled).MaterialHoverable(Hoverable)
	Dim icnStyle As String = style.GetCssStyle("ibi")
	Dim icn As String = Element.MaterialGetIcon(sIconName,"",IconTheme,False,False,False,False,False,icnStyle)
	Dim infobox As HTMLElement
	infobox = infobox.CreateDIV("").AddClass("info-box").AddClassOnCondition(HoverZoom,"hover-zoom-effect")
	infobox.AddClassOnCondition(HoverExpand,"hover-expand-effect")
	infobox.MaterialUseThemeOnCondition(ThemeContent,sTheme)
	Dim sDataTo As String = MashPlugIns.GetNumbers(sValue)
	If Prefix <> "" Then sValue = Prefix & sValue
	If Suffix <> "" Then sValue = sValue & Suffix
	Dim s As String = $"<div class="icon ${Element.MaterialGetTheme(sTheme)}">
                            ${icn}
                        </div>
                        <div class="content">
                            <div class="itext">${sTitle}</div>
                            <div class="inumber ${compid}" data-from="0" data-to="${sDataTo}" data-speed="${Speed}" data-fresh-interval="20">${sValue}</div>
                        </div>"$
	infobox.AddContent(s)
	Element.AddElement(infobox)
	If Animated = True Then JavaCalls.Add($"$('.${compid}').countTo();"$)
	If ArrayName = "" Then ArrayName = compid
	Element.AddOnClickEventProperty(ArrayName,Element.ID).addcursor
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If MashPlugIns.Debug = True Then
		Element.VerifyJavaScript(JavaCalls)
		Element.VerifyHTML(HTML)
		Page.ws.Eval(script, Array As String(compid))
	Else
		Page.ws.Eval(script, Array As String(compid))
	End If
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compid))
End Sub

Sub HideScript() As String
	Return Element.JQueryHide
End Sub

Sub Hide
	JQueryExecute(Element.JQueryHide)
End Sub

Sub HideSlow()
	JQueryExecute(Element.JQueryHideSlow)
End Sub

Sub Animate(animationType As String, bInfinity As Boolean, bAfter As String)
	JQueryExecute(Element.JQueryAnimate(animationType,bInfinity,bAfter))
End Sub

Sub FadeOutSlow
	JQueryExecute(Element.JQueryFadeOutSlow)
End Sub

