﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Public Theme As String
	Public Enabled As Boolean
	Public Visibility As String
	Public ZDepth As String
	Private Issues As Map
	Private ul As HTMLElement
	Public Title As String
	Public SubTitle As String
	Private Categories As Map
	Public HeaderIcon As String
	Public ColorCodeProgress As Boolean
	Private add As HTMLElement
	Public Pulse As Boolean
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.Initialize
	Page = InternalPage
	compID = ID.tolowercase
	ZDepth = ""
	Theme = ThemeName
	Issues.initialize
	Categories.initialize
	HeaderIcon = "mdi-action-bug-report"
	Title = "Issues"
	SubTitle = MashPlugIns.LongDateToday
	ul = ul.CreateUL(compID)
	ColorCodeProgress = True
	Pulse = True
End Sub

'clear the contents of the issues
Sub Clear
	Categories.Initialize 
	Issues.Initialize
	JavaCalls.Initialize
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = ul.MvFromList(JavaCalls,"")
	JQueryExecute(script)
End Sub

'refresh the contents of the list
Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = ul.MvFromList(JavaCalls,"")
	JQueryExecute(script)
	If Pulse = True Then JQueryExecute(add.JQueryAnimate(MashPlugIns.Anime.Attention_Seekers_pulse,True,""))
End Sub


'add categories for the colors for each task
Sub AddCategory(categoryID As String, categoryName As String, categoryColor As String)
	Dim catM As Map
	catM.Initialize
	catM.Put("name",categoryName)
	catM.Put("color", categoryColor)
	Categories.Put(categoryID,catM)
End Sub


Sub AddIssue(issueID As String, issueCategory As String, issueName As String, issueOwner As String, issuePercentProgress As Int)
	Dim Li As HTMLElement
	Li = Li.CreateLI($"${compID}${issueID}"$).AddClass("collection-item dismissable").ApplyStyle("padding:20px").addcursor
	'JavaCalls.Add(Li.AddChildClickEvent(compID,Li.id,issueID))
	Li.AddOnClickEventProperty(compID,issueID)
	Dim row As HTMLElement
	row = row.CreateDIV("").AddClass("row")
	Dim col As HTMLElement
	col = col.CreateDIV("").AddClass("col s12 m6 l6")
	'add issue number
	Dim strong As HTMLElement
	strong = strong.createstrong("").AddContent("#").AddContent(issueID)
	Dim ptitle As HTMLElement
	ptitle = ptitle.CreateP("").AddClass("collections-title").AddContent(strong.HTML).AddSpace.AddContent(issueName)
	ptitle.ApplyStyle("font-size:1.0rem;padding:0;margin:0;font-weight:500")
	Dim pOwner As HTMLElement
	pOwner = pOwner.CreateP("").AddClass("collections-content").AddContent(issueOwner)
	pOwner.ApplyStyle("font-size:0.9rem;padding:0;margin:0;font-weight:400")
	'consolidate items
	col.AddContent(ptitle.HTML)
	col.AddContent(pOwner.HTML)
	row.AddContent(col.HTML)
	'add the category
	Dim catColor As String = ABM.COLOR_LIGHTBLUE
	Dim catName As String = issueCategory
	If Categories.ContainsKey(issueCategory) Then
		Dim catMap As Map = Categories.Get(issueCategory)
		catColor = catMap.Get("color")
		catName = catMap.Get("name")
	End If	
	Dim cols3 As HTMLElement
	cols3 = cols3.CreateDIV("").AddClass("col s12 m2 l2")
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("task-cat").AddContent(catName)
	span.ApplyStyle("padding:2px 4px;color:#fff;font-weight:300")
	span.ApplyStyle("font-size:0.8rem;-webkit-border-radius:2px;-moz-border-radius:2px;border-radius:2px;background-clip:padding-box")
	'margin-left:37px;
	'get the project category color
	span.AddClass(catColor)
	cols3.AddContent(span.HTML)
	row.AddContent(cols3.HTML)
	'add the chart section to show the progress
	Dim colspline As HTMLElement
	colspline = colspline.CreateDIV("").AddClass("col s12 m12 l3")
	'will show the project progress here
	Dim progLine As HTMLElement
	progLine = progLine.CreateDIV("").AddClass("progress").ApplyStyle("display:inline-block")
	progLine.ApplyStyle("background-color:#ffffff")
	
	Dim progDet As HTMLElement
	progDet = progDet.CreateDIV("").AddClass("determinate").ApplyStyle($"width: ${issuePercentProgress}%"$)
	If ColorCodeProgress = True Then progDet.AddClass(catColor)
	progLine.AddContent(progDet.HTML)
	colspline.AddContent(progLine.HTML)
	row.AddContent(colspline.HTML)
	
	'let's create the badge
	Dim small As HTMLElement
	small = small.createsmall("").AddClass("notification-badge").AddContent(issuePercentProgress & "%")
	small.ApplyStyle("position:relative;color:#ffffff")
	If ColorCodeProgress = True Then small.applystyle($"background-color:${MashPlugIns.ABMGetColor(catColor,"")}"$)
	small.ApplyStyle("border-radius:50%;padding:4px 5px")
	
	Dim colbadge As HTMLElement
	colbadge = colbadge.CreateDIV("").AddClass("col s1 m1 l1")
	colbadge.ApplyStyle("margin:0")
	colbadge.AddContent(small.HTML)
	row.AddContent(colbadge.HTML)
	
	'add row to the list item
	Li.AddContent(row.HTML)
	'add the list item to the projects list
	Issues.Put(issueID,Li.HTML)
End Sub


Sub HTML As String
	'create the card
	ul.AddClass("collection")
	ul.MaterialEnable(Enabled).MaterialHoverable(Hoverable)
	ul.MaterialZDepth(ZDepth)
	ul.MaterialVisibility(Visibility)
	'build the header
	Dim li As HTMLElement
	li = li.createli("").AddClass("collection-item avatar").ApplyStyle("height:auto;padding-top:22px")
	MashPlugIns.MaterialUseTheme(Theme,li)
	Dim i As HTMLElement
	i = i.CreateI("").AddClass("circle").ApplyStyle("font-size:28px")
	i.MaterialBuildIcon(HeaderIcon,"")
	MashPlugIns.MaterialUseTheme(Theme,i)
	i.MaterialZDepth(ABM.ZDEPTH_1)
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("collection-header").AddContent(Title).ApplyStyle("font-size:1.14rem;font-weight:500")
	Dim p As HTMLElement
	p = p.CreateP("").AddContent(SubTitle)
	'add the components
	li.AddContent(i.HTML)
	li.AddContent(span.HTML)
	li.AddContent(p.HTML)
	
	'add the floating button to add tasks
	add = add.CreateA($"${compID}add"$).MaterialButtonFloating(True).MaterialWavesEffect(True).MaterialWavesLight(True)
	add.AddClass("task-add").applyStyle("position:absolute;right:10px;top:60px").AddCursor
	'JavaCalls.Add(add.AddChildClickEvent(compID,add.ID,"add"))
	add.AddOnClickEventProperty(compID,"add")
	Dim i As HTMLElement
	i = i.CreateI("").MaterialBuildIcon("mdi-content-add","")
	MashPlugIns.MaterialUseReversedTheme(Theme,i)
	add.AddContent(i.HTML)
	li.AddContent(add.html)
	
	ul.AddContent(li.HTML)
	'add each of the tasks
	For Each strKey As String In Issues.Keys
		Dim strValue As String = Issues.Get(strKey)
		ul.AddContent(strValue)
	Next
	Return ul.HTML
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return ul.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub