﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private fx As JFX
	Public Value As Double = 0
	Public Label As String   ' appears at bottom
	Public Title As String   ' appears at top
	Public MaxValue As Double = 100
	Public MinValue As Double = 0
	'Public Width As String = "100%"
	'Public Height As String = "100%"
	Public donut As Boolean = False
	Public counter As Boolean = False
	Public gaugeWidthScale As Double = 1.0
	Public shadowSize As Int = 5
	Public shadowVerticalOffset As Int = 3
	Public hideMinMax As Boolean = False
	Public startAnimationTime As Long = 700
	Public startAnimationType As String = ">"
	Public refreshAnimationTime As Long = 700
	Public gaugeColor As Paint
	Private levelColors As List
	Public decimals As Int = 0
	Public humanFriendly As Boolean = False
	Private CustomSectors As List
	Public valueFontColor As Paint
	Public labelFontColor As Paint
	Public formatNumber As Boolean = False
	Public symbol As String = ""
	Public pointer As Boolean = False
	Public pointertoplength As Int = 0
	Public pointerbottomlength As Int = 0
	Public pointerbottomwidth As Int = 0
	Public pointercolor As Paint
	Public pointerstroke As Paint
	Public pointerstrokewidth As Int = 0
	Public pointerstrokelinecap As String = "square"
	Public noGradient As Boolean = False
	Public relativeGaugeSize As Boolean = False
	Public reverse As Boolean = False
	Public shadowOpacity As Double = 0.2
	Public humanFriendlyDecimal As Int = 0
	Type AnimationTypeEnum(linear As String, Right As String, left As String,  leftright As String, bounce As String)
	Public EnumAnimationType As AnimationTypeEnum
	Public refreshAnimationType As String = ">"
	Public donutStartAngle As Int = 90
	Public hideValue As Boolean = False
	Public valueMinFontSize As Int = 16
	Public labelMinFontSize As Int = 10
	Public minLabelMinFontSize As Int = 10
	Public maxLabelMinFontSize As Int = 10
	Public titleMinFontSize As Int = 10
	Public titleFontColor As Paint
	Public titlePosition As String = "above"
	Type TitlePositionEnum(above As String, below As String)
	Public EnumTitlePosition As TitlePositionEnum
	Public hideInnerShadow As Boolean = False
	Public LevelColor1 As Paint
	Public LevelColor2 As Paint
	Public LevelColor3 As Paint
	Type PointerStrokeLineCapEnum(isround As String, issquare As String)
	Public EnumPointerStrokeLineCap As PointerStrokeLineCapEnum
	Public ToolTip As String
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, myValue As Double, myTitle As String, myLabel As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	EnumPointerStrokeLineCap.initialize
	EnumPointerStrokeLineCap.isround = "round"
	EnumPointerStrokeLineCap.issquare = "square"
	Value = myValue
	Label = myLabel
	Title = myTitle
	levelColors.Initialize
	CustomSectors.Initialize
	EnumAnimationType.Initialize
	EnumAnimationType.bounce = "bounce"
	EnumAnimationType.left = "<"
	EnumAnimationType.leftright = "<>"
	EnumAnimationType.linear = "linear"
	EnumAnimationType.right = ">"
	gaugeColor = fx.Colors.RGB(237,235,235)
	valueFontColor = fx.Colors.black
	labelFontColor = fx.Colors.RGB(179,179,179)
	titleFontColor = fx.Colors.rgb(153,153,153)
	pointercolor = fx.Colors.RGB(0,0,0)
	pointerstroke = fx.Colors.RGB(237,237,237)
	EnumTitlePosition.Initialize
	EnumTitlePosition.above = "above"
	EnumTitlePosition.below = "below"
	LevelColor1 = fx.Colors.RGB(169,215,11)
	LevelColor2 = fx.Colors.RGB(249,200,2)
	LevelColor3 = fx.Colors.RGB(255,0,0)
End Sub
'add custom sector
Sub AddCustomSector(color As Paint, lo As Double, hi As Double)
	Dim sb As String = $"{color:"${ColorToHex(color)}", lo:${lo}, hi:${hi}}"$
	CustomSectors.Add(sb)
End Sub
'build the pointer options
Sub BuildPointerOptions As String
	Dim sb As String = $"{toplength:${pointertoplength},bottomlength:${pointerbottomlength},bottomwidth:${pointerbottomwidth},color:'${ColorToHex(pointercolor)}',stroke:'${ColorToHex(pointerstroke)}',stroke_width:${pointerstrokewidth},stroke_linecap:'${pointerstrokelinecap}'}"$
	Return sb
End Sub
'add a level color to be used at a particular percentage
Sub AddLevelColor(color As Paint)
	Dim sColor As String = ColorToHex(color)
	levelColors.Add(sColor)
End Sub
'build the level colors added
private Sub BuildLevelColors As String
	If (levelColors.Size - 1) = -1 Then
		AddLevelColor(LevelColor1)
		AddLevelColor(LevelColor2)
		AddLevelColor(LevelColor3)
	End If
	Dim sb As StringBuilder
	sb.Initialize
	For Each strColor As String In levelColors
		sb.Append(InQuotes(strColor)).Append(",")
	Next
	If sb.ToString.EndsWith(",") = True Then sb.Remove(sb.Length-1,sb.Length)
	Return sb.tostring
End Sub
'build the custom sectors added
private Sub BuildCustomSectors As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strColor As String In CustomSectors
		sb.Append(InQuotes(strColor)).Append(",")
	Next
	If sb.ToString.EndsWith(",") = True Then sb.Remove(sb.Length-1,sb.Length)
	Return sb.tostring
End Sub
'enclose a string inside quotes
private Sub InQuotes(sValue As String) As String
	Return QUOTE & sValue & QUOTE
End Sub
Sub Right(Text As String, Length As Long) As String
	If Length>Text.Length Then Length=Text.Length
	Return Text.SubString(Text.Length-Length)
End Sub
'convert a color to a hex value, taken from cssutils module
private Sub ColorToHex(Color As Paint) As String
	Dim c As Int  = fx.Colors.To32Bit(Color)
	'Dim alpha As Int = Bit.UnsignedShiftRight(c, 24)
	'Dim red As Int = Bit.And(Bit.UnsignedShiftRight(c, 16), 0xFF)
	'Dim green As Int = Bit.And(Bit.UnsignedShiftRight(c, 8), 0xFF)
	'Dim blue As Int = Bit.And(c, 0xFF)
	Dim hex As String = Bit.ToHexString(c)
	hex = hex.touppercase
	hex = "#" & Right(hex,6)
	Return hex
End Sub
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	Return $"<div id="${internalID}"></div><script>var _${internalID};</script>"$
End Sub
private Sub BuildHTML(internalID As String) As String
	Dim script As String = $"$("#${internalID}").empty();
	_${internalID} = new JustGage({
	id: "${internalID}",
	value: ${Value},
	min: ${MinValue},
	max: ${MaxValue},
	relativeGaugeSize: ${relativeGaugeSize},
	gaugeWidthScale: ${gaugeWidthScale},
	valueMinFontSize: ${valueMinFontSize},
	labelMinFontSize: ${labelMinFontSize},
	counter: ${counter},
	shadowOpacity: ${shadowOpacity},
	shadowSize: ${shadowSize},
	shadowVerticalOffset: ${shadowVerticalOffset},
	startAnimationTime: ${startAnimationTime},
	startAnimationType: "${startAnimationType}",
	refreshAnimationTime: ${refreshAnimationTime},
	refreshAnimationType: "${refreshAnimationType}",
	humanFriendly: ${humanFriendly},
	customSectors: [${BuildCustomSectors}],
	titleFontColor: '${ColorToHex(titleFontColor)}',
	valueFontColor: '${ColorToHex(valueFontColor)}',
	labelFontColor: '${ColorToHex(labelFontColor)}',
	minLabelMinFontSize: ${minLabelMinFontSize},
	formatNumber: ${formatNumber},
	maxLabelMinFontSize: ${maxLabelMinFontSize},
	hideInnerShadow: ${hideInnerShadow},
	humanFriendlyDecimal: ${humanFriendlyDecimal},
	donutStartAngle: ${donutStartAngle},
	titleMinFontSize: ${titleMinFontSize},
	noGradient: ${noGradient},
	hideValue: ${hideValue},
	reverse: ${reverse},
	pointer: ${pointer},
	symbol: '${symbol}',
	decimals: ${decimals},
	pointerOptions: ${BuildPointerOptions},
	levelColors: [${BuildLevelColors}],
	gaugeColor: '${ColorToHex(gaugeColor)}',
	titleFontColor: '${ColorToHex(titleFontColor)}',
	titlePosition: "${titlePosition}",
	hideMinMax: ${hideMinMax},
	donut: ${donut},
	title: "${Title}",
	label: "${Label}"
	});"$
	Return script
End Sub
' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Dim script As String = BuildHTML(internalID)
	InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
	' flush not needed, it's done in the refresh method in the lib
End Sub
' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub
' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
