﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private Items As Map
	Private maindiv As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private hasHeaders As Boolean
	Private groups As Map
	Public GroupItems As Boolean
	Public MapID As String
	Public MapIcon As String
	Public MapImage As String
	Public MapTitle As String
	Public MapDescription As String
	Public MapItemTheme As String
	Public MapIconTheme As String
	Public MapBadgeText As String
	Public MapBadgeNew As String
	Public MapBadgeTheme As String
	Public Dismissable As Boolean
	Public DefaultIcon As String
	Public DefaultImage As String
	Public ItemMethod As String
	Public DefaultItemTheme As String
	Public DefaultIconTheme As String
	Public DefaultBadgeTheme As String
	Type ReloadMethodType(rAddItemAvatar As String, rAddItemIcon As String)
	Public EnumReloadMethod As ReloadMethodType
End Sub

'Clear the contents of the list, remember to refresh
Sub Clear
	groups.Initialize 
	JavaCalls.Initialize
	Items.Initialize 
End Sub

'when an item is clicked, you can run this method to save the record and then navigate to edit page
'run ABMShared.NavigateTo if you have to Navigate to another page else AddEditRecord if on same page
Sub SetEditMode(SourceTable As String, PrimaryKey As String,PrimaryValue As String)
	Dim sKey As String = $"${SourceTable}${PrimaryKey}"$
	sKey = sKey.tolowercase
	Page.ws.Session.SetAttribute("action", "edit")
	Page.ws.Session.SetAttribute(sKey, PrimaryValue)
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pg As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, pg, ID,"")
	Page = pg
	Dismissable = False
	compID = ID
	EnumReloadMethod.Initialize
	EnumReloadMethod.rAddItemAvatar = "AddItemAvatar"
	EnumReloadMethod.rAddItemIcon = "AddItemIcon"
	ItemMethod = "AddItemIcon"
	JavaCalls.Initialize
	compID = ID
	'get the page name
	Page = pg
	DefaultItemTheme = ""
	DefaultIconTheme = ""
	DefaultBadgeTheme = ""
	groups.Initialize
	Items.Initialize
	GroupItems = False
	hasHeaders = False
	MapID = ""
	MapIcon = ""
	MapImage = ""
	MapTitle = ""
	MapDescription = ""
	MapItemTheme = ""
	MapIconTheme = ""
	MapBadgeText = ""
	MapBadgeNew = ""
	MapBadgeTheme = ""
	maindiv.Initialize(ID,"ul").AddClass("collection").AddClass("listview").ApplyStyle("min-height: 56px")
	MashPlugIns.AddExternalStyle("listview","margin: .5rem 0 1rem 0; border: 1px solid #e0e0e0; border-radius: 2px; overflow: hidden; position: relative;")
	MashPlugIns.AddExternalStyle("listview","padding-left: 0; list-style-type: none;")
	MashPlugIns.AddExternalStyle("listitem","min-height: 56px;background-color: #fff; line-height: 1.5rem; padding-top: 10px;padding-right: 20px; margin: 0; border-bottom: 1px solid #e0e0e0;list-style-type: none;")
	MashPlugIns.AddExternalStyle("hasheader","padding-left:30px")
	MashPlugIns.AddExternalStyle("list-item-avatar","min-height: 60px;padding-left: 72px; position: relative;")
	MashPlugIns.AddExternalStyle("badge1","min-width: 3rem; padding: 0 6px; margin-left: 14px; text-align: center; font-size: 1rem; line-height: 22px; height:none;float: right;box-sizing: border-box;margin-top: calc(.75rem - 11px);border-radius: 5px;")
	MashPlugIns.AddExternalStyle("circle1","position: absolute; width: 42px; height: 42px; overflow: hidden; left: 15px; display: inline-block; vertical-align: middle; border-radius: 50%; border: 1px;font-size: 40px;")
	MashPlugIns.AddExternalStyle("icon","text-align: center; vertical-align: middle;float: left; margin-right: 10px;")
End Sub


'load items from the list of maps from a database and run a refresh method after
Sub Reload(lstRecords As List)
	If MapID = "" Or MapTitle = "" Then
		Log("MashListView Reload: The IDField and the Title Fields should be specified.")
		Return
	End If
	'clear the items first
	Clear
	For Each recMap As Map In lstRecords
		Dim sMapID As String = ""
		Dim sMapIcon As String = ""
		Dim sMapImage As String = ""
		Dim sMapTitle As String = ""
		Dim sMapDescription As String = ""
		Dim sMapItemTheme As String = ""
		Dim sMapIconTheme As String = ""
		Dim sMapBadgeText As String = ""
		Dim sMapBadgeNew As String = ""
		Dim sMapBadgeTheme As String = ""
		Dim badgeNew As Boolean = False
		If MapID <> "" Then sMapID = recMap.GetDefault(MapID,"")
		If MapTitle <> "" Then sMapTitle = recMap.GetDefault(MapTitle,"")
		If MapIcon <> "" Then sMapIcon = recMap.GetDefault(MapIcon,"")
		If MapImage <> "" Then sMapImage = recMap.GetDefault(MapImage,"")
		If MapDescription <> "" Then sMapDescription = recMap.GetDefault(MapDescription,"")
		If MapItemTheme <> "" Then sMapItemTheme = recMap.GetDefault(MapItemTheme,"")
		If MapIconTheme <> "" Then sMapIconTheme = recMap.GetDefault(MapIconTheme,"")
		If MapBadgeText <> "" Then sMapBadgeText = recMap.GetDefault(MapBadgeText,"")
		If MapBadgeNew <> "" Then sMapBadgeNew = recMap.GetDefault(MapBadgeNew,"")
		If MapBadgeTheme <> "" Then sMapBadgeTheme = recMap.GetDefault(MapBadgeTheme,"")
		If sMapIcon = "" Then sMapIcon = DefaultIcon
		If sMapImage = "" Then sMapImage = DefaultImage
		If sMapIconTheme = "" Then sMapIconTheme = DefaultIconTheme
		If sMapItemTheme = "" Then sMapItemTheme = DefaultItemTheme
		If sMapBadgeTheme = "" Then sMapBadgeTheme = DefaultBadgeTheme
		If sMapBadgeNew = "1" Then
			badgeNew = True
		else if sMapBadgeNew.ToLowerCase = "true" Then
			badgeNew = True
		End If
		sMapID = $"${compID}${sMapID}"$
		Select Case ItemMethod
		Case EnumReloadMethod.rAddItemAvatar
			AddItemAvatar(sMapID,sMapImage,sMapTitle,sMapDescription,Dismissable,sMapItemTheme,sMapBadgeText,badgeNew,sMapBadgeTheme)
		Case EnumReloadMethod.rAddItemIcon	
			AddItemIcon(sMapID,sMapIcon,sMapTitle,sMapDescription,Dismissable,sMapItemTheme,sMapIconTheme,sMapBadgeText,badgeNew,sMapBadgeTheme)
		End Select
	Next
End Sub


Sub AddHeader(itemID As String, itemText As String, itemTheme As String, bPrefixOnly As Boolean)
	Dim brief As HTMLElement
	itemID = itemID.tolowercase
	Dim li As HTMLElement
	li.Initialize("","li").AddClass("collection-header").ApplyStyle("border-bottom: 1px solid #e0e0e0;	padding: 10px 20px;")
	li.ApplyStyle("list-style-type: none;")
	
	If bPrefixOnly = True Then
		Dim prefix As String = MashPlugIns.Left(itemText,1)
		prefix = prefix.touppercase
		brief = brief.CreateSPAN("").AddClass("circle").AddContent(prefix)
		brief.ApplyStyle("position: absolute; width: 42px; height: 42px; overflow: hidden; left: 15px;")
		brief.ApplyStyle("display: inline-block; vertical-align: middle; text-align: center; font-size: 1.5rem;")
		brief.ApplyStyle("font-weight: 300; padding: 5px;").AddClass(MashPlugIns.AlphaColorCode(prefix)).MaterialTextColor(ABM.COLOR_WHITE)
		li.ApplyStyle("height:60px")
	Else
		brief = brief.CreateH5("")
		brief.AddContent(itemText)
	End If
	li.AddContent(brief.HTML)
	MashPlugIns.MaterialUseTheme(itemTheme,li)
	Items.put(itemID,li.html)
	maindiv.AddClass("with-header")
	hasHeaders = True
End Sub

private Sub GetHeader(itemID As String, itemText As String) As String
	Dim brief As HTMLElement
	itemID = itemID.tolowercase
	Dim li As HTMLElement
	li.Initialize("","li").AddClass("collection-header").ApplyStyle("border-bottom: 1px solid #e0e0e0;	padding: 10px 20px;")
	li.ApplyStyle("list-style-type: none;")
	
	Dim prefix As String = MashPlugIns.Left(itemText,1)
	prefix = prefix.touppercase
	brief = brief.CreateSPAN("").AddClass("circle").AddContent(prefix)
	brief.ApplyStyle("position: absolute; width: 42px; height: 42px; overflow: hidden; left: 15px;")
	brief.ApplyStyle("display: inline-block; vertical-align: middle; text-align: center; font-size: 1.5rem;")
	brief.ApplyStyle("font-weight: 300; padding: 5px;").AddClass(MashPlugIns.AlphaColorCode(prefix)).MaterialTextColor(ABM.COLOR_WHITE)
	li.ApplyStyle("height:60px")
	li.AddContent(brief.HTML)
	Return li.HTML
End Sub

Sub AddItemIcon(itemID As String, itemIcon As String, itemTitle As String, itemDescription As String, bDismissable As Boolean, itemTheme As String, iconTheme As String, badgeText As String, badgeNew As Boolean, badgeTheme As String)
	itemID = itemID.tolowercase
	'define the avatar
	Dim li As HTMLElement
	li.Initialize(itemID,"li")
	li.MaterialCollectionItem(True).AddClass("listitem")
	li.MaterialAvatar(True)
	li.AddClass("list-item-avatar")
	li.MaterialDismissable(bDismissable)
	li.addcursor
	li.MaterialAddIcon(itemIcon,"",iconTheme,True,False,False,False,False,MashPlugIns.ExternalStyle.Get("circle1"))
	
	Dim title As HTMLElement
	title.Initialize(itemID & "title","span")
	title.AddClass("title").ApplyStyle("font-size: 16px;font-weight: bold;")
	title.AddContent(itemTitle)
	MashPlugIns.MaterialUseTheme(itemTheme,title)
	li.AddContent(title.HTML)
	
	'define the description
	Dim desc As HTMLElement
	desc.Initialize(itemID & "desc","p").ApplyStyle("font-size: 14px;")
	desc.AddContent(itemDescription)
	MashPlugIns.MaterialUseTheme(itemTheme,desc)
	li.AddContent(desc.HTML)
	
	If badgeText <> "" Then
		li.MaterialAddBadge(Page,badgeText,badgeNew,ABM.VISIBILITY_ALL,False,badgeTheme,False,MashPlugIns.ExternalStyle.Get("badge1"),True)
	End If
	li.AddOnClickEventProperty(compID,li.ID)
	
	Items.put(itemID,li.html)
	Dim sPrefix As String = MashPlugIns.Left(itemTitle,1)
	If groups.ContainsKey(sPrefix) Then
		Dim nTitles As List = groups.Get(sPrefix)
	Else
		Dim nTitles As List
		nTitles.Initialize
	End If
	nTitles.Add(itemID)
	groups.Put(sPrefix,nTitles)
End Sub


Sub AddItemAvatar(itemID As String, itemImageURL As String, itemTitle As String, itemDescription As String, bDismissable As Boolean, itemTheme As String, badgeText As String, badgeNew As Boolean, badgeTheme As String)
	itemID = itemID.tolowercase
	'itemID = $"${compID}${itemID}"$
	'define the avatar
	Dim li As HTMLElement
	li.Initialize(itemID,"li")
	li.MaterialAvatar(True)
	li.MaterialCollectionItem(True).AddClass("listitem")
	li.AddClass("list-item-avatar")
	li.MaterialDismissable(bDismissable)
	li.AddCursor
	
	'li.applystyle("-webkit-tap-highlight-color:rgba(0,0,0,0)")
	li.MaterialAddImage(itemImageURL,"","","",True,True,MashPlugIns.ImageTopMargin,False,False,MashPlugIns.ExternalStyle.Get("circle1"))

	Dim title As HTMLElement
	title.Initialize(itemID & "title","span")
	title.AddClass("title").ApplyStyle("font-size: 16px;font-weight: bold;")
	title.AddContent(itemTitle)
	title.MaterialUseTheme(itemTheme)
	
	'define the description
	Dim desc As HTMLElement
	desc.Initialize(itemID & "desc","p").ApplyStyle("font-size: 14px;")
	desc.AddContent(itemDescription)
	desc.MaterialUseTheme(itemTheme)
	
	
	li.AddContent(title.HTML)
	li.AddContent(desc.HTML)
	
	If badgeText <> "" Then
		li.MaterialAddBadge(Page,badgeText,badgeNew,ABM.VISIBILITY_ALL,False,badgeTheme,False,MashPlugIns.ExternalStyle.Get("badge1"),True)
	End If

	li.AddOnClickEventProperty(compID,li.id)
	
	Items.put(itemID,li.html)
	'JavaCalls.Add(maindiv.AddChildDocumentClickEvent(compID,itemID,itemID))
	Dim sPrefix As String = MashPlugIns.Left(itemTitle,1)
	If groups.ContainsKey(sPrefix) Then
		Dim nTitles As List = groups.Get(sPrefix)
	Else
		Dim nTitles As List
		nTitles.Initialize
	End If
	nTitles.Add(itemID)
	groups.Put(sPrefix,nTitles)
End Sub

Sub Refresh
	If (Items.Size-1) = -1 Then
		GroupItems = False
		AddHeader("norecords","No Records Listed","",False)
	End If
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = maindiv.MvFromList(JavaCalls,"")
	If MashPlugIns.Debug = True Then
		maindiv.VerifyJavaScript(JavaCalls)
		maindiv.VerifyHTML(HTML)
		Page.ws.Eval(script, Array As String(compID))
	Else
		Page.ws.Eval(script, Array As String(compID))
	End If
End Sub

Sub HTML As String
	maindiv.ID = compID
	maindiv.SetElementType("ul")
	'if grouped, preprocess
	If GroupItems = True Then
		maindiv.AddClass("with-header")
		'sort the map
		groups = MashPlugIns.SortMap(groups)
		Dim nList As List
		nList.Initialize
		For Each strPrefix As String In groups.Keys
			maindiv.AddContent(GetHeader(strPrefix,strPrefix))
			'get the items
			Dim sItems As List = groups.Get(strPrefix)
			For Each strItem As String In sItems
				strItem = strItem.tolowercase
				strItem = Items.Get(strItem)
				maindiv.AddContent(strItem)	
			Next
		Next
	Else
		maindiv.AddContentMap(Items)
	End If
	maindiv.MaterialVisibility(Visibility)
	maindiv.MaterialZDepth(ZDepth)
	maindiv.MaterialEnable(Enabled)
	Return maindiv.html
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return maindiv.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compID))
End Sub

Sub HideScript() As String
	Return maindiv.JQueryHide
End Sub

Sub Hide
	JQueryExecute(maindiv.JQueryHide)
End Sub

Sub HideSlow()
	JQueryExecute(maindiv.JQueryHideSlow)
End Sub

Sub Animate(animationType As String, bInfinity As Boolean, bAfter As String)
	JQueryExecute(maindiv.JQueryAnimate(animationType,bInfinity,bAfter))
End Sub

Sub FadeOutSlow
	JQueryExecute(maindiv.JQueryFadeOutSlow)
End Sub

