﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Theme As String
	Private Element As HTMLElement
	Public WaveEffects As Boolean
	Public WavesEffect As Boolean
	Public Visibility As String
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
	Public Enabled As Boolean
	Public IconSize As String
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private Title As String
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, bTitle As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize
	Theme = ThemeName
	WaveEffects = True
	Element.Initialize(ID,"button")
	Enabled = True
	Visibility= ""
	ZDepth = ""
	WavesType= ""
	IconSize = ""
	WavesEffect = True
	WavesCircle = False
	Title = bTitle
End Sub

Sub HTML As String
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.AddContent(Title).ApplyStyle("margin-bottom: 20px;line-height: 32px; height: 34px;")
	Element.ApplyStyle("font-size: 14px; font-weight: normal; position: relative; display: inline-block; padding: 5 12px; cursor: pointer;")
	Element.ApplyStyle("text-align: center; white-space: nowrap; border-width: 1px; border-style: solid; border-radius: 100px; border: 1px solid transparent;")
	Element.ApplyStyle("font-family: inherit;margin: 5px;text-transform: none;touch-action: manipulation;").addcursor
	'leave this true for proper alignment
	Element.MaterialWavesEffect(True)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Element.AddOnClickEventProperty(compid,Element.id)
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	'JavaCalls.Add(Element.AddClickEvent(compid,compid))
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If script <> "" Then Page.ws.Eval(script, Array As String(compid))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub


