﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.9
@EndOfDesignText@
Sub Process_Globals
	Public ABM As ABMaterial
	Public ColorMap As Map
	Private Themes As Map
	Public EnumTextAlignment As MashTextAlignment
	Public MaterialIcons As MDI
	Public FontAwesomeIcons As FA
	Public Anime As MashAnimation
	Private ABM As ABMaterial
	Private Salt As String = "AneliciousUsiOloEso123...!"
	Private Bconv As ByteConverter
	Public EmailAddress As String
	Public LicensePath As String
	Private Intros As List
	Private toastCount As Int
	Public ffiles As List
	Public ffolders As List
	Public roots As String
	Public EnumAlignment As MashAlignment
	Public EnumElementType As MashElementType
	Public EnumIconSize As MashIconSize
	Public EnumLabelSizes As MashSize
	Public ImageTopMargin As String
	Public ImageHW As String
	Public ItemHeight As String
	Public TooltipDelay As String = 50
	Public TooltipPosition As String = "top"
	Private JavaCalls As List
	Public EnumCardSize As MashCardSize
	Public EnumWavesType As MashWavesTypes
	Public EnumThemes As MashThemes
	Public EnumButtonSize As MashButtonSize
	Public EnumIconPosition As MashIconPosition
	Public Debug As Boolean
	Public ExternalStyle As Map
End Sub

Sub GetNumbers(value As String) As String
	Dim strCnt As Int
	Dim str As String
	Dim sb As StringBuilder
	sb.Initialize
	Dim master As String = "0123456789"
	For strCnt = 0 To value.Length - 1
		str = value.CharAt(strCnt)
		If master.IndexOf(str) >= 0 Then
			sb.Append(str)
		End If
	Next
	Return sb.tostring
End Sub

Sub BuildStyleClasses() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each strKey As String In ExternalStyle.Keys
		Dim values As String = ExternalStyle.Get(strKey)
		sb.Append(".").Append(strKey).Append(" {").Append(values).Append("}").Append(CRLF)
	Next
	Return sb.tostring
End Sub

'add a style to be used across the project
Sub AddExternalStyle(styleName As String, content As String)
	styleName = styleName.trim
	Dim scontent As String
	If ExternalStyle.ContainsKey(styleName) Then
		scontent = ExternalStyle.Get(styleName)
		scontent = scontent & ";" & content
		ExternalStyle.Put(styleName,scontent)
	Else
		ExternalStyle.Put(styleName,content)
	End If
End Sub

Sub RemoveExternalStyle(styleName As String, styleProp As String)
	styleName = styleName.trim
	Dim scontent As String
	If ExternalStyle.ContainsKey(styleName) Then	
		scontent = ExternalStyle.Get(styleName)
		Dim spProps() As String = StrParse(";",scontent)
		Dim nList As List
		nList.initialize
		For Each strPropValue As String In spProps
			strPropValue = strPropValue.Trim
			Dim strProp As String = MvField(strPropValue,1,":")
			Dim strValue As String = MvField(strPropValue,2,":")
			strProp = strProp.Trim
			strValue = strValue.trim
			If styleProp.EqualsIgnoreCase(strProp) = False Then
				Dim nLine As String = $"${strProp}:${strValue}"$
				nList.Add(nLine)	
			End If
		Next
		scontent = MvFromList(nList,";")
		ExternalStyle.Put(styleName,scontent)
	End If		
End Sub

'The page needs the range slider
Sub NeedsRangeSlider(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/ion.rangeSlider.min.js")
	page.AddExtraCSSFile("custom/ion.rangeSlider.css")
	page.AddExtraCSSFile("custom/ion.rangeSlider.skinHTML5.css")
End Sub

'The page needs the flowchart
Sub NeedsFlowChart(page As ABMPage)
	'page.AddExtraJavaScriptFile("custom/excanvas.js")
	'page.AddExtraJavaScriptFile("custom/jquery.min.js")
	'page.AddExtraJavaScriptFile("custom/jquery-ui.min.js")
	page.AddExtraJavaScriptFile("custom/jquery.scrollTo.min.js")
	page.AddExtraJavaScriptFile("custom/svg.js")
	page.AddExtraJavaScriptFile("custom/flowsvg.js")
End Sub

'The page needs the split flap
Sub NeedSplitFlap(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/jquery.splitflap.js")
End Sub

'The page needs the footer css
private Sub NeedsFooter(page As ABMPage)
	page.InjectCSS($"body {display: flex; min-height: 100vh; flex-direction: column; }"$)
	page.InjectCSS($"main {flex: 1 0 auto; }"$)
End Sub

Sub NeedsDial(page As ABMPage)
	'page.AddExtraJavaScriptFile("custom/jquery.min.js")
	'page.AddExtraJavaScriptFile("custom/jquery-ui.min.js")
	page.AddExtraJavaScriptFile("custom/jquery.knob.min.js")
End Sub

Sub NeedsInputMask(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/inputmask.js")
End Sub


'Convert a list to multi delimited string
Sub MvFromList(lst As List, Delim As String) As String
	Dim lTot As Int
	Dim lCnt As Int
	Dim lStr As StringBuilder
	lStr.Initialize
	lTot = lst.Size - 1
	For lCnt = 0 To lTot
		lStr.Append(lst.Get(lCnt))
		If lCnt <> lTot Then lStr.Append(Delim)
	Next
	Return lStr.tostring
End Sub

'JQuery add a component to a particular location in the page
private Sub AddComponent(rowPos As Int, colPos As Int, el As String)
	Dim js As String
	js = $"JQAppendTo('r${rowPos}c${colPos}','${el.Replace(CRLF,"")}');"$
	JavaCalls.add(js)
End Sub

'remove a delimiter from a string
public Sub RemDelimSB(delimiter As String, value As StringBuilder) As StringBuilder
	If value.tostring.EndsWith(delimiter) = True Then
		Dim delimLen As Int = delimiter.length
		value.Remove(value.Length-delimLen,value.Length)
	End If
	Return value
End Sub

'Remove a delimiter
public Sub RemDelim(sValue As String, Delim As String) As String
	Dim lDelim As Int = Delim.Length
	Dim nValue As String = sValue
	If nValue.EndsWith(Delim) Then nValue = nValue.SubString2(0, nValue.Length-lDelim)
	Return nValue
End Sub

'Position of a string from the back
Sub InStrRev(value As String, search As String) As Long
	Return value.LastIndexOf(search) + 1
End Sub

'Prepare a recursive search, call this when you will do such a search
Sub PrepareRecursiveSearch
	ffiles.Initialize
	ffolders.Initialize
	roots = ""
End Sub

'Read a directory structure
Sub ReadDir(folder As String, recursive As Boolean)
	Try
		Dim lst As List = File.ListFiles(folder)
		For i = 0 To lst.Size - 1
			If File.IsDirectory(folder,lst.Get(i)) Then
				Dim v As String
				v = folder & "\" & lst.Get(i)
				ffolders.Add(v.SubString(roots.Length))
				If recursive Then
					ReadDir(v,recursive)
				End If
			Else
				ffiles.Add(folder & "\" & lst.Get(i))
			End If
		Next
	Catch
		Log(LastException)
	End Try
End Sub

'Format file sizes
Sub FormatFileSize(Bytes As Float) As String
	Try
		Private Unit() As String = Array As String(" Byte", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB")
		If Bytes = 0 Then
			Return "0 Bytes"
		Else
			Private Po, Si As Double
			Private I As Int
			Bytes = Abs(Bytes)
			I = Floor(Logarithm(Bytes, 1024))
			Po = Power(1024, I)
			Si = Bytes / Po
			Return NumberFormat(Si, 1, 3) & Unit(I)
		End If
	Catch
		Return "0 Bytes"
	End Try
End Sub


'clear the intros for entry
Sub ClearIntros
	Intros.Initialize
End Sub

'get the id of the uploader component for the intro
Sub ABMUploaderID(uplid As ABMUpload, uplTheme As String) As String
	Dim sout As String = $"upload${uplid.id}${uplTheme}"$
	Return sout
End Sub

'get the id of the uploader component for the intro
Sub ABMNavItemID(navbarid As String, itmpos As String) As String
	Dim sout As String = $"${navbarid}TI${itmpos}icon"$
	Return sout
End Sub

'Show the hints
Sub ShowHints(page As ABMPage)
	page.ws.Eval("introJs().showHints();",Null)
	page.ws.flush
End Sub

'Add the hints
Sub AddHints(page As ABMPage)
	page.ws.Eval("introJs().addHints();",Null)
	page.ws.flush
End Sub

'Start the into toue
Sub StartIntro(page As ABMPage)
	Dim tour As String = $"function startTour() {
			var tour = introJs()
			tour.setOption('tooltipPosition', 'auto');
			tour.setOption('positionPrecedence', ['left', 'right', 'bottom', 'top'])
			tour.start()
		}
		startTour();"$
	page.ws.Eval(tour,Null)
	'page.ws.Eval("introJs().start();",Null)
	page.ws.flush
End Sub

'return project days
Sub ProjectDays(sDays As String) As String
	Try
		sDays = sDays.trim
		If sDays = "" Then sDays = "0"
		sDays = sDays.Replace(",","")
		sDays = NumberFormat2(sDays,0,0,0,True)
		Return sDays & " Dys"
	Catch
		Return "0 Dys"
	End Try
End Sub

'return long date for today
Sub LongDateToday() As String
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim dt As Long = DateTime.now
	DateTime.DateFormat = "EEEE, dd MMMM yyyy"
	Return DateTime.Date(dt)
End Sub


'JQuery hide element by id script
Sub JQueryHideScript(id As String) As String
	Dim script As String = $"$('#${id}').hide();"$
	Return script
End Sub

'JQuery hide element by id slowly
Sub JQueryHide(page As ABMPage, id As String)
	Dim script As String = $"$('#${id}').hide("slow");"$
	page.ws.Eval(script,Null)
End Sub

' convert a list containing maps to json
Sub List2JSON(lst As List) As String
	Dim sOut As String
	Dim jsonGen As JSONGenerator
	jsonGen.Initialize2(lst)
	sOut = jsonGen.ToString
	Return sOut
End Sub

'parse a string, like split
Sub StrParse(Delimiter As String, MV As String) As String()
	Delimiter = FixDelimiter(Delimiter)
	Return Regex.Split(Delimiter, MV)
End Sub

'Create a list from a multi delimited string
Sub CreateList(Delimiter As String, Values As String) As List
	Dim newLst As List
	newLst.Initialize
	If Values.length > 0 Then
		Dim spV() As String = StrParse(Delimiter,Values)
		newLst.AddAll(spV)
	End If
	Return newLst
End Sub

'Set date ISO to a bootstrap material date picker experiments
public Sub SetDateISO(page As ABMPage, id As String, value As String)
	page.ws.Eval("$('#" & id.tolowercase & "').bootstrapMaterialDatePicker('setDateISO', '" & value & "');", Null)
End Sub

'JServer: Get value from JQuery element, jserver
public Sub GetValue(page As ABMPage, id As String) As String
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		Return jqe.GetVal.Value
	Catch
		Return ""
	End Try
End Sub

'JServer: setvalue
public Sub SetValue(page As ABMPage, id As String, value As String)
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		jqe.SetVal(value)
	Catch
		Log(LastException)
	End Try
End Sub

'Return project date
Sub ProjectDate(sDate As String) As String
	If sDate.Length = 0 Then Return ""
	Try
		DateTime.DateFormat = "yyyy-MM-dd"
		Dim dt As Long = DateTime.DateParse(sDate)
		DateTime.DateFormat = "dd-MMM-yyyy, EEE"
		Return DateTime.Date(dt)
	Catch
		Return ""
	End Try
End Sub

'Set an into for an element
Sub SetIntro(page As ABMPage, compID As String, stepNo As String, stepDescription As String)
	ABM.SetProperty(page,compID,"data-step",stepNo)
	ABM.SetProperty(page,compID,"data-intro",$"${stepDescription}"$)
	ABM.SetProperty(page,compID,"data-hint",$"${stepDescription}"$)
End Sub

'Add an intro for an element
Sub AddIntro(page As ABMPage, compID As String, stepDescription As String)
	Dim stepNo As Int = Intros.size + 1
	SetIntro(page,compID,stepNo,stepDescription)
	Intros.Add(compID)
End Sub

'Return left part of a string
public Sub Left(Text As String, Length As Long)As String
	If Length>Text.Length Then Length=Text.Length
	Return Text.SubString2(0, Length)
End Sub

'Convert bytes to a file
private Sub BytesToFile (Dir As String, FileName As String, Data() As Byte)
	Dim out As OutputStream = File.OpenOutput(Dir, FileName, False)
	out.WriteBytes(Data, 0, Data.Length)
	out.Close
End Sub

'Convert a file to bytes
private Sub FileToBytes (Dir As String, FileName As String) As Byte()
	Return Bit.InputStreamToBytes(File.OpenInput(Dir, FileName))
End Sub

'Create a license file
private Sub CreateLicense(UserEmail As String)
	Dim Cipher As B4XCipher
	Dim s As String = UserEmail
	Dim b() As Byte = Cipher.Encrypt(s.GetBytes("UTF8"), Salt)
	BytesToFile(File.DirApp,UserEmail,b)
	'write as string to file
	'Dim encryt As String = Bconv.HexFromBytes(b)
	'File.WriteString(File.DirApp,UserEmail,encryt)
End Sub

'Verify a donor
Sub VerifyDonator() As Boolean
	Try
		If EmailAddress.trim = "" Or LicensePath.Trim = "" Then Return False
		Dim b() As Byte = FileToBytes(LicensePath,EmailAddress)
		Dim Cipher As B4XCipher
		'use the donator key string saved
		'Dim b() As Byte = Bconv.HexToBytes(DonatorKey)
		Dim bb() As Byte = Cipher.Decrypt(b, Salt)
		Dim ss As String = Bconv.StringFromBytes(bb, "UTF8")
		If ss = EmailAddress Then
			Return True
		Else
			Log("This is a donators component, please get your DonatorKey to use this!")
			Return False
		End If
	Catch
		Log("This is a donators component, please get your DonatorKey to use this!")
		Return False
	End Try
End Sub

'Return contents of file from assets to view on html component
Sub WebViewAssetFile (FileName As String) As String
   #if B4J
	Return File.GetUri(File.DirAssets, FileName)
   #Else If B4A
     Dim jo As JavaObject
     jo.InitializeStatic("anywheresoftware.b4a.objects.streams.File")
     If jo.GetField("virtualAssetsFolder") = Null Then
       Return "file:///android_asset/" & FileName.ToLowerCase
     Else
       Return "file://" & File.Combine(jo.GetField("virtualAssetsFolder"), _
       jo.RunMethod("getUnpackedVirtualAssetFile", Array As Object(FileName)))
     End If
   #Else If B4i
     Return $"file://${File.Combine(File.DirAssets, FileName)}"$
   #End If
End Sub

Sub NeedsInputTags(Page As ABMPage)
	Page.AddExtraJavaScriptFile("custom/jquery.tagsinput.js")
End Sub

'Sub NeedsNProgress(Page As ABMPage)
'	Page.AddExtraJavaScriptFile("custom/nprogress.js")
'	Page.AddExtraCSSFile("custom/nprogress.css")	
'End Sub
'
'Sub NeedsProgressBar(Page As ABMPage)
'	Page.AddExtraCSSFile("custom/bootstrap-progressbar-3.3.4.min.css")
'	Page.AddExtraJavaScriptFile("custom/bootstrap-progressbar.min.js")
'End Sub

Sub NeedsValidator(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/validator.js")
End Sub

Sub NeedsProgress(page As ABMPage)
	page.addextracssfile("custom/progressbar.css")
	page.addextrajavascriptfile("custom/progressbar.js")
End Sub

Sub NeedsTooltip(page As ABMPage)
	page.AddExtraCSSFile("custom/tooltip.css")
	page.AddExtraJavaScriptFile("custom/tooltip.js")
End Sub

Sub NeedsPopOver(page As ABMPage)
	page.AddExtraCSSFile("custom/popover.css")
	page.AddExtrajavascriptFile("custom/popover.js")
End Sub

Sub NeedsPieGage(page As ABMPage)
	page.AddExtraCSSFile("custom/piegage.css")
	page.AddExtrajavascriptFile("custom/piegage.js")
End Sub

Sub NeedsHelpers(page As ABMPage)
	page.AddExtraCSSFile("custom/spacing.css")
	page.AddExtraCSSFile("custom/border-radius.css")
	page.AddExtraCSSFile("custom/page-transitions.css")
	page.AddExtraCSSFile("custom/utils.css")
End Sub

Sub NeedsXEditable(page As ABMPage)
	page.AddExtraCSSFile("custom/xeditable.css")
	page.AddExtraJavaScriptFile("custom/xeditable.js")
End Sub

Sub NeedsLazyLoad(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/lazyload.js")
End Sub

Sub NeedsColorPicker(page As ABMPage)
	page.addextracssfile("custom/colorpicker.css")
	page.AddExtraJavaScriptFile("custom/colorpicker.js")
End Sub

Sub NeedsTabs(page As ABMPage)
	page.AddExtraCSSFile("custom/tabs.css")
	page.AddExtraJavaScriptFile("custom/cbpFWTabs.js")
End Sub

Sub NeedsInfoBox(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/jquery.countTo.js")
End Sub

'Prepare resources to use with MashPlugIns, insert on ABMApplication page Initialize method after you initialize it
Sub PrepareResources(sAppName As String)
	'copy all needed resources to the Files folder in Objects
	'Dim rList As List = File.ListFiles(File.DirApp & "\Files")
	'rList.sort(True)
	'this gets the list of files
	'For Each strFile As String In rList
	'	Log(strFile)
	'Next
	Dim rFiles As List
	rFiles.Initialize
	rFiles.Add("jquery.countTo.js")
	rFiles.Add("no-image.jpg")
	rFiles.Add("xeditable.css")
	rFiles.Add("xeditable.js")
	rFiles.Add("lazyload.js")
	rFiles.Add("colorpicker.css")
	rFiles.Add("colorpicker.js")
	rFiles.Add("tabs.css")
	rFiles.Add("cbpFWTabs.js")
	rFiles.Add("spacing.css")
	rFiles.Add("border-radius.css")
	rFiles.Add("page-transitions.css")
	rFiles.Add("utils.css")
	
	rFiles.Add("piegage.css")
	rFiles.Add("piegage.js")
	
	rFiles.Add("tooltip.css")
	rFiles.Add("tooltip.js")
	rFiles.Add("popover.css")
	rFiles.Add("popover.js")
	
	rFiles.Add("validator.js")
	rFiles.Add("bootstrap-progressbar-3.3.4.min.css")
	rFiles.Add("bootstrap-progressbar.min.js")
	rFiles.Add("nprogress.js")
	rFiles.Add("nprogress.css")
	rFiles.Add("inputmask.js")
	rFiles.Add("jquery.tagsinput.js")
	rFiles.Add("animate.css")
	rFiles.Add("axesLabels.js")
	'rFiles.Add("bootstrap.min.css")
	'rFiles.Add("bootstrap.min.js")
	rFiles.Add("clock.css")
	rFiles.Add("clock.js")
	'rFiles.Add("cordova.js")
	'rFiles.Add("cordova_plugins.js")
	rFiles.Add("createWaterBall-jquery.js")
	rFiles.Add("ej.unobtrusive.min.js")
	'rFiles.Add("ej.web.all.min.js")
	'rFiles.Add("ej.widgets.all.min.js")
	rFiles.Add("excanvas.js")
	rFiles.Add("intro.min.js")
	rFiles.Add("introjs.min.css")
	rFiles.Add("ion.rangeSlider.css")
	rFiles.Add("ion.rangeSlider.min.js")
	rFiles.Add("ion.rangeSlider.skinHTML5.css")
	rFiles.Add("normalize.css")
	rFiles.Add("jqplot.renderers.js")
	'rFiles.Add("jquery-3.1.1.min.js")
	rFiles.Add("jquery.easing.1.3.min.js")
	'rFiles.Add("jquery.editableRecord.js")
	rFiles.Add("jquery.jqplot.min.css")
	rFiles.Add("jquery.jqplot.min.js")
	rFiles.Add("jquery.min.js")
	rFiles.Add("jquery-ui.min.js")
	rFiles.Add("jquery.sparkline.min.js")
	rFiles.Add("jquery.subwayMap-0.5.0.js")
	rFiles.Add("jquery.timeago.min.js")
	rFiles.Add("JsBarcode.all.js")
	rFiles.Add("JsBarcode.all.min.js")
	rFiles.Add("jsgrid-theme.min.css")
	rFiles.Add("jsgrid.min.css")
	rFiles.Add("jsgrid.min.js")
	rFiles.Add("jsrender.min.js")
	rFiles.Add("justgage.js")
	rFiles.Add("material-dashboard.css")
	rFiles.Add("material-dashboard.js")
	rFiles.Add("material-kit.css")
	rFiles.Add("material-kit.css.map")
	rFiles.Add("material-kit.js")
	rFiles.Add("materialize.min.css")
	rFiles.Add("materialize.min.js")
	rFiles.Add("sprite-skin-flat.png")
	rFiles.Add("sort_asc.png")
	rFiles.Add("sort_asc_disabled.png")
	rFiles.Add("sort_both.png")
	rFiles.Add("sort_desc.png")
	rFiles.Add("sort_desc_disabled.png")
	rFiles.Add("datatables.min.css")
	rFiles.Add("datatables.min.js")
	'rFiles.Add("dataTables.altEditor.free.js")
	'rFiles.Add("picker.date.js")
	'rFiles.Add("picker.js")
	'rFiles.Add("picker.time.js")
	'rFiles.Add("_default.date.scss")
	'rFiles.Add("_default.scss")
	'rFiles.Add("_default.time.scss")
	rFiles.Add("datedropper.min.css")
	rFiles.Add("datedropper.min.js")
	rFiles.Add("timedropper.min.css")
	rFiles.Add("timedropper.min.js")
	rFiles.Add("datedropper.eot")
	rFiles.Add("datedropper.svg")
	rFiles.Add("datedropper.ttf")
	rFiles.Add("datedropper.woff")
	rFiles.Add("jquery.splitflap.js")
	rFiles.Add("chars.png")
	
	rFiles.Add("jquery.scrollTo.min.js")
	rFiles.Add("svg.js")
	rFiles.Add("flowsvg.js")
	
	rFiles.Add("jgallery.min.js")
	rFiles.Add("tinycolor-0.9.16.min.js")
	rFiles.Add("touchswipe.min.js")
	rFiles.Add("jgallery.min.css")
	rFiles.Add("font-awesome.min.css")
	rFiles.Add("card.css")
	rFiles.Add("jquery.card.js")
	
	rFiles.Add("echarts.min.js")
	rFiles.Add("prettify.min.css")
	rFiles.Add("prettify.js")
	rFiles.Add("jquery.knob.min.js")

	rFiles.Add("progressbar.css")
	rFiles.Add("progressbar.js")
	
'  	 rFiles.Add("y.dataTables.min.css")
'	 rFiles.Add("jquery.dataTables.min.js")
'	 rFiles.Add("jquery.dataTables.min.css")
'	 rFiles.Add("jquery.dataTables.min.js")
'	 rFiles.Add("jszip.min.js")
'	 rFiles.Add("vfs_fonts.js")
'	 rFiles.Add("pdfmake.min.js")
'	 rFiles.Add("buttons.dataTables.min.css")
'	 rFiles.add("dataTables.buttons.min.js")
'	 rFiles.Add("buttons.html5.min.js")
'	 rFiles.Add("buttons.print.min.js")
'	 rFiles.add("dataTables.select.min.js")
	'rFiles.add("select.dataTables.min.css")
	'rFiles.Add("colReorder.dataTables.min.css")
	'rFiles.Add("dataTables.colReorder.min.js")
	'rFiles.Add("autoFill.dataTables.min.css")
	'rFiles.Add("dataTables.autoFill.min.js")
	'rFiles.Add("fixedColumns.dataTables.min.css")
	'rFiles.Add("dataTables.fixedColumns.min.js")
	'rFiles.Add("fixedHeader.dataTables.min.css")
	'rFiles.Add("dataTables.fixedHeader.min.js")
	'rFiles.Add("keyTable.dataTables.min.css")
	'rFiles.Add("dataTables.keyTable.min.js")
	'rFiles.Add("rowGroup.dataTables.min.css")
	'rFiles.Add("dataTables.rowGroup.min.js")
	
	'now copy all the files to the proper places
	
	Dim targetcss As String = "/www/css/custom/"
	Dim targetjs As String = "/www/js/custom/"
	Dim images As String = "/www/" & sAppName & "/images/"
		
	'lets create the folders just in case
	File.MakeDir(File.DirApp,targetcss)
	File.MakeDir(File.DirApp,targetcss & "images/")
	File.MakeDir(File.DirApp,targetcss & "src/")
	File.makedir(File.dirapp,targetjs)
	
	For Each strFile As String In rFiles
		Dim actPath As String = WebViewAssetFile(strFile)
		If actPath <> "" Then
			If actPath.EndsWith(".css") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss)
			else If actPath.EndsWith(".scss") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss)
			else If actPath.EndsWith(".png") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss & "images/")
				File_CopyFileFromAssets(strFile,File.DirApp & images)
			else if actPath.EndsWith(".jpg") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss & "images/")
				File_CopyFileFromAssets(strFile,File.DirApp & images)
			else if actPath.EndsWith(".js") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetjs)
			else if actPath.EndsWith("datedropper.eot") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss & "src/")
			else if actPath.EndsWith("datedropper.svg") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss & "src/")
			else if actPath.EndsWith("datedropper.ttf") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss & "src/")
			else if actPath.EndsWith("datedropper.woff") Then
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss & "src/")
			Else
				'copy to css folder
				File_CopyFileFromAssets(strFile,File.DirApp & targetcss)
			End If
		End If
	Next
End Sub

'Copy a file from assets folder
Public Sub File_CopyFileFromAssets(FileName As String,TargetDir As String) As Boolean
	Dim Inp As InputStream = File.OpenInput(File.DirAssets, FileName)
	Dim outp As OutputStream = File.OpenOutput(TargetDir, FileName, False)
	File.Copy2(Inp, outp)
	outp.Close
	Inp.close
	Return File.Exists(TargetDir,FileName)
End Sub

'The page needs a data table
Sub NeedsDataTable(page As ABMPage)
	'complete libraries
	'page.AddExtraCSSFile("custom/bootstrap.min.css")
	page.AddExtraCSSFile("custom/datatables.min.css")
	page.AddExtraJavaScriptFile("custom/datatables.min.js")
	'page.AddExtraJavaScriptFile("custom/dataTables.altEditor.free.js")
	'page.AddExtraJavaScriptFile("custom/bootstrap.min.js")
	
End Sub

Sub NeedsPrettyfy(page As ABMPage)
	page.AddExtraCSSFile("custom/prettify.min.css")
	page.AddExtraJavaScriptFile("custom/prettify.js")
End Sub

Sub NeedsECharts(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/echarts.min.js")
End Sub

'The page needs a barcode
Sub NeedsBarcode(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/JsBarcode.all.js")
End Sub

'The page needs waterballs
Sub NeedsWaterBall(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/createWaterBall-jquery.js")
End Sub

'The page needs subway
Sub NeedsSubWay(page As ABMPage)
	'page.AddExtraJavaScriptFile("custom/jquery.min.js")
	'page.AddExtraJavaScriptFile("custom/jquery-ui.min.js")
	page.AddExtraJavaScriptFile("custom/jquery.subwayMap-0.5.0.js")
End Sub

'The page needs syncfusion
Sub NeedsSyncFusion(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/axesLabels.js")
	page.AddExtraJavaScriptFile("custom/ej.unobtrusive.min.js")
	page.AddExtraJavaScriptFile("custom/ej.web.all.min.js")
	page.AddExtraJavaScriptFile("custom/ej.widgets.all.min.js")
	page.AddExtraJavaScriptFile("custom/jquery.easing.1.3.min.js")
	page.AddExtraJavaScriptFile("custom/jsrender.min.js")
	page.AddExtraJavaScriptFile("custom/ej.unobtrusive.min.js")
End Sub

'The page needs intros
Sub NeedsIntro(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/intro.min.js")
	page.AddExtraCSSFile("custom/introjs.min.css")
End Sub

'The page needs materialize
Sub NeedsMaterialize(page As ABMPage)
	page.AddExtraCSSFile("custom/materialize.min.css")
	page.AddExtraJavaScriptFile("custom/materialize.min.js")
End Sub

'The page needs credit card
Sub NeedsCreditCard(page As ABMPage)
	page.AddExtraCSSFile("custom/card.css")
	page.AddExtraJavaScriptFile("custom/jquery.card.js")
End Sub

'The page needs animation
Sub NeedsAnimation(page As ABMPage)
	page.AddExtraCSSFile("custom/animate.css")
End Sub

'The page needs sparklines
Sub NeedsSparkLine(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/jquery.sparkline.min.js")
End Sub

'The page needs the gallery
Sub NeedsJGallery(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/tinycolor-0.9.16.min.js")
	page.AddExtraJavaScriptFile("custom/touchswipe.min.js")
	page.AddExtraJavaScriptFile("custom/jgallery.min.js?v=1.6.0")
	page.AddExtraCSSFile("custom/font-awesome.min.css")
	page.AddExtraCSSFile("custom/jgallery.min.css?v=1.6.0")
End Sub

'The page needs the clock
Sub NeedsClock(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/clock.js")
	page.AddExtraCSSFile("custom/clock.css")
End Sub

'The page needs creative tim
Sub NeedsCreativeTim(page As ABMPage)
	'page.AddExtrajavascriptfile("custom/bootstrap.min.js")
	page.AddExtraJavaScriptFile("custom/material.min.js")
	page.AddExtraJavaScriptFile("custom/material-dashboard.js")
	'page.AddExtraCSSFile("custom/bootstrap.min.css")
	page.AddExtraCSSFile("custom/material-dashboard.css")
End Sub

'The page needs JQPlot
Sub NeedsJQPlot(page As ABMPage)
	page.AddExtraCSSFile("custom/jquery.jqplot.min.css")
	'page.AddExtraJavaScriptFile("custom/jquery.min.js")
	'page.AddExtraJavaScriptFile("custom/jquery-ui.min.js")	
	page.AddExtraJavaScriptFile("custom/jquery.jqplot.min.js")
	page.AddExtraJavaScriptFile("custom/jqplot.renderers.js")
End Sub

'The page needs the Date Dropper
Sub NeedsDateDropper(page As ABMPage)
	page.AddExtraCSSFile("custom/datedropper.min.css")
	page.AddExtraJavaScriptFile("custom/datedropper.min.js")
End Sub

'The page needs a time dropper
Sub NeedsTimeDropper(Page As ABMPage)
	Page.AddExtraCSSFile("custom/timedropper.min.css")
	Page.AddExtraJavaScriptFile("custom/timedropper.min.js")
End Sub

'The page needs JustGage
Sub NeedsJustGage(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/raphael-2.1.4.min.js")
	page.AddExtraJavaScriptFile("custom/justgage.js")
End Sub

'The page needs the JSGrid
Sub NeedsJSGrid(page As ABMPage)
	page.AddExtraCssFile("custom/jsgrid.min.css")
	page.AddExtraCssFile("custom/jsgrid-theme.min.css")
	page.AddExtraJavaScriptFile("custom/jsgrid.min.js")
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	ExternalStyle.initialize
	Debug = False
	Themes.Initialize
	InitColorMap
	EnumThemes.Initialize
	EnumButtonSize.Initialize
	EnumIconPosition.initialize
	

	Anime.Initialize
	FontAwesomeIcons.initialize
	MaterialIcons.initialize
	EnumTextAlignment.Initialize
	
	EnumAlignment.initialize
	EnumElementType.initialize
	EnumIconSize.initialize
	EnumWavesType.initialize
	JavaCalls.initialize
	EnumLabelSizes.initialize
	EnumCardSize.initialize
	ImageTopMargin = "8px"
	ImageHW = "32px"
	ItemHeight = "43px"
End Sub

'Get the forecolor name from the theme
Sub GetForeColorOnlyFromTheme(sTheme As String) As String
	Dim savedTheme As Map = GetTheme(sTheme)
	If savedTheme.IsInitialized = True Then
		Dim scolor As String = savedTheme.getdefault("fc","")
		scolor = scolor.Replace("-text","").Replace("text-","")
		scolor = scolor.Trim
		Return scolor
	End If
	Return ""
End Sub

'Get the back color name from the theme
Sub GetBackColorOnlyFromTheme(sTheme As String) As String
	Dim savedTheme As Map = GetTheme(sTheme)
	If savedTheme.IsInitialized = True Then
		Dim scolor As String = savedTheme.getdefault("bc","")
		scolor = scolor.Replace("-text","").Replace("text-","")
		scolor = scolor.Trim		
		Return scolor
	End If
	Return ""
End Sub

'Get the forecolor class from the theme
Sub GetForeColorFromTheme(sTheme As String) As String
	Dim savedTheme As Map = GetTheme(sTheme)
	If savedTheme.IsInitialized = True Then
		Dim scolor As String = savedTheme.getdefault("fc","")
		Dim sinten As String = savedTheme.getdefault("fci", "")
		scolor = $"${scolor} ${sinten}"$
		scolor = scolor.Trim
		Return scolor
	End If
	Return ""
End Sub

'Get the backcolor class from the theme
Sub GetBackColorFromTheme(sTheme As String) As String
	Dim savedTheme As Map = GetTheme(sTheme)
	If savedTheme.IsInitialized = True Then
		Dim scolor As String = savedTheme.getdefault("bc","")
		Dim sinten As String = savedTheme.getdefault("bci", "")
		scolor = $"${scolor} ${sinten}"$
		scolor = scolor.Trim
		Return scolor
	End If
	Return ""
End Sub

'JQuery set css property
public Sub JQuerySetCssProperty(sID As String, cssid As String, cssvalue As String) As String
	Dim script As String = $"$('#${sID}').css('${cssid}', '${cssvalue}');"$
	Return script
End Sub

'Get the forecolor hex value from the theme
Sub ABMGetForeColor(sTheme As String) As String
	Dim savedTheme As Map = GetTheme(sTheme)
	Dim fc As String = savedTheme.GetDefault("fc","")
	Dim fci As String = savedTheme.GetDefault("fci","")
	fc = fc.Replace("-text","").Replace("text-","")
	fci = fci.Replace("-text","").Replace("text-","")
	Dim sColor As String = $"${fc} ${fci}"$
	sColor = sColor.Trim
	sColor = ColorMap.GetDefault(sColor,"")
	Return sColor
End Sub

'Get the background color hex from the theme
Sub ABMGetBackGroundColor(sTheme As String) As String
	Dim savedTheme As Map = GetTheme(sTheme)
	Dim fc As String = savedTheme.GetDefault("bc","")
	Dim fci As String = savedTheme.GetDefault("bci","")
	fc = fc.Replace("-text","").Replace("text-","")
	fci = fci.Replace("-text","").Replace("text-","")
	Dim sColor As String = $"${fc} ${fci}"$
	sColor = sColor.Trim
	sColor = ColorMap.GetDefault(sColor,"")
	Return sColor
End Sub

'Get the hex value for a color and intensity
Sub ABMGetColor(color As String, intensity As String) As String
	Dim sKey As String = color & " " & intensity
	Dim sColor As String = ""
	sKey = sKey.trim
	sColor = ColorMap.GetDefault(sKey,"")
	If sColor = "" Then Return color
	Return sColor
End Sub

'Use a theme on this element
Sub MaterialUseTheme(sTheme As String, el As HTMLElement) As HTMLElement
	Dim savedTheme As Map = GetTheme(sTheme)
	If savedTheme.IsInitialized = True Then
		el.ForeColor = savedTheme.getdefault("fc","")
		el.ForeColorIntensity = savedTheme.getdefault("fci", "")
		el.BackColor = savedTheme.getdefault("bc", "")
		el.BackColorIntensity = savedTheme.getdefault("bci", "")
	End If
	Return el
End Sub

Sub SortMap(m As Map) As Map
	Try
		Dim nm As Map
		nm.Initialize
		Dim lst As List
		lst.Initialize
		For Each strkey As String In m.Keys
			lst.Add(strkey)
		Next
		'sort the list keys
		lst.Sort(True)
		For Each strkey As String In lst
			Dim strvalue As Object = m.Get(strkey)
			nm.Put(strkey,strvalue)
		Next
		Return nm
	Catch
		Return m
	End Try
End Sub

'this will be used for the background color of the alphabets of the senders
public Sub AlphaColorCode(sPrefix As String) As String
	Select Case sPrefix.ToLowerCase
		Case "a"
			Return "red darken-3"
		Case "b"
			Return "pink darken-3"
		Case "c"
			Return "purple darken-3"
		Case "d"
			Return "deep-purple darken-3"
		Case "e"
			Return "blue darken-3"
		Case "f"
			Return "indigo darken-3"
		Case "g"
			Return "light-blue darken-3"
		Case "h"
			Return "cyan darken-3"
		Case "i"
			Return "teal darken-3"
		Case "j"
			Return "green darken-3"
		Case "k"
			Return "lime darken-3"
		Case "l"
			Return "light-green darken-3"
		Case "m"
			Return "yellow darken-3"
		Case "o"
			Return "orange darken-3"
		Case "p"
			Return "deep-orange darken-3"
		Case "q"
			Return "brown darken-3"
		Case "r"
			Return "grey darken-3"
		Case "s"
			Return "red darken-1"
		Case "t"
			Return "indigo darken-1"
		Case "u"
			Return "blue darken-1"
		Case "v"
			Return "teal darken-1"
		Case "w"
			Return "green darken-1"
		Case "x"
			Return "pink darken-1"
		Case "y"
			Return "orange darken-1"
		Case "z"
			Return "cyan darken-1"
		Case Else
			Return "light-blue darken-1"
	End Select
End Sub

'Use a theme on this component in reverse i.e backcolor becomes forecolor and forecolor become backcolor
Sub MaterialUseReversedTheme(sTheme As String, el As HTMLElement) As HTMLElement
	Dim savedTheme As Map = GetTheme(sTheme)
	If savedTheme.IsInitialized = True Then
		el.BackColor = savedTheme.getdefault("fc","")
		el.BackColorIntensity = savedTheme.getdefault("fci", "")
		el.ForeColor = savedTheme.getdefault("bc", "")
		el.ForeColorIntensity = savedTheme.getdefault("bci", "")
		el.BackColor = el.BackColor.Replace("-text","").Replace("text-","")
		el.BackColorIntensity = el.BackColorIntensity.Replace("text-","").Replace("-text","")
		el.ForeColor = el.ForeColor.Replace("-text","").Replace("text-","")
		el.ForeColorIntensity = el.ForeColorIntensity.Replace("text-","").Replace("-text","")
	End If
	Return el
End Sub

'Add a theme to mashplugins
Sub AddTheme(themeName As String, sForeColor As String, sForeColorIntensity As String, sBackColor As String, sBackColorIntensity As String)
	themeName = themeName.tolowercase
	Dim fc As String = sForeColor & "-text"
	Dim fci As String = "text-" & sForeColorIntensity
	If fc = "-text" Then fc = ""
	If fci = "text-" Then fci = ""
	Dim Theme As Map
	Theme.Initialize
	Theme.Put("bc", sBackColor)
	Theme.Put("bci", sBackColorIntensity)
	Theme.Put("fc", fc)
	Theme.Put("fci",fci)
	Themes.Put(themeName,Theme)
End Sub

'get a theme from saved themes
private Sub GetTheme(themeName As String) As Map
	themeName = themeName.ToLowerCase
	Dim Theme As Map
	If Themes.ContainsKey(themeName) Then
		Theme = Themes.Get(themeName)
	End If
	Return Theme
End Sub

'Fix an image path
Public Sub FixImage(sPath As String, sExtension As String) As String
	sPath = sPath.replace("[","")
	sPath = sPath.replace("]","")
	sPath = sPath.replace(",","")
	sPath = sPath.replace("-","")
	sPath = sPath.replace(" ","")
	sPath = sPath.trim
	sPath = sPath & sExtension
	Return sPath.ToLowerCase
End Sub

'Fix a delimiter
Sub FixDelimiter(sValue As String) As String
	If sValue = "|" Then sValue = "\|"
	If sValue = "." Then sValue = "\."
	If sValue = "\" Then sValue = "\\"
	If sValue = "^" Then sValue = "\^"
	If sValue = "$" Then sValue = "\$"
	If sValue = "?" Then sValue = "\?"
	If sValue = "*" Then sValue = "\*"
	If sValue = "+" Then sValue = "\+"
	If sValue = "(" Then sValue = "\("
	If sValue = ")" Then sValue = "\)"
	If sValue = "[" Then sValue = "\["
	If sValue = "{" Then sValue = "\{"
	If sValue = ";" Then sValue = "\;"
	Return sValue
End Sub

'Initialize the color map hex values
private Sub InitColorMap
	ColorMap.Initialize
	ColorMap.Put("maroon","#800000")
	ColorMap.put("red", "#f44336")
	ColorMap.put("orange", "#ff9800")
	ColorMap.put("yellow", "#ffeb3b")
	ColorMap.put("olive", "#808000")
	ColorMap.put("green", "#4caf50")
	ColorMap.put("purple", "#9c27b0")
	ColorMap.Put("fuchsia", "#ff00ff")
	ColorMap.put("lime", "#cddc39")
	ColorMap.put("teal", "#009688")
	ColorMap.Put("aqua", "#00ffff")
	ColorMap.put("grey", "#9e9e9e")
	ColorMap.put("pink", "#e91e63")
	ColorMap.put("blue", "#2196f3")
	ColorMap.put("brown", "#795548")
	ColorMap.put("deep-purple", "#673ab7")
	ColorMap.put("indigo", "#3f51b5")
	ColorMap.put("light-blue", "#03a9f4")
	ColorMap.put("cyan", "#00bcd4")
	ColorMap.put("light-green", "#8bc34a")
	ColorMap.put("amber", "#ffc107")
	ColorMap.put("deep-orange", "#ff5722")
	ColorMap.put("blue-grey", "#607d8b")
	ColorMap.put("black", "#000000")
	ColorMap.put("navy", "#000080")
	ColorMap.Put("silver", "#c0c0c0")
	ColorMap.Put("aquamarine", "#7fffd4")
	ColorMap.put("white", "#ffffff")
	ColorMap.Put("blueviolet", "#8a2be2")
	ColorMap.Put("burlywood", "#deb887")
	ColorMap.Put("cadetblue","#5f9ea0")
	ColorMap.Put("chartreuse", "#7fff00")
	ColorMap.Put("chocolate", "#d2691e")
	ColorMap.Put("coral","#ff7f50")
	ColorMap.Put("cornflowerblue","#6495ed")
	ColorMap.Put("forestgreen","#228b22")
	ColorMap.put("gold","#ffd700")
	ColorMap.Put("goldenrod","#daa520")
	ColorMap.Put("khaki","#f0e68c")
	ColorMap.Put("lavendar", "#e6e6fa")
	ColorMap.Put("lightcoral","#f08080")
	ColorMap.put("lightseagreen","#20b2aa")
	ColorMap.put("rosybrown","#bc8f8f")
	ColorMap.Put("steelblue","#4682b4")
	ColorMap.Put("yellowgreen","#9acd32")
	ColorMap.put("red lighten-5", "#ffebee")
	ColorMap.put("red lighten-4", "#ffcdd2")
	ColorMap.put("red lighten-3", "#ef9a9a")
	ColorMap.put("red lighten-2", "#e57373")
	ColorMap.put("red lighten-1", "#ef5350")
	ColorMap.put("red", "#f44336")
	ColorMap.put("red darken-1", "#e53935")
	ColorMap.put("red darken-2", "#d32f2f")
	ColorMap.put("red darken-3", "#c62828")
	ColorMap.put("red darken-4", "#b71c1c")
	ColorMap.put("red accent-1", "#ff8a80")
	ColorMap.put("red accent-2", "#ff5252")
	ColorMap.put("red accent-3", "#ff1744")
	ColorMap.put("red accent-4", "#d50000")
	ColorMap.put("pink lighten-5", "#fce4ec")
	ColorMap.put("pink lighten-4", "#f8bbd0")
	ColorMap.put("pink lighten-3", "#f48fb1")
	ColorMap.put("pink lighten-2", "#f06292")
	ColorMap.put("pink lighten-1", "#ec407a")
	ColorMap.put("pink", "#e91e63")
	ColorMap.put("pink darken-1", "#d81b60")
	ColorMap.put("pink darken-2", "#c2185b")
	ColorMap.put("pink darken-3", "#ad1457")
	ColorMap.put("pink darken-4", "#880e4f")
	ColorMap.put("pink accent-1", "#ff80ab")
	ColorMap.put("pink accent-2", "#ff4081")
	ColorMap.put("pink accent-3", "#f50057")
	ColorMap.put("pink accent-4", "#c51162")
	ColorMap.put("purple lighten-5", "#f3e5f5")
	ColorMap.put("purple lighten-4", "#e1bee7")
	ColorMap.put("purple lighten-3", "#ce93d8")
	ColorMap.put("purple lighten-2", "#ba68c8")
	ColorMap.put("purple lighten-1", "#ab47bc")
	ColorMap.put("purple", "#9c27b0")
	ColorMap.put("purple darken-1", "#8e24aa")
	ColorMap.put("purple darken-2", "#7b1fa2")
	ColorMap.put("purple darken-3", "#6a1b9a")
	ColorMap.put("purple darken-4", "#4a148c")
	ColorMap.put("purple accent-1", "#ea80fc")
	ColorMap.put("purple accent-2", "#e040fb")
	ColorMap.put("purple accent-3", "#d500f9")
	ColorMap.put("purple accent-4", "#aa00ff")
	ColorMap.put("deep-purple lighten-5", "#ede7f6")
	ColorMap.put("deep-purple lighten-4", "#d1c4e9")
	ColorMap.put("deep-purple lighten-3", "#b39ddb")
	ColorMap.put("deep-purple lighten-2", "#9575cd")
	ColorMap.put("deep-purple lighten-1", "#7e57c2")
	ColorMap.put("deep-purple", "#673ab7")
	ColorMap.put("deep-purple darken-1", "#5e35b1")
	ColorMap.put("deep-purple darken-2", "#512da8")
	ColorMap.put("deep-purple darken-3", "#4527a0")
	ColorMap.put("deep-purple darken-4", "#311b92")
	ColorMap.put("deep-purple accent-1", "#b388ff")
	ColorMap.put("deep-purple accent-2", "#7c4dff")
	ColorMap.put("deep-purple accent-3", "#651fff")
	ColorMap.put("deep-purple accent-4", "#6200ea")
	ColorMap.put("indigo lighten-5", "#e8eaf6")
	ColorMap.put("indigo lighten-4", "#c5cae9")
	ColorMap.put("indigo lighten-3", "#9fa8da")
	ColorMap.put("indigo lighten-2", "#7986cb")
	ColorMap.put("indigo lighten-1", "#5c6bc0")
	ColorMap.put("indigo", "#3f51b5")
	ColorMap.put("indigo darken-1", "#3949ab")
	ColorMap.put("indigo darken-2", "#303f9f")
	ColorMap.put("indigo darken-3", "#283593")
	ColorMap.put("indigo darken-4", "#1a237e")
	ColorMap.put("indigo accent-1", "#8c9eff")
	ColorMap.put("indigo accent-2", "#536dfe")
	ColorMap.put("indigo accent-3", "#3d5afe")
	ColorMap.put("indigo accent-4", "#304ffe")
	ColorMap.put("blue lighten-5", "#e3f2fd")
	ColorMap.put("blue lighten-4", "#bbdefb")
	ColorMap.put("blue lighten-3", "#90caf9")
	ColorMap.put("blue lighten-2", "#64b5f6")
	ColorMap.put("blue lighten-1", "#42a5f5")
	ColorMap.put("blue", "#2196f3")
	ColorMap.put("blue darken-1", "#1e88e5")
	ColorMap.put("blue darken-2", "#1976d2")
	ColorMap.put("blue darken-3", "#1565c0")
	ColorMap.put("blue darken-4", "#0d47a1")
	ColorMap.put("blue accent-1", "#82b1ff")
	ColorMap.put("blue accent-2", "#448aff")
	ColorMap.put("blue accent-3", "#2979ff")
	ColorMap.put("blue accent-4", "#2962ff")
	ColorMap.put("light-blue lighten-5", "#e1f5fe")
	ColorMap.put("light-blue lighten-4", "#b3e5fc")
	ColorMap.put("light-blue lighten-3", "#81d4fa")
	ColorMap.put("light-blue lighten-2", "#4fc3f7")
	ColorMap.put("light-blue lighten-1", "#29b6f6")
	ColorMap.put("light-blue", "#03a9f4")
	ColorMap.put("light-blue darken-1", "#039be5")
	ColorMap.put("light-blue darken-2", "#0288d1")
	ColorMap.put("light-blue darken-3", "#0277bd")
	ColorMap.put("light-blue darken-4", "#01579b")
	ColorMap.put("light-blue accent-1", "#80d8ff")
	ColorMap.put("light-blue accent-2", "#40c4ff")
	ColorMap.put("light-blue accent-3", "#00b0ff")
	ColorMap.put("light-blue accent-4", "#0091ea")
	ColorMap.put("cyan lighten-5", "#e0f7fa")
	ColorMap.put("cyan lighten-4", "#b2ebf2")
	ColorMap.put("cyan lighten-3", "#80deea")
	ColorMap.put("cyan lighten-2", "#4dd0e1")
	ColorMap.put("cyan lighten-1", "#26c6da")
	ColorMap.put("cyan", "#00bcd4")
	ColorMap.put("cyan darken-1", "#00acc1")
	ColorMap.put("cyan darken-2", "#0097a7")
	ColorMap.put("cyan darken-3", "#00838f")
	ColorMap.put("cyan darken-4", "#006064")
	ColorMap.put("cyan accent-1", "#84ffff")
	ColorMap.put("cyan accent-2", "#18ffff")
	ColorMap.put("cyan accent-3", "#00e5ff")
	ColorMap.put("cyan accent-4", "#00b8d4")
	ColorMap.put("teal lighten-5", "#e0f2f1")
	ColorMap.put("teal lighten-4", "#b2dfdb")
	ColorMap.put("teal lighten-3", "#80cbc4")
	ColorMap.put("teal lighten-2", "#4db6ac")
	ColorMap.put("teal lighten-1", "#26a69a")
	ColorMap.put("teal", "#009688")
	ColorMap.put("teal darken-1", "#00897b")
	ColorMap.put("teal darken-2", "#00796b")
	ColorMap.put("teal darken-3", "#00695c")
	ColorMap.put("teal darken-4", "#004d40")
	ColorMap.put("teal accent-1", "#a7ffeb")
	ColorMap.put("teal accent-2", "#64ffda")
	ColorMap.put("teal accent-3", "#1de9b6")
	ColorMap.put("teal accent-4", "#00bfa5")
	ColorMap.put("green lighten-5", "#e8f5e9")
	ColorMap.put("green lighten-4", "#c8e6c9")
	ColorMap.put("green lighten-3", "#a5d6a7")
	ColorMap.put("green lighten-2", "#81c784")
	ColorMap.put("green lighten-1", "#66bb6a")
	ColorMap.put("green", "#4caf50")
	ColorMap.put("green darken-1", "#43a047")
	ColorMap.put("green darken-2", "#388e3c")
	ColorMap.put("green darken-3", "#2e7d32")
	ColorMap.put("green darken-4", "#1b5e20")
	ColorMap.put("green accent-1", "#b9f6ca")
	ColorMap.put("green accent-2", "#69f0ae")
	ColorMap.put("green accent-3", "#00e676")
	ColorMap.put("green accent-4", "#00c853")
	ColorMap.put("light-green lighten-5", "#f1f8e9")
	ColorMap.put("light-green lighten-4", "#dcedc8")
	ColorMap.put("light-green lighten-3", "#c5e1a5")
	ColorMap.put("light-green lighten-2", "#aed581")
	ColorMap.put("light-green lighten-1", "#9ccc65")
	ColorMap.put("light-green", "#8bc34a")
	ColorMap.put("light-green darken-1", "#7cb342")
	ColorMap.put("light-green darken-2", "#689f38")
	ColorMap.put("light-green darken-3", "#558b2f")
	ColorMap.put("light-green darken-4", "#33691e")
	ColorMap.put("light-green accent-1", "#ccff90")
	ColorMap.put("light-green accent-2", "#b2ff59")
	ColorMap.put("light-green accent-3", "#76ff03")
	ColorMap.put("light-green accent-4", "#64dd17")
	ColorMap.put("lime lighten-5", "#f9fbe7")
	ColorMap.put("lime lighten-4", "#f0f4c3")
	ColorMap.put("lime lighten-3", "#e6ee9c")
	ColorMap.put("lime lighten-2", "#dce775")
	ColorMap.put("lime lighten-1", "#d4e157")
	ColorMap.put("lime", "#cddc39")
	ColorMap.put("lime darken-1", "#c0ca33")
	ColorMap.put("lime darken-2", "#afb42b")
	ColorMap.put("lime darken-3", "#9e9d24")
	ColorMap.put("lime darken-4", "#827717")
	ColorMap.put("lime accent-1", "#f4ff81")
	ColorMap.put("lime accent-2", "#eeff41")
	ColorMap.put("lime accent-3", "#c6ff00")
	ColorMap.put("lime accent-4", "#aeea00")
	ColorMap.put("yellow lighten-5", "#fffde7")
	ColorMap.put("yellow lighten-4", "#fff9c4")
	ColorMap.put("yellow lighten-3", "#fff59d")
	ColorMap.put("yellow lighten-2", "#fff176")
	ColorMap.put("yellow lighten-1", "#ffee58")
	ColorMap.put("yellow", "#ffeb3b")
	ColorMap.put("yellow darken-1", "#fdd835")
	ColorMap.put("yellow darken-2", "#fbc02d")
	ColorMap.put("yellow darken-3", "#f9a825")
	ColorMap.put("yellow darken-4", "#f57f17")
	ColorMap.put("yellow accent-1", "#ffff8d")
	ColorMap.put("yellow accent-2", "#ffff00")
	ColorMap.put("yellow accent-3", "#ffea00")
	ColorMap.put("yellow accent-4", "#ffd600")
	ColorMap.put("amber lighten-5", "#fff8e1")
	ColorMap.put("amber lighten-4", "#ffecb3")
	ColorMap.put("amber lighten-3", "#ffe082")
	ColorMap.put("amber lighten-2", "#ffd54f")
	ColorMap.put("amber lighten-1", "#ffca28")
	ColorMap.put("amber", "#ffc107")
	ColorMap.put("amber darken-1", "#ffb300")
	ColorMap.put("amber darken-2", "#ffa000")
	ColorMap.put("amber darken-3", "#ff8f00")
	ColorMap.put("amber darken-4", "#ff6f00")
	ColorMap.put("amber accent-1", "#ffe57f")
	ColorMap.put("amber accent-2", "#ffd740")
	ColorMap.put("amber accent-3", "#ffc400")
	ColorMap.put("amber accent-4", "#ffab00")
	ColorMap.put("orange lighten-5", "#fff3e0")
	ColorMap.put("orange lighten-4", "#ffe0b2")
	ColorMap.put("orange lighten-3", "#ffcc80")
	ColorMap.put("orange lighten-2", "#ffb74d")
	ColorMap.put("orange lighten-1", "#ffa726")
	ColorMap.put("orange", "#ff9800")
	ColorMap.put("orange darken-1", "#fb8c00")
	ColorMap.put("orange darken-2", "#f57c00")
	ColorMap.put("orange darken-3", "#ef6c00")
	ColorMap.put("orange darken-4", "#e65100")
	ColorMap.put("orange accent-1", "#ffd180")
	ColorMap.put("orange accent-2", "#ffab40")
	ColorMap.put("orange accent-3", "#ff9100")
	ColorMap.put("orange accent-4", "#ff6d00")
	ColorMap.put("deep-orange lighten-5", "#fbe9e7")
	ColorMap.put("deep-orange lighten-4", "#ffccbc")
	ColorMap.put("deep-orange lighten-3", "#ffab91")
	ColorMap.put("deep-orange lighten-2", "#ff8a65")
	ColorMap.put("deep-orange lighten-1", "#ff7043")
	ColorMap.put("deep-orange", "#ff5722")
	ColorMap.put("deep-orange darken-1", "#f4511e")
	ColorMap.put("deep-orange darken-2", "#e64a19")
	ColorMap.put("deep-orange darken-3", "#d84315")
	ColorMap.put("deep-orange darken-4", "#bf360c")
	ColorMap.put("deep-orange accent-1", "#ff9e80")
	ColorMap.put("deep-orange accent-2", "#ff6e40")
	ColorMap.put("deep-orange accent-3", "#ff3d00")
	ColorMap.put("deep-orange accent-4", "#dd2c00")
	ColorMap.put("brown lighten-5", "#efebe9")
	ColorMap.put("brown lighten-4", "#d7ccc8")
	ColorMap.put("brown lighten-3", "#bcaaa4")
	ColorMap.put("brown lighten-2", "#a1887f")
	ColorMap.put("brown lighten-1", "#8d6e63")
	ColorMap.put("brown", "#795548")
	ColorMap.put("brown darken-1", "#6d4c41")
	ColorMap.put("brown darken-2", "#5d4037")
	ColorMap.put("brown darken-3", "#4e342e")
	ColorMap.put("brown darken-4", "#3e2723")
	ColorMap.put("grey lighten-5", "#fafafa")
	ColorMap.put("grey lighten-4", "#f5f5f5")
	ColorMap.put("grey lighten-3", "#eeeeee")
	ColorMap.put("grey lighten-2", "#e0e0e0")
	ColorMap.put("grey lighten-1", "#bdbdbd")
	ColorMap.put("grey", "#9e9e9e")
	ColorMap.put("grey darken-1", "#757575")
	ColorMap.put("grey darken-2", "#616161")
	ColorMap.put("grey darken-3", "#424242")
	ColorMap.put("grey darken-4", "#212121")
	ColorMap.put("blue-grey lighten-5", "#eceff1")
	ColorMap.put("blue-grey lighten-4", "#cfd8dc")
	ColorMap.put("blue-grey lighten-3", "#b0bec5")
	ColorMap.put("blue-grey lighten-2", "#90a4ae")
	ColorMap.put("blue-grey lighten-1", "#78909c")
	ColorMap.put("blue-grey", "#607d8b")
	ColorMap.put("blue-grey darken-1", "#546e7a")
	ColorMap.put("blue-grey darken-2", "#455a64")
	ColorMap.put("blue-grey darken-3", "#37474f")
	ColorMap.put("blue-grey darken-4", "#263238")
	ColorMap.put("black", "#000000")
	ColorMap.put("white", "#ffffff")
	ColorMap.put("transparent", "transparent")
End Sub

'Use a material theme based on a condition
Sub MaterialUseThemeOnCondition(bStatus As Boolean, themeName As String, el As HTMLElement) As HTMLElement
	If bStatus = True Then
		MaterialUseTheme(themeName,el)
	End If
	Return el
End Sub

'JQuery toogle class
Sub JQueryToggleClassScript(id As String, class As String) As String
	Dim script As String = $"$('#${id}').toggleClass('${class}');"$
	Return script
End Sub

'JQuery toggle class execute
Sub JQueryToggleClass(page As ABMPage,id As String, class As String)
	Dim script As String = JQueryToggleClassScript(id,class)
	page.ws.Eval(script,Array As String(id))
End Sub

'JQuery remove class
Sub JQueryRemoveClassScript(id As String, class As String) As String
	Dim script As String = $"$('#${id}').removeClass('${class}');"$
	Return script
End Sub

'JQuery remove class execute
Sub JQueryRemoveClass(page As ABMPage,id As String, class As String)
	Dim script As String = JQueryRemoveClassScript(id,class)
	page.ws.Eval(script,Array As String(id))
End Sub

'JQuery add class
Sub JQueryAddClassScript(id As String, class As String) As String
	Dim script As String = $"$('#${id}').addClass('${class}');"$
	Return script
End Sub

'JQuery add class execute
Sub JQueryAddClass(page As ABMPage,id As String, class As String)
	Dim script As String = JQueryAddClassScript(id,class)
	page.ws.Eval(script,Array As String(id))
End Sub

'JQuery hide element
Sub JQueryHideSlowScript(id As String) As String
	Dim script As String = $"$('#${id}').hide("slow");"$
	Return script
End Sub

'JQuery hide element slowly
Sub JQueryHideSlow(page As ABMPage, id As String)
	Dim script As String = JQueryHideSlowScript(id)
	page.ws.Eval(script,Array As String(id))
End Sub

'JQuery fade element slowly
Sub JQueryFadeOutSlowScript(id As String) As String
	Dim script As String = $"$('#${id}').fadeOut('slow');"$
	Return script
End Sub

'JQuery show element
Sub JQueryShowScript(id As String) As String
	Dim script As String = $"$('#${id}').show();"$
	Return script
End Sub

'JQuery show element execute
Sub JQueryShow(page As ABMPage, id As String)
	page.ws.Eval(JQueryShowScript(id),Array As String(id))
End Sub

'JQuery fade element slowly execute
Sub JQueryFadeOutSlow(page As ABMPage, id As String)
	Dim script As String = JQueryFadeOutSlowScript(id)
	page.ws.Eval(script,Array As String(id))
End Sub

'JQuery animate
Sub JQueryAnimateScript(id As String, animationType As String, bInfinity As Boolean, bAfter As String) As String
	Dim inf As String = ""
	If bInfinity = True Then inf = "infinite"
	Dim script As String = $"$('#${id}').addClass('animated ${inf} ${animationType}').one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend',
	function() { $(this).removeClass('animated ${inf} ${animationType}');
	${bAfter}
	});"$
	Return script
End Sub

'JQuery animate execute
Sub JQueryAnimate(page As ABMPage, id As String, animationType As String, bInfinity As Boolean, bAfter As String)
	Dim script As String = JQueryAnimateScript(id, animationType, bInfinity, bAfter)
	page.ws.Eval(script,Null)
End Sub

'Return the long date from yyyy-MM-dd
Sub LongDate(sDate As String) As String
	If sDate.Length = 0 Then Return ""
	Try
		DateTime.DateFormat = "yyyy-MM-dd"
		Dim dt As Long = DateTime.DateParse(sDate)
		DateTime.DateFormat = "EEEE, dd MMMM yyyy"
		Return DateTime.Date(dt)
	Catch
		Return ""
	End Try
End Sub

'Return the long date time from yyyy-MM-dd HH:mm
Sub LongDateTime(sDate As String) As String
	If sDate.Length = 0 Then Return ""
	Try
		DateTime.DateFormat = "yyyy-MM-dd HH:mm"
		Dim dt As Long = DateTime.DateParse(sDate)
		DateTime.DateFormat = "EEEE, dd MMMM yyyy HH:mm"
		Return DateTime.Date(dt)
	Catch
		Return ""
	End Try
End Sub

'JServer: GetText
public Sub GetText(page As ABMPage, id As String) As String
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		Return jqe.GetText.value
	Catch
		Return ""
	End Try
End Sub

'JServer: SetText
public Sub SetText(page As ABMPage, id As String, value As String)
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		jqe.SetText(value)
	Catch
		Log(LastException)
	End Try
End Sub

'JServer: GetHTML
public Sub GetHTML(page As ABMPage, id As String) As String
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		Return jqe.GetHtml.value
	Catch
		Return ""
	End Try
End Sub

'JServer: SetHTML
public Sub SetHTML(page As ABMPage, id As String, value As String)
	Try
		id = id.tolowercase
		Dim jqe As JQueryElement = page.ws.GetElementById(id)
		jqe.SetHtml(value)
	Catch
		Log(LastException)
	End Try
End Sub

'Show a toast of a message green
Sub Inform(page As ABMPage, msg As String)
	toastCount = toastCount + 1
	page.ShowToast("toast" & toastCount, "toastgreen", $"${msg}"$, 3000,False)
End Sub

'Show a toast of a message red
Sub Warn(page As ABMPage, msg As String)
	toastCount = toastCount + 1
	page.ShowToast("toast" & toastCount, "toastred", $"${msg}"$, 3000, False)
End Sub

'Add sidebar sub item
Sub AddSideBarSubItem(pg As ABMPage,sidebarreturnName As String, returnname As String, text As String, iconName As String, url As String, divInfront As String, divAfter As String)
	If divInfront = "1" Then
		pg.NavigationBar.AddSideBarSubDivider(sidebarreturnName)
	End If
	pg.NavigationBar.AddSideBarSubItem(sidebarreturnName, returnname, text, iconName, url)
	If divAfter = "1" Then
		pg.NavigationBar.AddSideBarSubDivider(sidebarreturnName)
	End If
End Sub

'Add side bar item
Sub AddSideBarItem(pg As ABMPage,returnName As String, text As String, iconname As String, url As String, divInfront As String, divAfter As String)
	If divInfront = "1" Then
		pg.NavigationBar.AddSideBarDivider
	End If
	pg.NavigationBar.AddSideBarItem(returnName, text, iconname,url)
	If divAfter = "1" Then
		pg.NavigationBar.AddSideBarDivider
	End If
End Sub

'Get date from an excel date, for jPOI
public Sub DateFromExcelDate(sValue As String) As String
	If IsNumber(sValue) = True Then
		Dim myperiod As Period
		myperiod.Days = sValue - 2
		Dim xlsDate As Long = DateUtils.SetDate(1900, 1, 1)
		Dim newDate As Long = DateUtils.AddPeriod(xlsDate,myperiod)
		DateTime.DateFormat = "yyyy-MM-dd"
		Return DateTime.Date(newDate)
	Else
		Return sValue
	End If
End Sub

'Convert value to a double
Public Sub CDbl(value As String) As Double
	Try
		value = value.Trim
		If value = "" Then value = "0"
		value = value.Replace(",","")
		Dim out As Double = NumberFormat2(value,0,2,2,False)
		Return out
	Catch
		Return value
	End Try
End Sub

'Verify if an import is valid
Sub IsImportValid(m As Map, fields As List) As Boolean
	Dim bIsValid As Boolean
	Dim vCnt As Int = 0
	bIsValid = True
	If (fields.Size - 1) = 0 Then Return True
	For Each strField As String In fields
		Dim strValue As String = m.GetDefault(strField.ToLowerCase,"")
		If strValue.Length = 0 Then
			vCnt = vCnt + 1
		End If
	Next
	If vCnt = 0 Then
		Return True
	Else
		Return False
	End If
End Sub

'POI: get cell value
Sub GetPoiCellValue(row As PoiRow, colAlpha As String) As String
	Dim cell As PoiCell = GetPoiRowPoiCell(row,colAlpha)
	Return PoiCellReturn(cell)
End Sub

'POI: get row
Sub GetPoiRow(ws As PoiSheet, rowPos As Int) As PoiRow
	Try
		Dim rowP As Int = rowPos - 1
		Dim row As PoiRow = ws.GetRow(rowP)
		row.IsInitialized
		Return row
	Catch
		Return Null
	End Try
End Sub

'POI: get row cell
Sub GetPoiRowPoiCell(row As PoiRow, colAlpha As String) As PoiCell
	Try
		Dim colP As Int = 0
		If IsNumber(colAlpha) = False Then
			colP = GetColumnPos(colAlpha) - 1
		Else
			colP = colAlpha -1
		End If
		Dim cell As PoiCell = row.GetCell(colP)
		cell.IsInitialized
		Return cell
	Catch
		Return Null
	End Try
End Sub

'Return a proper case string
Sub ProperCase(myStr As String) As String
	Try
		If myStr.trim.length = 0 Then Return ""
		Dim x As String
		Dim j, k As Int
		myStr = myStr.tolowercase
		x = myStr.ToUpperCase.CharAt(0)
		myStr = x & myStr.SubString2(1, myStr.Length)
		For j = 1 To myStr.Length
			k = myStr.IndexOf2(" ", j + 1)
			If k = -1 Then Exit
			x = myStr.ToUpperCase.CharAt(k + 1)
			myStr = myStr.SubString2(0, k + 1) & x & myStr.SubString2(k + 2, myStr.Length)
		Next
		Return myStr
	Catch
		Return myStr
	End Try
End Sub

'POI: Get cell value
Sub PoiCellReturn(cell As PoiCell) As String
	If cell.IsInitialized = True Then
		Select Case cell.CellType
			Case cell.TYPE_NUMERIC
				Return cell.ValueNumeric
			Case cell.TYPE_STRING
				Return cell.ValueString
			Case cell.TYPE_FORMULA
				Return cell.ValueFormula
			Case cell.TYPE_BLANK
				Return ""
			Case cell.TYPE_BOOLEAN
				Return cell.ValueBoolean
			Case cell.TYPE_ERROR
				Return ""
			Case Else
				Return cell.Value
		End Select
	Else
		Return ""
	End If
End Sub


'return the column position based on the alphabet, a-az (52 columns)
Sub GetColumnPos(colAlpha As String) As Int
	Select Case colAlpha.tolowercase
		Case "a"
			Return 1
		Case "b"
			Return 2
		Case "c"
			Return 3
		Case "d"
			Return 4
		Case "e"
			Return 5
		Case "f"
			Return 6
		Case "g"
			Return 7
		Case "h"
			Return 8
		Case "i"
			Return 9
		Case "j"
			Return 10
		Case "k"
			Return 11
		Case "l"
			Return 12
		Case "m"
			Return 13
		Case "n"
			Return 14
		Case "o"
			Return 15
		Case "p"
			Return 16
		Case "q"
			Return 17
		Case "r"
			Return 18
		Case "s"
			Return 19
		Case "t"
			Return 20
		Case "u"
			Return 21
		Case "v"
			Return 22
		Case "w"
			Return 23
		Case "x"
			Return 24
		Case "y"
			Return 25
		Case "z"
			Return 26
		Case "aa"
			Return 27
		Case "ab"
			Return 28
		Case "ac"
			Return 29
		Case "ad"
			Return 30
		Case "ae"
			Return 31
		Case "af"
			Return 32
		Case "ag"
			Return 33
		Case "ah"
			Return 34
		Case "ai"
			Return 35
		Case "aj"
			Return 36
		Case "ak"
			Return 37
		Case "al"
			Return 38
		Case "am"
			Return 39
		Case "an"
			Return 40
		Case "ao"
			Return 41
		Case "ap"
			Return 42
		Case "aq"
			Return 43
		Case "ar"
			Return 44
		Case "as"
			Return 45
		Case "at"
			Return 46
		Case "au"
			Return 47
		Case "av"
			Return 48
		Case "aw"
			Return 49
		Case "ax"
			Return 50
		Case "ay"
			Return 51
		Case "az"
			Return 52
	End Select
End Sub

'POI: Get Row Cell Value
Sub GetRowCellValue(ws As PoiSheet, rowpos As Int, colAlpha As String) As String
	Dim cell As PoiCell = GetPoiCell(ws,rowpos,colAlpha)
	Return PoiCellReturn(cell)
End Sub

'POI: Get poi cell
Sub GetPoiCell(ws As PoiSheet, rowPos As Int, colAlpha As String) As PoiCell
	Try
		Dim rowP As Int = rowPos - 1
		Dim colP As Int = 0
		If IsNumber(colAlpha) = False Then
			colP = GetColumnPos(colAlpha) - 1
		Else
			colP = colAlpha -1
		End If
		Dim row As PoiRow = ws.GetRow(rowP)
		row.IsInitialized
		Dim cell As PoiCell = row.GetCell(colP)
		cell.IsInitialized
		Return cell
	Catch
		Return Null
	End Try
End Sub

'Return a random string
Sub RandomString(Length As Int, LowerCase As Boolean, UpperCase As Boolean, Numbers As Boolean, AdditionalChars As String) As String
	Dim source As String
	If LowerCase = True Then
		source = source &"abcdefghijklmnopqrstuvwxyz"
	End If
	If UpperCase = True Then
		source = source &"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	End If
	If Numbers = True Then
		source = source &"0123456789"
	End If
	If AdditionalChars.Length > 0 Then
		source = source&AdditionalChars
	End If

	Dim SB As StringBuilder
	SB.Initialize
	For i = 1 To Length
		Dim r As Int = Rnd(0,source.Length-1)
		SB.Append(source.SubString2(r,r+1))
	Next
	Return SB.ToString
End Sub

'Return a random password
Sub GeneratePassword(IntNum As Int) As String
	Return RandomString(IntNum,True,True,True,"")
End Sub

'Format source code in a file
Sub CodeFormatter(strCode As String) As String
	Try
		File.WriteString(File.DirApp,"code.txt",strCode)
		Dim clsCM As MashCodeModule
		clsCM.Initialize(File.DirApp,"code.txt")
		clsCM.Code_Beautify
		clsCM.save
		Return File.ReadString(File.DirApp,"code.txt")
	Catch
		Return strCode
	End Try
End Sub

'remove lines containing a string from a list
Sub Code_RemoveLines(Lines As List, StrSearch As String, ExactMatch As Boolean) As List
	Dim totLines As Long
	Dim cntLines As Long
	Dim curLine As String
	Dim xLines As List
	xLines = Lines
	totLines = xLines.size - 1
	For cntLines = totLines To 0 Step -1
		curLine = xLines.Get(cntLines)
		curLine = Trim(curLine)
		If ExactMatch = True Then
			If LCase(StrSearch) = LCase(curLine) Then
				xLines.RemoveAt(cntLines)
			End If
		Else
			If InStr(LCase(curLine), LCase(StrSearch)) > 0 Then
				xLines.RemoveAt(cntLines)
			End If
		End If
	Next
	Return xLines
End Sub

'Trim a string
private Sub Trim(strValue As String) As String
	Return strValue.trim
End Sub

'Lowercase a string
Sub LCase(Text As String) As String
	Return Text.ToLowerCase
End Sub

'generate a number of spaces based on a value
Sub Space(HM As Int) As String
	Dim RS As String = ""
	Do While Len(RS) < HM
		RS = RS & " "
	Loop
	Return RS
End Sub

'return a quotes string
Public Sub InQuotes(sValue As String) As String
	Return QUOTE & sValue & QUOTE
End Sub

'gets position of a string
Sub InStr(Text As String, sFind As String) As Int
	Return Text.IndexOf(sFind)
End Sub

'extract all numeric values from a string
Public Sub Val(value As String) As String
	Try
		value = value.Trim
		If value = "" Then value = "0"
		Dim sout As String = ""
		Dim mout As String = ""
		Dim slen As Int = value.Length
		Dim i As Int = 0
		For i = 0 To slen - 1
			mout = value.CharAt(i)
			If InStr("0123456789.-", mout) <> -1 Then
				sout = sout & mout
			End If
		Next
		Return sout + 0
	Catch
		Return value
	End Try
End Sub

'return an image path for a variance (up, down, same)
Public Sub UpDownSame(variance As String) As String
	If variance < 0 Then Return "../images/up.png"
	If variance > 0 Then Return "../images/down.png"
	If variance = 0 Then Return "../images/same.png"
	Return ""
End Sub

'return a delimited field at a position in a delimited string
Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim xPos As Int: xPos = sValue.IndexOf(Delimiter)
	If xPos = -1 Then Return sValue
	Dim mValues() As String
	Dim tValues As Int
	Delimiter = FixDelimiter(Delimiter)
	If sValue.EndsWith(Delimiter) Then sValue = sValue & " "
	mValues = Regex.split(Delimiter, sValue)
	tValues = mValues.Length -1
	Select Case iPosition
	Case -1
		Return mValues(tValues)
	Case -2
		Return mValues(tValues - 1)
	Case Else
		iPosition = iPosition - 1
		If iPosition <= -1 Then Return mValues(tValues)
		If iPosition > tValues Then Return ""
		Return mValues(iPosition)
	End Select
End Sub

'Rename a folder
Sub RenameFolder(OldName As String, NewName As String) As Boolean
	Dim jo1, jo2 As JavaObject
	jo1.InitializeNewInstance("java.io.File", Array(OldName))
	jo2.InitializeNewInstance("java.io.File", Array(NewName))
	Return jo1.RunMethod("renameTo", Array(jo2))
End Sub

'delete a folder
Public Sub DeleteFolder(Folder As String)
Try
	For Each f As String In File.ListFiles(Folder)
		If File.Exists(Folder,f) = True Then File.Delete(Folder, f)
	Next
	File.Delete("",Folder)
Catch
	Log(LastException)
End Try
End Sub

'delete a folder recursively
Sub DeleteFolderRecursive(Folder As String)
	Try
   For Each f As String In File.ListFiles(Folder)
     If File.IsDirectory(Folder, f) Then
       DeleteFolderRecursive (File.Combine(Folder, f))
     End If
     If File.Exists(Folder,f) = True Then File.Delete(Folder, f)
   Next
   Catch
   	Log(LastException)
   End Try
End Sub

'return 0/1 based on n/y
Sub YesNo2ZeroOne(value As String) As String
	If value = "N" Or value = "" Then
		Return "0"
	Else
		Return "1"	
	End If
End Sub

'return n/y based on 0/1
Sub ZeroOne2YN(value As String) As String
	If value = "0" Or value = "" Then
		Return "N"
	Else 
		Return "Y"
	End If
End Sub

'replace a string in another
Sub Replace(Text As String, sFind As String, sReplaceWith As String) As String
	Return Text.Replace(sFind, sReplaceWith)
End Sub

'return the right part of a string
Sub Right(Text As String, Length As Long) As String
   If Length>Text.Length Then Length=Text.Length
   Return Text.SubString(Text.Length-Length)
End Sub

'convert a list to an array of strings
Private Sub List2Array (a_lstArgs As List) As String()
    Dim arrArgs(a_lstArgs.Size) As String
    For i = 0 To arrArgs.Length - 1
        arrArgs(i) = a_lstArgs.Get(i)
    Next
    Return arrArgs
End Sub

'convert a string to monetary format
Sub MakeMoney(sValue As String) As String
	If sValue.Length = 0 Then Return "0.00"
	If sValue = "null" Then sValue = "0.00"
	sValue = sValue.Replace(",","")
	sValue = Val(sValue)
	If sValue = "0" Then sValue = "000"
	sValue = Round2(sValue,2)
	Return NumberFormat2(sValue, 1, 2, 2, True)
End Sub

'convert a string to a percentage
Sub Percentage(sValue As String) As String
    If sValue = "" Then sValue = "0.00"	
	If sValue.Length = 0 Then Return "0.00"
	If sValue = "null" Then sValue = "0.00"
	sValue = sValue.Replace(",","")
	sValue = Val(sValue)
	If sValue = "0" Then sValue = "0.00"
	sValue = Round2(sValue,2)
	sValue = sValue & "%"
	Return sValue
End Sub

' convert a json string to a map
Sub Json2Map(jsonText As String) As Map
	Dim json As JSONParser
	Dim Map1 As Map
	Map1.Initialize
	If Len(jsonText) > 0 Then 
		json.Initialize(jsonText) 
		Map1 = json.NextObject
	End If
	Return Map1
End Sub

'convert a map to a json string
Sub Map2Json(m As Map) As String
	Dim gen As JSONGenerator
	Dim outJSON As String
	gen.Initialize(m)
	outJSON = gen.ToString
	Return outJSON
End Sub

'convert a json string to a list
Sub Json2List(jsonTxt As String) As List
	Dim root As List
	root.Initialize 
	Try
		Dim parser As JSONParser
		parser.Initialize(jsonTxt)
		root = parser.NextArray
		Return root
	Catch
		Return root
	End Try
End Sub

'convert a map to a query string e.g. website address
Sub Map2QueryString(sm As Map) As String
    ' convert a map to a querystring string
	Dim SU As StringUtils
    Dim iCnt As Int
    Dim iTot As Int
    Dim sb As StringBuilder
	Dim mValue As String
    sb.Initialize
	
	' get size of map
    iTot = sm.Size - 1
    iCnt = 0
    For Each mKey As String In sm.Keys
        mValue = sm.Get(mKey)
		mValue = SU.EncodeUrl(mValue, "UTF8")
		mKey = mKey.Trim 
		If mKey.EndsWith("=") = False Then mKey = mKey & "="  
		sb.Append(mKey).Append(mValue)
		If iCnt < iTot Then sb.Append("&")
        iCnt = iCnt + 1
    Next
    Return sb.ToString
End Sub

'return the length of a string
Sub Len(Text As String) As Int
	Return Text.Length
End Sub

'convert a date to a string
Sub Date2String(date As Long, withTime As Boolean) As String
	Dim OrigFormat As String=DateTime.DateFormat
	If withTime Then
		DateTime.DateFormat="yyyy-MM-dd'T'HH:mm:ss"
	Else
		DateTime.DateFormat="yyyy-MM-dd"
	End If
	Dim MyDate As String =DateTime.Date(date)
	DateTime.DateFormat=OrigFormat
	Return MyDate
End Sub

'convert a string to a date
Sub String2Date(date As String) As Long
	Dim lng As Long
	Dim OrigFormat As String=DateTime.DateFormat
	If date.Length > 10 Then
		DateTime.DateFormat = "yyyy-MM-dd"
		DateTime.DateFormat = "HH:mm:ss"
		Dim d As String = date.SubString2(0,11)
		Dim t As String = date.SubString(12)
		lng = DateTime.DateTimeParse(d,t)
	Else
		DateTime.DateFormat = "yyyy-MM-dd"
		lng = DateTime.Dateparse(date)
	End If
	DateTime.DateFormat=OrigFormat
	Return lng
End Sub

'return a string in the middle from pos to pos end
Sub Mid(Text As String, Start As Int, Length As Int) As String
	Return Text.SubString2(Start-1,Start+Length-1)
End Sub

'return a string in the middle from pos
Sub Mid2(Text As String, Start As Int) As String
	Return Text.SubString(Start-1)
End Sub

'return value based on condition
Sub iif(Expression2Evaluate As String, ReturnIfTrue As String, ReturnIfFalse As String) As String
	If Expression2Evaluate = True Then Return ReturnIfTrue Else Return ReturnIfFalse
End Sub

'JQuery show a toast
Sub JQExecuteShowToast(Content As String, Duration As String, bRounded As Boolean) As String
	Dim srounded As String = ""
	srounded = iif(bRounded=True,"rounded","")
	Dim js As String = $"Materialize.toast('${Content}', '${Duration}', '${srounded}');"$
	Return js
End Sub

'JQuery open a modal by id
Sub JQExecuteOpenModal(id As String) As String
	Dim js As String = $"$('#${id}').modal('open');"$
	Return js
End Sub

'JQuery close a modal by id
Sub JQExecuteCloseModal(id As String) As String
	Dim js As String = $"$('#${id}').modal('close');"$
	Return js
End Sub
