﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private Element As HTMLElement
	Public ZDepth As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Private Theme As String
	Public Visibility As String
	Public Enabled As Boolean
	Private products As Map
	Private productitems As Map
	Public ToolTip As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddProductItem(productID As String, itemDescription As String)
	Dim li As HTMLElement
	li = li.CreateLI("").AddClass("collection-item").AddContent(itemDescription)
	li.ApplyStyle("border-bottom:none;text-align:center;font-size: 1.07rem;line-height: 1.6em")
	Dim item As String = li.html
	'lets get stored items
	If productitems.ContainsKey(productID) Then
		Dim piList As List = productitems.Get(productID)
		If piList.IndexOf(item) = -1 Then piList.Add(li)
		productitems.Put(productID,piList)
	End If
End Sub

private Sub RenderProduct(product As Map) As HTMLElement
	Dim sID As String = product.GetDefault("id","")
	Dim sName As String = product.GetDefault("name","")
	Dim sCurrency As String = product.GetDefault("currency","")
	Dim sPrice As String = product.GetDefault("price","")
	Dim sSubscription As String = product.GetDefault("sub","")
	Dim sDescription As String = product.GetDefault("description","")
	Dim sThemeName As String = product.GetDefault("theme","")
	Dim sCaption As String = product.GetDefault("caption","")
		
	Dim article As HTMLElement
	article = article.CreateARTICLE($"${compID}${sID}"$).AddClass("col s12 m6 l4")
	'the complete card
	Dim card As HTMLElement
	card = card.CreateDIV("").AddClass("card hoverable").ApplyStyle("overflow: hidden")
	Dim cardimage As HTMLElement
	cardimage = cardimage.CreateDIV("").AddClass("card-image").MaterialWavesEffect(True)
	cardimage.ApplyStyle("position:relative;width:100%;")
	MashPlugIns.MaterialUseTheme(sThemeName,cardimage)
	Dim cardtitle As HTMLElement
	cardtitle = cardtitle.CreateDIV("").AddClass("card-title").AddContent(sName)
	cardtitle.ApplyStyle("position:relative;font-size:1.28rem;line-height:1.6em;text-align:center")
	cardtitle.ApplyStyle("width:100%;padding:10px 15px;text-transform:uppercase")
	MashPlugIns.MaterialUseTheme(sThemeName,cardtitle)
	cardimage.AddElement(cardtitle)
	Dim Price As HTMLElement
	Price = Price.CreateDIV("").AddClass("price").AddSup(sCurrency).AddContent(sPrice)
	Price.AddSub(sSubscription)
	Price.ApplyStyle("position:relative;font-size:5rem;line-height:1.6em;color:#fff;font-weight:300;text-align:center")
	cardimage.AddElement(Price)
	Dim pricedesc As HTMLElement
	pricedesc = pricedesc.CreateDIV("").AddClass("price-desc").AddContent(sDescription)
	pricedesc.ApplyStyle("text-align:center;color:#fff;padding-bottom:10px")
	cardimage.AddElement(pricedesc)
	'card image section complete
	card.AddElement(cardimage)
	'lets create the product items
	Dim cardcontent As HTMLElement
	cardcontent = cardcontent.CreateDIV("").AddClass("card-content")
	cardcontent.ApplyStyle("padding:0")
	Dim itemul As HTMLElement
	itemul = itemul.CreateUL("").AddClass("collection").ApplyStyle("border:none")
	'add each item to the ul here
	If productitems.ContainsKey(sID) Then
		Dim items As List = productitems.Get(sID)
		For Each el As HTMLElement In items
			itemul.AddElement(el)
		Next
	End If
	cardcontent.AddElement(itemul)
	card.AddElement(cardcontent)
	
	'lets create a button to select this product
	Dim cardaction As HTMLElement
	cardaction = cardaction.CreateDIV("").AddClass("card-action center-align")
	Dim button As HTMLElement
	button = button.CreateBUTTON($"${compID}${sID}select"$).MaterialWavesEffect(True).MaterialWavesLight(True).AddClass("btn")
	button.AddContent(sCaption)
	MashPlugIns.MaterialUseTheme(sThemeName,button)
	'when we click this get the product id selected
	'JavaCalls.Add(button.AddChildClickEvent(compID,button.ID,sID))
	button.AddOnClickEventProperty(compID,sID)
	cardaction.AddElement(button)
	card.AddElement(cardaction)
	'add card to the article
	article.AddElement(card)
	Return article
End Sub

'a price table can have a variety of products
Sub AddProduct(ID As String, Name As String, Currency As String, Price As String, Subscription As String, Description As String, ButtonCaption As String, ThemeName As String)
	'create a map to store the products
	Dim product As Map = CreateMap("id":ID, "name":Name, "currency":Currency, "price":Price,"sub":Subscription, "description":Description,"theme":ThemeName, "caption":ButtonCaption)
	'store empty items
	Dim piList As List
	piList.Initialize
	productitems.Put(ID,piList)
	products.Put(ID,product)
End Sub

Sub Clear
	products.Initialize
	productitems.Initialize
	JavaCalls.Initialize
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	JQueryExecute(script)
End Sub

'refresh the contents of the list
Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	JQueryExecute(script)
End Sub

Sub HTML As String
	MashPlugIns.MaterialUseTheme(Theme,Element)
	'leave this true for proper alignment
	Element.MaterialWavesEffect(True).MaterialHoverable(Hoverable)
	Element.MaterialVisibility(Visibility)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	
	'lets build the component
	Element.AddClass("plans-container")
	For Each strProduct As String In products.Keys
		Dim productMap As Map = products.Get(strProduct)
		Dim productIT As HTMLElement = RenderProduct(productMap)
		Element.AddElement(productIT)
	Next
	Return Element.html
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.initialize
	Page = InternalPage
	compID = ID.tolowercase
	WavesEffect = False
	WavesType = ""
	WavesCircle = False
	ZDepth = ""
	Enabled = True
	products.Initialize
	productitems.initialize
	Element = Element.CreateSECTION(compID)
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compID))
End Sub