﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public compid As String
	Private Element As HTMLElement
	Public Visibility As String
	Public ZDepth As String
	Public Enabled As Boolean
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private sTheme As String
	Public Value As String
	Public Small As Boolean
	Private ShowToolTip As Boolean
	Private Overlay As Boolean
	Private Striped As Boolean
	Private bStacked As Boolean
	Private pList As List
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	Page = InternalPage
	compid = ID
	JavaCalls.Initialize
	Element.Initialize(compid,"div").AddClass("progressbar")
	Enabled = True
	Visibility= ""
	ZDepth = ""
	sTheme = ThemeName
	Small = False
	ShowToolTip = False
	Overlay = False
	Striped = False
	pList.initialize
	MashPlugIns.AddExternalStyle("pstacked","position: absolute; overflow: hidden; clip: rect(0, 0, 0, 0); width: 1px; height: 1px; margin: -1px; padding: 0; border: 0;")
End Sub

Sub AddProgress(pPercentage As String, pTheme As String)
	If pPercentage.EndsWith("%") Then pPercentage = pPercentage.Replace("%","")
	Dim pChild As HTMLElement
	pChild = pChild.CreateDIV("").AddClass("progress-bar").AddStyleAttribute("width",pPercentage & "%").ApplyStyle("border-radius: 0;")
	pChild.MaterialUseTheme(pTheme)
	pChild.CreateSPAN("").AddClass("pstacked").AddContent(pPercentage & "%").pop
	pList.Add(pChild.HTML)
	bStacked = True
End Sub

Sub HTML As String
	Element.AddProperty("data-value",Value)
	Element.MaterialVisibility(Visibility)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialEnable(Enabled)
	Element.AddClassOnCondition(Small,"progressbar-small")
	Element.AddClassoncondition(Striped,"progress-striped")
	
	If bStacked = False Then	
		Dim pbvalue As HTMLElement
		pbvalue = pbvalue.CreateDIV($"${compid}value"$).AddClass("progressbar-value")
		pbvalue.materialusetheme(sTheme)
		pbvalue.AddClassOnCondition(ShowToolTip,"tooltip-button")
		pbvalue.AddAttributeOnCondition(ShowToolTip,"title","")
		pbvalue.AddAttributeOnCondition(ShowToolTip, "data-original-title", Value & "%")
		Dim outcome As Double = MashPlugIns.val(Value) * 10
		pbvalue.AddStyleAttribute("width", $"${outcome}px"$)
		If Overlay = True Then pbvalue.CreateDIV("").AddClass("progress-overlay").pop
		Dim pblabel As HTMLElement
		pblabel = pblabel.CreateDIV($"${compid}label"$).AddClass("progress-label").AddContent(Value & "%").ApplyStyle("font-size:14px")
		pbvalue.AddElementoncondition(Not(Small),pblabel)
		Element.AddElement(pbvalue)
	Else
		Element.RemoveAttribute("data-value").ApplyStyle("border-radius: 0;")
		Element.AddContentList(pList)
	End If
	Return Element.html
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(Page,compid,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	If MashPlugIns.Debug = True Then
		Element.VerifyJavaScript(JavaCalls)
		Element.VerifyHTML(HTML)
		Page.ws.Eval(script, Array As String(compid))
	Else
		Page.ws.Eval(script, Array As String(compid))
	End If
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compid = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compid = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub


