﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Public Theme As String
	Public Enabled As Boolean
	Public Visibility As String
	Public ZDepth As String
	Private Projects As Map
	Private ul As HTMLElement
	Public Title As String
	Public SubTitle As String
	Private Categories As Map
	Public HeaderIcon As String
	Private projectLine As HTMLElement
	Private progress As Map
	Public SparkLineChartType As String
	Public SparkLineHeight As String
	Public SparkLineFillColor As String
	Public SparkLineColor As String 
	Type SparkLineChartTypeObj(Bar As String, Line As String)
	Public EnumSparkLineType As SparkLineChartTypeObj
	Private CategoryLinks As Map
	Public SparkLineColorCode As Boolean
	Private add As HTMLElement
	Public Pulse As Boolean
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.Initialize
	Page = InternalPage
	compID = ID.tolowercase
	ZDepth = ""
	Theme = ThemeName
	Projects.initialize
	Categories.initialize
	progress.initialize
	'spark lines type
	SparkLineChartType = "line"
	SparkLineHeight = "50"
	SparkLineFillColor = ""
	EnumSparkLineType.Initialize 
	EnumSparkLineType.Bar = "bar"
	EnumSparkLineType.Line = "line"
	SparkLineColor = MashPlugIns.ABMGetColor(ABM.COLOR_LIGHTBLUE,"")
	CategoryLinks.initialize
	SparkLineColorCode = True
	Title = "Projects"
	SubTitle = MashPlugIns.LongDateToday
	Pulse = True
	HeaderIcon = "mdi-file-folder"
	ul = ul.CreateUL(compID)
End Sub

Sub SparkLineSetColor(sColor As String, sIntensity As String)
	SparkLineColor = MashPlugIns.ABMGetColor(sColor,sIntensity)
End Sub

'add categories for the colors for each task
Sub AddCategory(categoryID As String, categoryName As String, categoryColor As String)
	Dim catM As Map
	catM.Initialize
	catM.Put("name",categoryName)
	catM.Put("color", categoryColor)
	Categories.Put(categoryID,catM)
End Sub

Sub AddProgress(projectID As String, progressList As List)
	progress.Put(projectID, progressList)
End Sub

'clear the contents of the issues
Sub Clear
	Categories.Initialize
	Projects.Initialize
	JavaCalls.Initialize
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = ul.MvFromList(JavaCalls,"")
	JQueryExecute(script)
End Sub

'refresh the contents of the list
Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = ul.MvFromList(JavaCalls,"")
	JQueryExecute(script)
	If Pulse = True Then JQueryExecute(add.JQueryAnimate(MashPlugIns.Anime.Attention_Seekers_pulse,True,""))
	'add the sparklines for each project
	For Each strProgress As String In progress.Keys
		'projectLine = projectLine.CreateDIV($"${compID}${projectID}progress"$)
		Dim projProgress As List = progress.Get(strProgress)
		Dim sparkLine As MashSparkLine
		'get the category color and asign it
		If SparkLineColorCode = True Then
			SparkLineColor = CategoryLinks.Get(strProgress)
			SparkLineSetColor(SparkLineColor,"")
		End If
		sparkLine.Initialize(Page,$"${compID}${progress}data"$)
		sparkLine.SetPoints(projProgress)
		sparkLine.ChartType = SparkLineChartType
		sparkLine.LineOptions.Height = SparkLineHeight
		sparkLine.LineOptions.FillColor = SparkLineFillColor
		sparkLine.BarOptions.BarHeight = SparkLineHeight
		sparkLine.BarOptions.BarColor = SparkLineColor
		sparkLine.LineOptions.LineColor = SparkLineColor
		sparkLine.RenderTo($"${compID}${strProgress}progress"$)
	Next
End Sub


Sub AddProject(projectID As String, projectName As String, projectCategory As String, projectOwner As String)
	Dim Li As HTMLElement
	Li = Li.CreateLI($"${compID}${projectID}"$).AddClass("collection-item dismissable").ApplyStyle("padding:20px").addcursor
	'JavaCalls.Add(Li.AddChildClickEvent(compID,Li.id,projectID))
	Li.AddOnClickEventProperty(compID,projectID)
	Dim row As HTMLElement
	row = row.CreateDIV("").AddClass("row")
	Dim col As HTMLElement
	col = col.CreateDIV("").AddClass("col s12 m6 l6")
	Dim ptitle As HTMLElement
	ptitle = ptitle.CreateP("").AddClass("collections-title").AddContent(projectName)
	ptitle.ApplyStyle("font-size:1.0rem;padding:0;margin:0;font-weight:500")
	Dim pOwner As HTMLElement
	pOwner = pOwner.CreateP("").AddClass("collections-content").AddContent(projectOwner)
	pOwner.ApplyStyle("font-size:0.9rem;padding:0;margin:0;font-weight:400")
	'consolidate items
	col.AddContent(ptitle.HTML)
	col.AddContent(pOwner.HTML)
	row.AddContent(col.HTML)
	'add the category
	Dim catColor As String = ABM.COLOR_LIGHTBLUE
	Dim catName As String = projectCategory
	If Categories.ContainsKey(projectCategory) Then
		Dim catMap As Map = Categories.Get(projectCategory)
		catColor = catMap.Get("color")
		catName = catMap.Get("name")
	End If
	Dim cols3 As HTMLElement
	cols3 = cols3.CreateDIV("").AddClass("col s12 m3 l3")
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("task-cat").AddContent(catName)
	span.ApplyStyle("padding:2px 4px;color:#fff;font-weight:300")
	span.ApplyStyle("font-size:0.8rem;-webkit-border-radius:2px;-moz-border-radius:2px;border-radius:2px;background-clip:padding-box")
	'margin-left:37px;
	'save the categorycolor link for this project
	CategoryLinks.Put(projectID,catColor)
	span.AddClass(catColor)	
	cols3.AddContent(span.HTML)
	row.AddContent(cols3.HTML)
	'add the chart section to show the progress
	Dim colspline As HTMLElement
	colspline = colspline.CreateDIV("").AddClass("col s12 m3 l3")	
	'will show the project line here
	projectLine = projectLine.CreateDIV($"${compID}${projectID}progress"$)
	colspline.AddContent(projectLine.HTML)
	row.AddContent(colspline.HTML)
	'add row to the list item
	Li.AddContent(row.HTML)
	'add the list item to the projects list
	Projects.Put(projectID,Li.HTML)
End Sub


Sub HTML As String
	ul.AddClass("collection")
	ul.MaterialEnable(Enabled).MaterialHoverable(Hoverable)
	ul.MaterialZDepth(ZDepth)
	ul.MaterialVisibility(Visibility)
	'build the header
	Dim li As HTMLElement
	li = li.createli("").AddClass("collection-item avatar").ApplyStyle("height:auto;padding-top:22px")
	MashPlugIns.MaterialUseTheme(Theme,li)
	Dim i As HTMLElement
	i = i.CreateI("").MaterialBuildIcon(HeaderIcon,"").AddClass("circle").ApplyStyle("font-size:28px")
	MashPlugIns.MaterialUseTheme(Theme,i)
	i.MaterialZDepth(ABM.ZDEPTH_1)
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("collection-header").AddContent(Title).ApplyStyle("font-size:1.14rem;font-weight:500")
	Dim p As HTMLElement
	p = p.CreateP("").AddContent(SubTitle)
	'add the components
	li.AddContent(i.HTML)
	li.AddContent(span.HTML)
	li.AddContent(p.HTML)
	
	'add the floating button to add tasks
	add = add.CreateA($"${compID}add"$).MaterialButtonFloating(True).MaterialWavesEffect(True).MaterialWavesLight(True)
	add.AddClass("task-add").applyStyle("position:absolute;right:10px;top:60px").AddCursor
	'JavaCalls.Add(add.AddChildClickEvent(compID,add.ID,"add"))
	add.AddOnClickEventProperty(compID,"add")
	Dim i As HTMLElement
	i = i.CreateI("").MaterialBuildIcon("mdi-content-add","")
	MashPlugIns.MaterialUseReversedTheme(Theme,i)
	add.AddContent(i.HTML)
	li.AddContent(add.html)
	ul.AddContent(li.HTML)
	
	'add each of the tasks
	For Each strKey As String In Projects.Keys
		Dim strValue As String = Projects.Get(strKey)
		ul.AddContent(strValue)
	Next
	Return ul.HTML
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return ul.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub