﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Public Element As HTMLElement
	Public ZDepth As String
	Public Visibility As String
	Public Enabled As Boolean
	Private page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private ABM As ABMaterial
	Type SlideTypeObj(issingle As String, isdouble As String)
	Public EnumSlideType As SlideTypeObj
	Public SlideType As String
	Public MinValue As String
	Public MaxValue As String
	Public FromValue As String
	Public ToValue As String
	Public StepValue As String
	Public Grid As Boolean
	Public Prefix As String
	Public Postfix As String
	Private ValuesM As Map
	Public MaxPostfix As String
	Public DecorateBoth As Boolean
	Public ValuesSeparator As String
	Public HideMinMax As Boolean
	Public HideFromTo As Boolean
	Private Theme As String
	Private Themes As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String,ThemeName As String)
	Themes.Initialize 
	Theme = ThemeName
	Dim sTheme As String = ""
	If Theme <> "" Then
		'lets build the css for this component
		Dim sbackground As String = MashPlugIns.ABMGetBackGroundColor(Theme)
		Dim style As HTMLElement
		style = style.CreateSTYLE(".irs-bar")
		style.ApplyStyle("border-top:1px solid " & sbackground)
		style.ApplyStyle("border-bottom:1px solid " & sbackground)
		style.ApplyStyle("background:" & sbackground)
		Themes.Add(style.BuildStyleClass)
		style = style.CreateSTYLE(".irs-bar-edge")
		style.ApplyStyle("border-top:1px solid " & sbackground)
		style.ApplyStyle("background:" & sbackground)
		Themes.Add(style.BuildStyleClass)
		style = style.CreateSTYLE(".irs-from")
		style.ApplyStyle("background:" & sbackground)
		Themes.Add(style.BuildStyleClass)
		style = style.CreateSTYLE(".irs-to")
		style.ApplyStyle("background:" & sbackground)
		Themes.Add(style.BuildStyleClass)
		style = style.CreateSTYLE(".irs-single")
		style.ApplyStyle("background:" & sbackground)
		Themes.Add(style.BuildStyleClass)
		style = style.CreateSTYLE(".irs-grid-pol")
		style.ApplyStyle("background:" & sbackground)
		Themes.Add(style.BuildStyleClass)
		sTheme = style.MvFromList(Themes,CRLF)	
	Else
		sTheme = ""
	End If
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,sTheme)
	page = InternalPage
	JavaCalls.Initialize
	compID = ID.tolowercase
	Enabled = True
	ZDepth = ""
	Visibility = ""
	Element.Initialize(compID,"div")
	EnumSlideType.Initialize 
	EnumSlideType.isdouble = "double"
	EnumSlideType.issingle = "single"
	SlideType = EnumSlideType.issingle
	MinValue = ""
	MaxValue = ""
	FromValue = ""
	ToValue = ""
	StepValue = ""
	Grid = False
	Prefix = ""
	Postfix=""
	ValuesM.Initialize
	MaxPostfix="" 
	DecorateBoth = False
	ValuesSeparator = ""
	HideMinMax = False
	HideFromTo = False
	Element.Initialize(compID,"input").SetTYPE("text").SetNAME(compID).SetVALUE("")
End Sub

private Sub BuildValues() As String
	Dim sb As StringBuilder
	sb.Initialize 
	'sb.Append("[")
	For Each strV As String In ValuesM.Keys
		sb.Append(strV).Append(",")
	Next
	MashPlugIns.RemDelimSB(",",sb)
	'sb.Append("]")
	Return sb.tostring
End Sub

Public Sub AddValue(sValue As String) As MashRangeSlider
	ValuesM.put(sValue,sValue)
	Return Me
End Sub

Sub HTML As String
	
	Element.MaterialVisibility(Visibility).MaterialZdepth(ZDepth).MaterialEnable(Enabled)
	Element.AddDataAttribute("type", SlideType).AddDataAttribute("min",MinValue).AddDataAttribute("max",MaxValue)
	Element.AddDataAttribute("from",FromValue).AddDataAttribute("to",ToValue).AddDataAttribute("step",StepValue)
	Element.AddDataAttribute("grid",Grid).AddDataAttribute("prefix",Prefix).AddDataAttribute("postfix",Postfix)
	Element.AddDataAttribute("disable",Not(Enabled)).AddDataAttribute("max-postfix",MaxPostfix)
	Element.AddDataAttribute("values-separator",ValuesSeparator).AddDataAttribute("hide-min-max",HideMinMax)
	Element.AddDataAttribute("decorate-both",DecorateBoth).AddDataAttribute("hide-from-to",HideFromTo)
	Dim sValues As String = BuildValues
	If sValues <> "" Then Element.AddDataAttribute("values",sValues)
	Dim options As String = $"$('#${compID}').ionRangeSlider({onChange: function (data) {
        console.log(data.from);
		b4j_raiseEvent('${compID}_change', {'value':data.from});
    }});"$
	JavaCalls.Add(options) 
	Return Element.html
End Sub

Sub Disable
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"var ${compID}slider = $('#${compID}').data("ionRangeSlider");"$)
	sb.Append($"${compID}slider.update({"disable": true});"$)
	page.ws.Eval(sb.tostring, Array As String(compID))
End Sub

Sub Enable
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"var ${compID}slider = $('#${compID}').data("ionRangeSlider");"$)
	sb.Append($"${compID}slider.update({"disable": false});"$)
	page.ws.Eval(sb.tostring, Array As String(compID))
End Sub

Sub Update(nValue As String)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"var ${compID}slider = $('#${compID}').data("ionRangeSlider");"$)
	sb.Append($"${compID}slider.update({from: ${nValue}});"$)
	page.ws.Eval(sb.tostring, Array As String(compID))
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,HTML)
	Dim script As String = Element.MvFromList(JavaCalls,"")
	page.ws.Eval(script, Array As String(compID))
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub