﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Element As HTMLElement
	Public ZDepth As String
	Public Visibility As String
	Public Hoverable As Boolean
	Public Enabled As Boolean
	Private sCaption As String
	Private page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private Theme As String
	Private sContent As String
	Public OnRight As Boolean
	Public ArrayName As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, Caption As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	page = InternalPage
	JavaCalls.Initialize
	compID = ID
	compID = ID.tolowercase
	Enabled = True
	ZDepth = ""
	Visibility = ""
	ArrayName = ""
	Hoverable = True
	OnRight = False
	sCaption = Caption
	Theme = ThemeName
	Element.Initialize(ID,"div")
	MashPlugIns.AddExternalStyle("content-box","margin-bottom: 20px;border-radius: 3px;background: #fff;padding: 20px")
	MashPlugIns.AddExternalStyle("content-box","position: relative;	border-width: 1px; border-style: solid;")
	MashPlugIns.AddExternalStyle("ribbon","position: absolute; top: -5px; left: -5px; overflow: hidden; width: 100px; height: 100px;")
	MashPlugIns.AddExternalStyle("ribbond","position: relative; z-index: 100; top: 10px; left: -30px; width: 120px; padding: 7px 0; -webkit-transform: rotate(-45deg); text-align: center;")
	MashPlugIns.AddExternalStyle("ribbond","font-size: 14px")
End Sub

Sub SetContent(Content As String) 
	sContent = Content
End Sub

Sub SetSizes(Small As Int, Medium As Int, Large As Int)
	Element.MaterialSetSizes(Small,Medium,Large)
End Sub

Sub HTML As String
	Element.ID = compID 
	Element.MaterialVisibility(Visibility).addcursor
	Element.MaterialEnable(Enabled)
	Element.ApplyStyle("float: left;position: relative;	min-height: 1px; padding-right: 10px; padding-left: 10px;box-sizing: border-box;")
	Dim child As HTMLElement
	child = child.CreateDIV("").AddClass("content-box").SetBorderColorFromTheme(Theme)
	child.MaterialHoverable(Hoverable)
	child.MaterialZdepth(ZDepth)
	Dim r As HTMLElement
	r = r.CreateDIV("").AddClass("ribbon")
	If OnRight = True Then
		MashPlugIns.AddExternalStyle("ribbon","right: -6px; left: auto; top: -6px")
	End If
	Dim r1 As HTMLElement
	r1 = r1.CreateDIV("").AddContent(sCaption).AddClass("ribbond")
	If OnRight = True Then
		MashPlugIns.AddExternalStyle("ribbond","right: -8px; left: auto; -webkit-transform: rotate(45deg);")
	End If
	r1.MaterialUseTheme(Theme)
	child.AddContent(sContent)
	r.AddElement(r1)
	child.AddElement(r)
	Element.AddElement(child)
	Element.AddOnClickEventProperty(ArrayName,Element.id)
	Return Element.html
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,HTML)
	'If ArrayName = "" Then ArrayName = compID
	'JavaCalls.Add(Element.AddChildClickEvent(ArrayName,compID,compID))
	Dim script As String = Element.MvFromList(JavaCalls,"")
	page.ws.Eval(script, Array As String(compID))
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub