﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Public Enabled As Boolean
	Public Visibility As String
	Public ZDepth As String
	Type ChartObjectType(Bar As String, Line As String, pie As String, TriState As String, discrete As String, Bullet As String, box As String)
	Public EnumChartType As ChartObjectType
	Private Element As HTMLElement
	Public ChartType As String
	Type BarOptionsType(BarHeight As String, BarWidth As String, BarSpacing As String, BarColor As String, negBarColor As String, zeroColor As String)
	Public BarOptions As BarOptionsType
	Private Points As List
	Type LineOptionsType(Width As String, Height As String, LineWidth As String, LineColor As String, FillColor As String, highlightSpotColor As String, highlightLineColor As String, minSpotColor As String, maxSpotColor As String, spotColor As String, spotRadius As String)
	Public LineOptions As LineOptionsType
	Type TriStateType(Width As String, Height As String, posBarColor As String, negBarColor As String, barWidth As String, barSpacing As String, zeroAxis As Boolean)
	Public TriStateOptions As TriStateType
	Type BulletType(targetColor As String,targetWidth As String, performanceColor As String)
	Public BulletOptions As BulletType
	Public ToolTip As String
	Public Hoverable As Boolean
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.Initialize
	Page = InternalPage
	compID = ID.tolowercase
	ZDepth = ""
	EnumChartType.Initialize 
	EnumChartType.bar = "bar"
	EnumChartType.line = "line"
	EnumChartType.pie = "pie"
	EnumChartType.tristate = "tristate"
	EnumChartType.discrete = "discrete"
	EnumChartType.bullet = "bullet"
	EnumChartType.box = "box"
	Element = Element.CreateDIV(compID)
	ChartType = EnumChartType.line
	BarOptions.Initialize
	BarOptions.BarHeight = "25"
	BarOptions.BarColor = "#C7FCC9"
	BarOptions.BarSpacing = "4"
	BarOptions.BarWidth = "7"
	BarOptions.negBarColor = "#81d4fa"
	BarOptions.zeroColor = "#81d4fa"
	Points.initialize
	LineOptions.initialize
	LineOptions.width = "100%"
	LineOptions.height = "30"
	LineOptions.lineWidth = "2"
	LineOptions.lineColor = "#E1D0FF"
	LineOptions.fillColor = "rgba(233, 30, 99, 0.4)"
	LineOptions.highlightSpotColor = "#E1D0FF"
	LineOptions.highlightLineColor = "#E1D0FF"
	LineOptions.minSpotColor = "#f44336"
	LineOptions.maxSpotColor = "#4caf50"
	LineOptions.spotColor = "#E1D0FF"
	LineOptions.spotRadius = "4"
	TriStateOptions.Initialize
	TriStateOptions.width = "100%"
	TriStateOptions.height = "25"
	TriStateOptions.posBarColor = "#B9DBEC"
	TriStateOptions.negBarColor = "#C7EBFC"
	TriStateOptions.barWidth = "7"
	TriStateOptions.barSpacing = "4"
	TriStateOptions.zeroAxis = False
	BulletOptions.Initialize
	BulletOptions.performanceColor = ""
	BulletOptions.targetColor = ""
	BulletOptions.targetWidth = "2"
End Sub

Sub HTML As String
	'create the card
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility).MaterialHoverable(Hoverable)
	Prepare
	Return Element.html
End Sub

Sub SetPoints(lPoints As List)
	Points = lPoints
End Sub

Sub Bar() As String
	Dim sPoints As String = Element.MvFromList(Points,",")	
	Dim script As String = $"$("#${compID}").sparkline([${sPoints}], {
        type: 'bar',
        height: '${BarOptions.BarHeight}',
        barWidth: ${BarOptions.BarWidth},
        barSpacing: ${BarOptions.barspacing},
        barColor: '${BarOptions.BarColor}',
        negBarColor: '${BarOptions.negbarcolor}',
        zeroColor: '${BarOptions.zerocolor}'
    });"$
	Return script
End Sub

Sub Bullet() As String
	Dim sPoints As String = Element.MvFromList(Points,",")	
	Dim script As String = $"$("#${compID}").sparkline([${sPoints}], {
        type: 'bullet',
        targetColor: '${BulletOptions.targetColor}',
        targetWidth: ${BulletOptions.targetWidth},
        performanceColor: '${BulletOptions.performanceColor}'
    });"$
	Return script
End Sub



Sub Line() As String
	Dim sPoints As String = Element.MvFromList(Points,",")
	Dim script As String = $"$("#${compID}").sparkline([${sPoints}], {
    type: 'line',
    width: '${LineOptions.Width}',
    height: '${LineOptions.height}',
    lineWidth: ${LineOptions.LineWidth},
    lineColor: '${LineOptions.linecolor}',
    fillColor: '${LineOptions.fillcolor}',
    highlightSpotColor: '${LineOptions.highlightSpotColor}',
    highlightLineColor: '${LineOptions.highlightLineColor}',
    minSpotColor: '${LineOptions.minSpotColor}',
    maxSpotColor: '${LineOptions.maxSpotColor}',
    spotColor: '${LineOptions.spotColor}',
    spotRadius: ${LineOptions.spotRadius}
	});"$
	Return script
End Sub

Sub TriState() As String
	Dim sPoints As String = Element.MvFromList(Points,",")
	Dim script As String = $"$("#${compID}").sparkline([${sPoints}], {
    type: 'tristate',
    width: '${TriStateOptions.width}',
    height: '${TriStateOptions.height}',
    posBarColor: '${TriStateOptions.posbarcolor}',
    negBarColor: '${TriStateOptions.negbarcolor}',
    barWidth: ${TriStateOptions.barwidth},
    barSpacing: ${TriStateOptions.barspacing},
    zeroAxis: ${TriStateOptions.zeroaxis}
});"$
	Return script
End Sub

Private Sub Prepare
	Select Case ChartType
	Case EnumChartType.Bar
		JavaCalls.Add(Bar)
	Case EnumChartType.Line
		JavaCalls.Add(Line)
	Case EnumChartType.pie
		JavaCalls.Add("")
	Case EnumChartType.TriState
		JavaCalls.Add(TriState)
	Case EnumChartType.Bullet
		JavaCalls.Add(Bullet)
	End Select
End Sub	

Sub RenderTo(elementID As String)
	JavaCalls.initialize
	compID = elementID
	Prepare
	Dim script As String = Element.MvFromList(JavaCalls,"")
	JQueryExecute(script)
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Dim script As String = Element.MvFromList(JavaCalls,"")
	InternalPage.ws.Eval(script, Array As String(compID))
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Null)
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub