﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Public Element As HTMLElement
	Public Theme As String
	Public Enabled As Boolean
	Public Title As String
	Public TitleIcon As String
	Public Value As String
	Public Percentage As String
	Public PercentageComment As String
	Public StatsType As String
	Public TooltipPosition As String
	Public TooltipDelay As String
	Public ToolTip As String
	Public Visibility As String
	Public WavesEffect As Boolean
	Public WavesType As String
	Public WavesCircle As Boolean
	Public ZDepth As String
	Private compID As String
	Private JavaCalls As List
	Type StatsType(increase As String, decrease As String, equal As String)
	Public EnumStatsType As StatsType
	Public ToolTip As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub


Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub


Sub SetTitle(sTitle As String) As MashStats
	Title = sTitle
	Return Me
End Sub

Sub SetTitleIcon(sTitleIcon As String) As MashStats
	TitleIcon = sTitleIcon
	Return Me
End Sub

Sub SetValue(sValue As String) As MashStats
	Value = sValue
	Return Me
End Sub

Sub SetPercentage(sPercentage As String) As MashStats
	Percentage = sPercentage & "%"
	Return Me
End Sub

Sub SetStatsType(sStatsType As String) As MashStats
	StatsType = sStatsType
	Return Me
End Sub

Sub SetComment(sPercentageComment As String) As MashStats
	PercentageComment = sPercentageComment
	Return Me
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, ThemeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	EnumStatsType.Initialize
	EnumStatsType.increase = "increase"
	EnumStatsType.decrease = "decrease"
	EnumStatsType.equal = "equal"
	Page = InternalPage
	compID = ID
	Title = ""
	TitleIcon=""
	Value=""
	Percentage=""
	PercentageComment=""
	StatsType =""
	Visibility = ""
	Enabled = True
	Theme = ThemeName
	ZDepth = ""
	Element.Initialize(ID,"div")
	WavesType = ""
	WavesCircle = False
	WavesEffect = True
	JavaCalls.initialize
End Sub

private Sub HTML As String
	Element.ID = compID
	MashPlugIns.MaterialUseTheme(Theme,Element)
	Element.MaterialEnable(Enabled)
	Element.MaterialZDepth(ZDepth)
	Element.MaterialVisibility(Visibility)
	Element.MaterialSetToolTip(TooltipPosition,TooltipDelay,ToolTip)
	Element.MaterialWavesEffect(WavesEffect)
	Element.MaterialWavesType(WavesType)
	Element.MaterialWavesCircle(WavesCircle).MaterialHoverable(Hoverable)
	Element.AddClass("card").ApplyStyle("overflow:hidden")
	Element.AddOnClickEventProperty(compID,Element.id)
	'JavaCalls.Add(Element.AddClickEvent(compID,compID))
	'define card content
	Dim ccontent As HTMLElement
	ccontent.Initialize("","div").AddClass("card-content")
	ccontent.ApplyStyle("text-align:center").ApplyStyle("padding:10px 14px")
	'ABMShared.MaterialUseTheme(Theme,ccontent)
	ccontent.AddClass(MashPlugIns.EnumAlignment.Center)
	'define the title
	Dim a As HTMLElement
	a.Initialize(compID,"a")
	a.SetElementType("p")
	a.AddClass(MashPlugIns.EnumTextAlignment.center)
	a.MaterialAddIcon(TitleIcon,"","",False,True,True,False,False,"")
	a.AddContent(Title)
	a.MaterialWavesEffect(True)
	
	'define the numbers
	Dim h4 As HTMLElement
	h4.Initialize("","h4").AddClass("card-stats-number").AddContent(Value)
	h4.ApplyStyle("font-size:1.8rem;line-height:2.0rem;margin:0.2rem 0 0.2rem 0;font-weight:500")
	h4.AddClass(MashPlugIns.EnumTextAlignment.center)
	'define the stats
	Dim details As HTMLElement
	details.Initialize("","p").AddClass("card-stats-compare")
	details.ApplyStyle("font-size:0.8rem")
	details.AddClass(MashPlugIns.EnumTextAlignment.center)
	Select Case StatsType
		Case "increase"
			details.MaterialAddIcon("mdi-keyboard_arrow_up","","",False,False,False,False,False,"position:relative;top:5px")
		Case "decrease"
			details.MaterialAddIcon("mdi-keyboard_arrow_down","","",False,False,False,False,False,"position:relative;top:5px")
	End Select
	Dim span As HTMLElement
	span.Initialize("","span")
	span.AddContent(Percentage).AddSpace.AddContent(PercentageComment)
	details.AddContent(span.HTML)
	
	'add card contents
	ccontent.AddContent(a.HTML)
	ccontent.AddContent(h4.HTML)
	ccontent.AddContent(details.HTML)
	
	'add the card content to the card
	Element.AddContent(ccontent.HTML)
	Return Element.html
End Sub


Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = MashPlugIns.MvFromList(JavaCalls,"")
	InternalPage.ws.Eval(script, Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
