﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'wrapped by Anele 'Mashy' Mbanga for ABMaterial
'anele@mbangas.com
'NB: DONT EVER USE NUMERIC MAP KEYS
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Public ABM As ABMaterial
	Private page As ABMPage
	Private compID As String
	Private table As HTMLElement
	Public IsBordered As Boolean
	Public IsResponsive As Boolean
	Public IsScrollable As Boolean
	Private IsTableEdit As Boolean
	Private Rows As Map
	Private FooterRows As Map
	Public IsSortable As Boolean
	Public Visibility As String
	Public ZDepth As String
	Public IsStriped As Boolean
	Public IsHighlight As Boolean
	Public IsCentered As Boolean
	Private IsSemantic As Boolean
	Private DataTable As String
	Private PrimaryKey As String
	Private Columns As Map
	Private IsFooTable As Boolean
	Type DataType(isemail As String,istel As String, isurl As String, isselect As String,ischkbox As String,isdate As String,istext As String, isnumeric As String, istextarea As String,ispassword As String, istime As String, isaction As String)
	Public EnumDataType As DataType
	Type ColumnType(name As String,heading As String,datatype As String,height As String, width As String,visible As Boolean,sortable As Boolean, required As Boolean, cdefault As String, options As List, checked As String, unchecked As String, valueField As String, textField As String,outFormat As String, searchable As Boolean)
	Private JavaOptions As List
	Private FooShowToggle As Boolean
	Private FooPaging As Boolean
	Private FooSorting As Boolean
	Private FooFiltering As Boolean
	Private FooEditing As Boolean
	Private IsDataTable As Boolean
	Private JavaCalls As List
	Private IsEditableTableWidget As Boolean
	Type TableType(DefaultTable As String, TableEdit As String, Semantic As String, FooTable As String, DataTable As String, EditableTableWidget As String)
	Public EnumTableType As TableType
	Public TableType As String
	Public DataTableColumnReorder As Boolean
	Public DataTableAutoFill As Boolean
	Public DataTableFixedHeader As Boolean
	Public DataTableKeys As Boolean
	Public DataTableSelect As Boolean
	Public pElement As HTMLElement
	Public DataTableSaveState As Boolean
	Public DataTablePageSize As Int
	Public DataTableAltEditor As Boolean
	Private NextSequence As Int
	Public MaterialControls As Boolean
	Public UseInputControls As Boolean
	Public SelectMonths As Boolean
	Public SelectYears As String
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Public Sub Initialize(InternalPage As ABMPage, id As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, id,"")
	NextSequence = 0
	DataTableColumnReorder = True
	DataTableAutoFill = True
	DataTableFixedHeader = True
	SelectMonths = True
	SelectYears = 15
	DataTableSelect = True
	DataTableSaveState = True
	DataTableAltEditor = True
	MaterialControls = False
	UseInputControls = True
	DataTablePageSize = 10
	DataTableKeys = True
	EnumTableType.Initialize
	EnumTableType.DataTable = "DataTable"
	EnumTableType.editableTableWidget = "editableTableWidget"
	EnumTableType.FooTable = "FooTable"
	EnumTableType.Semantic = "Semantic"
	EnumTableType.TableEdit = "TableEdit"
	TableType = EnumTableType.DefaultTable
	page = InternalPage
	compID = id
	JavaCalls.initialize
	FooShowToggle = False
	FooPaging = False
	FooSorting = False
	FooEditing = False
	IsTableEdit = False
	JavaOptions.Initialize
	EnumDataType.Initialize
	EnumDataType.ischkbox = "checkbox"
	EnumDataType.isdate = "date"
	EnumDataType.isemail = "email"
	EnumDataType.isselect = "select"
	EnumDataType.istext = "text"
	EnumDataType.isnumeric = "number"
	EnumDataType.istextarea = "textarea"
	EnumDataType.ispassword = "password"
	EnumDataType.istime = "time"
	EnumDataType.isaction = "action"
	EnumDataType.istel = "tel"
	EnumDataType.isurl = "url"
	IsScrollable = False
	IsStriped = False
	IsResponsive = True
	IsHighlight = True
	IsCentered = False
	IsBordered = True
	IsHighlight = True
	IsSortable = True
	ZDepth = ""
	Rows.Initialize
	FooterRows.initialize
	IsSemantic = False
	If IsHighlight = True Then IsStriped = False
	DataTable = ""
	PrimaryKey = ""
	IsFooTable = False
	Columns.initialize
	table.Initialize(compID & "tbl","table")
	pElement.Initialize(compID,"div").AddClass("container")
	IsDataTable = False
End Sub

'important
Sub SetTableType(tblType As String)
	IsDataTable = False
	IsEditableTableWidget = False
	IsFooTable = False
	IsSemantic = False
	IsTableEdit = False
	Select Case tblType
		Case EnumTableType.DataTable
			IsDataTable = True
		Case EnumTableType.editableTableWidget
			IsEditableTableWidget = True
		Case EnumTableType.FooTable
			IsFooTable = True
		Case EnumTableType.Semantic
			IsSemantic = True
		Case EnumTableType.TableEdit
			IsTableEdit = True
	End Select
End Sub


'add javascriptcode
private Sub AddOptions(sOption As String)
	JavaOptions.Add(sOption)
End Sub

'add a column to the table
Sub AddColumn(cName As String, cHeading As String, cDataType As String, cVisible As Boolean, cSortable As Boolean, cRequired As Boolean, bSearchable As Boolean)
	cName = cName.Trim.tolowercase
	'create a new column
	Dim nOptions As List
	nOptions.Initialize
	Dim eachCol As ColumnType
	eachCol.initialize
	eachCol.datatype = cDataType
	eachCol.heading = cHeading
	eachCol.name = cName
	eachCol.sortable = cSortable
	eachCol.visible = cVisible
	eachCol.width = ""
	eachCol.required = cRequired
	eachCol.cdefault = ""
	eachCol.options = nOptions
	eachCol.checked = ""
	eachCol.unchecked = ""
	eachCol.height = 48
	eachCol.valueField = ""
	eachCol.textField = ""
	eachCol.outFormat = ""
	eachCol.searchable = bSearchable
	If IsSemantic = True Then eachCol.height = ""
	If IsFooTable = True Then eachCol.height = ""
	'If IsTableEdit = True Then eachCol.height = ""
	Columns.Put(cName,eachCol)
End Sub


'only for visible columns
private Sub DataTableBuildColumns() As String
	Dim colPos As Int = -1
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each coltype As ColumnType In Columns.values
		colPos = colPos + 1
		Dim cTitle As String = coltype.heading
		Dim eColumn As String = $"{defaultContent:'${coltype.cdefault}',targets:${colPos},visible:${coltype.visible},searchable:${coltype.searchable},orderable:${coltype.sortable},name:"${coltype.name}",title:"${cTitle}"},"$
		sb.Append(eColumn)
	Next
	sb = MashPlugIns.RemDelimSB(",",sb)
	sb.Append("]")
	Return sb.tostring
End Sub


'set a select column details i.e. value field and textfield and contents
Sub SetSelectOptions(sFieldName As String, cDefault As String, sValueField As String, sTextField As String, values As Map)
	sFieldName = sFieldName.tolowercase
	If Columns.ContainsKey(sFieldName) Then
		'get the column definition
		Dim colDef As ColumnType = Columns.Get(sFieldName)
		Dim oList As List = colDef.Options
		'indicate the value and textfield for the column
		colDef.valuefield = sValueField
		colDef.textfield = sTextField
		colDef.cdefault = cDefault
		'add to the select list all items provided
		For Each strKey As String In values.Keys
			Dim strValue As String = values.Get(strKey)
			'define the column combo properties
			Dim item As String = $"{${sTextField}: "${strValue}", ${sValueField}: ${strKey}}"$
			If IsTableEdit = True Then
				Dim item As String = $""${strKey}":"${strValue}""$
			End If
			'update the list with the new item
			If oList.IndexOf(item) = -1 Then oList.Add(item)
		Next
		'update the items property of the column definition
		colDef.options = oList
		'update the master column definitions
		Columns.Put(sFieldName,colDef)
	Else
		Log("SetSelectOptions: " & sFieldName & " not found!")
	End If
End Sub

'set the options for the checkbox column
Sub SetCheckOptions(cName As String, checked As String, unchecked As String)
	cName = cName.Trim.ToLowerCase
	If Columns.ContainsKey(cName) Then
		Dim colDef As ColumnType = Columns.Get(cName)
		colDef.checked = checked
		colDef.unchecked = unchecked
		Columns.Put(cName,colDef)
	End If
End Sub

Sub SetFormatOptions(cName As String, outFormat As String)
	cName = cName.Trim.ToLowerCase
	If Columns.ContainsKey(cName) Then
		Dim colDef As ColumnType = Columns.Get(cName)
		colDef.outFormat = outFormat
		Columns.Put(cName,colDef)
	End If
End Sub

private Sub BuildJavaOptions() As String
	Return table.MvFromList(JavaOptions,CRLF)
End Sub

private Sub TableEditScripts() As String
	Dim sb As String = $"$('#${compID}').Tabledit({
callBack: '${compID}',
url: './${DataTable}.json',
hideIdentifier: true,
rowIdentifier: 'data-id',
columns: {
identifier: [0, '${PrimaryKey}'],                    
editable: [${TableEditBuildEditColumns}]
}
});
$('.datepicker').pickadate();
"$
	Return sb
	'$('.timepicker').pickatime({ default: 'now', fromnow: 0, twelvehour: false, donetext: 'OK', cleartext: 'Clear', canceltext: 'Cancel', autoclose: true, ampmclickable: true, aftershow: function(){}});
End Sub

private Sub FooTableScripts() As String
	Dim sb As String = $"$(function(){
$('#${compID}').footable();
});"$
	Return sb
End Sub


'altEditor: ${DataTableAltEditor},
'Select: 'single',
'Select: ${DataTableSelect},
			
private Sub DataTableScripts() As String
	Dim dataSet As String
	If UseInputControls = True Then
		dataSet = DataTableBuildDataSetInputs
		Dim script As String = $"var dataSet = ${dataSet};var dataColumns = ${DataTableBuildColumns};var table = $('#${compID}tbl').DataTable();table.destroy();$('#${compID}tbl').DataTable({data: dataSet, columns: dataColumns, dom: 'rtip',deferRender: true,colReorder: ${DataTableColumnReorder},stateSave: ${DataTableSaveState},keys: ${DataTableKeys},fixedHeader: ${DataTableFixedHeader},
		autoFill: ${DataTableAutoFill}});"$
	Else
		dataSet = DataTableBuildDataSet
		Dim script As String = $"var dataSet = ${dataSet};var dataColumns = ${DataTableBuildColumns};var table = $('#${compID}tbl').DataTable();var domIT = '<"top"Bfr<"clear">>t<"bottom"ip<"clear">>';table.destroy();$('#${compID}tbl').DataTable({data: dataSet, columns: dataColumns, dom: 'Bfrtip' ,buttons: ['copyHtml5',	'csvHtml5','excelHtml5','pdfHtml5','print'],deferRender: true,colReorder: ${DataTableColumnReorder},stateSave: ${DataTableSaveState},keys: ${DataTableKeys},fixedHeader: ${DataTableFixedHeader},
		autoFill: ${DataTableAutoFill}});"$
	End If
	Return script
End Sub

Sub DataTableFixLeftColumns(colIndex As Int)
	If colIndex < 0 Then Return
	Dim script As String = $"var table = $('#${compID}tbl').DataTable({fixedColumns:{ leftColumns: ${colIndex}});"$
	page.ws.Eval(script, Null)
End Sub

Sub DataTableFixRightColumns(colIndex As Int)
	If colIndex < 0 Then Return
	Dim script As String = $"var table = $('#${compID}tbl').DataTable({fixedColumns:{ rightColumns: ${colIndex}});"$
	page.ws.Eval(script, Null)
End Sub

'group the table by
private Sub DataTableGroupByColumnIndex(colIndex As Int, displayLength As Int)
	Dim script As String = $"var table = $('#${compID}tbl').DataTable({
        "columnDefs": [
            { "visible": false, "targets": 2 }
        ],
        "order": [[ 2, 'asc' ]],
        "displayLength": ${displayLength},
        "drawCallback": function ( settings ) {
            var api = this.api();
            var rows = api.rows( {page:'current'} ).nodes();
            var last=null;
 
            api.column(2, {page:'current'} ).data().each( function ( group, i ) {
                if ( last !== group ) {
                    $(rows).eq( i ).before(
	'<tr class="group"><td colspan="5">'+group+'</td></tr>'
                    ); 
                    last = group;
                }
            } );
        }
    } ); 
    // Order by the grouping
    $('#${compID}tbl tbody').on( 'click', 'tr.group', function () {
        var currentOrder = table.order()[0];
        if ( currentOrder[0] === 2 && currentOrder[1] === 'asc' ) {
            table.order( [ 2, 'desc' ] ).draw();
        }
        else {
            table.order( [ 2, 'asc' ] ).draw();
        }
    } );"$
	page.ws.Eval(script, Null)
End Sub

private Sub SemanticScripts() As String
	Dim sb As String = $"$(function(){
	$('#${compID}').editableRecord({
        idName: '${PrimaryKey}',
		createUrl: './${DataTable}.json',
        updateUrl: './${DataTable}.json',
        saveUrl: './${DataTable}.json',
        deleteUrl: './${DataTable}.json',
		callBack: '${compID}'
    });
	${BuildJavaOptions}
	$('.datepicker').pickadate();
	});"$
	Return sb
End Sub

'set the primarykey and the file to save records to
Sub SetDatabase(mPrimaryKey As String, mDataTable As String)
	DataTable = mDataTable
	PrimaryKey = mPrimaryKey
End Sub

'clear the table
Sub Clear
	Rows.initialize
End Sub

'clear the footer
Sub ClearFooter
	FooterRows.initialize
End Sub

'add a row to the table
Sub AddRow(id As String, rowData As List)
	Dim crow As Int = id
	'lets store the values for the next available row
	If crow > NextSequence Then NextSequence = crow
	Rows.Put(id,rowData)
End Sub


private Sub DataTableBuildDataSet() As String
	Dim lRows As List
	lRows.initialize
	Dim colPos As Int = -1
	Dim rowpos As Int = 0
	For Each rowKey As String In Rows.keys
		rowpos = rowpos + 1
		Dim rowData As List = Rows.get(rowKey)
		'add each column
		colPos = -1
		Dim column As List
		column.initialize
		For Each col As String In Columns.Keys
			colPos = colPos + 1
			Dim colDef As ColumnType = Columns.GetValueAt(colPos)
			If colDef.visible = True And colDef.name <> "actions" Then
				Dim td As HTMLElement = GetColumn("div",rowpos,colPos,colDef)
				'td.AddProperty("tabindex",colPos+1)
				Dim colData As String = ""
				If rowData.Size-1 >= colPos Then colData = rowData.Get(colPos)
				td.addcontent(colData)
				column.Add(td.HTML)
			End If
		Next
		'let's add update/delete buttons
		Dim td As HTMLElement
		'ensure everything displays in one line
		td = td.CreateDIV("").ApplyStyle("white-space:nowrap;").AddProperty("data-column","actions").AddProperty("data-id",rowKey)
		td.CreateBUTTON($"${compID}update"$).AddProperty("data-id",rowKey).AddClass("btn btn-primary btn-xs").AddClass("btn-floating blue").MaterialAddIconSimple("mdi-content-save","whitetransparent").Pop
		td.CreateBUTTON($"${compID}delete"$).AddProperty("data-id",rowKey).AddClass("btn btn-danger btn-xs").AddClass("btn-floating red").MaterialAddIconSimple("mdi-action-delete","whitetransparent").Pop
		column.Add(td.HTML)
		lRows.Add(column)
	Next
	Dim output As String = MashPlugIns.List2JSON(lRows)
	Return output
End Sub

private Sub DataTableBuildDataSet1() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each rowKey As String In Rows.Keys
		Dim rowList As List = Rows.Get(rowKey)
		Dim rowData As StringBuilder
		rowData.Initialize
		rowData.Append("[")
		For Each rowpart As String In rowList
			rowpart = MashPlugIns.InQuotes(rowpart)
			rowData.Append(rowpart).Append(",")
		Next
		rowData = MashPlugIns.RemDelimSB(",",rowData)
		rowData.Append("],")
		sb.Append(rowData)
	Next
	sb = MashPlugIns.RemDelimSb(",",sb)
	sb.Append("]")
	Return sb.tostring
End Sub

'add a footer row
Sub AddFooterRow(rowData As List)
	Dim nextFooter As Int = FooterRows.size
	FooterRows.Put("r" & nextFooter,rowData)
End Sub



private Sub MaterializeInitialize As String
	Dim sb As List
	sb.initialize
	sb.Add($"$("select").material_select();"$)
	sb.Add($"$("select").not(".disabled").material_select();"$)
	sb.Add($"$('.datepicker').pickadate({format:'yyyy-mm-dd',formatSubmit: 'yyyy-mm-dd',selectMonths: ${SelectMonths}, selectYears: ${SelectYears}});"$)
	sb.Add($"$("textarea").trigger('autoresize');"$)
	sb.Add("$('.timepicker').pickatime({default:'now',fromnow:0,ampmclickable: true,twelvehour:false,donetext:'OK',cleartext:'Clear',canceltext:'Cancel',autoclose:false});")
	sb.Add("Materialize.updateTextFields();")
	Return pElement.MvFromList(sb,"")
End Sub

'prepare the table for entry
Private Sub Prepare() As String
	'add the actions column
	AddColumn("Actions","Actions",EnumDataType.isaction,True,False,False,False)
	pElement.Initialize(compID,"div").AddClass("container")
	pElement.ApplyStyle("width:1270px;padding:20px;background-color:#fff;border:1px solid #ccc;border-radius:5px;margin-top:25px;box-sizing:border-box;")
	table.Initialize(compID & "tbl","table")
	table.AddClass(ZDepth)
	table.AddClassOncondition(IsBordered,"bordered").AddClassOncondition(IsStriped,"striped").AddClassOncondition(IsHighlight,"highlight")
	table.AddClassOncondition(IsCentered,"centered").AddClassOncondition(IsResponsive,"responsive-table")
	'div.AddClassOncondition(IsSortable,"sortable")
	'div.AddClassOncondition(IsInteractive,"tableinteractive")
	'div.AddClassOncondition(UsingQueriesToSort,"noautosort")
	If IsTableEdit = True Then
		table.AddClass("table").AddClass("table-hover")
		table.AddClass("u-full-width").AddClass("demo")
		'remove material based settings
		RemoveMaterialClasses
		JavaCalls.Add(TableEditScripts)
	End If
	If IsSemantic = True Then
		table.AddClassOnCondition(IsSemantic,"ui table")
		'remove material based settings
		RemoveMaterialClasses
		JavaCalls.Add(SemanticScripts)
	End If
	If IsFooTable = True Then
		table.AddClass("table")
		table.addproperty("data-show-toggle",FooShowToggle)
		table.AddProperty("data-paging",FooPaging)
		table.AddProperty("data-sorting", FooSorting)
		table.AddProperty("data-filtering",FooFiltering)
		table.AddProperty("data-editing", FooEditing)
		table.AddProperty("data-state", FooEditing)
		'remove material based settings
		RemoveMaterialClasses
		JavaCalls.Add(FooTableScripts)
	End If
	If IsDataTable = True Then
		RemoveMaterialClasses
		table.AddClass("display").addproperty("cellspacing","0").AddProperty("width","100%")
		table.AddProperty("data-page-length",DataTablePageSize)
		table.AddClassOnCondition(IsResponsive,"responsive-table")
		table.AddClassOncondition(IsStriped,"table-striped")
		table.AddClass("dataTable")
		JavaCalls.Add(DataTableScripts)
		'JavaCalls.Add(MashPlugIns.JQueryAddClassScript($"${compID}_wrapper"$,ZDepth))
		'add extra init scripts
		Dim script As String = $"$(".dropdown-content.select-dropdown li").on("click", function() {var that = this; setTimeout(function(){ if($(that).parent().hasClass('active')){ $(that).parent().removeClass('active');$(that).parent().hide();}},100);});"$
		JavaCalls.Add(script)
		'script = $"$('#${compID}tbl tbody').on( 'click', 'tr', function () {
		'	$(this).toggleClass('selected');
		'} );"$
		'JavaCalls.Add(script)
		'add onclick event for the add button
		If UseInputControls = True Then
			JavaCalls.Add(table.JQueryOnClickEvent($"${compID}add"$,DataTableCreateInsertRowInputs))
			JavaCalls.Add(table.JQueryOnDocumentClickEvent($"${compID}insert"$,DataTableCreateInsertSaveInputs))
			JavaCalls.Add(table.JQueryOnDocumentClickEvent($"${compID}update"$,DataTableCreateUpdateSaveInputs))
			JavaCalls.Add(table.JQueryOnDocumentClickEvent($"${compID}delete"$,DataTableCreateDeleteInputs))
			JavaCalls.Add($"$("input[type='checkbox']").on('change', function(){$(this).toggleClass('checked');if ($(this).hasClass('checked')) { $(this).attr('checked', 'checked'); $(this).attr('value', '1');} else { $(this).removeAttr('checked'); 
				$(this).attr('value', '0');}});"$)
		Else
			JavaCalls.Add(table.JQueryOnClickEvent($"${compID}add"$,DataTableCreateInsertRow))
			JavaCalls.Add(table.JQueryOnDocumentClickEvent($"${compID}insert"$,DataTableCreateInsertSave))
			JavaCalls.Add(table.JQueryOnDocumentClickEvent($"${compID}update"$,DataTableCreateUpdateSave))
			JavaCalls.Add(table.JQueryOnDocumentClickEvent($"${compID}delete"$,DataTableCreateDelete))
		End If
		JavaCalls.Add(table.JQueryOnDocumentClickEvent($"${compID}cancel"$,DataTableCreateCancel))
		If MaterialControls = True Then JavaCalls.Add(MaterializeInitialize)
	End If
	
	'lets add an add button to the container (experimental)
	Dim div As HTMLElement
	div = div.CreateDIV("").AlignRight
	div.AddChildElement("button").AddProperty("data-id","nr").AddProperty("data-column","button").MaterialAddIconSimple("mdi-content-add","whitetransparent").AddProperty("type","button").AddProperty("name",$"${compID}add"$).AddProperty("id",$"${compID}add"$).AddClass("btn btn-info btn-xs").AddClass("btn-large btn-floating light-blue").Pop
	
	table.AddElement(div).AddLineBreak
	'add alert message
	Dim am As HTMLElement
	am = am.creatediv($"${compID}alert_message"$)
	table.AddElement(am).addlinebreak
	table.AddContent(BuildBody)
		
	pElement.AddElement(table).MaterialZDepth(ZDepth)
	Return pElement.html
End Sub

'the cancel code for the entry
private Sub DataTableCreateCancel() As String
	'lets get the row the button is clicked
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"var tr = $(this).closest("tr");tr.remove();$('#${compID}alert_message').html('');$('#${compID}add').show();"$)
	Return sb.tostring
End Sub


private Sub DataTableCreateDelete() As String
	'lets get the row the button is clicked
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"var item = {};var divs = $(this).closest("tr").find("div");$.each(divs, function (index, data) {var id = $(this).attr('data-id');var cl = $(this).attr('data-column');var tx = $(this).text();item ["id"] = id;item [cl] = tx;});delete item.actions;var entry = JSON.stringify(item);"$)
	'raise this outside the app
	sb.Append($"b4j_raiseEvent('${compID}_delete', {'value':entry});"$)
	Return sb.tostring
End Sub

private Sub DataTableCreateDeleteInputs() As String
	'lets get the row the button is clicked
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"${DataTableGetRow}
    $('#${compID}alert_message').html('');"$)
	'raise this outside the app
	sb.Append($"b4j_raiseEvent('${compID}_delete', {'value':entry});"$)
	Return sb.tostring
End Sub


'code to when update is clicked
private Sub DataTableCreateUpdateSave() As String
	'lets get the row the button is clicked
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"var item = {};var divs = $(this).closest("tr").find("div");$.each(divs, function (index, data) {var id = $(this).attr('data-id');var cl = $(this).attr('data-column');var tx = $(this).text();item ["id"] = id;item [cl] = tx;});delete item.actions;var entry = JSON.stringify(item);$('#${compID}alert_message').html('');"$)	
	'raise this outside the app
	sb.Append($"b4j_raiseEvent('${compID}_update', {'value':entry});"$)
	Return sb.tostring
End Sub

private Sub DataTableCreateUpdateSaveInputs() As String
'lets get the row the button is clicked
Dim sb As StringBuilder
sb.Initialize
sb.Append($"${DataTableGetRow}
$('#${compID}alert_message').html('');"$)
'raise this outside the app
sb.Append($"b4j_raiseEvent('${compID}_update', {'value':entry});"$)
Return sb.tostring
End Sub

private Sub DataTableGetRow() As String
Dim script As String = $"var item = {};var els = $(this).closest("tr").find("input[type=text],input[type=tel],input[type=time],input[type=date],input[type=checkbox],input[type=email],input[type=password],input[type=number],select,textarea,input[type=radio]");$.each(els, function (index, data) {var id = $(this).attr('data-id');var cl = $(this).attr('data-column');var tx = $(this).val();item ["id"] = id;item [cl] = tx;});delete item.actions;delete item.undefined;var entry = JSON.stringify(item);"$
Return script
End Sub

'code to when update is clicked
private Sub DataTableCreateInsertSaveInputs() As String
'lets get the row the button is clicked
Dim sb As StringBuilder
sb.Initialize
sb.Append($"${DataTableGetRow}
${DataTableCreateCancel}"$)
'raise this outside the app
sb.Append($"b4j_raiseEvent('${compID}_insert', {'value':entry});"$)
Return sb.tostring
End Sub

'code to when insert is clicked to save
private Sub DataTableCreateInsertSave() As String
	Dim sb As StringBuilder
	sb.Initialize
	For Each eachCol As ColumnType In Columns.values
		If eachCol.visible = True And eachCol.name <> "actions" Then
			Dim colName As String = eachCol.name
			Dim sLine As String = $"var v${colName} = $('#nr${colName}').text();"$
			sb.Append(sLine)
		End If
	Next
	'add values to array
	sb.Append("var item = {};")
	sb.Append("var row = [];")
	For Each eachCol As ColumnType In Columns.Values
		If eachCol.visible = True And eachCol.name <> "actions" Then
			Dim colName As String = eachCol.name
			Dim sItem As String = $"item ["${colName}"] = v${colName};"$
			sb.Append(sItem)
			sb.Append($"row.push(v${colName});"$)
		End If
	Next
	Dim entry As String = $"var entry = JSON.stringify(item);"$
	sb.Append(entry)
	'update the alert msg
	sb.Append(DataTableCreateCancel)
	'raise this outside the app
	sb.Append($"b4j_raiseEvent('${compID}_insert', {'value':entry});"$)
	Return sb.tostring
End Sub


private Sub DataTableCreateInsertRow() As String
	Dim focusId As String = ""
	Dim colpos As Int = -1
	Dim tr As HTMLElement
	tr = tr.CreateTR("nr")
	'loop through each column
	For Each eachCol As ColumnType In Columns.Values
		If eachCol.visible = True And eachCol.name <> "actions" Then
			colpos = colpos + 1
			If colpos = 0 Then
				focusId = $"nr${eachCol.name}"$
			End If
			Dim td As HTMLElement
			td = td.CreateTD($"nr${eachCol.name}"$).AddLooseAttribute("contenteditable").AddProperty("tabindex",colpos+1)
			'If colpos = 0 Then td.AddLooseAttribute("autofocus")
			tr.AddElement(td)
		End If
	Next
	'now add the insert button
	Dim td As HTMLElement
	td = td.CreateTD("").AddProperty("data-id","nr").AddProperty("data-column","actions")
	td.CreateBUTTON($"${compID}insert"$).AddClass("btn btn-success btn-xs").AddClass("btn-floating green").MaterialAddIconSimple("mdi-navigation-check","whitetransparent").Pop
	td.CreateBUTTON($"${compID}cancel"$).AddClass("btn btn-warning btn-xs").AddClass("btn-floating orange").MaterialAddIconSimple("mdi-navigation-close","whitetransparent").Pop
	tr.AddElement(td)
	Dim script As String = $"$('#${compID}alert_message').html('');
	$('#${compID}add').hide();
	var html = '${tr.html}';
	$('#${compID}tbl tbody').prepend(html);
	$('#${focusId}').focus();"$
	Return script
	'${MashPlugIns.JQueryAnimateScript(sID,MashPlugIns.Anime.Zoom_Exits_zoomOutRight,False,sAfter)}	
End Sub

private Sub DataTableCreateRow(rowPos As String, RowData As List, rowKey As String, mode As String) As List
	Dim colPos As Int = -1
	'add each column
	colPos = -1
	Dim column As List
	column.initialize
	For Each col As String In Columns.Keys
		colPos = colPos + 1
		Dim colDef As ColumnType = Columns.GetValueAt(colPos)
		If colDef.visible = True And colDef.name <> "actions" Then
			Dim colData As String = ""
			If RowData.Size-1 >= colPos Then colData = RowData.Get(colPos)
			Dim td As HTMLElement
			td = td.CreateDIV("").AddClass("input-field")
			If mode = "insert" Then 
				td.AddProperty("tabindex",colPos+1)
				td.SetElementType("td")
			End If
			Dim inpKey As String = $"row-${rowPos}-${colDef.name}"$
			Dim inp As HTMLElement
			inp = inp.CreateINPUT(inpKey).SetNAME(inpKey)
			inp.SetVALUE(colData)
			inp.AddProperty("data-id",rowPos)
			inp.AddProperty("data-column",colDef.name)
			Select Case colDef.datatype
				Case EnumDataType.istel
					inp.settype(colDef.datatype)
				Case EnumDataType.isurl
					inp.SetTYPE(colDef.datatype)
				Case EnumDataType.isemail
					inp.SetTYPE(colDef.datatype)
				Case EnumDataType.isselect
					inp.SetTYPE(EnumDataType.istext).AddClass("autocomplete")
					If MaterialControls = True Then
						inp.SetElementType(EnumDataType.isselect)
						inp.AddChildElement("option").AddProperty("value","").AddClass("disabled").AddClass("selected").AddContent("Choose your option").pop
					End If
				Case EnumDataType.ischkbox
					inp.SetTYPE(colDef.datatype)
					inp.setvalue("")
					Select Case colData.ToLowerCase
					Case "1","true","y"
						inp.AddProperty("checked","checked")
						inp.AddProperty("value","1")
						inp.AddClass("checked")
					Case Else
						inp.AddProperty("value","0")
					End Select
				Case EnumDataType.isdate
					'inp.SetTYPE(colDef.datatype)
					'datedropper
					inp.SetTYPE(EnumDataType.istext)
					inp.addproperty("data-format","Y-m-d")
					inp.AddProperty("data-fx","true")
					inp.AddProperty("data-large-mode","true")
					inp.AddProperty("data-large-default","true")
					If colData <> "" Then inp.AddProperty("data-default-date", SwapDate(colData))
					If MaterialControls = True Then
						inp.SetTYPE(EnumDataType.istext)
						inp.AddClass("datepicker")
					Else
						JavaCalls.Add(inp.JQueryOnDocumentClickEvent(inpKey,$"$('#${inpKey}').dateDropper();$('#${inpKey}').focus();return false;"$))
					End If
					If colData <> "" Then inp.AddProperty("data-value",colData)
				Case EnumDataType.istext
					inp.SetTYPE(colDef.datatype)
				Case EnumDataType.isnumeric
					inp.SetTYPE(colDef.datatype)
				Case EnumDataType.istextarea
					inp.SetElementType("textarea")
					inp.AddClass("materialize-textarea")
					JavaCalls.Add($"$('#${inpKey}').val('${colData}');"$)
				Case EnumDataType.ispassword
					inp.SetTYPE(colDef.datatype)
				Case EnumDataType.istime
					inp.SetTYPE(colDef.datatype)
					'timedropper
					inp.SetTYPE(EnumDataType.istext)
					If MaterialControls = True Then
						inp.SetTYPE(EnumDataType.istext)
						inp.AddClass("timepicker")
					Else
						JavaCalls.Add(inp.JQueryOnDocumentClickEvent(inpKey,$"$('#${inpKey}').timeDropper({setCurrentTime:false, format:'HH:mm'});$('#${inpKey}').focus();return false;"$))
					End If
				Case EnumDataType.isaction
			End Select
			If colDef.required = True Then
				If MaterialControls = True Then	inp.AddClass("validate")
			End If
			'td.AddProperty("tabindex",colPos+1)
			If colDef.datatype = EnumDataType.ischkbox Then
				'center the checkbox
				td.ApplyStyle("text-align:center;vertical-align: middle;")
				Dim p As HTMLElement
				p = p.CreateP("")
				p.AddElement(inp).AddChildElement("label").SetFOR(inpKey).pop
				td.AddElement(p)
			Else 
				td.AddElement(inp)
			End If
			column.Add(td.HTML)
		End If
	Next
	'let's add update/delete buttons
	Dim td As HTMLElement
	'ensure everything displays in one line
	Select Case mode
	Case "edit"
		td = td.CreateDIV("").ApplyStyle("white-space:nowrap;").AddProperty("data-column","actions").AddProperty("data-id",rowKey)
			td.CreateBUTTON($"${compID}update"$).AddProperty("data-id",rowKey).AddClass("btn btn-primary btn-xs").AddClass("btn-floating blue").MaterialAddIconSimple("mdi-content-save","whitetransparent").Pop
			td.CreateBUTTON($"${compID}delete"$).AddProperty("data-id",rowKey).AddClass("btn btn-danger btn-xs").AddClass("btn-floating red").MaterialAddIconSimple("mdi-action-delete","whitetransparent").Pop
	Case "insert"
		td = td.CreateTD("").AddProperty("data-id","nr").AddProperty("data-column","actions")
			td.CreateBUTTON($"${compID}insert"$).AddClass("btn btn-success btn-xs").AddClass("btn-floating green").MaterialAddIconSimple("mdi-navigation-check","whitetransparent").Pop
			td.CreateBUTTON($"${compID}cancel"$).AddClass("btn btn-warning btn-xs").AddClass("btn-floating orange").MaterialAddIconSimple("mdi-navigation-close","whitetransparent").Pop
	End Select
	column.Add(td.HTML)
	Return column
End Sub

private Sub SwapDate(sDate As String) As String
	Dim yyyy As String = MashPlugIns.MvField(sDate,1,"-")
	Dim mm As String = MashPlugIns.MvField(sDate,2,"-")
	Dim dd As String = MashPlugIns.MvField(sDate,3,"-")
	Return $"${mm}-${dd}-${yyyy}"$
End Sub

private Sub DataTableGetFocusID As String
	Dim colPos As Int = -1
	Dim focusID As String = ""
	For Each eachCol As ColumnType In Columns.Values
		If eachCol.visible = True And eachCol.name <> "actions" Then
			colPos = colPos + 1
			If colPos = 0 Then
				focusID = $"nr${eachCol.name}"$
				Return focusID
			End If
		End If
	Next
End Sub

private Sub DataTableCreateInsertRowInputs() As String
	Dim focusID As String = DataTableGetFocusID
	Dim rowKey As String = "nr"
	'create a blank row
	Dim rowData As List
	rowData.Initialize
	For Each eachCol As ColumnType In Columns.Values
		If eachCol.visible = True And eachCol.name <> "actions" Then
			rowData.Add("")
		End If
	Next
	Dim column As List = DataTableCreateRow(rowKey,rowData,rowKey,"insert")
	Dim tr As HTMLElement
	tr = tr.CreateTR("nr")
	tr.AddContentList(column)
	Dim script As String = $"$('#${compID}alert_message').html('');$('#${compID}add').hide();var html = '${tr.html}';$('#${compID}tbl tbody').prepend(html);$('#${focusID}').focus();"$
	If MaterialControls = True Then script = script & MaterializeInitialize
	Return script
End Sub

Private Sub RemoveMaterialClasses
	table.RemoveClass("bordered").RemoveClass("striped")
	table.RemoveClass("highlight").RemoveClass("centered").RemoveClass("responsive-table")
	table.RemoveClass(ZDepth)
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return table.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Refresh
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,Prepare)
	Dim script As String = table.MvFromList(JavaCalls,"")
	script = script.Replace(CRLF,"")
	File.WriteString(File.DirApp,"scripts.txt",script)
	page.ws.Eval(script, Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

'convert the json string inserted/updated/deleted to a map
Sub RowToMap(newData As String) As Map
	Dim Row As Map = MashPlugIns.Json2Map(newData)
	Row.Remove("actions")
	Return Row
End Sub

'define a column
Private Sub GetColumn(oftype As String, rowpos As Int, colPos As Int, colDef As ColumnType) As HTMLElement
	Dim td As HTMLElement
	td.initialize("",oftype)
	If IsFooTable = True Then
		td.AddAttributeOnFalseCondition(colDef.visible,"data-visible","false")
	Else
		td.AddStyleAttributeOnFalseCondition(colDef.Visible,"display","none")
	End If
	td.AddLooseAttribute("contenteditable").AddClass("update")
	td.AddProperty("data-id",rowpos)
	td.AddProperty("data-column",colDef.name)
	td.addattribute("id",$"${compID}row${rowpos}col${colPos}"$,True)
	td.AddAttribute("name", $"${compID}row${rowpos}col${colPos}${colDef.name}"$,True)
	td.AddAttributeOnCondition(IsFooTable,"data-title",colDef.heading)
	If colDef.Required = True Then
		td.AddAttributeOnCondition(IsSemantic,"data-notnull","true")
		td.AddAttributeOnCondition(IsSemantic,"data-validation","notnull")
	End If
	If colDef.DataType <> "" Then
		td.AddAttributeOnCondition(IsSemantic,"data-type", colDef.DataType)
		Select Case colDef.DataType
			Case EnumDataType.ischkbox
				If colDef.Checked <> "" Then td.AddAttributeOnCondition(IsSemantic,"data-checked",colDef.Checked)
				If colDef.UnChecked <> "" Then td.AddAttributeOnCondition(IsSemantic,"data-unchecked", colDef.UnChecked)
			Case EnumDataType.isselect
				td.AddAttributeOnCondition(IsSemantic,"data-defaultvalue",colDef.cDefault)
				If colDef.heading <> "" Then td.AddAttributeOnCondition(IsSemantic,"data-defaultlable", colDef.heading)
				If colDef.valueField <> "" Then td.AddAttributeOnCondition(IsSemantic,"data-valuefield", colDef.valueField)
				If colDef.textField <> "" Then td.AddAttributeOnCondition(IsSemantic,"data-textfield",colDef.textField)
				'get the list to select from
				Dim selList As List = colDef.options
				Dim selItems As String = "[" & table.MvFromList(selList,",") & "]"
				td.AddAttributeOnCondition(IsSemantic,"data-options", selItems)
		End Select
	End If
	If colDef.outFormat <> "" Then
		td.AddAttributeOnCondition(IsFooTable,"data-format-string",colDef.outFormat)
	End If
	If colDef.Height <> "0" Then td.addstyleattribute("height",colDef.Height & "px")
	'tabledit specific
	td.AddAttributeOnCondition(IsTableEdit,"data-id",rowpos)
	td.AddAttributeOnCondition(IsTableEdit,"data-field",colDef.name)
	Return td
End Sub

Private Sub TableEditBuildEditColumns() As String
	Dim sb As StringBuilder
	sb.initialize
	Dim colPos As Int = -1 ' start from column 1
	For Each col As String In Columns.keys
		colPos = colPos + 1
		Dim colDef As ColumnType = Columns.Get(col)
		If colDef.name.EqualsIgnoreCase(PrimaryKey) Then
		Else
			Select Case colDef.datatype
				Case  EnumDataType.isselect
					Dim options As List = colDef.options
					Dim soptions As String = table.MvFromList(options,",")
					Dim sline As String = $"[${colPos}, '${colDef.name}', '${colDef.datatype}', '{${soptions}}']"$
					sb.Append(sline).Append(",")
				Case Else
					Dim sline As String = $"[${colPos}, '${colDef.name}', '${colDef.datatype}']"$
					sb.Append(sline).Append(",")
			End Select
		End If
	Next
	If sb.ToString.endswith(",") Then
		'remove last comma
		sb.Remove(sb.Length-1,sb.Length)
	End If
	Return sb.tostring
End Sub


'build the body of the table
private Sub BuildBody() As String
	Dim sb As StringBuilder
	Dim head As HTMLElement
	Dim tr As HTMLElement
	Dim tbody As HTMLElement
	Dim tfoot As HTMLElement
	sb.initialize
	'initialize the heading
	head.initialize("","thead")
	'initializ the heading ror
	tr.initialize("","tr")
	'initialize the body
	tbody.initialize("","tbody")
	'initialize the footer
	tfoot.initialize("","tfoot")
	Dim colPos As Int = -1
	For Each col As String In Columns.keys
		colPos = colPos + 1
		Dim colDef As ColumnType = Columns.Get(col)
		Dim th As HTMLElement = GetColumn("th",colPos,colPos,colDef)
		th.addcontent(colDef.heading)
		'add to the row
		tr.addcontent(th.html)
	Next
	'add the row to the header
	head.addcontent(tr.html)
	'add the head to the output
	sb.append(head.html)
	'build the body of the table
	Select Case TableType
		Case EnumTableType.DataTable
			'data is loaded directly
		Case Else
			Dim rowpos As Int = 0
			For Each rowKey As String In Rows.keys
				rowpos = rowpos + 1
				Dim rowData As List = Rows.get(rowKey)
				Dim tr As HTMLElement
				tr.initialize("","tr")
				tr.AddProperty("id",rowKey)
				tr.addattribute("uniqueid",compID & "row" & rowpos,True)
				'add each column
				colPos = -1
				For Each col As String In Columns.Keys
					colPos = colPos + 1
					Dim colDef As ColumnType = Columns.GetValueAt(colPos)
					Dim td As HTMLElement = GetColumn("td",rowpos,colPos,colDef)
					Dim colData As String = MashPlugIns.InQuotes("")
					If rowData.Size-1 >= colPos Then colData = rowData.Get(colPos)
					td.addcontent(colData)
					tr.addcontent(td.html)
				Next
				tbody.addcontent(tr.html)
			Next
	End Select
	sb.append(tbody.html)
	'build the footer if we have
	If FooterRows.size >= 1 Then
		rowpos = 0
		For Each rowKey As String In FooterRows.keys
			rowpos = rowpos + 1
			Dim rowData As List = FooterRows.get(rowKey)
			Dim tr As HTMLElement
			tr.initialize("","tr")
			tr.addattribute("uniqueid",compID & "footerrow" & rowpos,True)
			'add each column
			colPos = -1
			For Each col As String In Columns.Keys
				colPos = colPos + 1
				Dim colDef As ColumnType = Columns.GetValueAt(colPos)
				Dim td As HTMLElement = GetColumn("td",rowpos,colPos,colDef)
				Dim colData As String = MashPlugIns.InQuotes("")
				If (rowData.Size-1) >= colPos Then colData = rowData.Get(colPos)
				td.addcontent(colData)
				tr.addcontent(td.html)
			Next
			tfoot.addcontent(tr.html)
		Next
		sb.append(tfoot.html)
	End If
	Return sb.tostring
End Sub


'build the data set for the table
private Sub DataTableBuildDataSetInputs() As String
	Dim lRows As List
	lRows.initialize
	Dim rowpos As Int = 0
	For Each rowKey As String In Rows.keys
		rowpos = rowpos + 1
		Dim rowData As List = Rows.get(rowKey)
		Dim column As List = DataTableCreateRow(rowpos,rowData,rowKey,"edit")
		lRows.Add(column)
	Next
	Dim output As String = MashPlugIns.List2JSON(lRows)
	Return output
End Sub