﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Public Theme As String
	Public Enabled As Boolean
	Public Visibility As String
	Public ZDepth As String
	Private Tasks As Map
	Private ul As HTMLElement
	Public Title As String
	Public SubTitle As String
	Public Pulse As Boolean
	Private Categories As Map
	Private add As HTMLElement
	Public HeaderIcon As String
	Public Hoverable As Boolean
	Private ABM As ABMaterial
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

Public Sub Initialize(InternalPage As ABMPage, ID As String, themeName As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	JavaCalls.Initialize
	Page = InternalPage
	compID = ID.tolowercase
	ZDepth = ""
	SubTitle = MashPlugIns.LongDateToday
	Title = "Tasks"
	Theme = themeName
	Tasks.initialize
	Pulse = True
	Categories.initialize
	HeaderIcon = "mdi-action-assignment"
	ul = ul.CreateUL(compID)
End Sub


'add categories for the colors for each task
Sub AddCategory(categoryID As String, categoryName As String, categoryColor As String)
	Dim catM As Map
	catM.Initialize
	catM.Put("name",categoryName)
	catM.Put("color", categoryColor)
	Categories.Put(categoryID,catM)
End Sub

'add a task to the component
Sub AddTask(taskID As String, taskCategory As String, taskTitle As String,taskDueDate As String, taskChecked As Boolean, taskEnabled As Boolean)
	taskCategory = taskCategory.Trim.tolowercase
	Dim li As HTMLElement
	li = li.CreateLI($"${compID}${taskID}"$).AddClass("collection-item dismissable").ApplyStyle("padding:20px").addcursor
	Dim chk As HTMLElement
	chk = chk.CreateINPUT($"${compID}${taskID}chk"$).SetTYPE("checkbox")
	If taskChecked = True Then chk.AddProperty("checked","checked")
	If taskEnabled = False Then chk.AddProperty("disabled","disabled")
	chk.MaterialEnable(True)
	chk.addproperty("name",chk.id)
	JavaCalls.Add(chk.AddChangeEvent(compID,chk.ID,taskID))
	li.AddContent(chk.HTML)
	Dim lbl As HTMLElement
	lbl = lbl.CreateLABEL("").SetFOR(chk.id).AddContent(taskTitle).ApplyStyle("display:block;color:rgba(0,0,0,0.87);height:auto")
	Dim a As HTMLElement
	a = a.CreateA("").AddClass("secondary-content")
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("ultra-small").AddContent(taskDueDate)
	span.applystyle("font-size:0.8rem;margin:0;padding:0")
	a.AddContent(span.HTML)
	lbl.AddContent(a.HTML)
	li.AddContent(lbl.HTML)
	'define category
	Dim catColor As String = ABM.COLOR_LIGHTBLUE
	Dim catName As String = taskCategory
	If Categories.ContainsKey(taskCategory) Then
		Dim catMap As Map = Categories.Get(taskCategory)
		catColor = catMap.Get("color")
		catName = catMap.Get("name")
	End If
	Dim cat As HTMLElement
	cat = cat.CreateSPAN("").AddClass("task-cat").AddContent(catName)
	cat.ApplyStyle("padding:2px 4px;color:#fff;margin-left:37px;font-weight:300;font-size:0.8rem;-webkit-border-radius:2px;-moz-border-radius:2px;border-radius:2px;background-clip:padding-box")
	'get the task category
	cat.AddClass(catColor)
	li.AddContent(cat.HTML)
	Tasks.Put(taskID,li.HTML)
End Sub


Sub HTML As String
	ul.AddClass("collection")
	ul.MaterialEnable(Enabled).MaterialHoverable(Hoverable)
	ul.MaterialZDepth(ZDepth)
	ul.MaterialVisibility(Visibility)
	'build the header
	Dim li As HTMLElement
	li = li.createli("").AddClass("collection-item avatar").ApplyStyle("height:auto;padding-top:22px")
	MashPlugIns.MaterialUseTheme(Theme,li)
	Dim i As HTMLElement
	i = i.CreateI("").MaterialBuildIcon(HeaderIcon,"").AddClass("circle").ApplyStyle("font-size:28px")
	MashPlugIns.MaterialUseTheme(Theme,i)
	i.MaterialZDepth(ABM.ZDEPTH_1)
	Dim span As HTMLElement
	span = span.CreateSPAN("").AddClass("collection-header").AddContent(Title).ApplyStyle("font-size:1.14rem;font-weight:500")
	Dim p As HTMLElement
	p = p.CreateP("").AddContent(SubTitle)
	'add the components
	li.AddContent(i.HTML)
	li.AddContent(span.HTML)
	li.AddContent(p.HTML)
	
	'add the floating button to add tasks
	add = add.CreateA($"${compID}add"$).MaterialButtonFloating(True).MaterialWavesEffect(True).MaterialWavesLight(True)
	add.AddClass("task-add").applyStyle("position:absolute;right:10px;top:60px").AddCursor
	'JavaCalls.Add(add.AddChildClickEvent(compID,add.ID,"add"))
	add.AddOnClickEventProperty(compID,"add")
	Dim i As HTMLElement
	i = i.CreateI("").MaterialBuildIcon("mdi-content-add","")
	MashPlugIns.MaterialUseReversedTheme(Theme,i)
	add.AddContent(i.HTML)
	li.AddContent(add.html)
	ul.AddContent(li.HTML)
	
	
	'add each of the tasks
	For Each strKey As String In Tasks.Keys
		Dim strValue As String = Tasks.Get(strKey)
		ul.AddContent(strValue)
	Next
	'when the status is changed, strike-through the text
	Dim script As String = $"// Check first if any of the task is checked
    $('#${compID} input:checkbox').each(function() { checkbox_check(this); });
    // Task check box
    $('#${compID} input:checkbox').change(function() { checkbox_check(this); });
    // Check Uncheck function
    function checkbox_check(el) {
      if (!$(el).is(':checked')) {
        $(el).next().css('text-decoration', 'none'); // or addClass
      } else {
        $(el).next().css('text-decoration', 'line-through'); //or addClass
      }
    }"$
	JavaCalls.Add(script)
	Return ul.HTML
End Sub

'clear the contents of the issues
Sub Clear
	Categories.Initialize
	Tasks.Initialize
	JavaCalls.Initialize
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = ul.MvFromList(JavaCalls,"")
	JQueryExecute(script)
End Sub

'refresh the contents of the list
Sub Refresh
	ABM.ReplaceMyHTML(Page,compID,HTML)
	Dim script As String = ul.MvFromList(JavaCalls,"")
	JQueryExecute(script)
	If Pulse = True Then JQueryExecute(add.JQueryAnimate(MashPlugIns.Anime.Attention_Seekers_pulse,True,""))
End Sub


Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	Page = InternalPage
	compID = internalID
	Return ul.GetComponentBuilder
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	compID = internalID
	Refresh
End Sub

private Sub JQueryExecute(script As String)
	Page.ws.Eval(script,Array As String(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub