﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private Circle As Boolean
	Public URL As String
	Public Alt As String
	Private Element As HTMLElement
	Public ZDepth As String
	Public Visibility As String
	Public Hoverable As Boolean
	Public Enabled As Boolean
	Public Caption As String
	Private page As ABMPage
	Private compID As String
	Private JavaCalls As List
	Private ABM As ABMaterial
	Private bStatic As Boolean
	Private imgBadge As HTMLElement
	Public Bordered As Boolean
	Public ArrayName As String
	Public Width As String
	Public Height As String
	Private parent As HTMLElement
	Private sStatusColor As String
	Private sStatusBackColor As String
	Private sTheme As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, imgURL As String, Static As Boolean, StatusTheme As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	page = InternalPage
	JavaCalls.Initialize
	bStatic = Static
	compID = ID
	Bordered = False
	ArrayName = ""
	Circle = True
	URL = imgURL
	Alt = ""
	compID = ID.tolowercase
	Enabled = True
	ZDepth = ""
	Visibility = ""
	Caption = ""
	Hoverable = True
	parent.Initialize(ID,"div").AddClass("status-badge")
	Element.Initialize(ID & "img","img")
	imgBadge.Initialize(ID & "badge","div")
	sTheme = StatusTheme
	Width = ""
	Height = ""
	MashPlugIns.AddExternalStyle("img-bordered", "padding: 3px; border-width: 1px; border-style: solid;	background: #fff;")
	MashPlugIns.AddExternalStyle("img-circle","border-radius: 50%;")
	MashPlugIns.AddExternalStyle("small-badge", "overflow: hidden; width: 14px;	height: 14px; padding: 0; border: #fff solid 2px; border-radius: 20px;")
	MashPlugIns.AddExternalStyle("status-badge","position: relative;display: inline-block;box-sizing: border-box;margin: 10px;")
	MashPlugIns.AddExternalStyle("small-badge","position: absolute; right: 1px;	bottom: 10px;")
	MashPlugIns.AddExternalStyle("img-status","border: 0;vertical-align: middle;")
End Sub

Sub Success
	sTheme = "success"
End Sub

Sub Primary
	sTheme = "primary"
End Sub

Sub Danger
	sTheme = "danger"
End Sub

Sub Warn
	sTheme = "warn"
End Sub

Sub Info
	sTheme = "info"
End Sub

Sub Muted
	sTheme = "muted"
End Sub


Sub Update(StatusTheme As String)
	sTheme = StatusTheme
End Sub

Sub SetSize(imgHeight As String, imgWidth As String)
	Element.SetHEIGHT(imgHeight)
	Element.SetWIDTH(imgWidth)
	Width = imgWidth
	Height = imgHeight
End Sub

Sub HTML As String
	Element.ID = compID & "img"
	Element.AddClass("img-status")
	Element.AddClassOnCondition(Bordered,"img-bordered").addcursor
	Element.AddStyleAttributeOnCondition(Bordered,"overflow","visible")
	Element.AddClassOncondition(Circle,"img-circle")
	Element.MaterialVisibility(Visibility)
	Element.MaterialHoverable(Hoverable)
	Element.MaterialZdepth(ZDepth)
	Element.MaterialCircle(Circle)
	Element.SetAlt(Alt)
	Element.SetSrc(URL,bStatic)
	Element.MaterialHoverable(Hoverable)
	Element.MaterialEnable(Enabled)
	Element.AddDataAttribute("caption",Caption)
	Element.SetWIDTH(Width)
	Element.SetHEIGHT(Height)
	imgBadge.AddClass("small-badge")	
	sStatusColor = MashPlugIns.ABMGetForeColor(sTheme)
	sStatusBackColor = MashPlugIns.ABMGetBackGroundColor(sTheme)
	imgBadge.AddStyleAttribute("color", sStatusColor)
	imgBadge.AddStyleAttribute("background", sStatusBackColor)	
	Element.AddElement(imgBadge)
	parent.AddElement(Element)
	parent.AddOnClickEventProperty(ArrayName,parent.id)
	Return parent.html
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	Return Element.GetComponentBuilder
End Sub

Sub Refresh
	ABM.ReplaceMyHTML(page,compID,HTML)
	'If ArrayName = "" Then ArrayName = compID
	'JavaCalls.Add(Element.AddChildClickEvent(ArrayName,compID,compID))
	Dim script As String = Element.MvFromList(JavaCalls,"")
	page.ws.Eval(script, Array As String(compID))
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Refresh
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub