﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'wrapped by Anele 'Mashy' Mbanga for ABMaterial
'source: https://github.com/CoolCola/createWaterBall
'anele@mbangas.com
'NB: DONT EVER USE NUMERIC MAP KEYS
Sub Class_Globals
	Public ABMComp As ABMCustomComponent
	Private vWidth As String
	Private vHeight As String
	Public isLoading As Boolean
	Private vnowRange As String ' the value now
	Private vtargetRange As String ' the target value to be achieved
	Private page As ABMPage
	Private compID As String
	Private range1 As String
	Private range2 As String
	Private range3 As String
	Private wWidth As String
	Private wHeight As String
	Private div As HTMLElement
	Public ToolTip As String
End Sub

Sub AddTheme(themeName As String, ForeColor As String, ForeColorIntensity As String, BackColor As String, BackColorIntensity As String)
	MashPlugIns.AddTheme(themeName,ForeColor,ForeColorIntensity,BackColor,BackColorIntensity)
End Sub

'Initiaobject. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, Width As String, Height As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	page = InternalPage
	compID = ID
	vWidth = Width
	vHeight = Height
	range1 = "50"
	range2 = "80"
	range3 = "100"
	wWidth = "0.02"
	wHeight = "5"
End Sub

'add three ranges to mark to change colors between red, orange, green
Sub SetRanges(red As String, orange As String, green As String)
	range1 = red
	range2 = orange
	range3 = green
End Sub

'set the values now
Sub SetValues(nowRange As String, targetRange As String)
	vnowRange = nowRange
	vtargetRange = targetRange
End Sub

'build the waterball	
private Sub BuildWaterBall As String
	'we will replace everything on build, lets create the build
	Dim script As String = $"var loadingEle = $('.${compID}');
	var loading_width = loadingEle.width(),loading_height = loadingEle.height();
	$('.${compID}').createWaterBall({
		cvs_config:{
			width:loading_width,
			height:loading_height
		},
		wave_config:{
            waveWidth:${wWidth},
            waveHeight:${wHeight}
        },
        data_range:[${range1},${range2},${range3}],
        isLoading:${isLoading},
        nowRange:${vnowRange},
        targetRange:${vtargetRange}
	});"$
	Return script
End Sub

Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	'add this to page build. <script type="text/javascript" src="createWaterBall-jquery.js"></script>
	'lets try and inject the page with css
	page = InternalPage
	compID = internalID
	div.Initialize(compID,"div")
	div.AddClass(compID).AddStyleAttribute("width",vWidth & "px").AddStyleAttribute("height",vHeight & "px")
	Dim sb As StringBuilder
	sb.initialize
	sb.Append(div.HTML.Replace(CRLF,"")).Append($"<script>var _${internalID};</script>"$)
	Return sb.tostring
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	page = InternalPage
	compID = internalID
	Dim script As String = BuildWaterBall
	InternalPage.ws.Eval(script, Array As Object(compID))
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub

' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
