﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Dim ABM As ABMaterial
	Dim ABMComp As ABMCustomComponent
	Dim Page As ABMPage
	Dim compID As String
	Public Height As String
	Public Width As String
	Public Title As String
	Public LegendVisible As Boolean
	Public LegendTitle As String
	Public LegendShape As String
	Public LegendPosition As String
	Public SeriesList As List
	Public YAxisLabelFormat As String
	Public YAxisTitle As String
	Public XAxisTitle As String
	Public SetCommon As Boolean
	Public XAxisLabelFormat As String
	Public IsResponsive As Boolean
	Public EnableZooming As Boolean
	Public HTML As String
	Public enableCanvasRendering As Boolean
	Public PrimaryXAxisValueType As String
	Public PrimaryYAxisValueType As String
	Public XAxislabelIntersectAction As String
	Public ValuePrefix As String
	Public ValueSuffix As String
	Public enable3D As Boolean
	Public ColumnWidth As String
	Public ChartWidth As String
	Public ChartHeight As String
	Public UseRandomColors As Boolean
	Public SingleSeries As Boolean
	Type SeriesObj(xname As String, yname As String, stype As String, Width As String, xy As Map, name As String, tooltipvisible As Boolean, fillColor As String, _
	enableAnimation As Boolean, markershape As String, markervisible As Boolean, markerdatalabelsvisible As Boolean, borderwidth As String, bordercolor As String, labelposition As String, enableSmartLabels As Boolean, _
	startangle As String,endangle As String,explode As Boolean,tooltipformat As String,markerdatalabelshape As String,markerdatalabelconnectorLinetype As String, markerdatalabelconnectorLinecolor As String, _
	markerdatalabelfont As String, text As String, markerwidth As String, markerheight As String, markerdatalabelfontcolor As String)
	Type TypeEnum(line As String, Column As String, area As String, bar As String, spline As String, pie As String, doughnut As String, steparea As String, splinearea As String,stackingarea As String, _
	stackingarea100 As String, rangearea As String, stackingColumn As String, stackingBar As String, stackingBar100 As String, Scatter As String, Bubble As String, StepLine As String, HiLo As String, _
	HiLoOpenClose As String, Candle As String, RangeColumn As String, Pyramid As String, Funnel As String, Polar As String, Radar As String)
	Public EnumType As TypeEnum
	Type LegendPositionEnum(left As String, right As String, top As String, bottom As String)
	Public EnumLegendPosition As LegendPositionEnum
	Type CommonSeriesOptionsObj(stype As String, enableAnimation As Boolean, markershape As String, markervisible As Boolean, markerdatalabelsvisible As Boolean, _
	tooltipvisible As Boolean, fillColor As String, LineWidth As String,MarkerHeight As String,MarkerWidth As String,enableSmartLabels As Boolean, labelPosition As String)
	Public CommonSeriesOptions As CommonSeriesOptionsObj
	Public SubTitle As String
	Private iID As String
	Public YAxisLabelFormatLocale As Boolean
	Public toolTipInitialize As Boolean
End Sub
Sub Download(InternalPage As ABMPage)
	Dim sb As String
	sb = $"var chart = $("#${iID}").ejChart("instance");
	chart.model.enableCanvasRendering = true;
	chart.redraw();
	var canvas = chart.export();
	var lnk = canvas.toDataURL("image/png");
	var url = lnk.replace(/^data:image\/[^;]/, 'data:application/octet-stream');
	var a = document.createElement("a");
	a.download = "${iID}.png";
	a.href = url;
	a.target = "_blank";
	document.body.appendChild(a);
	a.click();
	document.body.removeChild(a);
	delete a;
	chart.model.enableCanvasRendering = false;
	chart.redraw();"$
	InternalPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub
Sub AddXY(so As SeriesObj, x As String, y As String)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{x: '")
	sb.Append(x)
	sb.Append("', y: ")
	sb.Append(y)
	sb.Append("}")
	so.xy.Put(x, sb.ToString)
End Sub
Sub AddXYText(so As SeriesObj, x As String, y As String, text As String)
	Dim xytext As String = $"{x: '${x}', y:${y}, text:'${text}'}"$
	so.xy.Put(x, xytext)
End Sub
'build the series data
private Sub BuildXYSeriesData(so As SeriesObj) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each strRecord As String In so.xy.Keys
		Dim rec As String = so.xy.Get(strRecord)
		sb.Append(rec).Append(",")
	Next
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub
Sub Len(Text As String) As Int
	Return Text.Length
End Sub
Sub Json2Map(jsonText As String) As Map
	Dim json As JSONParser
	Dim Map1 As Map
	Map1.Initialize
	Try
		If Len(jsonText) > 0 Then
			json.Initialize(jsonText)
			Map1 = json.NextObject
		End If
		Return Map1
	Catch
		Return Map1
	End Try
End Sub
Sub MakeSingleSeries
	If (SeriesList.Size-1) =-1 Then Return
	Dim ms As SeriesObj
	InitializeSeries(ms)
	Dim eachPoint As Int = 0
	For Each series As SeriesObj In SeriesList
		For Each strRecord As String In series.xy.Keys
			Dim rec As String = series.xy.Get(strRecord)
			Select Case CommonSeriesOptions.stype
				Case EnumType.pie, EnumType.doughnut
					Dim recmap As Map = Json2Map(rec)
					Dim x As String = recmap.GetDefault("x","")
					Dim y As String = recmap.GetDefault("y","")
					rec = $"{x: '${x}', y:${y}, text:'${x}, ${y}'}"$
					ms.xy.Put(strRecord,rec)
				Case Else
					If UseRandomColors = True Then
						Dim recmap As Map = Json2Map(rec)
						Dim x As String = recmap.GetDefault("x","")
						Dim y As String = recmap.GetDefault("y","")
						Dim fill As String = MashPlugIns.ColorMap.GetValueAt(eachPoint)
						rec = $"{x: '${x}', y:${y}, fill:'${fill}'}"$
						ms.xy.Put(strRecord,rec)
						eachPoint = eachPoint + 1
					Else
						ms.xy.Put(strRecord,rec)
					End If
			End Select
		Next
	Next
	Dim os As SeriesObj = SeriesList.Get(0)
	ms.xname = os.xname
	ms.stype = os.stype
	ms.Width = os.Width
	ms.yname = os.yname
	ms.text = os.text
	ms.name = os.name
	Select Case CommonSeriesOptions.stype
		Case EnumType.pie, EnumType.doughnut
			ms.name = ""
			ms.xname = ""
			ms.yname = ""
		Case Else
	End Select
	ms.fillColor = os.fillColor
	ms.borderwidth = os.borderwidth
	ms.bordercolor = os.bordercolor
	ms.labelposition = os.labelposition
	ms.enableSmartLabels = os.enableSmartLabels
	ms.startangle = os.startangle
	ms.endangle = os.endangle
	ms.explode = os.explode
	ms.tooltipvisible = os.tooltipvisible
	ms.tooltipformat = os.tooltipformat
	ms.enableAnimation = os.enableAnimation
	ms.markershape = os.markershape
	ms.markervisible = os.markervisible
	ms.markerdatalabelshape = os.markerdatalabelshape
	ms.markerdatalabelconnectorLinetype = os.markerdatalabelconnectorLinetype
	ms.markerdatalabelconnectorLinecolor = os.markerdatalabelconnectorLinecolor
	ms.markerdatalabelfont = os.markerdatalabelfont
	ms.markerdatalabelfontcolor = os.markerdatalabelfontcolor
	ms.markerdatalabelsvisible = os.markerdatalabelsvisible
	ms.markerwidth = os.markerwidth
	ms.markerheight = os.markerheight
	SeriesList.Initialize
	AddSeries(ms)
End Sub
'build the series to be added
Private Sub BuildXYSeries(so As SeriesObj) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	sb.Append("points: []")
	'if SingleSeries = .Append(BuildXYSeriesData(so)).Append("]")
	If so.name.Length > 0 Then
		sb.Append($",name: '${so.name}'"$)
	End If
	If so.Fillcolor.Length > 0 Then
		sb.Append($",fill: '${so.fillcolor}'"$)
	End If
	If so.sType.Length > 0 Then
		sb.Append($",type: '${so.stype}'"$)
	End If
	If so.labelposition.Length > 0 Then
		sb.Append($",labelPosition:'${so.labelposition}'"$)
	End If
	'	If so.xname.Length > 0 Then
	'		sb.Append("xName: ")
	'		sb.Append(QUOTE)
	'		sb.Append(so.xname)
	'		sb.Append(QUOTE)
	'		sb.Append(",")
	'	End If
	'	If so.yname.Length > 0 Then
	'		sb.Append("yName: ")
	'		sb.Append(QUOTE)
	'		sb.Append(so.yname)
	'		sb.Append(QUOTE)
	'		sb.Append(",")
	'	End If
	If so.tooltipvisible = True Then
		sb.Append(",tooltip: {visible: true}")
	End If
	If so.enableAnimation = True Then
		sb.Append(",enableAnimation: true")
	End If
	If so.enableSmartLabels = True Then
		sb.Append(",enableSmartLabels: true")
	End If
	If so.startAngle.Length > 0 Then
		sb.Append($",startAngle: ${so.startAngle}"$)
	End If
	If so.endAngle.Length > 0 Then
		sb.Append($",endAngle: ${so.endAngle}"$)
	End If
	If so.bordercolor.Length > 0 Or so.borderwidth.Length > 0 Then
		sb.Append($",border :{width:${so.borderwidth}, color:'${so.bordercolor}'}"$)
	End If
	If so.markervisible = True Then
		sb.Append(",marker: {")
		sb.Append("visible: true")
		If so.markershape.Length > 0 Then sb.Append(",shape: '").Append(so.markershape).Append("'")
		If so.markerwidth.Length > 0 Or so.markerheight.Length > 0 Then
			sb.Append($",size: {height: ${so.markerheight}, width: ${so.markerwidth}}"$)
		End If
		If so.markerdatalabelsvisible = True Then
			sb.Append($",dataLabel: { visible: true"$)
			If so.markerdatalabelshape.Length > 0 Then sb.Append($",shape: '${so.markerdatalabelshape}'"$)
			If so.markerdatalabelfont.Length > 0 Then sb.Append($",font: {color: '${so.markerdatalabelfontcolor}', size:'${so.markerdatalabelfont}px'}"$)
			If so.markerdatalabelconnectorLinecolor.Length > 0 Or so.markerdatalabelconnectorLinetype.Length > 0 Then
				sb.Append($",connectorLine: { type: '${so.markerdatalabelconnectorLinetype}',color: '${so.markerdatalabelconnectorLinecolor}'}"$)
			End If
			sb.Append("}")
		End If
		sb.Append("}")
	End If
	sb.Append("},")
	Return sb.tostring
End Sub
public Sub InitializeSeries(Series As SeriesObj)
	Series.Initialize
	Series.xname = ""
	Series.stype = ""
	Series.Width = ""
	Series.yname = ""
	Series.text = ""
	Series.name = ""
	Series.fillColor = ""
	Series.borderwidth = ""
	Series.bordercolor = ""
	Series.labelposition = ""
	Series.enableSmartLabels = False
	Series.startangle = ""
	Series.endangle = ""
	Series.explode = False
	Series.tooltipvisible = False
	Series.tooltipformat = ""
	Series.enableAnimation = False
	Series.markershape = ""
	Series.markervisible = False
	Series.markerdatalabelshape = ""
	Series.markerdatalabelconnectorLinetype = ""
	Series.markerdatalabelconnectorLinecolor = ""
	Series.markerdatalabelfont = ""
	Series.markerdatalabelfontcolor = ""
	Series.markerdatalabelsvisible = False
	Series.markerheight=""
	Series.markerwidth = ""
	Series.xy.Initialize
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	ChartWidth = "100%"
	ChartHeight = "700"
	PrimaryXAxisValueType = ""
	PrimaryYAxisValueType = ""
	SeriesList.Initialize
	LegendVisible = True
	LegendTitle = ""
	LegendShape = ""
	SetCommon = True
	enableCanvasRendering = False
	Width = "100%"
	Height = "100%"
	enable3D = False
	IsResponsive = True
	EnumType.Initialize
	EnumType.column = "column"
	EnumType.line = "line"
	EnumType.area = "area"
	EnumType.bar = "bar"
	EnumType.spline = "spline"
	EnumType.pie = "pie"
	EnumType.doughnut = "doughnut"
	EnumType.steparea = "steparea"
	EnumType.splinearea = "splinearea"
	EnumType.stackingarea = "stackingarea"
	EnumType.stackingarea100 = "stackingarea100"
	EnumType.rangearea = "rangearea"
	EnumType.stackingColumn = "stackingColumn"
	EnumType.stackingBar = "stackingBar"
	EnumType.stackingBar100 = "stackingBar100"
	EnumType.Scatter = "Scatter"
	EnumType.Bubble = "Bubble"
	EnumType.StepLine = "StepLine"
	EnumType.HiLo = "HiLo"
	EnumType.HiLoOpenClose = "HiLoOpenClose"
	EnumType.Candle = "Candle"
	EnumType.RangeColumn = "RangeColumn"
	EnumType.Pyramid = "Pyramid"
	EnumType.Funnel = "Funnel"
	EnumType.Polar = "Polar"
	EnumType.Radar = "Radar"
	LegendPosition = "bottom"
	EnableZooming = False
	YAxisLabelFormatLocale = False
	HTML = ""
	EnumLegendPosition.Initialize
	EnumLegendPosition.left = "left"
	EnumLegendPosition.right = "right"
	EnumLegendPosition.top = "top"
	EnumLegendPosition.bottom = "bottom"
	YAxisTitle = ""
	XAxisTitle = ""
	CommonSeriesOptions.Initialize
	CommonSeriesOptions.enableAnimation = False
	CommonSeriesOptions.markerdatalabelsvisible = False
	CommonSeriesOptions.markershape = ""
	CommonSeriesOptions.stype = ""
	CommonSeriesOptions.tooltipvisible = False
	CommonSeriesOptions.LineWidth = ""
	CommonSeriesOptions.markerWidth = ""
	CommonSeriesOptions.markerheight = ""
	SubTitle = ""
	toolTipInitialize = False
End Sub
' runs when an object is created for the first time. Expects a valid html string
' will get surrounded by a div automatically
' in the html file:
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	Page = InternalPage
	iID = internalID
	Return $"<div id="${internalID}" style="width: ${Width}; height: ${Height};"></div>"$
End Sub
Sub AddSeries(so As SeriesObj)
	SeriesList.Add(so)
End Sub
' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Page = InternalPage
	iID = internalID
	Refresh
End Sub

Sub Refresh
	HTML = BuildChart(iID)
	' do some script stuff like you do in RunJavaScript
	Page.ws.Eval(HTML, Null)
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	' use these methods to adjust the object
	' ABM.HasClass
	' ABM.AddClass
	' ABM.RemoveClass
	' ABM.AddHTML
	' ABM.InsertHTMLAfter
	' ABM.RemoveHTML
	' ABM.GetProperty
	' ABM.SetProperty
	' ABM.RemoveProperty
	' ABM.GetStyleProperty
	' ABM.SetStyleProperty
	'set chart properties
End Sub
' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub
private Sub BuildChart(xid As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(").Append(QUOTE).Append("#").Append(xid).Append(QUOTE).Append(").ejChart({").Append(CRLF)
	sb.Append("initSeriesRender: false,").Append(CRLF)
	sb.Append($"size: { width: '${ChartWidth}', height: '${ChartHeight}' },"$).Append(CRLF)
	If YAxisLabelFormatLocale = True Then
		sb.append("axesLabelRendering: 'axesLabels',").append(CRLF)
	End If
	If toolTipInitialize = True Then
		sb.append("toolTipInitialize: 'tooltipFormat',").append(CRLF)
	End If
	'yaxis label format
	Select Case CommonSeriesOptions.stype
		Case EnumType.doughnut
		Case EnumType.pie
		Case Else
			sb.Append("primaryYAxis:{").Append(CRLF)
			If YAxisLabelFormatLocale = False Then
				If YAxisLabelFormat.Length > 0 Then sb.Append("labelFormat: '").Append(YAxisLabelFormat).Append("',").Append(CRLF)
			End If
			If YAxisTitle.Length > 0 Then sb.Append("title: { text: '").Append(YAxisTitle).Append("'},").Append(CRLF)
			If PrimaryYAxisValueType.Length > 0 Then sb.Append("valueType: '").Append(PrimaryYAxisValueType).Append("',").Append(CRLF)
			sb.Append("},").Append(CRLF)
			sb.Append("primaryXAxis:{").Append(CRLF)
			If XAxisTitle.Length > 0 Then sb.Append("title: { text: '").Append(XAxisTitle).Append("'},").Append(CRLF)
			If XAxisLabelFormat.Length > 0 Then sb.Append("labelFormat: '").Append(XAxisLabelFormat).Append("',").Append(CRLF)
			If PrimaryXAxisValueType.Length > 0 Then sb.Append("valueType: '").Append(PrimaryXAxisValueType).Append("',").Append(CRLF)
			If XAxislabelIntersectAction.Length > 0 Then sb.Append("labelIntersectAction: '").Append(XAxislabelIntersectAction).Append("',").Append(CRLF)
			sb.Append("},").Append(CRLF)
	End Select
	If SetCommon = True Then
		sb.Append("commonSeriesOptions: {").Append(CRLF)
		sb.Append($"tooltip: {visible: ${CommonSeriesOptions.tooltipvisible}},"$).Append(CRLF)
		sb.Append($"enableAnimation: ${CommonSeriesOptions.enableAnimation},"$).Append(CRLF)
		sb.Append($"enableSmartLabels : ${CommonSeriesOptions.enableSmartLabels},"$).Append(CRLF)
		sb.Append($"labelPosition : '${CommonSeriesOptions.labelPosition}',"$).Append(CRLF)
		sb.Append($"type: '${CommonSeriesOptions.stype}',"$).Append(CRLF)
		If CommonSeriesOptions.markervisible = True Then
			sb.Append("marker: {")
			sb.Append("visible: true,").Append(CRLF)
			sb.Append("shape: '").Append(CommonSeriesOptions.markershape).Append("',").Append(CRLF)
			If CommonSeriesOptions.markerwidth.Length > 0 Or CommonSeriesOptions.markerheight.Length > 0 Then
				sb.Append($"size: {height: ${CommonSeriesOptions.markerheight}, width: ${CommonSeriesOptions.markerwidth}},"$)
			End If
			If CommonSeriesOptions.markerdatalabelsvisible = True Then
				sb.Append("dataLabel: { visible: true },").Append(CRLF)
			End If
			sb.Append("}").Append(CRLF)
		End If
		sb.Append("},").Append(CRLF)
	End If
	'set the title
	If Title.Length > 0 Or SubTitle.Length > 0 Then
		sb.Append("title: { text: '").Append(Title).Append("'")
		If SubTitle.length > 0 Then
			sb.append(",subTitle: { text: '").append(SubTitle).append("', textAlignment: 'center'}")
		End If
		sb.append("},").Append(CRLF)
	End If
	sb.Append("series: [").Append(CRLF)
	For Each obj As SeriesObj In SeriesList
		Dim strSeries As String = BuildXYSeries(obj)
		sb.Append(strSeries)
	Next
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.append(CRLF).Append("],").Append(CRLF)
	'set the legend
	sb.Append("legend: {").Append(CRLF)
	If LegendVisible = True Then
		sb.Append("visible: true,").Append(CRLF)
		If LegendShape.Length > 0 Then sb.Append($"shape: '${LegendShape}',"$).Append(CRLF)
		If LegendPosition.Length > 0 Then sb.append("position: '").Append(LegendPosition).Append("',").Append(CRLF)
		If LegendTitle.Length > 0 Then
			sb.Append("title: {").Append(CRLF)
			sb.Append("text: ").append(QUOTE).append(LegendTitle).append(QUOTE).append(",").Append(CRLF)
			sb.Append("},").Append(CRLF)
		End If
	Else
		sb.Append("visible: false,").Append(CRLF)
	End If
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("},").Append(CRLF)
	If IsResponsive = True Then
		sb.Append("isResponsive: true,").Append(CRLF)
	End If
	If EnableZooming = True Then
		sb.Append("zooming: {enable: true},").Append(CRLF)
	End If
	If enableCanvasRendering = True Then
		sb.Append("enableCanvasRendering: true,").Append(CRLF)
	End If
	If enable3D = True Then
		sb.Append("enable3D: true,").Append(CRLF)
	End If
	sb.append("exporting: { type: 'png', mode: 'client', fileName: 'ChartSnapshot' }").append(CRLF)
	'done with the chart
	sb.Append("});").Append(CRLF)
	sb.Append($"var chart = $("#${xid}").ejChart("instance");
	chart.model.initSeriesRender = true;
	chart.model.series[0].points=[];
	chart.redraw();
	${PushPoints}
	chart.redraw();"$).Append(CRLF)
	If ColumnWidth.Length > 0 Then
		sb.Append($"$('#${xid}').ejChart('option', { commonSeriesOptions: { columnWidth: ${ColumnWidth} } });"$).Append(CRLF)
	End If
	Return sb.tostring
End Sub
Sub PushPoints() As String
	Dim sb As StringBuilder
	sb.initialize
	Dim serCnt As Int = 0
	For Each obj As SeriesObj In SeriesList
		Dim strSeries As String = BuildXYSeriesData(obj)
		Dim push As String = $"chart.model.series[${serCnt}].points=${strSeries};"$
		sb.Append(push).Append(CRLF)
		serCnt = serCnt + 1
	Next
	Return sb.tostring
End Sub
