﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals
	Dim ABMComp As ABMCustomComponent
	Public Height As String
	Public Width As String
	Public HTML As String
	Private iID As String
	Public KeyField As String = "Status"
	Public PrimaryKey As String = "Id"
	Public SwimlaneKey As String = "Assignee"
	Public Content As String = "Summary"
	Public Tag As String = "Tags"
	Public Priority As String = "RankId"
	Public Color As String = "Type"
	Public Title As String = "Assignee"
	Private Cards As List
	Private Columns As List
	Public AllowTitle As Boolean = False
	Public ShowHeaderIcons As Boolean = False
	Public AllowToggleColumn As Boolean = False
	Public EnableTotalCount As Boolean = False
	Public AllowSelection As Boolean = False
	Private kanbancss As String = ""
	Private WorkFlows As List
	Private Colors As List
	Public IsResponsive As Boolean = True
	Public AllowKeyboardNavigation As Boolean = True
	Public AllowSearching As Boolean = False
	Public EnableContextMenu As Boolean = False
	Public AllowPrinting As Boolean = True
	Public allowDragAndDrop As Boolean = True
	Public allowFiltering As Boolean = False
	Public allowHover As Boolean = True
	Public enableTouch As Boolean = True
	Private Resources As Map
	Public allowScrolling As Boolean = False
	Public allowEditing As Boolean = False
	Public allowAdding As Boolean = False
	Private Filters As List
	Private Statuses As Map
	Private Types As Map
	Private Priorities As Map
	Public ScrollHeight As String = "100%"
	Public ScrollWidth As String = "100%"
	Public enableRTL As Boolean = False
	Public Locale As String = ""
	Private intPage As ABMPage
	Private ColumnMap As Map
	Private sBorderColor As String = "#c8c8c8"
End Sub

'add a filter
Sub AddFilter(stext As String, sColumn As String, svalue As String)
	Dim sb As String = $"{text: "${stext}", query: new ej.Query().where("${sColumn}", "equal", "${svalue}")}"$
	Filters.Add(sb)
End Sub

'Add filters for each resource
Sub AddResourceFilters
	For Each strResource As String In Resources.Keys
		AddFilter(strResource,"Assignee",strResource)
	Next
End Sub

'Add Status filters
Sub AddStatusFilters
	For Each strStatus As String In Statuses.Keys
		AddFilter(strStatus,"Status",strStatus)
	Next
End Sub

'Add Status filters
Sub AddTypeFilters
	For Each strType As String In Types.Keys
		AddFilter(strType,"Type",strType)
	Next
End Sub

'Add Status filters
Sub AddPrioritiesFilters
	For Each strPriority As String In Priorities.Keys
		AddFilter(strPriority,"Priority",strPriority)
	Next
End Sub

'add a resource for the kanban
Sub AddResource(resourceName As String, imgURL As String)
	Resources.Put(resourceName,imgURL)
End Sub

'add a color for the kanban for the Type property
Sub AddColor(colorid As String, typeof As String)
	Dim sb As String = $""${colorid}": "${typeof}""$
	Colors.Add(sb)
End Sub

'add a workflow to control where items can go/not go
Sub AddWorkFlow(colKey As String, colAllowedTransitions As String)
	Dim sb As String = $"{ key: "${colKey}", allowedTransitions: "${colAllowedTransitions}"}"$
	WorkFlows.Add(sb)
End Sub


'add a column with all properties
Sub AddColumn(colKey As String, colHeader As String, colVisible As Boolean, colCollapsed As Boolean, colDrag As Boolean, colDrop As Boolean, showAddButton As Boolean)
	Dim sb As String = $"{ headerText: "${colHeader}", key: "${colKey}", visible: ${colVisible}, isCollapsed: ${colCollapsed}, allowDrag: ${colDrag}, allowDrop: ${colDrop}, showAddButton: ${showAddButton}}"$
	Columns.Add(sb)
	ColumnMap.Put(colHeader,colKey)
End Sub

'build the filters to show in the kanban
private Sub BuildFilters() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each strFilter As String In Filters
		sb.Append(strFilter).Append(",")
	Next
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub

'build the columns to show in the kanban
private Sub BuildColumns() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each strColumn As String In Columns
		sb.Append(strColumn).Append(",")
	Next
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub

'build the color mappings for the colors to use
private Sub BuildColorMappings() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("colorMapping: {")
	For Each strColor As String In Colors
		sb.Append(strColor).Append(",")
	Next
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("},")
	Return sb.tostring
End Sub

'build the workflows to control placement of cards
private Sub BuildWorkFlows() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each strColumn As String In WorkFlows
		sb.Append(strColumn).Append(",")
	Next
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub

'build the fields that control the kanban
private Sub BuildFields() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	sb.Append($"content: "${Content}",primaryKey: "${PrimaryKey}",imageUrl: "ImgUrl",priority: "${Priority}",tag: "${Tag}",color: "${Color}",title: "${Title}""$)
	If SwimlaneKey.Length > 0 Then
		sb.Append($",swimlaneKey: "${SwimlaneKey}"$)
	End If
	sb.Append("}")
	Return sb.tostring
End Sub

'build all data from what has been added with AddCard
private Sub BuildKanBanData() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[")
	For Each strEntry As String In Cards
		sb.Append(strEntry).Append(",")
	Next
	If sb.ToString.EndsWith(",") Then sb.Remove(sb.Length-1,sb.Length)
	sb.Append("]")
	Return sb.tostring
End Sub

'get the imgURL from AddResource
private Sub GetImgURL(resourceName As String) As String
	If Resources.ContainsKey(resourceName) = True Then
		Return Resources.Get(resourceName)
	Else
		Return "" 
	End If
End Sub

'Add a card to the kanban
Sub AddCard(sid As String, sstatus As String, ssummary As String, stypeof As String, sPriority As String, stags As String, sestimate As String, sassignee As String, srankid As String)
	Dim sb As String
	Dim simgurl As String = GetImgURL(sassignee)
	sb = $"{ Id: ${sid}, Status: "${sstatus}", Summary: "${ssummary}", Type: "${stypeof}", Priority: "${sPriority}", Tags: "${stags}", Estimate: ${sestimate}, Assignee: "${sassignee}", ImgUrl: "${simgurl}", RankId: ${srankid} }"$
	sb = sb.Replace(QUOTE & "null" & QUOTE,"null")
	Cards.add(sb)
	'build other maps that are needed
	If Statuses.ContainsKey(sstatus) = False Then
		Statuses.put(sstatus,sstatus)
	End If
	If Types.Containskey(stypeof) = False Then
		Types.put(stypeof, stypeof)
	End If
	If Priorities.ContainsKey(sPriority) = False Then
		Priorities.Put(sPriority, sPriority)
	End If
	If Resources.ContainsKey(sassignee) = False Then
		Resources.Put(sassignee,"")
	End If
End Sub

'update a card to the kanban
Sub UpdateCard(sid As String, sstatus As String, ssummary As String, stypeof As String, sPriority As String, stags As String, sestimate As String, sassignee As String, srankid As String)
	Dim simgurl As String = GetImgURL(sassignee)
	'build other maps that are needed
	If Statuses.ContainsKey(sstatus) = False Then
		Statuses.put(sstatus,sstatus)
	End If
	If Types.Containskey(stypeof) = False Then
		Types.put(stypeof, stypeof)
	End If
	If Priorities.ContainsKey(sPriority) = False Then
		Priorities.Put(sPriority, sPriority)
	End If
	If Resources.ContainsKey(sassignee) = False Then
		Resources.Put(sassignee,"")
	End If
	Dim sb As String = $"var kanbanObj = $("#${ABMComp.ID}").data("ejKanban");
	kanbanObj.updateCard(${sid},{Id: ${sid}, Status: "${sstatus}", Summary: "${ssummary}", Type: "${stypeof}", Priority: "${sPriority}", Tags: "${stags}", Estimate: ${sestimate}, Assignee: "${sassignee}", ImgUrl: "${simgurl}", RankId: ${srankid} });"$
	intPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

'add a card to the kanban
Sub AddCard1(sid As String, sstatus As String, ssummary As String, stypeof As String, sPriority As String, stags As String, sestimate As String, sassignee As String, srankid As String)
	Dim simgurl As String = GetImgURL(sassignee)
	'build other maps that are needed
	If Statuses.ContainsKey(sstatus) = False Then
		Statuses.put(sstatus,sstatus)
	End If
	If Types.Containskey(stypeof) = False Then
		Types.put(stypeof, stypeof)
	End If
	If Priorities.ContainsKey(sPriority) = False Then
		Priorities.Put(sPriority, sPriority)
	End If
	If Resources.ContainsKey(sassignee) = False Then
		Resources.Put(sassignee,"")
	End If
	Dim sb As String = $"var kanbanObj = $("#${ABMComp.ID}").data("ejKanban");
	kanbanObj.KanbanEdit.addCard(${sid},{Id: ${sid}, Status: "${sstatus}", Summary: "${ssummary}", Type: "${stypeof}", Priority: "${sPriority}", Tags: "${stags}", Estimate: ${sestimate}, Assignee: "${sassignee}", ImgUrl: "${simgurl}", RankId: ${srankid} });"$
	intPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

'Update a card using a map
Sub UpdateCard1(record As Map)
	For Each strKey As String In record.Keys
		Dim strValue As String = record.Get(strKey)
		record.Put(strKey.ToLowerCase,strValue)
	Next
	Dim sid As String = record.GetDefault("id","")
	Dim sstatus As String = record.GetDefault("status","")
	Dim ssummary As String = record.GetDefault("summary","")
	Dim stypeof As String = record.GetDefault("type","")
	Dim spriority As String = record.GetDefault("priority","Low")
	Dim stags As String = record.GetDefault("tags","")
	Dim sestimate As String = record.GetDefault("estimate","0")
	Dim sassignee As String = record.GetDefault("assignee","")
	Dim srankid As String = record.GetDefault("rankid","0")
	UpdateCard(sid,sstatus,ssummary,stypeof,spriority,stags,sestimate,sassignee,srankid)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String, BorderColor As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID,"")
	intPage = InternalPage
	Width = "100%"
	Height = "100%"
	Cards.Initialize
	Columns.Initialize
	WorkFlows.Initialize
	Colors.Initialize
	Resources.Initialize
	Filters.Initialize 
	Statuses.initialize
	Types.Initialize 
	Priorities.Initialize
	ColumnMap.Initialize
	HTML = ""
	kanbancss = $".e-backlog,.e-done {
        font-size: 16px;
        padding-right: 5px;
        display: inline-block;
        }    
    .e-backlog:before {
        content: "\e807";
        }    
    .e-done:before {
        content: "\e80a";
        }
	.e-templatetable {
        width: 100%;
    }
    .details > table {
        margin-left: 2px;
        border-collapse: separate;
        border-spacing: 2px;
        width: 100%;
    }
    .details td {
        vertical-align: top;
    }
    .details {
        padding: 8px 8px 10px 0;
    }
    .photo {
        padding: 8px 6px 10px 6px;
        text-align: center;
    }
    .CardHeader {
        font-weight: bolder;
        padding-right: 10px;
    }"$
	'InternalPage.InjectCSS(kanbancss)
	InternalPage.InjectCSS($".e-kanban {border: 1px solid ${BorderColor};}"$)
End Sub

'clear everything for complete data entry
Sub Clear
	Cards.Initialize
	Columns.Initialize
	WorkFlows.Initialize
	Colors.Initialize
	Resources.Initialize
	Filters.Initialize
	Statuses.initialize
	Types.Initialize
	Priorities.Initialize
	ColumnMap.Initialize
	HTML = ""  
End Sub

' runs when an object is created for the first time. Expects a valid html string
' will get surrounded by a div automatically
' in the html file:
Sub ABMComp_Build(InternalPage As ABMPage,internalID As String) As String
	iID = internalID
	Return $"<div id="${internalID}" style="width: ${Width}; height: ${Height};"></div>"$
End Sub

' Is useful to run some initalisation script.
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	intPage = InternalPage
	'build the chart here and initialize it
	HTML = Build(internalID)
	InternalPage.ws.Eval(HTML, Array As Object(ABMComp.ID))
	' flush not needed, it's done in the refresh method in the lib
End Sub
' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
End Sub
' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
End Sub

'remove a column during runtime
Sub RemoveColumn(colHeader As String)
	Dim colKey As String = ColumnMap.Get(colHeader)
	Dim sb As String = $"var kanbanObj = $("#${ABMComp.ID}").data("ejKanban");
	kanbanObj.columns("${colHeader}","${colKey}", "remove");"$
	intPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

'hide a column during runtime
Sub HideColumn(colHeader As String)
	Dim colKey As String = ColumnMap.Get(colHeader)
	Dim sb As String = $"var kanbanObj = $("#${ABMComp.ID}").data("ejKanban");
	kanbanObj.hideColumns("${colHeader}");"$
	intPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

'show a column during runtime
Sub ShowColumn(colHeader As String)
	Dim colKey As String = ColumnMap.Get(colHeader)
	Dim sb As String = $"var kanbanObj = $("#${ABMComp.ID}").data("ejKanban");
	kanbanObj.showColumns("${colHeader}");"$
	intPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

'delete a card
Sub DeleteCard(sid As String)
	Dim sb As String = $"var kanbanObj = $("#${ABMComp.ID}").data("ejKanban");
	kanbanObj.KanbanEdit.deleteCard(${sid});"$
	intPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

'add a column during runtime
Sub AddColumn1(colKey As String, colHeader As String)
	ColumnMap.Put(colHeader,colKey)
	Dim sb As String = $"var kanbanObj = $("#${ABMComp.ID}").data("ejKanban");
	kanbanObj.columns("${colHeader}","${colKey}", "add");"$
	intPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

'build the html of the kanban board for rendering
private Sub Build(xid As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(function () {").Append(CRLF)
	sb.Append($"var kanbanData = ${BuildKanBanData};"$).Append(CRLF)
	sb.Append("var dataManager = ej.DataManager(kanbanData);").Append(CRLF)
	sb.Append($"$("#${xid}").ejKanban({"$).Append(CRLF)
	sb.Append("dataSource: dataManager,").Append(CRLF)
	If Locale.Length > 0 Then
		sb.Append($"locale: "${Locale}","$).Append(CRLF)
	End If
	sb.Append($"allowToggleColumn:${AllowToggleColumn},"$).Append(CRLF)
	sb.Append($"enableTotalCount:${EnableTotalCount},"$).Append(CRLF)
	sb.Append($"workflows: ${BuildWorkFlows},"$).Append(CRLF)
	sb.Append($"columns: ${BuildColumns},"$).Append(CRLF)
	sb.Append($"fields: ${BuildFields},"$).Append(CRLF)
	sb.Append($"cardSettings: {${BuildColorMappings}},"$).Append(CRLF)
	sb.Append($"contextMenuSettings: {enable: ${EnableContextMenu}},"$).Append(CRLF)
	sb.Append($"keyField: "${KeyField}","$).Append(CRLF)
	sb.Append($"allowTitle: ${AllowTitle},"$)
	sb.Append($"allowSelection: ${AllowSelection},"$).Append(CRLF)
	sb.Append($"isResponsive: ${IsResponsive},"$).Append(CRLF)
	sb.Append($"allowKeyboardNavigation: ${AllowKeyboardNavigation},"$).Append(CRLF)
	sb.Append($"allowSearching: ${AllowSearching},"$).Append(CRLF)
	sb.Append($"allowPrinting: ${AllowPrinting},"$).Append(CRLF)
	sb.Append($"allowDragAndDrop: ${allowDragAndDrop},"$).Append(CRLF)
	sb.Append($"allowFiltering: ${allowFiltering},"$).Append(CRLF)
	sb.Append($"allowHover: ${allowHover},"$).Append(CRLF)
	sb.Append($"enableTouch: ${enableTouch},"$).Append(CRLF)
	sb.Append($"allowScrolling: ${allowScrolling},"$).Append(CRLF)
	sb.Append($"enableRTL: ${enableRTL},"$).Append(CRLF)
	sb.Append($"scrollSettings: { width: "${ScrollWidth}", height: "${ScrollHeight}"},"$).Append(CRLF)
	sb.Append($"editSettings: {
	editMode: ej.Kanban.EditMode.Dialog,	
	editItems: [
	{ field: "Id", editType: ej.Kanban.EditingType.String, validationRules: { required: true, number:true }},
	{ field: "Summary", editType: ej.Kanban.EditingType.TextArea, validationRules: { required: true }},
	{ field: "Status", editType: ej.Kanban.EditingType.Dropdown, validationRules: { required: true } },
	{ field: "Assignee", editType: ej.Kanban.EditingType.Dropdown, validationRules: { required: true } },
	{ field: "ImgURL", editType: ej.Kanban.EditingType.String },
	{ field: "Type", editType: ej.Kanban.EditingType.Dropdown, validationRules: { required: true } },
	{ field: "Priority", editType: ej.Kanban.EditingType.Dropdown, validationRules: { required: true } },
	{ field: "Estimate", editType: ej.Kanban.EditingType.Numeric, editParams: { decimalPlaces: 2 } },
	{ field: "RankId", editType: ej.Kanban.EditingType.Numeric, validationRules: { required: true }},
	{ field: "Tags", editType: ej.Kanban.EditingType.Text}],
	allowEditing: ${allowEditing},
	allowAdding: ${allowAdding},
	},"$).Append(CRLF)
	'add filters
	sb.Append($"filterSettings: ${BuildFilters},"$).Append(CRLF)
	sb.append($"selectionType:ej.Kanban.SelectionType.Multiple,"$).Append(CRLF)
	'add events to trap
	sb.Append($"endEdit: function endEdit(args) {
	b4j_raiseEvent('${ABMComp.ID}_endEdit', args.data[0]);
	},
	endAdd: function endAdd(args) {
	b4j_raiseEvent('${ABMComp.ID}_endAdd', args.data[0]);
	},
	endDelete: function endDelete(args) {
	b4j_raiseEvent('${ABMComp.ID}_endDelete', args.data[0]);
	}, 
	cardClick: function cardClick(args) {
	b4j_raiseEvent('${ABMComp.ID}_cardClick', args.data[0]);
	}, 
	cardDrop: function cardDrop(args) {
	b4j_raiseEvent('${ABMComp.ID}_cardDrop', args.data[0]);
	}"$).Append(CRLF) 
	sb.Append("});").Append(CRLF)
	sb.Append("});").Append(CRLF)
	Return sb.tostring
End Sub
